#ifndef BatchLab_BaseObject_h
#define BatchLab_BaseObject_h

// Inheritance :
#include <AIDA/IManagedObject.h>
#include <Slash/Store/IObject.h>

namespace Slash {namespace Core {class IWriter;}}
namespace Slash {namespace Core {class IRelationManager;}}
namespace Slash {namespace Thread {class IMutex;}}
namespace Slash {namespace Store {class IFolder;}}

namespace BatchLab {

class BaseObject 
:public virtual AIDA::IManagedObject 
,public virtual Slash::Store::IObject 
{
public: //AIDA/IManagedObject
  virtual std::string name() const;
public: //Slash::Store::IObject
  virtual void* cast(const std::string&) const;
  virtual void setFolder(Slash::Store::IFolder*);
  virtual void setName(const std::string&);
public:
  virtual Slash::Core::IWriter& printer() const;
  virtual void emitUpdate();
protected:
  BaseObject(Slash::Core::IWriter&,const std::string&);
  BaseObject(const BaseObject&);
protected:
  bool lock() const;
  bool unlock() const;
public:
  virtual ~BaseObject();
  void setRelationManager(Slash::Core::IRelationManager*);//FIXME
  void setVerboseLevel(int);
  int verboseLevel() const;
  bool setThreadSafe(bool);
  bool hasMutex() const;
private:
  Slash::Core::IWriter& fPrinter;
  std::string fName;
  Slash::Store::IFolder* fFolder;
  Slash::Core::IRelationManager* fRelationManager;
  int fVerboseLevel;
  Slash::Thread::IMutex* fMutex;
};

}

#endif
