#ifndef BatchLab_Rio_ROOT_h
#define BatchLab_Rio_ROOT_h

namespace HCL {
  class Axis;
  class Histogram;
  class HistogramData;
}

#include <Rio/Core/Named.h>

namespace BatchLab {

namespace Rio {

class TH : public ::Rio::Named {
public:
  TH(const ::Rio::IDictionary&);
  virtual ~TH();
  bool streamTH1(::Rio::IBuffer&,HCL::Histogram&);
  bool streamTH2(::Rio::IBuffer&,HCL::Histogram&);
  HCL::Histogram* hclHistogram() const;
  const std::string& annotation() const;
protected:
  HCL::Histogram* fHistogram;
  std::string fAnnotation;
  double fEntries;
  double fSw;
};

class TH1F : public TH {
  RIO_META_HEADER(TH1F)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TH1F(const ::Rio::IDictionary&);
  TH1F(const ::Rio::IDictionary&,const HCL::Histogram*,const std::string&);
  virtual ~TH1F();
};

class TH1D : public TH {
  RIO_META_HEADER(TH1D)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TH1D(const ::Rio::IDictionary&);
  TH1D(const ::Rio::IDictionary&,
       const HCL::Histogram*,const std::string&,
       const std::string&);
  virtual ~TH1D();
};

class TH2F : public TH {
  RIO_META_HEADER(TH2F)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TH2F(const ::Rio::IDictionary&);
  TH2F(const ::Rio::IDictionary&,const HCL::Histogram*,const std::string&);
  virtual ~TH2F();
};

class TH2D : public TH {
  RIO_META_HEADER(TH2D)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TH2D(const ::Rio::IDictionary&);
  TH2D(const ::Rio::IDictionary&,
       const HCL::Histogram*,const std::string&,
       const std::string&);
  virtual ~TH2D();
};

class TProfile : public TH1D {
  RIO_META_HEADER(TProfile)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TProfile(const ::Rio::IDictionary&);
  TProfile(const ::Rio::IDictionary&,
           const HCL::Histogram*,const std::string&,
           const std::string&);
  virtual ~TProfile();
private:
  HCL::Histogram* fProfile;
};

class TVectorD : public ::Rio::Object {
  RIO_META_HEADER(TVectorD)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TVectorD(const ::Rio::IDictionary&);
  virtual ~TVectorD();
};

class TMatrix : public ::Rio::Object {
  RIO_META_HEADER(TMatrix)
public: //::Rio::IObject:
  virtual void* cast(const ::Rio::IClass&) const;
  virtual bool stream(::Rio::IBuffer&);
public:
  TMatrix(const ::Rio::IDictionary&);
  virtual ~TMatrix();
};

} //Rio

} //BatchLab

#endif
