
// this :
#include <BatchLab/Core/Annotation.h>

#include <Lib/Cast.h>

#define NotFound (-1)

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Item::Item(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Item::Item(
 const std::string& aKey
,const std::string& aValue
,bool aSticky
)
:fKey(aKey)
,fValue(aValue)
,fSticky(aSticky)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Item::~Item()
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Item::Item(
 const Item& aFrom
)
:Slash::Store::IStorable(aFrom)
,fKey(aFrom.fKey)
,fValue(aFrom.fValue)
,fSticky(aFrom.fSticky)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::Item::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Slash::Store::IStorable)
  else if_Lib_SCast(BatchLab::Item)
  else return 0;
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Item& BatchLab::Item::operator=(
 const Item& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fKey = aFrom.fKey;
  fValue = aFrom.fValue;
  fSticky = aFrom.fSticky;
  return *this;
}
SLASH_STORE_SOURCE(BatchLab::Item)
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Item::visit(
  Slash::Store::IConstVisitor& aVisitor
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SLASH_STORE_BEGIN(BatchLab::Item)

  int version = 1;
  if(!aVisitor.visit("fVersion",version)) return false;

  if(!aVisitor.visit("fKey",fKey)) return false;
  if(!aVisitor.visit("fValue",fValue)) return false;
  if(!aVisitor.visit("fSticky",fSticky)) return false;

  if(!aVisitor.end(*this)) return false;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Item::read(
 Slash::Store::IVisitor& aVisitor
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!aVisitor.begin(*this)) return false;

  int version;
  if(!aVisitor.visit(version)) return false;

  if(!aVisitor.visit(fKey)) return false;
  if(!aVisitor.visit(fValue)) return false;
  if(!aVisitor.visit(fSticky)) return false;

  if(!aVisitor.end(*this)) return false;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Annotation::Annotation(
)
:fItems("BatchLab::Item")
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  addItem("Title","",true);
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Annotation::Annotation(
 const Annotation& aFrom
)
:AIDA::IAnnotation(aFrom)
,Slash::Store::IStorable(aFrom)
,fItems(aFrom.fItems)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Annotation::~Annotation(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::Annotation::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Slash::Store::IStorable)
  else if_Lib_SCast(AIDA::IAnnotation)
  else if_Lib_SCast(BatchLab::Annotation)
  else return 0;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::Annotation::clear(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fItems.clear();
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Annotation& BatchLab::Annotation::operator=(
 const Annotation& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fItems = aFrom.fItems;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::addItem( 
 const std::string& aKey
,const std::string& aValue
,bool aSticky
)
//////////////////////////////////////////////////////////////////////////////
// If item exist, override values.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Item* note = findItem(aKey);
  if(note){
    note->fValue = aValue;
    note->fSticky = aSticky;
    return false;
  }
  fItems.push_back(Item(aKey,aValue,aSticky));
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::removeItem( 
 const std::string& aKey
)
//////////////////////////////////////////////////////////////////////////////
/// Remove the item, if it is not sticky, indicated by a given key
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<Item>::iterator it;
  for(it=fItems.begin();it!=fItems.end();++it) {
    if((*it).fKey==aKey) {
      if((*it).fSticky) return false;
      fItems.erase(it);
      return true;
    }
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::Annotation::value(
 const std::string& aKey
) const
//////////////////////////////////////////////////////////////////////////////
// Retrieve the value for a given key
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  const Item* note = findItem(aKey);
  if(!note) return "";
  return note->fValue;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::visibility( 
 const std::string& aKey
) const
//////////////////////////////////////////////////////////////////////////////
/// Retrieve the visibility flag for a given key
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  const Item* note = findItem(aKey);
  if(!note) return true;
  return note->fSticky;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::Annotation::setValue( 
 const std::string& aKey
,const std::string& aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Item* note = findItem(aKey);
  if(!note) return;
  note->fValue = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::Annotation::setSticky( 
 const std::string& aKey
,bool aSticky
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Item* note = findItem(aKey);
  if(!note) return;
  note->fSticky = aSticky;
}
//////////////////////////////////////////////////////////////////////////////
int BatchLab::Annotation::size(
) const
//////////////////////////////////////////////////////////////////////////////
/// Get the number of items in the Annotation
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fItems.size();
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::Annotation::key(
 int aIndex
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aIndex<0) return "";
  if(aIndex>=int(fItems.size())) return "";
  return fItems[aIndex].fKey;
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::Annotation::value(
 int aIndex
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aIndex<0) return "";
  if(aIndex>=int(fItems.size())) return "";
  return fItems[aIndex].fValue;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::Annotation::reset(
)
//////////////////////////////////////////////////////////////////////////////
// Do not remove sticky items.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<Item>::iterator it;
  for(it=fItems.begin();it!=fItems.end();) {
    if((*it).fSticky) {
      ++it;
    } else {
      it = fItems.erase(it);
    }
  }
}
//AIDA-v3r3p0
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::isSticky(
 const std::string& aKey
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  const Item* note = findItem(aKey);
  if(!note) return false; //FIXME
  return note->fSticky;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::isSticky(
 int aIndex
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aIndex<0) return false;
  if(aIndex>=int(fItems.size())) return false;
  return fItems[aIndex].fSticky;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::hasKey(
 const std::string& aKey
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return findItem(aKey) ? true : false;
}
//////////////////////////////////////////////////////////////////////////////
int BatchLab::Annotation::findKey(
 const std::string& aKey
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  int index = 0;
  std::vector<Item>::const_iterator it;
  for(it=fItems.begin();it!=fItems.end();++it) {
    if((*it).fKey==aKey) return index;
    index++;
  }
  return NotFound;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Item* BatchLab::Annotation::findItem(
 const std::string& aKey
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<Item>::iterator it;
  for(it=fItems.begin();it!=fItems.end();++it) {
    if((*it).fKey==aKey) {
      return &(*it);
    }
  }
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
const BatchLab::Item* BatchLab::Annotation::findItem(
 const std::string& aKey
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<Item>::const_iterator it;
  for(it=fItems.begin();it!=fItems.end();++it) {
    if((*it).fKey==aKey) {
      return &(*it);
    }
  }
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
const std::vector<BatchLab::Item>& BatchLab::Annotation::items(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fItems;
}
//////////////////////////////////////////////////////////////////////////////
std::vector<BatchLab::Item>& BatchLab::Annotation::items(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fItems;
}
SLASH_STORE_SOURCE(BatchLab::Annotation)
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::visit(
 Slash::Store::IConstVisitor& aVisitor
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SLASH_STORE_BEGIN(BatchLab::Annotation)

  int version = 1;
  if(!aVisitor.visit("fVersion",version)) return false;

  if(!aVisitor.visit("fItems",fItems)) return false;

  if(!aVisitor.end(*this)) return false;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Annotation::read(
 Slash::Store::IVisitor& aVisitor
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!aVisitor.begin(*this)) return false;

  int version;
  if(!aVisitor.visit(version)) return false;

  if(!fItems.read(aVisitor)) return false;

  if(!aVisitor.end(*this)) return false;
  return true;
}
