// this :
#include <BatchLab/Core/Evaluator.h>

#include <Lib/Processor.h>
#include <Lib/Debug.h>
#include <Lib/valuemanip.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Cast.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::Evaluator::Evaluator(
 Slash::Core::IWriter& aPrinter
,const std::string& aScript
,AIDA::ITree& aTree
)
:Calculator(aPrinter,aScript,aTree)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::Evaluator");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Evaluator::~Evaluator(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("BatchLab::Evaluator");
}

//private:
BatchLab::Evaluator::Evaluator(const Evaluator& aFrom):AIDA::IEvaluator(),Calculator(aFrom){Lib::Debug::increment("BatchLab::Evaluator");}
BatchLab::Evaluator& BatchLab::Evaluator::operator=(const Evaluator&){return *this;}


//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Evaluator::initialize(
 AIDA::ITuple& aTuple
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return Calculator::initialize(aTuple);
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::Evaluator::expression(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fScript;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::Evaluator::evaluateDouble(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib_self(Evaluator);
  if(!self.getVariables()) return 0; //FIXME : throw
  std::string serror;
  if(!fProcessor->execute(fVals,self.fResult,serror)) { //FIXME : throw
    Lib::Out out(fPrinter);
    out << "BatchLab::Evaluator::evaluateDouble :"
        << " processor execution failed for " << Lib::sout(fScript) << "."
        << Lib::endl;
    out << serror << Lib::endl;
    return 0;
  }
  double value;
  if(!Lib::valuemanip::to_double(self.fResult,value)) {
    Lib::Out out(fPrinter);
    out << "BatchLab::Evaluator::evaluateDouble :"
        << " can't convert the result Lib::Value to a double"
        << " (" << fResult.stype() << ")"
        << " for " << Lib::sout(fScript)
        << Lib::endl;
    return 0;
  }
  return value;
}
