// this :
#include <BatchLab/Core/FitParameterSettings.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::FitParameterSettings::FitParameterSettings(
 const std::string& aName
)
:fName(aName)
,fStepSize(1)
,fLowerBound(0)
,fUpperBound(0)
,fFixed(false)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::FitParameterSettings::FitParameterSettings(
 const FitParameterSettings& aFrom
)
:AIDA::IFitParameterSettings()
,fName(aFrom.fName)
,fStepSize(aFrom.fStepSize)
,fLowerBound(aFrom.fLowerBound)
,fUpperBound(aFrom.fUpperBound)
,fFixed(aFrom.fFixed)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::FitParameterSettings::~FitParameterSettings(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::FitParameterSettings& BatchLab::FitParameterSettings::operator =(
 const FitParameterSettings& aFrom
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fName = aFrom.fName;
  fStepSize = aFrom.fStepSize;
  fLowerBound = aFrom.fLowerBound;
  fUpperBound = aFrom.fUpperBound;
  fFixed = aFrom.fFixed;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::FitParameterSettings::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::FitParameterSettings::stepSize(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fStepSize;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::FitParameterSettings::upperBound(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fUpperBound;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::FitParameterSettings::lowerBound(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLowerBound;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::FitParameterSettings::isBound(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::FitParameterSettings::isFixed(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fFixed;
}
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::setStepSize(
 double aStepSize
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fStepSize = aStepSize;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::setBounds(
 double aLowerBound
,double aUpperBound
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLowerBound = aLowerBound;
  fUpperBound = aUpperBound;
}
#else
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::FitParameterSettings::setStepSize(
 double aStepSize
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fStepSize = aStepSize;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::FitParameterSettings::setBounds(
 double aLowerBound
,double aUpperBound
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLowerBound = aLowerBound;
  fUpperBound = aUpperBound;
  return true;
}
#endif
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::removeBounds(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::setFixed(
 bool aFixed
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fFixed = aFixed;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::setLowerBound(
 double aLowerBound
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLowerBound = aLowerBound;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::setUpperBound(
 double aUpperBound
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fUpperBound = aUpperBound;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::FitParameterSettings::reset(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fStepSize = 1;
  fLowerBound = 0;
  fUpperBound = 0;
  fFixed = false;
}
