// this :
#include <BatchLab/Core/FitResult.h>

#include <AIDA/IFunction.h>

#include <Lib/Debug.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::FitResult::FitResult(
 AIDA::IFunction& aFunction
,const std::vector<double>& aErrs
,int aNDF
,double aQuality
) 
:fFunction(aFunction)
,fQuality(aQuality)
,fNDF(aNDF)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::FitResult");

  fFittedParameters = aFunction.parameters();
  fFittedParameterNames = aFunction.parameterNames();

  fErrors.resize(aErrs.size());
  fErrorsPlus.resize(aErrs.size());
  fErrorsMinus.resize(aErrs.size());
  for(unsigned int index=0;index<aErrs.size();index++) {
    fErrors[index] = aErrs[index];
    fErrorsPlus[index] = aErrs[index]/2;
    fErrorsMinus[index] = -aErrs[index]/2;
  }

}
//////////////////////////////////////////////////////////////////////////////
BatchLab::FitResult::~FitResult(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("BatchLab::FitResult");
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::FitResult::isValid(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return true;
}
//////////////////////////////////////////////////////////////////////////////
AIDA::IFunction& BatchLab::FitResult::fittedFunction(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fFunction;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::FitResult::quality(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fQuality;
}
//////////////////////////////////////////////////////////////////////////////
int BatchLab::FitResult::ndf(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fNDF;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
int BatchLab::FitResult::fitStatus(
) 
{
  return 0;
}
double BatchLab::FitResult::covMatrixElement(
 int
,int
) 
{
  return 0;
}
std::string BatchLab::FitResult::fitMethodName(
) 
{
  return fFitMethodName;
}
std::string BatchLab::FitResult::engineName(
) 
{
  return fEngineName;
}
std::string BatchLab::FitResult::dataDescription(
) 
{
  return fDataDescription;
}
std::vector<std::string> BatchLab::FitResult::constraints(
) 
{
  return fConstraints;
}
AIDA::IFitParameterSettings* BatchLab::FitResult::fitParameterSettings(
 const std::string& /*aName*/
) 
{
  return 0;
}
const std::vector<double>& BatchLab::FitResult::fittedParameters(
) const 
{
  return fFittedParameters;
}
std::vector<std::string> BatchLab::FitResult::fittedParameterNames(
) const 
{
  return fFittedParameterNames;
}
double BatchLab::FitResult::fittedParameter(
 const std::string& /*aName*/
) 
{
  return 0;
}
const std::vector<double>& BatchLab::FitResult::errors(
) const 
{
  return fErrors;
}
const std::vector<double>& BatchLab::FitResult::errorsPlus(
) const 
{
  return fErrorsPlus;
}
const std::vector<double>& BatchLab::FitResult::errorsMinus(
) const 
{
  return fErrorsMinus;
}
