// this :
#include <BatchLab/Core/LinkFolder.h>

#include <Lib/Out.h>
#include <Lib/smanip.h>
#include <Lib/Cast.h>
#include <Lib/Debug.h>

#include <BatchLab/Core/Folder.h>
#include <Slash/Store/IFolderIterator.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::LinkFolder::LinkFolder(
 Slash::Core::IWriter& aPrinter
,Slash::Store::IFolder* aParent
,const std::string& aName
,Slash::Store::ITree& aTree
,Slash::Store::IFolder* aLinkedFolder
)
:BaseFolder(aPrinter,aParent,aName,aTree)
,fLinkedFolder(aLinkedFolder)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder->setLinkingFolder(this);
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::LinkFolder::~LinkFolder(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fLinkedFolder) fLinkedFolder->setLinkingFolder(0);
}
//////////////////////////////////////////////////////////////////////////////
void* BatchLab::LinkFolder::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Slash::Store::IFolder)
  else if_Lib_SCast(BatchLab::BaseFolder)
  else if_Lib_SCast(BatchLab::LinkFolder)
  else return 0;
}
//////////////////////////////////////////////////////////////////////////////
Slash::Store::IFolder* BatchLab::LinkFolder::linkedFolder(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLinkedFolder;
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::LinkFolder::setLinkedFolder(
 Slash::Store::IFolder* aLinkedFolder
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder = aLinkedFolder;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::LinkFolder::isSymlink(
)
//////////////////////////////////////////////////////////////////////////////
// If not a symlink, it is a mouting point.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return (&(tree())==&(fLinkedFolder->tree()));
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::LinkFolder::clear(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder->clear();
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::LinkFolder::add(
 Slash::Store::IObject* aObject
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder->add(aObject);
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::LinkFolder::remove(
 Slash::Store::IObject* aObject
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder->remove(aObject);
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::LinkFolder::add(
 Slash::Store::IFolder* aFolder
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder->add(aFolder);
}
//////////////////////////////////////////////////////////////////////////////
void BatchLab::LinkFolder::remove(
 Slash::Store::IFolder* aFolder
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLinkedFolder->remove(aFolder);
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::LinkFolder::link(
 Slash::Store::IFolder* aFolder
,const std::string& aName
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLinkedFolder->link(aFolder,aName);
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::LinkFolder::unlink(
 Slash::Store::IFolder* aFolder
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLinkedFolder->unlink(aFolder);
}
//////////////////////////////////////////////////////////////////////////////
Slash::Store::IFolder* BatchLab::LinkFolder::mkdir(
 const std::string& aName
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLinkedFolder->mkdir(aName);
}
//////////////////////////////////////////////////////////////////////////////
Slash::Store::IObjectIterator* BatchLab::LinkFolder::objects(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLinkedFolder->objects();
}
//////////////////////////////////////////////////////////////////////////////
Slash::Store::IFolderIterator* BatchLab::LinkFolder::folders(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLinkedFolder->folders();
}
