#ifndef BatchLab_BaseTree_h
#define BatchLab_BaseTree_h

// Inheritance :
#include <AIDA/ITree.h>
#include <Slash/Core/IManager.h>
#include <Slash/Core/IHierarchy.h>
#include <Slash/Store/ITree.h>

#include <list>

namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Core {class IWriter;}}

namespace Slash {namespace Core {class IRelationManager;}} 

namespace BatchLab {

class BaseTree 
:public virtual AIDA::ITree
,public virtual Slash::Store::ITree
,public virtual Slash::Core::IManager
,public virtual Slash::Core::IHierarchy {
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const; //ITree, AIDA::ITree.
public: //Slash::Store::ITree
  virtual bool manageObject(Slash::Store::IObject*,const std::string&);
  virtual void emitUpdate();
public:
  BaseTree(Slash::Core::ISession&,const std::string&);
  virtual ~BaseTree();
public:
  virtual void setVerboseLevel(int);
  int verboseLevel() const;
public:
  virtual Slash::Core::IWriter& printer() const;
  virtual Slash::Core::ISession& session() const;
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  int fVerboseLevel;
protected:
  Slash::Core::IRelationManager* fRelationManager;
};

}

#endif
