#ifndef BatchLab_TreeFactory_h
#define BatchLab_TreeFactory_h

#include <AIDA/ITreeFactory.h>
#include <AIDA/IConstants.h> //For AIDA_VERSION

namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Core {class IWriter;}}

namespace BatchLab {

class TreeFactory : public virtual AIDA::ITreeFactory {
public: //AIDA/ITreeFactory
  virtual AIDA::ITree* create();
  virtual AIDA::ITree* createTree(const std::string& = ""); //AIDA-v3r3p0
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
#else
  virtual AIDA::ITree* createTree(const std::string& storeName,
                                  const std::string& storeType,
                                  int mode = AIDA::ITreeFactory::AUTO,
                                  const std::string & options = "");
  virtual AIDA::ITree* createNamedTree(const std::string& name,
                                       const std::string& storeName,
                                       const std::string& storeType,
                                       int mode = AIDA::ITreeFactory::AUTO,
                                       const std::string& options = "");
#endif
  virtual AIDA::ITree* create(const std::string&,
                              const std::string& = "",
                              bool = false, 
                              bool = false, 
                              const std::string& = "" );
public:
  TreeFactory(Slash::Core::ISession&);
  virtual ~TreeFactory();
protected:
  AIDA::ITree* create_tree(const std::string&,
                           const std::string&,
                           const std::string& = "",
                           bool = false, 
                           bool = false, 
                           const std::string& = "" );
private:
  AIDA::ITree* loadTree(const std::string&,
                        const std::string&,const std::string&,
                        const std::string&,const std::string&,
                        bool,bool,
                        const std::string&);
protected:
  Slash::Core::ISession& fSession;
  Slash::Core::IWriter& fPrinter;
};

}

#endif
