// this :
#include <BatchLab/Core/Environment.h>

#include <Slash/Tools/system.h>

namespace BatchLab {

bool set_env(std::ostream& a_out){

  std::string dir_osc;
  if(!Slash::getenv("OSC_HOME_DIR",dir_osc)) {
    // look for AIDA_HOME_DIR :
    if(!Slash::getenv("AIDA_HOME_DIR",dir_osc)) {
      a_out << "BatchLab::set_env :"
            << " environment variable" 
            << " OSC_HOME_DIR and AIDA_HOME_DIR not defined."
            << " Can't guess where OpenScientist had been installed."
            << std::endl;
      return false;
    }
  }


  std::string fs = Slash::file_separator();
  std::string BATCHLABROOT = dir_osc + fs + "Resources" + fs + "BatchLab";

  if(!Slash::putenv
        ("BATCHLABROOT",dir_osc+fs+"Resources"+fs+"BatchLab")) return false;

  // For the BatchLab/source/Core/FunctionCatalog.cxx and
  // BatchLab/scripts/[sh,DOS]/mak[c,f77]dll[.bat] :
  if(!Slash::putenv("SLASHROOT",dir_osc+fs+"Resources"+fs+"Slash")) return false;
  if(!Slash::putenv("LIBROOT",dir_osc+fs+"Resources"+fs+"Lib")) return false;
  if(!Slash::putenv("LIBDIRLIB",dir_osc+fs+"lib")) return false;
  if(!Slash::putenv("BATCHLABDIRLIB",dir_osc+fs+"lib")) return false;

  return true;
}

}
