// this :
#include <BatchLab/Core/Filter.h>

#include <Lib/Processor.h>
#include <Lib/Debug.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Cast.h>

//////////////////////////////////////////////////////////////////////////////
BatchLab::Filter::Filter(
 Slash::Core::IWriter& aPrinter
,const std::string& aScript
,AIDA::ITree& aTree
)
:Calculator(aPrinter,aScript,aTree)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::Filter");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Filter::~Filter(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("BatchLab::Filter");
}

//private:
BatchLab::Filter::Filter(const Filter& aFrom):AIDA::IFilter(),Calculator(aFrom){Lib::Debug::increment("BatchLab::Filter");}
BatchLab::Filter& BatchLab::Filter::operator=(const Filter&) {return *this;}


//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Filter::initialize(
 AIDA::ITuple& aTuple
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return Calculator::initialize(aTuple);
}
//////////////////////////////////////////////////////////////////////////////
std::string BatchLab::Filter::expression(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fScript;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Filter::accept(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib_self(Filter);
  if(!fScript.size()) return true;
  if(!self.getVariables()) return true; //FIXME : throw
  std::string serror;
  if(!fProcessor->execute(fVals,self.fResult,serror)) { //FIXME : throw
    Lib::Out out(fPrinter);
    out << "BatchLab::Filter::accept :"
        << " processor execution failed for " << Lib::sout(fScript) << "."
        << Lib::endl;
    out << serror << Lib::endl;
    return true;
  }
  if(fResult.type()!=Slash::Core::IValue::BOOL) {
    Lib::Out out(fPrinter);
    out << "BatchLab::Filter::accept :"
        << " result Lib::Variable not a BOOLEAN" 
        << " (" << fResult.stype() << ")"
        << " for " << Lib::sout(fScript)
        << Lib::endl;
    return true;
  }
  return fResult.get_bool();
}
