// this :
#include <BatchLab/Core/Measurement.h>

#include <Lib/Debug.h>

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
BatchLab::Measurement::Measurement(
)
:fValue(0)
,fErrorPlus(0)
,fErrorMinus(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::Measurement");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Measurement::Measurement(
 double aValue
,double aErrorPlus
,double aErrorMinus
)
:fValue(aValue)
,fErrorPlus(aErrorPlus)
,fErrorMinus(aErrorMinus)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::Measurement");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Measurement::Measurement(
 const Measurement& aFrom
)
:AIDA::IMeasurement(aFrom)
,fValue(aFrom.fValue)
,fErrorPlus(aFrom.fErrorPlus)
,fErrorMinus(aFrom.fErrorMinus)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("BatchLab::Measurement");
}
//////////////////////////////////////////////////////////////////////////////
BatchLab::Measurement::~Measurement(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("BatchLab::Measurement");
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::Measurement::value(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fValue;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::Measurement::errorPlus(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fErrorPlus;
}
//////////////////////////////////////////////////////////////////////////////
double BatchLab::Measurement::errorMinus(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fErrorMinus;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Measurement::setValue(
 double aValue
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  fValue = aValue;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Measurement::setErrorPlus(
 double aErrorPlus
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  fErrorPlus = aErrorPlus;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool BatchLab::Measurement::setErrorMinus(
 double aErrorMinus
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  fErrorMinus = aErrorMinus;
  return true;
}
