#ifndef G3Simple_Types_h
#define G3Simple_Types_h

// Inheritance :
#include <OnX/Inventor/InventorAccessor.h>

namespace G3Simple {

class EventType : public Lib::BaseAccessor {
public:
  EventType(Slash::Core::ISession&);
  virtual ~EventType();
public: //Slash::Data::IAccessor
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,
                                         const std::string&,
                                         void*);
private:
  Slash::Core::ISession& fSession;
  std::string fType;
};

class TOWE_Type : public OnX::InventorAccessor {
public: //Slash::Data::IAccessor
  virtual void* cast(const std::string&) const;
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,
                                         const std::string&,
                                         void*);
public: //Slash::Data::IVisualizer
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
public:
  TOWE_Type(Slash::Core::ISession&);
  virtual ~TOWE_Type();
public:
  void fill_ids();
private:
  Slash::Core::ISession& fSession;
  std::string fType;
  std::vector<int*> f_ids;
};

}

#endif
