#ifndef G3Lab_Iterator_h
#define G3Lab_Iterator_h

#include <Slash/Data/IIterator.h>

namespace G3Lab {

  class Iterator : public virtual Slash::Data::IIterator {
  public: //Slash::Data::IIterator
    virtual Slash::Data::IAccessor::Data object() {
      if(fIndex==fVector.size()) return 0;
      return (void*)fVector[fIndex];
    }
    virtual void next() { fIndex++;}
    virtual void* tag() { return 0;}
  public:
    Iterator(std::vector<int*>& aVector):fVector(aVector),fIndex(0) {}
    virtual ~Iterator() {}
  private:
    std::vector<int*>& fVector;
    unsigned int fIndex;
  };

  inline void clear_ids(std::vector<int*>& a_ids) {
    std::vector<int*>::iterator it;
    for(it=a_ids.begin();it!=a_ids.end();++it) delete *it;
    a_ids.clear();
  }

  inline void fill_ids(unsigned int a_number,std::vector<int*>& a_ids) {
    clear_ids(a_ids);
    a_ids.resize(a_number);
    for(unsigned int index=0;index<a_number;index++) {
      int* id = new int;
      *id = index+1;
      a_ids[index] = id;
    }  
  }

}  

#endif
