#ifndef G3Lab_Types_h
#define G3Lab_Types_h

// Inheritance :
#include <OnX/Inventor/InventorAccessor.h>

namespace G3Lab {

class VOLU_Type : public OnX::InventorAccessor {
public: //Slash::Data::IAccessor
  virtual void* cast(const std::string&) const;
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,
                                         const std::string&,
                                         void*);
public: //Slash::Data::IVisualizer
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
public:
  VOLU_Type(Slash::Core::ISession&);
  virtual ~VOLU_Type();
public:
  void fill_ids();
private:
  Slash::Core::ISession& fSession;
  std::string fType;
  std::vector<int*> f_ids;
};

class VERT_Type : public OnX::InventorAccessor {
public: //Slash::Data::IAccessor
  virtual void* cast(const std::string&) const;
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,
                                         const std::string&,
                                         void*);
public: //Slash::Data::IVisualizer
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
public:
  VERT_Type(Slash::Core::ISession&);
  virtual ~VERT_Type();
public:
  void fill_ids();
private:
  Slash::Core::ISession& fSession;
  std::string fType;
  std::vector<int*> f_ids;
};

class KINE_Type : public OnX::InventorAccessor {
public: //Slash::Data::IAccessor
  virtual void* cast(const std::string&) const;
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,
                                         const std::string&,
                                         void*);
public: //Slash::Data::IVisualizer
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
public:
  KINE_Type(Slash::Core::ISession&);
  virtual ~KINE_Type();
public:
  void fill_ids();
private:
  Slash::Core::ISession& fSession;
  std::string fType;
  std::vector<int*> f_ids;
};


/*
class UDET_Type : public OnX::BaseType {
public: //Lib::IType
  virtual const std::string& name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Lib::Variable value(Lib::Identifier,const std::string&,void*);
public: //Slash::Data::IVisualizer
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
public:
  UDET_Type(Slash::Core::ISession&);
  virtual ~UDET_Type();
private:
  Slash::Core::ISession& fSession;
  std::string fType;
};
*/

class DIGI_Type : public OnX::InventorAccessor {
public: //Slash::Data::IAccessor
  virtual void* cast(const std::string&) const;
  virtual std::string name() const;
  virtual Slash::Data::IIterator* iterator();
  virtual Slash::Core::IValue* findValue(Slash::Data::IAccessor::Data,
                                         const std::string&,
                                         void*);
public: //Slash::Data::IVisualizer
  virtual void visualize(Slash::Data::IAccessor::Data,void*);
public:
  DIGI_Type(Slash::Core::ISession&);
  virtual ~DIGI_Type();
public:
  void fill_ids();
private:
  bool uset_udet(std::string&,std::string&);
private:
  Slash::Core::ISession& fSession;
  std::string fType;
  std::string fUSET;
  std::string fUDET;
  std::vector<int*> f_ids;
};

}

#endif
