
#include <G4Lab/Version.h>

#include <Lib/smanip.h>
#include <Lib/fmanip.h>
#include <Lib/dirmanip.h>
#include <Lib/System.h>

#include <stdio.h>   //printf
#include <stdlib.h>  //EXIT_SUCCESS

#include "find_config.icxx"

//////////////////////////////////////////////////////////////////////////////
int main(
 int aArgn
,char** aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aArgn!=2) {
  
    ::printf("\
Usage: onx-config [OPTION]\n\
Options:\n\
        [--version]\n\
        [--cflagsm,--cppflags]\n\
        [--incs,--include]\n\
        [--libs,--lib]\n\
        [--g4_cflags,--g4_cppflags]\n\
        [--g4_incs,--g4_include]\n\
        [--g4_libs,--g4_lib]\n\
        [--pl_cflags,--pl_cppflags]\n\
        [--pl_incs,--pl_include]\n\
        [--pl_libs,--pl_lib]\n\
        [--compiler]\n\
        [--builder]\n\
");
    return EXIT_SUCCESS;
  } 

  std::string arg1 = aArgs[1];

  if(arg1=="--version") {
    ::printf("%s\n",G4LAB_VERSION);
    return EXIT_SUCCESS;

  } else if(arg1=="--builder") {

    ::printf("obuild\n");
    return EXIT_SUCCESS;

  } else if(arg1=="--compiler") {

    if(!find_cxx(aArgs[0],"G4Lab_config.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;

  } else if( (arg1=="--g4_incs") || 
             (arg1=="--g4_include") ) {
    if(!find_incs(aArgs[0],"G4Lab_config_Geant4.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;
  } else if( (arg1=="--g4_cflags") || 
             (arg1=="--g4_cppflags") ) {
      if(!find_flags(aArgs[0],"G4Lab_config_Geant4.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;
  } else if( (arg1=="--g4_libs") || 
             (arg1=="--g4_lib") ) {
    if(!find_libs(aArgs[0],"G4Lab_config_Geant4.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;

  } else if( (arg1=="--pl_incs") || 
             (arg1=="--pl_include") ) {
    if(!find_incs(aArgs[0],"G4Lab_config_physics_lists.save")) 
      return EXIT_FAILURE;
    return EXIT_SUCCESS;
  } else if( (arg1=="--pl_cflags") || 
             (arg1=="--pl_cppflags") ) {
      if(!find_flags(aArgs[0],"G4Lab_config_physics_lists.save")) 
      return EXIT_FAILURE;
    return EXIT_SUCCESS;
  } else if( (arg1=="--pl_libs") || 
             (arg1=="--pl_lib") ) {
    if(!find_libs(aArgs[0],"G4Lab_config_physics_lists.save")) 
      return EXIT_FAILURE;
    return EXIT_SUCCESS;

  } else if( (arg1=="--incs") || 
             (arg1=="--include") ) {
    if(!find_incs(aArgs[0],"G4Lab_config.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;
  } else if( (arg1=="--cflags") || 
             (arg1=="--cppflags") ) {
      if(!find_flags(aArgs[0],"G4Lab_config.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;
  } else if( (arg1=="--libs") || 
             (arg1=="--lib") ) {
    if(!find_libs(aArgs[0],"G4Lab_config.save")) return EXIT_FAILURE;
    return EXIT_SUCCESS;
  }

  ::fprintf(stderr,"onx-config : unknown option.\n");
  
 {::fprintf(stderr,"onx-config : passed arguments had been :\n");
  for(int index=0;index<aArgn;index++) {
    ::fprintf(stderr,"%s\n",aArgs[index]);
  }}
  
  return EXIT_FAILURE;
}

// embed Lib code :
#include <smanip.cxx>
#include <cmanip.cxx>
#include <sout.cxx>
#include <Out.cxx>
#include <fmanip.cxx>
#include <dirmanip.cxx>
#include <System.cxx>
