@ECHO OFF
SETLOCAL

REM # Check that onx-config is available :
onx-config 1> NUL 2> NUL
IF ERRORLEVEL 1 (
  ECHO onx-config program not found.
  GOTO build_return
)

IF NOT DEFINED CLHEP_BASE_DIR (
  ECHO Environment variable CLHEP_BASE_DIR not defined.
  GOTO build_return
)

IF NOT DEFINED G4INSTALL (
  ECHO Environment variable G4INSTALL not defined.
  GOTO build_return
)

SET bin=.

REM # /GR to enable RTTI and dynamic cast.
REM # /GX to enable exception handling (for STL).
REM # /O2 optimize
REM # /W3 warmings
SET def_cppflags=/nologo /DWIN32 /MD /GX /GR /O2 /W3

FOR /F "usebackq delims=;" %%s IN (`onx-config --cppflags`) DO SET onx_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --libs`) DO SET onx_libs=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --iv_cppflags`) DO SET onx_iv_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --iv_libs`) DO SET onx_iv_libs=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --core_libs`) DO SET onx_core_libs=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --g4lab_cppflags`) DO SET onx_g4lab_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`onx-config --g4lab_libs`) DO SET onx_g4lab_libs=%%s

REM #////////////////////////////////////////////////////////////////
REM #// substitute %CLHEP_BASE_DIR%, %G4INSTALL% by their value :
REM #////////////////////////////////////////////////////////////////
FOR /F "usebackq delims=;" %%s IN (`ECHO %onx_g4lab_cppflags%`) DO SET onx_g4lab_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`ECHO %onx_g4lab_libs%`) DO SET onx_g4lab_libs=%%s

REM #//////////////////////////////////////////////////
REM #// library :
REM #//////////////////////////////////////////////////
SET cppflags=%def_cppflags%
SET cppflags=%cppflags% /I..\include
SET cppflags=%cppflags% %onx_g4lab_cppflags%
cl.exe /c %cppflags% /Fo%bin%\Detector.obj /Tp..\src\Detector.cc
cl.exe /c %cppflags% /Fo%bin%\PhysicsList.obj /Tp..\src\PhysicsList.cc
cl.exe /c %cppflags% /Fo%bin%\PrimaryGeneratorAction.obj /Tp..\src\PrimaryGeneratorAction.cc
cl.exe /c %cppflags% /Fo%bin%\MagneticField.obj /Tp..\src\MagneticField.cc
cl.exe /c %cppflags% /Fo%bin%\SteppingAction.obj /Tp..\src\SteppingAction.cc

SET objs=%bin%\Detector.obj %bin%\PhysicsList.obj %bin%\PrimaryGeneratorAction.obj %bin%\MagneticField.obj  %bin%\SteppingAction.obj

lib.exe /nologo /machine:ix86 /out:%bin%\libfield.arc %objs%

DEL %objs%

REM #//////////////////////////////////////////////////
REM #// application :
REM #//////////////////////////////////////////////////

REM # application field :
SET cppflags=%def_cppflags%
SET cppflags=%cppflags% /DG4UI_USE_OSC
SET cppflags=%cppflags% /I..\include
SET cppflags=%cppflags% %onx_cppflags%
SET cppflags=%cppflags% %onx_iv_cppflags%
SET cppflags=%cppflags% %onx_g4lab_cppflags%
cl.exe /c %cppflags% /Fo%bin%\field.obj /Tp..\field.cc

IF EXIST %bin%\field.exe DEL %bin%\field.exe
SET libs=%onx_iv_libs%
SET libs=%libs% %onx_core_libs%
SET libs=%libs% %onx_libs%
SET libs=%libs% %onx_g4lab_libs%
link.exe /nologo /out:%bin%\field.exe %bin%\field.obj %bin%\libfield.arc %libs%

DEL %bin%\field.obj 

:build_return

ENDLOCAL
@ECHO ON
