// this :
#include <G4Lab/BestUnit.h>

// Geant4 :
#include <G4UnitsTable.hh>

#include <Slash/Tools/smanip.h>

//////////////////////////////////////////////////////////////////////////////
bool G4Lab::BestUnit::toDoubles(
 std::ostream& a_out
,const std::string& aString
,std::vector<double>& aVec
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> words;
  Slash::words(aString," ",false,words);
  unsigned int wordn = words.size();
  if(!wordn) {
    aVec.clear();
    return false;
  }
  G4double unit = G4UnitDefinition::GetValueOf(words[wordn-1]);
  if(unit==0.) {
    aVec.clear();
    return false;
  }
  aVec.resize(wordn-1);
  for(unsigned int index=0;index<(wordn-1);index++) {
    double v = 0;
    if(!Slash::to<double>(words[index],v)) {
      a_out << "G4Lab::BestUnit::toDoubles :" 
            << " \"" << words[index] << "\" not a double." 
            << std::endl;
      aVec.clear();
      return false;
    }
    aVec[index] = v * unit;
  }
  return true;
}
