
#include <Slash/UI/IUI.h>
#include <Slash/Tools/Manager.h>
#include <Slash/Tools/smanip.h>
#include <Slash/Tools/Data.h>

static void deprecated(Slash::UI::IUI& aUI,const std::string& aOld,const std::string& aNew) {
  std::ostream& out = aUI.session().cout();
  out << "DLD callback " << Slash::sout(aOld) << " is deprecated."
      << " Use " << Slash::sout(aNew) << " instead."
      << std::endl;
}

#include <G4Lab/Interfaces/IGeant4Manager.h>
#include <Slash/Tools/Manager.h>

inline IGeant4Manager* find_Geant4Manager(Slash::Core::ISession& aSession) {
  IGeant4Manager* g4Manager = 
    Slash_findManager(aSession,"Geant4Manager",IGeant4Manager);
  if(!g4Manager) {
    std::ostream& out = aSession.cout();
    out << "Geant4Manager not found." << std::endl;
    return 0;
  }
  return g4Manager;
}

extern "C" {

void G4Lab_dump_PVs(Slash::UI::IUI& aUI) {
  deprecated(aUI,"G4Lab_dump_PVs",
    "OnX data_collect PV, and then : OnX data_visualize");
  Slash::Core::ISession& session = aUI.session();
  Slash::Data::collect(session,"PV");
  std::string svalue;
  session.parameterValue("AccessorManager.dumpMode",svalue);
  Slash::Data::dump(session,svalue);
}
void G4Lab_data_PhysicsTable_dump(Slash::UI::IUI& aUI) {
  deprecated(aUI,"G4Lab_data_PhysicsTable_dump",
    "OnX data_collect PhysicsTable, and then : OnX data_dump");
  Slash::Core::ISession& session = aUI.session();
  Slash::Data::collect(session,"PhysicsTable");
  std::string svalue;
  session.parameterValue("AccessorManager.dumpMode",svalue);
  Slash::Data::dump(session,svalue);
}

void G4_dump_ParticleTables(Slash::UI::IUI& aUI) {
  deprecated(aUI,"G4_dump_ParticleTables","G4Lab_dump_particle_tables");
  aUI.executeScript("DLD","G4Lab G4Lab_dump_particle_tables");
}
void G4Lab_nextEvent(Slash::UI::IUI& aUI) {
  deprecated(aUI,"G4Lab_nextEvent","G4Lab_next_event");
  aUI.executeScript("DLD","G4Lab G4Lab_next_event"); 
}

void data_PV_dump(Slash::UI::IUI& aUI) {
  deprecated(aUI,"data_PV_dump","");
  G4Lab_dump_PVs(aUI);
}
void data_PhysicsTable_dump(Slash::UI::IUI& aUI) {
  deprecated(aUI,"data_PhysicsTable_dump","");
  G4Lab_data_PhysicsTable_dump(aUI);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void G4Lab_consolePrompt_complete( 
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"G4Lab_consolePrompt_complete","OnX ui_set_parameter consoleCommandLine.value @complete@[consolePrompt.value]@this.value@");

  IGeant4Manager* g4Manager = find_Geant4Manager(aUI.session());
  if(!g4Manager) return;

  std::string prompt;
  if(!aUI.parameterValue("consolePrompt.value",prompt)) return;
  if(prompt=="G4") {
    aUI.setParameter("consoleCommandLine.value",
                     g4Manager->completeCommand(aUI.callbackValue()));
  }
}

} // extern "C"
