
#include <Slash/UI/IScriptManager.h>
#include <Slash/UI/IInterpreter.h>
#include <Slash/Tools/Managers.h>

#include <AIDA/IAnalysisFactory.h>

inline AIDA::IAnalysisFactory* find_AIDA(Slash::Core::ISession& aSession){
  AIDA::IAnalysisFactory* aida = 
    Slash_findManager(aSession,"AnalysisFactory",AIDA::IAnalysisFactory);
  if(!aida) {
    Slash::UI::IScriptManager* scriptManager = Slash::scriptManager(aSession);
    if(!scriptManager) return 0;
    Slash::UI::IInterpreter::Options params;
    scriptManager->executeScript("Session","OnXLab OnXLab_createAIDA",params);
    aida = 
      Slash_findManager(aSession,"AnalysisFactory",AIDA::IAnalysisFactory);
  }
  return aida;
}
