#ifndef G4LabTemplateOne_Environment_h
#define G4LabTemplateOne_Environment_h

#include <Slash/Core/IWriter.h>

#include <Lib/Out.h>
#include <Lib/System.h>
#include <Lib/smanip.h>
#include <Lib/sout.h>
#include <Lib/dirmanip.h>

//////////////////////////////////////////////////////////////////////////////
inline bool check_G4LABTEMPLATEONEROOT(
 const std::string& aArg0
,Slash::Core::IWriter& aPrinter
,bool aWarn = true
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(Lib::System::isenv("G4LABTEMPLATEONEROOT")) return true; //Done by "source setup"

  std::string dir_root;
  if(!Lib::dirmanip::binaryPath(aArg0,dir_root)) {
    if(aWarn) {
      Lib::Out out(aPrinter);
      out << "G4LabTemplateOne::check_G4LABTEMPLATEONEROOT :"
          << " G4LABTEMPLATEONEROOT environment variable not found and" 
          << " we can't guess where the binary is from \"arg0\"." 
          << Lib::endl;
      out << " The \"arg0\" was " << Lib::sout(aArg0) << "."
          << Lib::endl;
    }
    return false;
  }

  std::string bname = Lib::smanip::basename(dir_root);
  bool is_release_area = ((bname=="bin")||(bname=="MacOS"));

  if(!is_release_area) {
    if(aWarn) {
      Lib::Out out(aPrinter);
      out << "G4LabTemplateOne::check_G4LABTEMPLATEONEROOT :"
          << " G4LABTEMPLATEONEROOT environment variable not found and" 
          << " the binary is in an unknown place (" 
          << dir_root << ")."
          << Lib::endl;
      out << " The \"arg0\" was " << Lib::sout(aArg0) << "."
          << Lib::endl;
    }
    return false;
  }
  
  dir_root = Lib::smanip::dirname(dir_root);

  std::string fs = Lib::System::fileSeparator();

  Lib::System::putenv("G4LABTEMPLATEONEROOT",dir_root+fs+"Resources"+fs+"G4LabTemplateOne");

  return true;
}

#endif
