
// this :
#include <G4LabTemplateOne/SteppingAction.h>

// AIDA :
#include <AIDA/IAnalysisFactory.h>
#include <AIDA/ITreeFactory.h>
#include <AIDA/IHistogramFactory.h>
#include <AIDA/IHistogram1D.h>

// Geant4 :
#include <G4Step.hh>

G4LabTemplateOne::SteppingAction::SteppingAction(AIDA::IAnalysisFactory* aAIDA)
:fAIDA(aAIDA)
,fHistoDE(0)
,fHistoDL(0)
{
  if(!fAIDA) return;
  AIDA::ITreeFactory* tf = fAIDA->createTreeFactory();
  AIDA::ITree* tree = tf->create();
  delete tf;
  if(!tree) return;
  AIDA::IHistogramFactory* hf = fAIDA->createHistogramFactory(*tree);
  if(!hf) return;
  fHistoDE = hf->createHistogram1D("histo_DE","StepDE",100,0,10);
  fHistoDL = hf->createHistogram1D("histo_DL","StepLength",100,0,40);
  delete hf;
}

G4LabTemplateOne::SteppingAction::~SteppingAction(){}

void G4LabTemplateOne::SteppingAction::UserSteppingAction(const G4Step* aStep) {
  // Get out MeV and mm :
  G4double delta = aStep->GetDeltaEnergy();
  //delta *= 10000.;
  delta = fabs(delta);
  if( (delta!=0.) && fHistoDE) fHistoDE->fill(fabs(delta),1.);
  G4double length = aStep->GetStepLength();
  length *= 10.;
  if( (length!=0.) && fHistoDL) fHistoDL->fill(length,1.);
}

