
#include "G4RunManager.hh"

#include "DetectorConstruction.hh"
#include "PhysicsList.hh"
#include "PrimaryGeneratorAction.hh"
//#include "SteppingAction.h"

#ifdef G4UI_USE_OSC
#include <G4Lab/UIOnX.h>
#undef G4VIS_USE
#endif

int main(int argc,char** argv)
{  
  G4RunManager* runManager = new G4RunManager;

  DetectorConstruction* detector = new DetectorConstruction;
  runManager->SetUserInitialization(detector);
  runManager->SetUserInitialization(new PhysicsList);
  runManager->SetUserAction(new PrimaryGeneratorAction(detector));
  //runManager->SetUserAction(new SteppingAction());

  runManager->Initialize();
      
  //std::string GUI_onx = "$G4LABROOT/examples/OnX/advanced.onx";
  //std::string GUI_onx = "$G4LABROOT/examples/OnX/novice.onx";
  std::string GUI_onx = "GUI.onx";
  G4UIsession* session = new G4Lab::UIOnX(*runManager,GUI_onx,argc,argv);
  session->SessionStart();
  delete session;     

  delete runManager;

  return 0;
}
