/*
 */

// Geant4 :
#include <G4RunManager.hh>

// G4Lab :
#include <G4Lab/UIOnX.h>

// G4LabTemplateThree :
#include <G4LabTemplateThree/Detector.h>
#include <G4LabTemplateThree/PhysicsList.h>
#include <G4LabTemplateThree/Primary.h>

#include <iostream>

//////////////////////////////////////////////////////////////////////////////
int main(
 int aArgc
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aArgc<=1) {
    std::cout << "Give a gdml file as first argument." << std::endl;
    return 1;
  }
  std::string file(aArgv[1]);

  G4RunManager* runManager = new G4RunManager;
  runManager->SetUserInitialization(new G4LabTemplateThree::Detector(file));
  runManager->SetUserInitialization(new G4LabTemplateThree::PhysicsList);
  runManager->SetUserAction(new G4LabTemplateThree::Primary);
  runManager->Initialize();
    
  // Need to pass the G4RunManager at UIOnX creation
  std::string gui = 
    "$G4LABTEMPLATETHREEROOT/scripts/OnX/G4LabTemplateThree.onx";
  G4Lab::UIOnX* session = new G4Lab::UIOnX(*runManager,gui,aArgc,aArgv);

  session->SessionStart();  // Main UI loop.

  delete session;

  delete runManager;

  return 0;
}

