//
//  All functions here should be OnX callbacks, that is to say
// functions with signature :
//   extern "C" {
//     void callback_without_arguments(Slash::UI::IUI&);
//     void callback_with_arguments(Slash::UI::IUI&,const std::vector<std::string>&);
//   }
//

#include <OnX/Callbacks/OnX.h>

// Lib :
#include <Slash/Core/ISession.h>
#include <Lib/Manager.h>

// OnX :
#include <Slash/UI/IUI.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void G4LabTemplateThree_Initialize(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
// Should be executed (in a widget create callback) 
// when the GUI is constructed 
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Slash::Core::ISession& session = aUI.session();

  aUI.setCallback("OnX_File_exit","activate","DLD","G4Lab G4Lab_exit");

  Slash::UI::IUI* ui = Lib_findManager(session,"UI_Manager",Slash::UI::IUI);
  if(ui) {
    ui->setParameter("viewer.decoration","TRUE");
    ui->setParameter("viewer.viewing","TRUE");
  }
}
//////////////////////////////////////////////////////////////////////////////
void G4LabTemplateThree_Finalize(
 Slash::UI::IUI&
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}

} // extern "C"

void G4LabTemplateThree_Callbacks_quiet_cxx() {
  OnX_quiet_cxx();
}
