//
//  All functions here should be OnX callbacks, that is to say
// functions with signature :
//   extern "C" {
//     void callback_without_arguments(Slash::UI::IUI&);
//     void callback_with_arguments(Slash::UI::IUI&,const std::vector<std::string>&);
//   }
//

//
// HEPVis and Inventor related callbacks.
//

#include <OnX/Callbacks/OnX.h>
#include <OnX/Callbacks/Inventor.h>

#include <Inventor/nodes/SoOrthographicCamera.h>

// HEPVis :
#include <HEPVis/SbMath.h>
#include <HEPVis/nodekits/SoPage.h>
#include <HEPVis/nodekits/SoDisplayRegion.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
void G4LabTemplateThree_Layout_default(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
// Used in scripts/OnX/Pages.onx 
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoPage* soPage = ui_SoPage(aUI);
  if(!soPage) return;

  soPage->deleteRegions();
  soPage->titleVisible.setValue(FALSE);
  soPage->createRegions("SoDisplayRegion",1,1,0);

  // First region ; side view :
  SoRegion* soRegion = page_currentRegion(*soPage);
  if(!soRegion) return;
  soRegion->color.setValue(SbColor(0,0,0));

  float size = 100;

  SoCamera* soCamera = region_camera(*soRegion);
  if(soCamera->isOfType(SoOrthographicCamera::getClassTypeId()))
    ((SoOrthographicCamera*)soCamera)->height.setValue(size);
  soCamera->nearDistance.setValue(1);
  soCamera->focalDistance.setValue(size);
  soCamera->farDistance.setValue(100*size);
}


} // extern "C"

//////////////////////////////////////////////////////////////////////////////
void G4LabTemplateThree_Callbacks_Inventor_quiet_cxx()
//////////////////////////////////////////////////////////////////////////////
// To quiet g++ warnings about unused macros.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  OnX_quiet_cxx();
  OnX_Inventor_quiet_cxx();
}
