#ifndef SpecialCuts_h
#define SpecialCuts_h 1

#include "G4ios.hh"
//#include "globals.hh"
#include "G4VProcess.hh"

//This code is inspired from proccess/transportation/G4StepLimiter

class StepLimiterMessenger;

namespace G4LabTemplateTwo {

class SpecialCuts : public G4VProcess 
{
  public:  // with description     

     SpecialCuts(const G4String& processName ="StepLimiter" );

     virtual ~SpecialCuts(); //JEC add the virtual method

     virtual G4double PostStepGetPhysicalInteractionLength(
                             const G4Track& track,
                             G4double   previousStepSize,
                             G4ForceCondition* condition
                            );

     virtual G4VParticleChange* PostStepDoIt(
                             const G4Track& ,
                             const G4Step& 
                            );
                            
  public:  // without description 
                                 
     //  no operation in  AtRestGPIL
     virtual G4double AtRestGetPhysicalInteractionLength(
                             const G4Track& ,
                             G4ForceCondition* 
                            ){ return -1.0; };
                            
     //  no operation in  AtRestDoIt      
     virtual G4VParticleChange* AtRestDoIt(
                             const G4Track& ,
                             const G4Step&
                            ){return 0;};

     //  no operation in  AlongStepGPIL
     virtual G4double AlongStepGetPhysicalInteractionLength(
                             const G4Track&,
                             G4double  ,
                             G4double  ,
                             G4double& ,
                             G4GPILSelection*
                            ){ return -1.0; };

     //  no operation in  AlongStepDoIt
     virtual G4VParticleChange* AlongStepDoIt(
                             const G4Track& ,
                             const G4Step& 
                            ) {return 0;};
 public:
     void SetVerbose(G4int);

 private:
     
     // hide assignment operator as private 
     SpecialCuts(SpecialCuts&);
     SpecialCuts& operator=(const SpecialCuts& right);
     
     //data member
     G4int    m_verboseLevel; //dump
     StepLimiterMessenger* pMessenger; // Messenger
     
};

}

#endif










