
// this :
#include <G4LabTemplateTwo/Primary.h>

// Geant4 :
#include <G4ParticleGun.hh>
#include <G4ParticleTable.hh>
#include <G4ParticleDefinition.hh>
#include <G4ios.hh>

//---------------------------------------------------------------------------
G4LabTemplateTwo::PrimaryGeneratorAction::PrimaryGeneratorAction(){

  //G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Ctor Start:"
  // << G4endl;


  //Shoot 1 proton
  fParticleGun = new G4ParticleGun(1);
  G4ParticleTable* particleTable = G4ParticleTable::GetParticleTable();
  if(!particleTable) {
    G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Ctor :"
           << " G4ParticleTable::GetParticleTable() returned 0 !!!" 
           << G4endl;
    return;
  }
  G4ParticleDefinition* particle = particleTable->FindParticle("proton");
  if(!particle) {
    G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Ctor :"
           << " can't find proton." 
           << G4endl;
    int number = particleTable->size();
    G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Ctor :"
           << " known particles (" << number << ") :"
           << G4endl;
    for(int index=0;index<number;index++) {
      G4cout << "   " << particleTable->GetParticleName(index) << G4endl;
    }
    exit (0);
    return;
  }
  fParticleGun->SetParticleDefinition(particle);

  //Energy 450 GeV/c
  //fParticleGun->SetParticleEnergy(1*GeV); Kinetic Energy
  //Direction along Positive Z
  //fParticleGun->SetParticleMomentumDirection(G4ThreeVector(0,0,1));

  //Fix the Momentum (implicitly fix the direction also)
  fParticleGun->SetParticleMomentum(G4ParticleMomentum(0.,
						0.,
						400. * GeV));

  //Start Z = -1mm
  fParticleGun->SetParticlePosition(G4ThreeVector(0*mm,0*mm,-1*mm));

  G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Ctor End:"
	 << G4endl;


}//PrimaryGeneratorAction

//---------------------------------------------------------------------------
G4LabTemplateTwo::PrimaryGeneratorAction::~PrimaryGeneratorAction(){
  delete fParticleGun;
}//Dtor

//---------------------------------------------------------------------------
void G4LabTemplateTwo::PrimaryGeneratorAction::GeneratePrimaries(G4Event* aEvent){
  //G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Generate Start:"
  // << G4endl;

  fParticleGun->GeneratePrimaryVertex(aEvent);

  //G4cout << "G4LabTemplateTwo::PrimaryGeneratorAction::Generate End:"
  // << G4endl;

}//GeneratePrimaries

