
// this :
#include <G4LabTemplateTwo/RunAction.h>

#include <iostream>

// Geant4 :
#include <G4Timer.hh>
#include <G4Run.hh>

G4LabTemplateTwo::RunAction::RunAction() {
  fTimer = new G4Timer;
}
G4LabTemplateTwo::RunAction::~RunAction() {
  delete fTimer;
}
void G4LabTemplateTwo::RunAction::BeginOfRunAction(const G4Run* aRun) {
  std::cout << "### Run " << aRun->GetRunID() << " start." << std::endl;
  fTimer->Start();
}
void G4LabTemplateTwo::RunAction::EndOfRunAction(const G4Run* aRun) {
  fTimer->Stop();
  if (fTimer->IsValid()) {
    std::cout << "number of event = " << aRun->GetNumberOfEvent()
              << " User = " << fTimer->GetUserElapsed() << "s"
              << " Real = " << fTimer->GetRealElapsed() << "s"
              << " Sys = " << fTimer->GetSystemElapsed() << "s" << std::endl;
  } else {
    std::cout << "number of event = " << aRun->GetNumberOfEvent()
              << " User=****s Real=****s Sys=****s" << std::endl;
  }
}
