//This
#include "G4LabTemplateTwo/StepLimiterBuilder.h"

//Geant4
#include <G4ParticleDefinition.hh>
#include <G4ProcessManager.hh>

//G4LabTemplateTwo
#include "G4LabTemplateTwo/SpecialCuts.h"

StepLimiterBuilder::StepLimiterBuilder(const G4String& name)
  :  G4VPhysicsConstructor(name) {
}//Ctor

StepLimiterBuilder::~StepLimiterBuilder() {
}//Dtor

void StepLimiterBuilder::ConstructParticle() {
}//ConstructParticle

void StepLimiterBuilder::ConstructProcess() {
  
  //This process is valid for all particles allowed
  G4LabTemplateTwo::SpecialCuts* stepMax = new G4LabTemplateTwo::SpecialCuts("JECStepMaxLimiter");

  theParticleIterator->reset();
  while( (*theParticleIterator)() ){
    G4ParticleDefinition* particle = theParticleIterator->value();
    G4ProcessManager* pmanager = particle->GetProcessManager();
    if (stepMax->IsApplicable(*particle) && !particle->IsShortLived()) {
      pmanager->AddProcess(stepMax,-1,-1,6);
    }
  }
}//ConstructProcess


