#include <stdlib.h>
#include <math.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#include <HEPVis/nodes/SoBackPrimitive.h>
#include <HEPVis/nodekits/SoArrowButton.h>

static void activateCB(void*,SoNode*);
static int sCount = 0;

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoBackPrimitive::initClass();
  SoPrimitive::initClass();
  SoArrowButton::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoOrthographicCamera* camera = new SoOrthographicCamera;
  camera->height.setValue(2);
  camera->position.setValue(0,0,4);
  camera->nearDistance.setValue(1);
  camera->farDistance.setValue(100);
  sceneGraph->addChild(camera);

  SoArrowButton* arrowButton = new SoArrowButton;
  arrowButton->foreground.setValue(0.4F,0.4F,0.4F);
  arrowButton->background.setValue(1,1,1);
  arrowButton->shadowThickness.setValue(0.1F);
  arrowButton->marginWidth.setValue(0.1F);
  arrowButton->marginHeight.setValue(0.1F);
  arrowButton->addActivateCallback(activateCB,arrowButton);
  sceneGraph->addChild(arrowButton);

  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(myWindow);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->setSize(SbVec2s(600,400));
  viewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoBackPrimitive::clearClass();
  SoPrimitive::clearClass();
  SoArrowButton::clearClass();

  SoGui::clear();  
#endif

  return EXIT_SUCCESS;
}
//////////////////////////////////////////////////////////////////////////////
static void activateCB (
 void* /*aUserData*/
,SoNode* aButton
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  sCount++;
  if(sCount==4) {
#ifdef SoFreePackage //Cleanup
    SoGui::sendExit();  
#else
    exit(EXIT_SUCCESS);
#endif
  } else {
    SoArrowButton* button = (SoArrowButton*)aButton;
    button->arrowDirection.setValue(sCount);  
  }
}

