/*
 * To Test manip. In fact it is pure Inventor, no HEPVis here.
 */

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoTransform.h>

#include <Inventor/draggers/SoDragPointDragger.h>
#include <Inventor/engines/SoCalculator.h>

#include <stdlib.h> //exit

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Set up the main window
  SoGuiWidget topWidget=SoGui::init(aArgv[0]);
  if (!topWidget) exit(1);

  // initialize HEPVis used classes :

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  SoDragPointDragger* soDragger;

 {SoSeparator* soSep = new SoSeparator;
  sceneGraph->addChild(soSep);

  SoTransform* tsf = new SoTransform();
  tsf->translation.setValue(10,0,0);
  tsf->scaleFactor.setValue(2,2,2);
  soSep->addChild(tsf);

  soDragger = new SoDragPointDragger;
  soSep->addChild(soDragger);}

 {SoSeparator* soSep = new SoSeparator;
  sceneGraph->addChild(soSep);

  SoTransform* tsf = new SoTransform();
  tsf->translation.setValue(-10,0,0);
  //tsf->scaleFactor.setValue(2,2,2);
  soSep->addChild(tsf);

  SoCube* soCube = new SoCube;
  soSep->addChild(soCube);

  SoCalculator* soCalc = new SoCalculator; 
  //soCalc->ref(); 
  //soCalc->A.connectFrom(&(transform->translation)); 
  soCalc->A.connectFrom(&(soDragger->translation)); 
  //soCalc->expression.setValue("oA = A"); 
  soCalc->expression.setValue("oA = vec3f(A[1],0,0)"); 

  tsf->translation.connectFrom(&(soCalc->oA));}

  SoGuiExaminerViewer* examinerViewer = new SoGuiExaminerViewer(topWidget);
  examinerViewer->setSceneGraph(sceneGraph);
  examinerViewer->show();

  SoGui::show(topWidget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete examinerViewer;

  return 0; 
}
