#include <stdlib.h>
#include <math.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>

#include <HEPVis/nodes/SoBackPrimitive.h>

#include <HEPVis/nodekits/SoArrowButton.h>
#include <HEPVis/nodekits/SoScrolledList.h>
#include <HEPVis/nodekits/SoFileSelectionBox.h>

static void okCB(void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget widget=SoGui::init(aArgv[0]);
  if(widget==NULL) exit(1);

  SoBackPrimitive::initClass();

  SoPrimitive::initClass();
  SoForm::initClass();
  SoArrowButton::initClass();
  SoList::initClass();
  SoScrolledList::initClass();
  SoFileSelectionBox::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoFileSelectionBox* fileSelectionBox = new SoFileSelectionBox;
  fileSelectionBox->directory.setValue("..");
  fileSelectionBox->addOkCallback(okCB,NULL);
  sceneGraph->addChild(fileSelectionBox);

  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(widget);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->show();

  SoGui::show(widget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoPrimitive::clearClass();
  SoForm::clearClass();
  SoArrowButton::clearClass();
  SoList::clearClass();
  SoScrolledList::clearClass();
  SoFileSelectionBox::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return 0; 
}
//////////////////////////////////////////////////////////////////////////////
static void okCB (
 void* /*aUserData*/
,SoNode* aNode
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoFileSelectionBox* fileSelectionBox = (SoFileSelectionBox*)aNode;
  if(fileSelectionBox==NULL) return;
  const SbString& file = fileSelectionBox->getSelectedFile();
  printf("Selected file : %s\n",file.getString());
}

