#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

// SGI : SoOffscreenRenderer.h include glx.h !
#ifdef __COIN__
#include <Inventor/SoOffscreenRenderer.h>
#endif

#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTexture2.h>
#include <Inventor/nodes/SoCube.h>
#include <Inventor/nodes/SoTexture2Transform.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoSpotLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoRotationXYZ.h>
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoText2.h>
#include <Inventor/nodes/SoText3.h>

#include <HEPVis/SbGIF.h>
#include <HEPVis/SbMath.h>

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  /*
  int w = 10;
  int h = 10;
  unsigned char* buffer = new unsigned char[3 * w * h];
  unsigned char* p = buffer;
  int row,col;
  for(row=0;row<3;row++) 
    for(col=0;col<w;col++) {*p = 255;p++;*p = 0;p++;*p = 0;p++;} 
  for(row=3;row<6;row++) 
    for(col=0;col<w;col++) {*p = 0;p++;*p = 255;p++;*p = 0;p++;} 
  for(row=6;row<10;row++) 
    for(col=0;col<w;col++) {*p = 0;p++;*p = 0;p++;*p = 255;p++;}
  */

  FILE* file = fopen("../data/hepvis99.gif","rb");
  unsigned int w,h;
  int colorn;
  double* rs;
  double* gs;
  double* bs;
  unsigned char* indices = 0;
  if(file) {
    int bg;
    indices = SbGIF::getImageFromStream(file,w,h,colorn,rs,gs,bs,bg);
    fclose(file);
  }
  unsigned char* buffer = 0;
  if(indices) {
    unsigned int row,col;
    buffer = new unsigned char[3 * w * h];
    unsigned char* p = buffer;
    unsigned char* i = indices;
    for(row=0;row<h;row++) {
      p = buffer + 3 * (h - 1 - row) * w;
      for(col=0;col<w;col++) {
        *p = (unsigned char)(255 * rs[*i]);p++;
        *p = (unsigned char)(255 * gs[*i]);p++;
        *p = (unsigned char)(255 * bs[*i]);p++;
        i++;
      } 
    } 
  } 
  
  int number = 4;
  float height = 2;
  float width = 2 * ((float)w) /((float)h);
  float offset = 0.1F;
  
  // Histo position :
  SoRotationXYZ* rx = new SoRotationXYZ;
  rx->axis=SoRotationXYZ::X;
  rx->angle = - FM_PI/4;
  
  SoRotationXYZ* rz = new SoRotationXYZ;
  rz->axis=SoRotationXYZ::Z;
  rz->angle = - FM_PI/4;
  
  SoTransform* histoTransform = new SoTransform;
  //histoTransform->combineLeft(rz);
  histoTransform->combineLeft(rx);
  rx->unref();
  rz->unref();
  sceneGraph->addChild(histoTransform);

  SoDirectionalLight* light = new SoDirectionalLight;
  light->color.setValue(1,1,1);
  light->direction.setValue(SbVec3f(0,0,-1));
  sceneGraph->addChild(light);

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue(1, 1, 1);
  sceneGraph->addChild(material);

  // Generate the texture map
  SoTexture2* texture2 = new SoTexture2;
  //texture2->filename.setValue("../data/brick_1.rgb");
#ifdef __COIN__
  texture2->image.setValue(SbVec2s(w,h),SoOffscreenRenderer::RGB,buffer);
#else
  texture2->image.setValue(SbVec2s(w,h),3,buffer);
#endif

  sceneGraph->addChild(texture2);

  for(int row=0;row<number;row++) {
    for(int col=0;col<number;col++) {
      SoSeparator* separator = new SoSeparator;
      sceneGraph->addChild(separator);

      SoTransform* transform = new SoTransform;
      separator->addChild(transform);
      if( (col==number-1) && (row==number-1) ) {
       //transform->rotation.setValue(SbRotation(SbVec3f(1.,1.,0.),FM_PI/6.));
        transform->translation.setValue(
        SbVec3f(col * width + 10 * offset, 
                row * height,0));
      } else if( (col==number-1) && (row==2) ) {
        transform->translation.setValue(
        SbVec3f(col * width + 10 * offset, 
                row * height,0));
      } else if( (col==number-1) && (row==1) ) {
        transform->translation.setValue(
        SbVec3f(col * width + 10 * offset, 
                row * height,0));
      } else if( (col==number-1) && (row==0) ) {
       //transform->rotation.setValue(SbRotation(SbVec3f(1.,-1.,0.),FM_PI/6.));
        transform->translation.setValue(
        SbVec3f(col * width + 10 * offset, 
                row * height - 10 * offset,0));
      } else if( (col==number-2) && (row==0) ) {
        transform->translation.setValue(
        SbVec3f(col * width + offset, 
                row * height - 10 * offset,0));
      } else {
        transform->translation.setValue(
         SbVec3f(col * width, row * height, 0));
      }

      SoTexture2Transform* texture2transform = new SoTexture2Transform;
      texture2transform->translation.setValue(SbVec2f(((float)col)/number,
                                                      ((float)row)/number));
      texture2transform->scaleFactor.setValue(SbVec2f(1.F/number,1.F/number));
      separator->addChild(texture2transform);

      SoCube* cube = new SoCube;
      cube->depth.setValue(0.01F);
      float factor = 0.97F;
      //float factor = 1;
      cube->height.setValue(2 * factor);
      cube->width.setValue(width * factor);
      separator->addChild(cube);

    }
  }

  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer* myViewer=new SoGuiExaminerViewer(myWindow);
  //myViewer->setBackgroundColor(SbColor(
  //                               0.593759,0.980484,0.593759 //palegreen
  //                               ));
  myViewer->setSceneGraph(sceneGraph);
  myViewer->setHeadlight(FALSE);
  myViewer->viewAll();
  myViewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete myViewer;

#ifdef SoFreePackage //Cleanup
  SoGui::clear();  
#endif

  return 0; 
}
