#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>

#include <HEPVis/nodes/SoBackPrimitive.h>

#include <HEPVis/nodekits/SoPrimitive.h>
#include <HEPVis/nodekits/SoList.h>

static void singleSelectionCB(void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoBackPrimitive::initClass();

  SoPrimitive::initClass();
  SoList::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoList* list = new SoList();
  list->shadowThickness.setValue(0.1F);
  list->marginWidth.setValue(0.1F);
  list->marginHeight.setValue(0.1F);
  SbString* strings = new SbString[4];
  strings[0] = "item 1";
  strings[1] = "item 2";
  strings[2] = "item 3";
  strings[3] = "Quit";
  list->items.setValues(0,4,strings);
  delete [] strings;
  list->addSingleSelectionCallback(singleSelectionCB,NULL);
  sceneGraph->addChild(list);

  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer *myViewer=new SoGuiExaminerViewer(myWindow);
  myViewer->setSceneGraph(sceneGraph);
  myViewer->viewAll();
  myViewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete myViewer;

#ifdef SoFreePackage //Cleanup
  SoPrimitive::clearClass();
  SoList::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return 0; 
}
//////////////////////////////////////////////////////////////////////////////
static void singleSelectionCB (
 void* /*aUserData*/
,SoNode* aNode
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoList* list = (SoList*)aNode;
  if(list==NULL) return;
  SbString line = list->getSelectedItem();
  printf("Selected : %s\n",line.getString());
  if(line=="Quit") {
#ifdef SoFreePackage //Cleanup
    SoGui::sendExit();  
#else
    exit(EXIT_SUCCESS);
#endif
  }
}

