#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#include <HEPVis/nodes/SoBackPrimitive.h>
#include <HEPVis/nodekits/SoPrimitive.h>

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoBackPrimitive::initClass();
  SoPrimitive::initClass();

  // Set up the sceneGraph of the scene database and
  // reference it

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoOrthographicCamera* camera = new SoOrthographicCamera;
  camera->height.setValue(2);
  camera->position.setValue(0,0,4);
  camera->nearDistance.setValue(1);
  camera->farDistance.setValue(100);
  sceneGraph->addChild(camera);

  SoMaterial* material = new SoMaterial;
  material->diffuseColor.setValue(0.8F, 0.8F, 0.8F);
  sceneGraph->addChild(material);

  SoPrimitive* primitive = new SoPrimitive;
  primitive->shadowThickness.setValue(0.5F);
  /*
  primitive->marginWidth.setValue(0.1F);
  primitive->marginHeight.setValue(0.1F);
  */
  sceneGraph->addChild(primitive);

  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(myWindow);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->setSize(SbVec2s(600,400));
  viewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoPrimitive::clearClass();
  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return EXIT_SUCCESS; 

}

