#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#include <HEPVis/nodes/SoBackPrimitive.h>
#include <HEPVis/nodekits/SoPrimitive.h>

#include <HEPVis/nodekits/SoPushButton.h>

static void activateCB (void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget myWindow=SoGui::init(aArgv[0]);
  if(myWindow==NULL) exit(1);

  SoBackPrimitive::initClass();
  SoPrimitive::initClass();
  SoPushButton::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoOrthographicCamera* camera = new SoOrthographicCamera;
  camera->height.setValue(2);
  camera->position.setValue(0,0,4);
  camera->nearDistance.setValue(1);
  camera->farDistance.setValue(100);
  sceneGraph->addChild(camera);

  SoPushButton* pushButton = new SoPushButton;
  pushButton->background.setValue(0.8F, 0.8F, 0.8F);
  pushButton->shadowThickness.setValue(0.1F);
  pushButton->marginWidth.setValue(0.1F);
  pushButton->marginHeight.setValue(0.1F);
  pushButton->labelString.setValue("Quit");
  pushButton->addActivateCallback(activateCB,NULL);
  sceneGraph->addChild(pushButton);

  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(myWindow);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->setSize(SbVec2s(600,400));
  viewer->show();

  SoGui::show(myWindow);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef SoFreePackage //Cleanup
  SoPrimitive::clearClass();
  SoPushButton::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return EXIT_SUCCESS;
}
//////////////////////////////////////////////////////////////////////////////
static void activateCB (
 void* /*aUserData*/
,SoNode* /*aNode*/
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
#ifdef SoFreePackage //Cleanup
  SoGui::sendExit();  
#else
  exit(EXIT_SUCCESS);
#endif
}

