
import CoinPython as Inventor

Inventor.SoDB.init()
Inventor.SoNodeKit.init()

root = Inventor.SoSeparator()

camera = Inventor.SoPerspectiveCamera()
root.addChild(camera)

scale = Inventor.SoScale()
scale.scaleFactor.setValue(Inventor.SbVec3f(0.1,0.1,0.1))
root.addChild(scale)

appearanceKit = Inventor.SoAppearanceKit()
root.addChild(appearanceKit)

import HEPVis

## Geometry :
HEPVis.Geometry_initClasses()

# SoPolyhedron : a trd :
trd2 = HEPVis.SbPolyhedronTrd2(10,0,10,0,10)
so_trd2 = HEPVis.SoPolyhedron(trd2)
so_trd2.solid.setValue(Inventor.FALSE)
so_trd2.reducedWireFrame.setValue(Inventor.TRUE)
root.addChild(so_trd2)

# SoPolyhedron : boolean operation :
box_1 = HEPVis.SbPolyhedronBox(10,10,10)
bool_op = HEPVis.SbPolyhedron(box_1);
box_2 = HEPVis.SbPolyhedronBox(5,5,5)
box_2.Transform(Inventor.SbRotation(),Inventor.SbVec3f(1,1,1))
bool_op = bool_op.add(box_2);
so_bool_op = HEPVis.SoPolyhedron(bool_op)
so_bool_op.solid.setValue(Inventor.FALSE)
so_bool_op.reducedWireFrame.setValue(Inventor.TRUE)
root.addChild(so_bool_op)

writeAction = Inventor.SoWriteAction()
writeAction.getOutput().setBinary(Inventor.FALSE)
writeAction.apply(root)

del writeAction
del root
