#include <math.h>
#include <stdlib.h>

#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>

#include <HEPVis/nodes/SoBackPrimitive.h>

#include <HEPVis/nodekits/SoArrowButton.h>
#include <HEPVis/nodekits/SoScrolledList.h>

static void singleSelectionCB(void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char ** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
 {SoGuiWidget widget=SoGui::init(aArgv[0]);
  if(widget==NULL) exit(1);

  SoBackPrimitive::initClass();

  SoPrimitive::initClass();
  SoForm::initClass();
  SoArrowButton::initClass();
  SoList::initClass();
  SoScrolledList::initClass();

  SoSeparator* sceneGraph=new SoSeparator;
  sceneGraph->ref();

  SoScrolledList* list = new SoScrolledList();
  list->shadowThickness.setValue(0.1F);
  list->marginWidth.setValue(0.1F);
  list->marginHeight.setValue(0.1F);
  SbString* strings = new SbString[10];
  strings[0] = "item 1";
  strings[1] = "item 2";
  strings[2] = "item 3";
  strings[3] = "item 4";
  strings[4] = "item 5";
  strings[5] = "item 6";
  strings[6] = "item 7";
  strings[7] = "item 8";
  strings[8] = "item 9";
  strings[9] = "Quit";
  list->items.setValues(0,10,strings);
  delete [] strings;
  list->addSingleSelectionCallback(singleSelectionCB,NULL);
  sceneGraph->addChild(list);

  // View the new object in an Examiner Viewer
  SoGuiExaminerViewer *viewer=new SoGuiExaminerViewer(widget);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->show();

  SoGui::show(widget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;}

#ifdef SoFreePackage //Cleanup
  SoPrimitive::clearClass();
  SoForm::clearClass();
  SoArrowButton::clearClass();
  SoList::clearClass();
  SoScrolledList::clearClass();

  SoBackPrimitive::clearClass();

  SoGui::clear();  
#endif

  return 0; 
}
//////////////////////////////////////////////////////////////////////////////
static void singleSelectionCB (
 void* /*aUserData*/
,SoNode* aNode
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoList* list = (SoList*)aNode;
  if(list==NULL) return;
  SbString line = list->getSelectedItem();
  printf("Selected : %s\n",line.getString());
  if(line=="Quit") {
#ifdef SoFreePackage //Cleanup
    SoGui::sendExit();  
#else
    exit(EXIT_SUCCESS);
#endif
  }
}

