#include <HEPVis/Gui/SoGui.h>

#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoOrthographicCamera.h>

#include <HEPVis/nodes/SoAreaStyle.h>
#include <HEPVis/nodes/SoTextStyle.h>
#include <HEPVis/nodekits/SoSimpleButton.h>

extern "C" {
  void HEPVisUtils_initClasses();
}

static void activateCB (void*,SoNode*);

//////////////////////////////////////////////////////////////////////////////
int main(
 int
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  SoGuiWidget topWidget = SoGui::init(aArgv[0]);
  if(topWidget==NULL) exit(1);

  HEPVisUtils_initClasses();

  SoSeparator* sceneGraph = new SoSeparator;
  sceneGraph->ref();

  SoOrthographicCamera* camera = new SoOrthographicCamera;
  camera->height.setValue(10);
  camera->position.setValue(0,0,10);
  camera->nearDistance.setValue(1);
  camera->farDistance.setValue(100);
  camera->focalDistance.setValue(10);
  sceneGraph->addChild(camera);

  SoSimpleButton* button = new SoSimpleButton;
  button->getBackStyle()->color.setValue(SbColor(0.9F,0,0));
  button->getLabelStyle()->color.setValue(SbColor(1,1,1));
  button->getLabelStyle()->fontName.setValue("Text3/defaultFont");
  //button->background.setValue(0.8F, 0.8F, 0.8F);
  //button->shadowThickness.setValue(0.1F);
  //button->marginWidth.setValue(0.1F);
  //button->marginHeight.setValue(0.1F);
  button->label.setValue("Quit");
  button->addCallback(activateCB,NULL);
  sceneGraph->addChild(button);

  SoGuiExaminerViewer* viewer = new SoGuiExaminerViewer(topWidget);
  viewer->setSceneGraph(sceneGraph);
  viewer->viewAll();
  viewer->setSize(SbVec2s(600,400));
  viewer->show();

  SoGui::show(topWidget);
  SoGui::mainLoop();

  sceneGraph->unref();
  delete viewer;

#ifdef HEPVisSDL
  SoGui::clear();  
#endif

  return EXIT_SUCCESS;
}
//////////////////////////////////////////////////////////////////////////////
static void activateCB (
 void* /*aUserData*/
,SoNode* /*aNode*/
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
#ifdef SoFreePackage //Cleanup
  SoGui::sendExit();  
#else
  exit(EXIT_SUCCESS);
#endif
}

