#ifndef HEPVis_SbPainterWin_h
#define HEPVis_SbPainterWin_h 

#include <HEPVis/SbBasic.h>

#ifdef HEPVisWin

#include <windows.h>

#include <HEPVis/SbPainter.h>

class SbPainterWin : public SbPainter {
public:
  SbPainterWin();
  ~SbPainterWin();
public:
  void beginTraversal();
  void clearColorBuffer(float,float,float);
  void drawPrimitive(SbPrimitiveType,int,float*,float*,float*,const SbPainterContext&);
  void endTraversal();
public:
  void setWindow(HWND);
  void setHDC(HDC);
private:
  SbBool allocatePoints(int,int);
  SbBool convertLineToPoints(int,float*,float*,float*);
  void drawPolygon(int,POINT*,float,float,float,const SbAreaStyle&);
  void drawLines(int,POINT*,float,float,float,SbLinePattern,int);
  void drawMarkers(int,POINT*,float,float,float,const SbMarkerStyle&,int);
  void drawMarkerSegments(SbMarkerStyle,int,int,int);
private:
  HWND fHWND;
  HDC fHDC;
  int fPointn;
  POINT* fPoints;
};

#endif

#endif





