// this :
#include <HEPVis/SDL/viewers/SoSDL_Viewer.h>

#include <Inventor/SbViewportRegion.h>

#include <HEPVis/SbColors.h>
#include <HEPVis/nodes/SoAreaStyle.h>
#include <HEPVis/nodekits/SoFormRegion.h>
#include <HEPVis/nodekits/SoSimpleButton.h>

HEPVis::SoSDL_Viewer::SoSDL_Viewer(SoSDL_Widget* aWidget)
: ::SoSDL_Viewer(aWidget)
,fShootRegion(0)
,fUI(0)
,fUI_current(0)
,fJoy_state(FALSE)
{}

HEPVis::SoSDL_Viewer::~SoSDL_Viewer(){}

void HEPVis::SoSDL_Viewer::setShootRegion(SoRegion* aRegion) {
  fShootRegion = aRegion;
}
void HEPVis::SoSDL_Viewer::setOptionsRegion(SoFormRegion* aRegion) {
  fUI = aRegion;  
}

SoRegion* HEPVis::SoSDL_Viewer::optionRegion() const {return fUI;}
SoRegion* HEPVis::SoSDL_Viewer::shootRegion() const {return fShootRegion;}

SbBool HEPVis::SoSDL_Viewer::showUI(SbBool& aRender) {
  aRender = FALSE;
  if(!fUI) return FALSE;
  if(fUI->visible.getValue()==FALSE) {
    fUI->visible.setValue(TRUE);  
    SoSimpleButton* button = getButton(fUI_current);
    if(!button) return FALSE;
    button->getBackStyle()->color.setValue(SbColor_red);
    aRender = TRUE;
    return TRUE;
  } else {
    fUI->visible.setValue(FALSE);  
    aRender = TRUE;
    return TRUE;
  }
}  
SbBool HEPVis::SoSDL_Viewer::uiVisible() const {
  if(!fUI) return FALSE;
  return fUI->visible.getValue();
}  
void HEPVis::SoSDL_Viewer::nextUI() {
 {SoSimpleButton* button = getButton(fUI_current);
  if(button) button->getBackStyle()->color.setValue(SbColor_white);}
  fUI_current++;
  if(fUI_current>=fUI->shapes.getNum()) fUI_current = 0;
  SoSimpleButton* button = getButton(fUI_current);
  if(button) button->getBackStyle()->color.setValue(SbColor_red);
}
void HEPVis::SoSDL_Viewer::prevUI() {
 {SoSimpleButton* button = getButton(fUI_current);
  if(button) button->getBackStyle()->color.setValue(SbColor_white);}
  fUI_current--;
  if(fUI_current<0) fUI_current = fUI->shapes.getNum()-1;
  SoSimpleButton* button = getButton(fUI_current);
  if(button) button->getBackStyle()->color.setValue(SbColor_red);
}
SbBool HEPVis::SoSDL_Viewer::activateUI(SbBool aDown) {
  if(!fUI) return FALSE;
  if(fUI->visible.getValue()==FALSE) return FALSE;
  if(fUI_current==-1) return FALSE;
  if(aDown==TRUE) return TRUE; //invokeCallbacks button on up only.
  SoSimpleButton* button = getButton(fUI_current);
  if(!button) return FALSE;
  button->invokeCallbacks();
  return TRUE;
}
SbBool HEPVis::SoSDL_Viewer::showShoot(SbBool& aRender) {
  aRender = FALSE;
  if(!fShootRegion) return FALSE;
  fShootRegion->visible.setValue
    (fShootRegion->visible.getValue()==FALSE?TRUE:FALSE);
  aRender = TRUE;
  return TRUE;
}
SbBool HEPVis::SoSDL_Viewer::activate(SbBool aDown,SbBool& aRender) {
  if(activateUI(aDown)==TRUE) {
    aRender = TRUE;
    return TRUE;
  } else {
    if(fShootRegion) {
      if(fShootRegion->visible.getValue()==TRUE) {
        const SbVec2s& win = getViewportRegion().getWindowSize();
        SbVec2s pos(win[0]/2,win[1]/2);
        if(aDown==TRUE) {
	  SoSDL::emulateLeftButtonDown(pos);
          aRender = TRUE;
          return TRUE;
        } else {
	  SoSDL::emulateLeftButtonUp(pos);
          aRender = TRUE;
          return TRUE;
        }
      } else { 
        return FALSE;
      }
    } else {
      return FALSE;
    }
  }
}
SoSimpleButton* HEPVis::SoSDL_Viewer::getButton(int aIndex) {
  if(!fUI) return 0;
  int shapen = fUI->shapes.getNum();
  if(shapen<=0) return 0;
  if((aIndex<0)||(aIndex>=shapen) ) return 0;
  return (SoSimpleButton*)fUI->shapes[aIndex];
}
