#include <HEPVis/SbGL.h>

#include <stdio.h>

extern "C" {

#ifdef WIN32
#else
#define CALLBACK
#endif

typedef GLvoid(CALLBACK *Func)();

void CALLBACK beginCallback(GLenum aWhich,GLvoid * aThis)
{
  printf("debug : beginCallback : 000 %lu %d\n",aThis,aWhich);
}
void CALLBACK errorCallback(GLenum aErrorCode,GLvoid * aThis)
{
  printf("debug : errorCallback : 000\n");
  const GLubyte* estring = gluErrorString(aErrorCode);
  fprintf(stderr, "Tessellation Error: %s\n", estring);
}

void endCallback()
{
  printf("debug : endCallback : 000\n");
}

void CALLBACK vertexCallback(GLvoid *vertex,GLvoid* aThis)
{
  printf("debug : vertexCallback : 000\n");
}


/*  combineCallback is used to create a new vertex when edges intersect.
    coordinate location is trivial to calculate, but weight[4] may be used
    to average color, normal, or texture coordinate data.
    In this program, color is weighted. */
void CALLBACK combineCallback(GLdouble coords[3],
                     void*,
                     GLfloat,
                     GLdouble **dataOut,
                     GLvoid* aThis)
{
  printf("debug : combineCallback : 000\n");
}

}


int main() 
{

  for(int i=0;i<2;i++) {

  printf("debug : main : 001 : %d\n",i);

  GLUtesselator* tobj = gluNewTess();

  //WIN32 : it wants the reinterpret_cast.
  gluTessCallback(tobj, GLU_TESS_VERTEX_DATA,(Func)vertexCallback);
  gluTessCallback(tobj, GLU_TESS_BEGIN_DATA,(Func)beginCallback);
  gluTessCallback(tobj, GLU_TESS_END,(Func)endCallback);
  gluTessCallback(tobj, GLU_TESS_ERROR_DATA,(Func)errorCallback);
  gluTessCallback(tobj, GLU_TESS_COMBINE_DATA,(Func)combineCallback);
  
  //gluTessProperty(tobj, GLU_TESS_WINDING_RULE,GLU_TESS_WINDING_ODD);

  double xxx1[33];
  double xxx2[33];
  double xxx3[33];
  double xxx4[33];
  double xxx5[33];

  gluTessBeginPolygon(tobj, 0);
  gluTessBeginContour(tobj);

  xxx1[0] = 0;
  xxx1[1] = 0;
  xxx1[2] = 0;
  gluTessVertex(tobj, xxx1,0);

  xxx2[0] = 1;
  xxx2[1] = 0;
  xxx2[2] = 0;
  gluTessVertex(tobj, xxx2,0);

  xxx3[0] = 1;
  xxx3[1] = 1;
  xxx3[2] = 0;
  gluTessVertex(tobj, xxx3,0);

  xxx4[0] = 0;
  xxx4[1] = 1;
  xxx4[2] = 0;
  gluTessVertex(tobj, xxx4,0);

  xxx5[0] = 0;
  xxx5[1] = 1.5;
  xxx5[2] = 0;
  gluTessVertex(tobj, xxx5,0);

  gluTessEndContour(tobj);

  printf("debug : main : gluTessEndPolygon : begin\n");
  gluTessEndPolygon(tobj);
  printf("debug : main : gluTessEndPolygon : end\n");

  gluDeleteTess(tobj);

  }

  return 0;
}
