#include <Lib/Arguments.h>
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/fmanip.h>

#include <stdlib.h>
#include <stdio.h>
//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);
  Lib::Arguments args(aArgc,aArgv);
#ifdef WIN32
  bool verbose = args.isAnArgument("-verbose");
  std::vector<std::string> text;
  Lib::fmanip::read("CVS/Root",text);
  if(text.size()!=1) {
    out << "Lib_cvsroot :"
        << " CVS/Root contains more than one line !"
        << Lib::endl;
    return EXIT_FAILURE;
  }
  if(verbose) {
    out << "Lib_cvsroot :"
        << " CVS/Root first line is \"" << text[0] << "\""
        << Lib::endl;
  }        
  FILE* file = ::fopen("setcvsroot.bat","wb");
  if(!file) return EXIT_FAILURE;
  fprintf(file,"set CVSROOT=%s\n",text[0].c_str());
  ::fclose(file);
  if(verbose) {
    out << "Lib_cvsroot :"
        << " file setcvsroot.bat created."
        << Lib::endl;
  }        
  return EXIT_SUCCESS;
#else
    out << "Lib_cvsroot :"
        << " Apply only on Windows/DOS." << Lib::endl;
#endif
}
