#ifndef Lib_DLL_h
#define Lib_DLL_h

#include <string>
#include <ostream>

namespace Lib {

typedef void (*Procedure)();

class DLL {
public:
  static bool isValid(const std::string&,std::ostream&);
public:
  DLL(const std::string&,std::ostream&,int = 0,bool = false);
  virtual ~DLL();
  bool open();
  Procedure findProcedure(const std::string&,bool quiet = false) const;
  void execute(const std::string&);
  const std::string& fileName() const;
  bool isOpened() const;
protected:
  void* fModule;
  std::ostream& fOut;
  std::string fName;
  std::string fDLL;
  int fVerboseLevel;
  std::string fError;
};

}

#endif




