#ifndef Lib_FortranOut_h
#define Lib_FortranOut_h

#include <Lib/FortranFormat.h>
#include <Lib/smanip.h>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class sout;

class FortranOut;
typedef FortranOut& (*FortranOutFunc)(FortranOut&); //For Lib::endl.

class FortranOut {
public:
  FortranOut(Slash::Core::IWriter&,const std::string&,int = 0);
  virtual ~FortranOut();
private:
  FortranOut(const FortranOut&);
  FortranOut& operator =(const FortranOut&);
public:
  FortranOut& operator<<(const char*);
  FortranOut& operator<<(const std::string&);
  FortranOut& operator<<(bool);
  FortranOut& operator<<(int);
  FortranOut& operator<<(double);
  FortranOut& operator<<(float);
  FortranOut& operator<<(long);
  FortranOut& operator<<(unsigned int);
  FortranOut& operator<<(unsigned long);
  FortranOut& operator<<(const void*);
  FortranOut& operator<<(FortranOutFunc);
  FortranOut& operator<<(char);
  FortranOut& operator<<(const std::vector<double>&);
public:
  Slash::Core::IWriter& writer() const;
  void reset();
  bool status() const;
private:
  DataDescriptor* next();
private:
  Slash::Core::IWriter& fWriter;
  int fVerboseLevel;
  std::string fFormat;
  FortranFormat fParser;
  DataDescriptorIterator* fIterator;
  DataDescriptor* fNext;
  smanip f_smanip;
  bool fStatus;
};

FortranOut& endl(FortranOut&);

}

#endif
