// this :
#include <Lib/Expression.h>

#include <Lib/Debug.h>
#include <Lib/Out.h>
#include <Lib/smanip.h>
#include <Lib/Functions.h>
#include <Lib/mmanip.h>
#include <Lib/valuemanip.h>
#include <Lib/Array.h>
#include <Lib/IExpFunc.h>

#include <math.h>

#define NotFound (-1)

//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
)
:fType(aType)
,fFunction(0)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Expression* aA
)
:fType(aType)
,fFunction(0)
,fIndex(NotFound)
,fA(aA),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Expression* aA
,Expression* aB
)
:fType(aType)
,fFunction(0)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Lib::IExpFunc* aFunction
,Expression* aA
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Lib::IExpFunc* aFunction
,Expression* aA
,Expression* aB
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Lib::IExpFunc* aFunction
,Expression* aA
,Expression* aB
,Expression* aC
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Lib::IExpFunc* aFunction
,Expression* aA
,Expression* aB
,Expression* aC
,Expression* aD
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(aD),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Lib::IExpFunc* aFunction
,Expression* aA
,Expression* aB
,Expression* aC
,Expression* aD
,Expression* aE
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(aD),fE(aE),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,Lib::IExpFunc* aFunction
,Expression* aA
,Expression* aB
,Expression* aC
,Expression* aD
,Expression* aE
,Expression* aF
)
:fType(aType)
,fFunction(aFunction)
,fIndex(NotFound)
,fA(aA),fB(aB),fC(aC),fD(aD),fE(aE),fF(aF)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,unsigned int aNumber
)
:fType(aType)
,fFunction(0)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
  fVariable.set(aNumber);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,double aNumber
)
:fType(aType)
,fFunction(0)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
  fVariable.set(aNumber);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,const std::string& aString
)
:fType(aType)
,fFunction(0)
,fIndex(NotFound)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
  fVariable.set(aString);
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::Expression(
 eType aType
,const std::string& aName
,int aIndex
)
:fType(aType)
,fFunction(0)
,fName(aName)
,fIndex(aIndex)
,fA(0),fB(0),fC(0),fD(0),fE(0),fF(0)
//////////////////////////////////////////////////////////////////////////////
// aName needed to not confuse with the constructor (eType,unsigned int).
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Debug::increment("Lib::Expression");
}
//////////////////////////////////////////////////////////////////////////////
Lib::Expression::~Expression(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fA;
  delete fB;
  delete fC;
  delete fD;
  delete fE;
  delete fF;
  Debug::decrement("Lib::Expression");
}
/*
//////////////////////////////////////////////////////////////////////////////
void Lib::Expression::print(
 Slash::Core::IWriter& aPrinter
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Out out(aPrinter);
  out << "Type : " << this << " " << (int)fType << endl;
  if(!fVariable.is_none()) fVariable.print(aPrinter);
  if(fA) fA->print(aPrinter);
  if(fB) fB->print(aPrinter);
}
*/
//////////////////////////////////////////////////////////////////////////////
Lib::Value& Lib::Expression::ret(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fReturn;
}
extern "C" {
  typedef double(*Func)(double);
}

#define EXEC(aExpression)\
  if(!(aExpression)->execute(aInput,aError)) {\
    fReturn.setNone();\
    return false;\
  }

#define OPER(aOperation,aArg)\
 {if(!Lib::valuemanip::aOperation(fReturn,aArg,aError)) {\
    fReturn.setNone();\
    return false;\
  }}

#define OPERU(aOperation)\
 {if(!Lib::valuemanip::aOperation(fReturn,aError)) {\
    fReturn.setNone();\
    return false;\
  }}

//////////////////////////////////////////////////////////////////////////////
bool Lib::Expression::execute(
 const std::vector<Lib::Value>& aInput
,std::string& aError //Inited by the caller to optimize.
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //FIXME : handle ret values of execute().
  switch(fType) {
  case GT:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_gt,fB->ret())
    return true;
  case GE:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_ge,fB->ret())
    return true;
  case LT:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_lt,fB->ret())
    return true;
  case LE:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_le,fB->ret())
    return true;
  case EQ:
    if(!fA || !fB) break;
   {EXEC(fA)
    EXEC(fB)
    Lib::Value& va = fA->ret();
    Lib::Value& vb = fB->ret();
    if( (fA->fType==NAME) && 
        (va.type()==Slash::Core::IValue::STRING) &&
        (vb.type()==Slash::Core::IValue::STRING) ){
      fReturn.set(smanip::match(va.get_string(),vb.get_string()));
      return true;
    } else {
      fReturn = va;
      OPER(if_eq,vb)
      return true;
    }}
  case NE:
    if(!fA || !fB) break;
   {EXEC(fA)
    EXEC(fB)
    Lib::Value& va = fA->ret();
    Lib::Value& vb = fB->ret();
    if( (fA->fType==NAME) && 
        (va.type()==Slash::Core::IValue::STRING) &&
        (vb.type()==Slash::Core::IValue::STRING) ){
      fReturn.set(smanip::match(va.get_string(),
                                vb.get_string())?false:true);
      return true;
    } else {
      fReturn = va;
      OPER(if_ne,vb)
      return true;
    }}
  case AND:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_and,fB->ret());
    return true;
  case OR:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(if_or,fB->ret());
    return true;
  case NOT:
    if(!fA) break;
    EXEC(fA)
    fReturn = fA->ret();
    OPERU(do_not)
    return true;
  case ASSIGN:
    if(!fA) break;
    EXEC(fA)
    fReturn = fA->ret(); //FIXME : or fReturn.assign(fA->ret()); ???
    return true;
  case ADD:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(add,fB->ret())
    return true;
  case MUL:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(multiply,fB->ret())
    return true;
  case SUB:
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(subtract,fB->ret())
    return true;
  case DIV:{
    if(!fA || !fB) break;
    EXEC(fA)
    EXEC(fB)
    fReturn = fA->ret();
    OPER(divide,fB->ret())
    return true;
  case MINUS:
    if(!fA) break;
    EXEC(fA)
    fReturn = fA->ret();
    OPERU(minus)
    return true;
  case NAME:
    if( (fIndex<0) || (fIndex>=(int)aInput.size()) ) {
      aError = std::string("Expression::execute : index out of range")
             + " " + Lib::smanip::tostring((int)fIndex)
             + " range [0," + Lib::smanip::tostring((int)aInput.size())
             + "] for variable "+fName+".";
      fReturn.setNone();
      return false;
    }
    fReturn = aInput[fIndex];
    return true;
  case UNSIGNED_INTEGER:
  case REAL:
  case STRING:
    fReturn = fVariable;
    return true;
  case PI:
    fReturn.set(Lib::mmanip::pi());
    return true;
  case BOOL_TRUE:
    fReturn.set(true);
    return true;
  case BOOL_FALSE:
    fReturn.set(false);
    return true;
  case FUNC:
    if(!fA) break;
    if(!fFunction) {
      aError = std::string("Expression::execute : null function");
      fReturn.setNone();
      return false;
    }
   {std::vector<Lib::Value> args;

    EXEC(fA)
    args.push_back(fA->ret());

    unsigned int argn = fFunction->numberOfArguments();
    if(argn==1) {
    } else if(argn==2) {
      if(!fB) break;
      EXEC(fB)
      args.push_back(fB->ret());
    } else if(argn==3) {
      if(!fB || !fC) break;
      EXEC(fB)
      EXEC(fC)
      args.push_back(fB->ret());
      args.push_back(fC->ret());
    } else if(argn==4) {
      if(!fB || !fC || !fD) break;
      EXEC(fB)
      EXEC(fC)
      EXEC(fD)
      args.push_back(fB->ret());
      args.push_back(fC->ret());
      args.push_back(fD->ret());
    } else if(argn==5) {
      if(!fB || !fC || !fD || !fE) break;
      EXEC(fB)
      EXEC(fC)
      EXEC(fD)
      EXEC(fE)
      args.push_back(fB->ret());
      args.push_back(fC->ret());
      args.push_back(fD->ret());
      args.push_back(fE->ret());
    } else if(argn==6) {
      if(!fB || !fC || !fD || !fE || !fF) break;
      EXEC(fB)
      EXEC(fC)
      EXEC(fD)
      EXEC(fE)
      EXEC(fF)
      args.push_back(fB->ret());
      args.push_back(fC->ret());
      args.push_back(fD->ret());
      args.push_back(fE->ret());
      args.push_back(fF->ret());
    }
    return fFunction->eval(args,fReturn,aError);
    }
  }
  }
  aError = std::string("Expression::execute : Can't apply on type ")
         + Lib::smanip::tostring((int)fType) + " : bad return value.";
  fReturn.setNone();
  return false;
}
