// this :
#include <Lib/FString.h>

#include <string.h>

#define MINIMUM(a,b)            ((a)<(b)?a:b)

// fString is not null terminated.

//////////////////////////////////////////////////////////////////////////////
Lib::FString::FString(
 unsigned aLength
)
:fLength(aLength)
,fString(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLength = fLength==0 ? 1 : fLength; // in fortran character*0 does not exist
  fString = new char[fLength];
  if(!fString) {fLength = 0;return;}
  for(unsigned int index=0;index<fLength;index++) fString[index] = ' ';
}
//////////////////////////////////////////////////////////////////////////////
Lib::FString::FString(
 const std::string& aString
)
:fLength(0)
,fString(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fLength = aString.size();
  fLength = fLength==0 ? 1 : fLength; // in fortran character*0 does not exist
  // Add one more white character so that CERNLIB LENOCC works :
  fString = new char[fLength+1];
  if(!fString) {fLength = 0;return;}
  unsigned int l = fLength + 1;
  for(unsigned int index=0;index<l;index++) fString[index] = ' ';
  ::strncpy(fString,aString.c_str(),aString.size());
}     
//////////////////////////////////////////////////////////////////////////////
Lib::FString::FString(
 void* aF77
,int aLength
)
:fLength(0)
,fString(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aLength<0) return;
  fLength = aLength;
  fLength = fLength==0 ? 1 : fLength; // in fortran character*0 does not exist
  // Add one more white character so that CERNLIB LENOCC works :
  fString = new char[fLength+1];
  if(!fString) {fLength = 0;return;}
  unsigned int l = fLength + 1;
  for(unsigned int index=0;index<l;index++) fString[index] = ' ';
  ::strncpy(fString,(char*)aF77,aLength);
}     
//////////////////////////////////////////////////////////////////////////////
Lib::FString::~FString(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete [] fString;
}
//////////////////////////////////////////////////////////////////////////////
char* Lib::FString::f_str(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fString;
}     
//////////////////////////////////////////////////////////////////////////////
unsigned int Lib::FString::size(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLength;
}     
//////////////////////////////////////////////////////////////////////////////
std::string Lib::FString::std_string(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string s;
  for(unsigned int index=0;index<fLength;index++) s += fString[index];
  return s;
}     
