// this :
#include <Lib/OpaqueManager.h>

#include <Lib/Cast.h>

//////////////////////////////////////////////////////////////////////////////
Lib::OpaqueProxy::OpaqueProxy(
 OpaqueManager& aManager
,void* aObject
,const std::string& aID
,bool aOwner
)
:fManager(aManager)
,fObject(aObject)
,fID(aID)
,fOwner(aOwner) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::OpaqueProxy::OpaqueProxy(
 const OpaqueProxy& aProxy
)
:fManager(aProxy.fManager)
,fObject(aProxy.fObject)
,fID(aProxy.fID)
,fOwner(aProxy.fOwner) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::OpaqueProxy::~OpaqueProxy(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::OpaqueProxy& Lib::OpaqueProxy::operator=(
 const OpaqueProxy& aProxy
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fObject = aProxy.fObject;
  fID = aProxy.fID;
  fOwner = aProxy.fOwner;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::OpaqueProxy::isOwner(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fOwner;
}
//////////////////////////////////////////////////////////////////////////////
void* Lib::OpaqueProxy::object(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fObject;
}
//////////////////////////////////////////////////////////////////////////////
const std::string& Lib::OpaqueProxy::identifier(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  return fID;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::operator==(
 const OpaqueProxy& aA
,const OpaqueProxy& aB
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aA.object()!=aB.object()) return false;
  if(aA.identifier()!=aB.identifier()) return false;
  if(aA.isOwner()!=aB.isOwner()) return false;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::OpaqueManager::OpaqueManager(
 const std::string& aName
)
:fName(aName) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::OpaqueManager::~OpaqueManager(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
std::string Lib::OpaqueManager::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
void* Lib::OpaqueManager::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Slash::Core::IManager)
  else if_Lib_SCast(Slash::Core::IOpaqueManager)
  else return 0;
}
//////////////////////////////////////////////////////////////////////////////
void* Lib::OpaqueManager::find(
 const std::string& aName
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::list<OpaqueProxy>::const_iterator it;
  for(it=fList.begin();it!=fList.end();++it) {
    if(aName==(*it).identifier()) return (*it).object();
  }
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::OpaqueManager::add(
 void* aObject
,const std::string& aName
,bool aOwner
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fList.push_back(OpaqueProxy(*this,aObject,aName,aOwner));
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::OpaqueManager::isOwner(
 const std::string& aName
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::list<OpaqueProxy>::const_iterator it;
  for(it=fList.begin();it!=fList.end();++it) {
    if(aName==(*it).identifier()) return (*it).isOwner();
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::OpaqueManager::destroy(
 const std::string& aName
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::list<OpaqueProxy>::const_iterator it;
  for(it=fList.begin();it!=fList.end();++it) {
    if(aName==(*it).identifier()) {
      fList.remove(*it);
      return true;
    }
  }
  return false;
}

