// Not tested and not used for the moment.

// this :
#include <Lib/RandomFromFunction.h>

// From the "ROOT of EVERYTHING" TF1 code.
// (Then probably wrong somewhere).

#include <Slash/Data/IFunction.h>
#include <Lib/Randoms.h>
#include <Lib/Out.h>

#include <vector>
#include <math.h>

static int BinarySearch(int,const double*,double);

//////////////////////////////////////////////////////////////////////////////
Lib::RandomFromFunction::RandomFromFunction(
 Slash::Data::IFunction& aFunction
,int aNpx
,double aXmin
,double aXmax
,Slash::Core::IWriter& aPrinter
)
:fFunction(aFunction)
,fPrinter(aPrinter)
,fNpx(aNpx)
,fXmin(aXmin)
,fXmax(aXmax)
,fIntegral(0)
,fAlpha(0)
,fBeta(0)
,fGamma(0)
,fRandomFlat(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib::RandomFromFunction::~RandomFromFunction(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  clear();
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::RandomFromFunction::isValid(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fIntegral?true:false;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::RandomFromFunction::clear(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(fIntegral) delete [] fIntegral;
  if(fAlpha) delete [] fAlpha;
  if(fBeta) delete [] fBeta;
  if(fGamma) delete [] fGamma;
  if(fRandomFlat) delete fRandomFlat;

  fIntegral = 0;
  fAlpha = 0;
  fBeta = 0;
  fGamma = 0;
  fRandomFlat = 0;

  fNpx = 0;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::RandomFromFunction::reset(
 int aNpx
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  clear();

  if(aNpx<=0) return false;

  fNpx = aNpx;

  double dx = (fXmax-fXmin)/fNpx;

  fIntegral = new double[fNpx+1];
  fAlpha    = new double[fNpx];
  fBeta     = new double[fNpx];
  fGamma    = new double[fNpx];
  fIntegral[0] = 0;
  int intNegative = 0;
  int i;
  double epsilon = 0.000001;
  for (i=0;i<fNpx;i++) {
    double integ;
    if(!integrate(double(fXmin+i*dx), double(fXmin+i*dx+dx),epsilon,integ)) {
      clear();
      return false;
    }
    if (integ < 0) {intNegative++; integ = -integ;}
    fIntegral[i+1] = fIntegral[i] + integ;
  }
  if (intNegative > 0) {
    Lib::Out out(fPrinter);
    out << "Lib::RandomFromFunction::reset :"
        << " WARNING : function has " << intNegative 
        << " negative values. abs assumed."
        << Lib::endl;
  }
  if (fIntegral[fNpx] == 0) {
    Lib::Out out(fPrinter);
    out << "Lib::RandomFromFunction::reset :"
        << " ERROR : integral of function is zero."
        << Lib::endl;
    clear();
    return false;
  }
  double total = fIntegral[fNpx];
  for (i=1;i<=fNpx;i++) {  // normalize integral to 1
    fIntegral[i] /= total;
  }
  //the integral r for each bin is approximated by a parabola
  //  x = alpha + beta*r + gamma*r**2
  // compute the coefficients alpha, beta, gamma for each bin
  for (i=0;i<fNpx;i++) {
    double x0 = fXmin+i*dx;
    double r2 = fIntegral[i+1] - fIntegral[i];
    double r1;
    if(!integrate(x0,x0+0.5*dx,epsilon,r1)) {
      clear();
      return false;
    }
    r1 /= total;
    fGamma[i] = (2*r2 - 4*r1)/(dx*dx);
    fBeta[i]  = r2/dx - fGamma[i]*dx;
    fAlpha[i] = x0;
    fGamma[i] *= 2;
  }

  fRandomFlat = new RandomFlat();

  return true;
}
//////////////////////////////////////////////////////////////////////////////
double Lib::RandomFromFunction::shoot(
)
//////////////////////////////////////////////////////////////////////////////
// Return a random number following this function shape
//
//   The distribution contained in the IFunction is integrated
//   over the channel contents.
//   It is normalized to 1.
//   For each bin the integral is approximated by a parabola.
//   The parabola coefficients are stored as non persistent data members
//   Getting one random number implies:
//     - Generating a random number between 0 and 1 (say r1)
//     - Look in which bin in the normalized integral r1 corresponds to
//     - Evaluate the parabolic curve in the selected bin to find
//       the corresponding X value.
//   The parabolic approximation is very good as soon as the number
//   of bins is greater than 50.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!isValid()) return 0; //Not initialized.

  double r  = fRandomFlat->shoot();
  int bin  = BinarySearch(fNpx,fIntegral,r);
  double rr = r - fIntegral[bin];

  double xx;
  if(fGamma[bin])
    xx = (-fBeta[bin] + ::sqrt(fBeta[bin]*fBeta[bin]+2*fGamma[bin]*rr))/fGamma[bin];
  else
    xx = rr/fBeta[bin];

  double x = fAlpha[bin] + xx;
  return x;
}
/*
//______________________________________________________________________________
double TF1::GetRandom(double xmin, double xmax)
{
// Return a random number following this function shape in [xmin,xmax]
//
//   The distribution contained in the function fname (TF1) is integrated
//   over the channel contents.
//   It is normalized to 1.
//   For each bin the integral is approximated by a parabola.
//   The parabola coefficients are stored as non persistent data members
//   Getting one random number implies:
//     - Generating a random number between 0 and 1 (say r1)
//     - Look in which bin in the normalized integral r1 corresponds to
//     - Evaluate the parabolic curve in the selected bin to find
//       the corresponding X value.
//   The parabolic approximation is very good as soon as the number
//   of bins is greater than 50.
//
//  IMPORTANT NOTE
//  The integral of the function is computed at fNpx points. If the function
//  has sharp peaks, you should increase the number of points (SetNpx)
//  such that the peak is correctly tabulated at several points.

//  Check if integral array must be build
   if (fIntegral == 0) {
      double dx = (fXmax-fXmin)/fNpx;
      fIntegral = new double[fNpx+1];
      fAlpha    = new double[fNpx];
      fBeta     = new double[fNpx];
      fGamma    = new double[fNpx];
      fIntegral[0] = 0;
      double integ;
      int intNegative = 0;
      int i;
      for (i=0;i<fNpx;i++) {
         integ = integrate(double(fXmin+i*dx), double(fXmin+i*dx+dx));
         if (integ < 0) {intNegative++; integ = -integ;}
         fIntegral[i+1] = fIntegral[i] + integ;
      }
      if (intNegative > 0) {
         Warning("GetRandom","function:%s has %d negative values: abs assumed",GetName(),intNegative);
      }
      if (fIntegral[fNpx] == 0) {
         Error("GetRandom","Integral of function is zero");
         return 0;
      }
      double total = fIntegral[fNpx];
      for (i=1;i<=fNpx;i++) {  // normalize integral to 1
         fIntegral[i] /= total;
      }
      //the integral r for each bin is approximated by a parabola
      //  x = alpha + beta*r +gamma*r**2
      // compute the coefficients alpha, beta, gamma for each bin
      double x0,r1,r2;
      for (i=0;i<fNpx;i++) {
         x0 = fXmin+i*dx;
         r2 = fIntegral[i+1] - fIntegral[i];
         r1 = integrate(x0,x0+0.5*dx)/total;
         fGamma[i] = (2*r2 - 4*r1)/(dx*dx);
         fBeta[i]  = r2/dx - fGamma[i]*dx;
         fAlpha[i] = x0;
         fGamma[i] *= 2;
      }
   }


// return random number
   double dx   = (fXmax-fXmin)/fNpx;
   int nbinmin = (int)((xmin-fXmin)/dx);
   int nbinmax = (int)((xmax-fXmin)/dx)+2;
   if(nbinmax>fNpx) nbinmax=fNpx;
   
   double pmin=fIntegral[nbinmin];
   double pmax=fIntegral[nbinmax];

   double r,x,xx,rr;
   do {
      r  = gRandom->Uniform(pmin,pmax);

      int bin  = BinarySearch(fNpx,fIntegral,r);
      rr = r - fIntegral[bin];

      if(fGamma[bin])
         xx = (-fBeta[bin] + ::sqrt(fBeta[bin]*fBeta[bin]+2*fGamma[bin]*rr))/fGamma[bin]; 
      else
         xx = rr/fBeta[bin];
      x = fAlpha[bin] + xx;
   } while(x<xmin || x>xmax);
   return x;
}

*/

//////////////////////////////////////////////////////////////////////////////
bool Lib::RandomFromFunction::integrate(
 double aA
,double aB
,double aEpsilon
,double& aValue
) const
//////////////////////////////////////////////////////////////////////////////
// Return Integral of function between a and b
//
// Based on original CERNLIB routine DGAUSS by Sigfried Kolbig.
// Converted to ROOT/C++ by Rene Brun.
// Extracted from the ROOT mess by Guy Barrand.
//
// aA,aB : End-points of integration interval. Note that aB may be less than aA
// aEpsilon : Accuracy parameter.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  const double Z1 = 1;
  const double HF = Z1/2;
  const double CST = 5*Z1/1000;

  double x[12] = { 0.96028985649753623,  0.79666647741362674,
                   0.52553240991632899,  0.18343464249564980,
                   0.98940093499164993,  0.94457502307323258,
                   0.86563120238783174,  0.75540440835500303,
                   0.61787624440264375,  0.45801677765722739,
                   0.28160355077925891,  0.09501250983763744};

  double w[12] = { 0.10122853629037626,  0.22238103445337447,
                   0.31370664587788729,  0.36268378337836198,
                   0.02715245941175409,  0.06225352393864789,
                   0.09515851168249278,  0.12462897125553387,
                   0.14959598881657673,  0.16915651939500254,
                   0.18260341504492359,  0.18945061045506850};

  std::vector<double> xx(1);

  double h = 0;
  if (aB == aA) {
    aValue = h;
    return true;
  }
  double aconst = CST/::fabs(aB-aA);
  double bb = aA;
CASE1:
  double aa = bb;
  bb = aB;
CASE2:
  double c1 = HF*(bb+aa);
  double c2 = HF*(bb-aa);
  double s8 = 0;
  int i;
  double u, f1, f2;
  for (i=0;i<4;i++) {
     u     = c2*x[i];
     xx[0] = c1+u;     
     if(!fFunction.value(xx,f1)) {
       aValue = 0;
       return false;
     }
     xx[0] = c1-u;
     if(!fFunction.value(xx,f2)) {
       aValue = 0;
       return false;
     }
     s8   += w[i]*(f1 + f2);
  }
  double s16 = 0;
  for (i=4;i<12;i++) {
     u     = c2*x[i];
     xx[0] = c1+u;
     if(!fFunction.value(xx,f1)) { 
       aValue = 0;
       return false;
     }
     xx[0] = c1-u;
     if(!fFunction.value(xx,f2)) {
       aValue = 0;
       return false;
     }
     s16  += w[i]*(f1 + f2);
  }
  s16 = c2*s16;
  if (::fabs(s16-c2*s8) <= aEpsilon*(1. + ::fabs(s16))) {
     h += s16;
     if(bb != aB) goto CASE1;
  } else {
     bb = c1;
     if(1. + aconst * ::fabs(c2) != 1) goto CASE2;
     h = s8;  //this is a crude approximation (cernlib function returned 0 !)
  }
  aValue = h;
  return true;
}

// From the "ROOT of EVERYTHING" TMath code.
// (Then probably wrong somewhere).

//////////////////////////////////////////////////////////////////////////////
int BinarySearch(
 int aNumber
,const double* aArray
,double aValue
)
//////////////////////////////////////////////////////////////////////////////
// Binary search in an array of n values to locate value.
//
// Array is supposed  to be sorted prior to this call.
// If match is found, function returns position of element.
// If no match found, function gives nearest element smaller than value.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  int nabove = aNumber + 1;
  int nbelow = 0;
  while(nabove-nbelow > 1) {
     int middle = (nabove+nbelow)/2;
     if (aValue == aArray[middle-1]) return middle-1;
     if (aValue  < aArray[middle-1]) nabove = middle;
     else nbelow = middle;
  }
  return nbelow-1;
}
