// this :
#include <Lib/StreamBuffer.h>

#include <Slash/Core/IWriter.h>

#include <string.h> //memcpy

Lib::StreamBuffer::StreamBuffer(Slash::Core::IWriter& aPrinter)
:fPrinter(aPrinter)
,fBuffer(0)
,fSize(4095)
,fCount(0)
{
  fBuffer = new char[fSize+1];
}
Lib::StreamBuffer::~StreamBuffer() {delete [] fBuffer;}

Lib::StreamBuffer::StreamBuffer(const StreamBuffer& aFrom)
:fPrinter(aFrom.fPrinter)
,fBuffer(0)
,fSize(aFrom.fSize)
,fCount(0)
{
  fBuffer = new char[fSize+1];
}

Lib::StreamBuffer& Lib::StreamBuffer::operator=(const StreamBuffer& aFrom){
  delete [] fBuffer;
  fSize = aFrom.fSize;
  fBuffer = new char[fSize+1];
  ::memcpy(fBuffer,aFrom.fBuffer,fSize+1);
  fCount = aFrom.fCount;
  return *this;
}

int Lib::StreamBuffer::overflow(int aChar) {
  int result = 0;
  if(fCount>=fSize) {
    fBuffer[fCount] = '\0';
    fCount = 0;
    result = receiveString();
  }
  fBuffer[fCount] = aChar;
  fCount++;
  if(aChar=='\n') {
    fBuffer[fCount] = '\0';
    fCount = 0;
    result = receiveString();
  }
  return result;
}
int Lib::StreamBuffer::sync() {
  fBuffer[fCount] = '\0';
  fCount = 0;
  return receiveString ();
}
#ifdef WIN32
int Lib::StreamBuffer::underflow() {return 0;}
#endif

int Lib::StreamBuffer::receiveString() {
  std::string stringToSend = fBuffer;
  fPrinter.write(stringToSend);
  return 0;
}
