
extern "C" {
  void Lib_Test_Init();
}

//////////////////////////////////////////////////////////////////////////////
void Lib_Test_Init(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}

#ifdef DEBUG

#include <Lib/Out.h>
#include <Lib/Cast.h>

#include <string>
#include <vector>
#include <map>

typedef std::vector<std::string> TestStdVector;

class Xxx {};
typedef std::map<std::string,Xxx*,std::less<std::string> > TestStdMap;

extern "C" {
void Lib_Test(Slash::Core::IWriter&);
}

std::string sString = "hello";
TestStdMap sMap;

//////////////////////////////////////////////////////////////////////////////
void Test(
 Slash::Core::IWriter& aPrinter
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Out out(aPrinter);
  out << "In Test function : test std::vector and std::map." << Lib::endl;
  TestStdVector testStdVector;
  TestStdMap testStdMap;
}

#include <Slash/Core/ISession.h>
#include <Slash/Core/IManager.h>

class Lib_TestManager : public Slash::Core::IManager {
public: //Slash::Core::IManager :
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public:
  Lib_TestManager(Slash::Core::ISession&,int,char**);
  virtual ~Lib_TestManager();
private:
  Slash::Core::ISession& fSession;
  std::string fName;
};
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
extern "C" {
Slash::Core::IManager* LibTestFactory(Slash::Core::ISession&,int,char**);
}
//////////////////////////////////////////////////////////////////////////////
Slash::Core::IManager* LibTestFactory(
 Slash::Core::ISession& aSession
,int aArgc
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return new Lib_TestManager(aSession,aArgc,aArgv);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
Lib_TestManager::Lib_TestManager(
 Slash::Core::ISession& aSession
,int //aArgc
,char** //aArgv
)
:fSession(aSession)
,fName("TestManager")
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Lib_TestManager::~Lib_TestManager(
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
}
//////////////////////////////////////////////////////////////////////////////
std::string Lib_TestManager::name(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fName;
}
//////////////////////////////////////////////////////////////////////////////
void* Lib_TestManager::cast(
 const std::string& aClass
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if_Lib_SCast(Slash::Core::IManager)
  else return 0;
}

#ifdef WIN32
#include <windows.h>
#if defined(_MSC_VER)
#define DllEntryPoint DllMain
#endif
//////////////////////////////////////////////////////////////////////////////
BOOL WINAPI DllEntryPoint(
 HINSTANCE //hInst
,DWORD //reason
,LPVOID //reserved
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  printf("Lib/Test/DllEntryPoint\n");
  return TRUE;
}

#endif


#endif //DEBUG

