// this :
#include <Lib/Value.h>

#include <Lib/Cast.h>
#include <Lib/Debug.h>
#include <Lib/Array.h>

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void* Lib::Value::cast(const std::string& aClass) const {
  if_Lib_SCast(Slash::Core::IValue)
  else if_Lib_SCast(Lib::Value)
  else return 0;
}
Slash::Core::IValue::Type Lib::Value::type() const {
  return fType;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
unsigned char Lib::Value::get_unsigned_char() const {
  return u.f_unsigned_char;
}
char Lib::Value::get_char() const {
  return u.f_char;
}
Slash::int64 Lib::Value::get_int64() const {
  return u.f_int64;
}
Slash::uint64 Lib::Value::get_unsigned_int64() const {
  return u.f_unsigned_int64;
}
unsigned int Lib::Value::get_unsigned_int() const {
  return u.f_unsigned_int;
}
int Lib::Value::get_int() const {
  return u.f_int;
}
unsigned short Lib::Value::get_unsigned_short() const {
  return u.f_unsigned_short;
}
short Lib::Value::get_short() const {
  return u.f_short;
}
float Lib::Value::get_float() const {
  return u.f_float;
}
double Lib::Value::get_double() const {
  return u.f_double;
}
void* Lib::Value::get_void_star() const {
  return u.f_void_star;
}
double* Lib::Value::get_double_star() const {
  return u.f_double_star;
}
float* Lib::Value::get_float_star() const {
  return u.f_float_star;
}
int* Lib::Value::get_int_star() const {
  return u.f_int_star;
}
bool Lib::Value::get_bool() const {
  return u.f_bool;
}
std::string Lib::Value::get_string() const {
  return *u.f_string;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#define GET_ARRAY(a_what,a_get_what,a_f_what) \
const std::vector<a_what>& Lib::Value::a_get_what(\
 std::vector<unsigned int>& aOrders\
) const {\
  aOrders = u.a_f_what->orders();\
  return u.a_f_what->vector();\
}
GET_ARRAY(unsigned char,get_array_unsigned_char,f_array_unsigned_char)
GET_ARRAY(char,get_array_char,f_array_char)
GET_ARRAY(unsigned short,get_array_unsigned_short,f_array_unsigned_short)
GET_ARRAY(short,get_array_short,f_array_short)
GET_ARRAY(unsigned int,get_array_unsigned_int,f_array_unsigned_int)
GET_ARRAY(int,get_array_int,f_array_int)
GET_ARRAY(Slash::uint64,get_array_unsigned_int64,f_array_unsigned_int64)
GET_ARRAY(Slash::int64,get_array_int64,f_array_int64)
GET_ARRAY(float,get_array_float,f_array_float)
GET_ARRAY(double,get_array_double,f_array_double)
GET_ARRAY(bool,get_array_bool,f_array_bool)
GET_ARRAY(std::string,get_array_string,f_array_string)
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
std::vector<double>& Lib::Value::array_double(
) {
  return u.f_array_double->vector();
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
Lib::Value::Value()
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = NONE;
  u.f_unsigned_int64 = 0;
}
Lib::Value::Value(bool aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = BOOL;
  u.f_bool = aValue;
}
Lib::Value::Value(char aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = CHAR;
  u.f_char = aValue;
}
Lib::Value::Value(short aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = SHORT;
  u.f_short = aValue;
}
Lib::Value::Value(int aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = INT;
  u.f_int = aValue;
}
Lib::Value::Value(Slash::int64 aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = INT64;
  u.f_int64 = aValue;
}
Lib::Value::Value(Slash::uint64 aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = UNSIGNED_INT64;
  u.f_unsigned_int64 = aValue;
}
Lib::Value::Value(float aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = FLOAT;
  u.f_float = aValue;
}
Lib::Value::Value(double aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = DOUBLE;
  u.f_double = aValue;
}

Lib::Value::Value(unsigned char aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = UNSIGNED_CHAR;
  u.f_unsigned_char = aValue;
}
Lib::Value::Value(unsigned short aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = UNSIGNED_SHORT;
  u.f_unsigned_short = aValue;
}
Lib::Value::Value(unsigned int aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = UNSIGNED_INT;
  u.f_unsigned_int = aValue;
}
Lib::Value::Value(void* aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = VOID_STAR;
  u.f_void_star = aValue;
}
Lib::Value::Value(double* aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = DOUBLE_STAR;
  u.f_double_star = aValue;
}
Lib::Value::Value(float* aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = FLOAT_STAR;
  u.f_float_star = aValue;
}
Lib::Value::Value(int* aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = INT_STAR;
  u.f_int_star = aValue;
}
Lib::Value::Value(const char* aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = STRING;
  u.f_string = new std::string(aValue?aValue:"");
}
Lib::Value::Value(const std::string& aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = STRING;
  u.f_string = new std::string(aValue);
}
Lib::Value::Value(const std::vector<double>& aValue)
:fLabel(0)
,fDimension(0)
{
  Debug::increment("Lib::Value");
  fType = ARRAY_DOUBLE;
  std::vector<unsigned int> is(1);
  is[0] = aValue.size();
  u.f_array_double = new Array<double>(is);
  u.f_array_double->fill(aValue);
}

#define VALUE_ARRAY(a_what,a_f_what,a_type) \
Lib::Value::Value(\
 const std::vector<unsigned int>& aOrders\
,const std::vector<a_what>& aValues\
)\
:fLabel(0)\
,fDimension(0)\
{\
  Debug::increment("Lib::Value");\
  fType = a_type;\
  u.a_f_what = new Array<a_what>(aOrders);\
  u.a_f_what->fill(aValues);\
}

VALUE_ARRAY(unsigned char,f_array_unsigned_char,Slash::Core::IValue::ARRAY_UNSIGNED_CHAR)
VALUE_ARRAY(char,f_array_char,Slash::Core::IValue::ARRAY_CHAR)
VALUE_ARRAY(unsigned short,f_array_unsigned_short,Slash::Core::IValue::ARRAY_UNSIGNED_SHORT)
VALUE_ARRAY(short,f_array_short,Slash::Core::IValue::ARRAY_SHORT)
VALUE_ARRAY(unsigned int,f_array_unsigned_int,Slash::Core::IValue::ARRAY_UNSIGNED_INT)
VALUE_ARRAY(int,f_array_int,Slash::Core::IValue::ARRAY_INT)
VALUE_ARRAY(Slash::uint64,f_array_unsigned_int64,Slash::Core::IValue::ARRAY_UNSIGNED_INT64)
VALUE_ARRAY(Slash::int64,f_array_int64,Slash::Core::IValue::ARRAY_INT64)
VALUE_ARRAY(float,f_array_float,Slash::Core::IValue::ARRAY_FLOAT)
VALUE_ARRAY(double,f_array_double,Slash::Core::IValue::ARRAY_DOUBLE)
VALUE_ARRAY(bool,f_array_bool,Slash::Core::IValue::ARRAY_BOOL)
VALUE_ARRAY(std::string,f_array_string,Slash::Core::IValue::ARRAY_STRING)


Lib::Value::~Value(){ 
  delete fLabel;
  reset();
  Debug::decrement("Lib::Value");
}

#define CP_ARRAY(a_what,a_f_what,a_type) \
  } else if(aFrom.fType==a_type) {\
    u.a_f_what = new Array<a_what>(*aFrom.u.a_f_what);


Lib::Value::Value(
 const Value& aFrom
) 
:IValue()
,fLabel(0)
{
  Debug::increment("Lib::Value");

  if(aFrom.fLabel) fLabel = new std::string(*aFrom.fLabel);

  fDimension = aFrom.fDimension;

  fType = aFrom.fType;

  if(aFrom.fType==STRING) {
    u.f_string = new std::string(*aFrom.u.f_string);

  CP_ARRAY(unsigned char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
  CP_ARRAY(char,f_array_char,ARRAY_CHAR)
  CP_ARRAY(unsigned short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
  CP_ARRAY(short,f_array_short,ARRAY_SHORT)
  CP_ARRAY(unsigned int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
  CP_ARRAY(int,f_array_int,ARRAY_INT)
  CP_ARRAY(Slash::uint64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
  CP_ARRAY(Slash::int64,f_array_int64,ARRAY_INT64)
  CP_ARRAY(float,f_array_float,ARRAY_FLOAT)
  CP_ARRAY(double,f_array_double,ARRAY_DOUBLE)
  CP_ARRAY(bool,f_array_bool,ARRAY_BOOL)
  CP_ARRAY(std::string,f_array_string,ARRAY_STRING)

  } else {
    u = aFrom.u;
  }
}
Lib::Value& Lib::Value::operator=(const Value& aFrom) {

  delete fLabel;
  fLabel = 0;
  if(aFrom.fLabel) fLabel = new std::string(*aFrom.fLabel);

  fDimension = aFrom.fDimension;

  reset();

  fType = aFrom.fType;

  if(aFrom.fType==STRING) {
    u.f_string = new std::string(*aFrom.u.f_string);

  CP_ARRAY(unsigned char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
  CP_ARRAY(char,f_array_char,ARRAY_CHAR)
  CP_ARRAY(unsigned short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
  CP_ARRAY(short,f_array_short,ARRAY_SHORT)
  CP_ARRAY(unsigned int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
  CP_ARRAY(int,f_array_int,ARRAY_INT)
  CP_ARRAY(Slash::uint64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
  CP_ARRAY(Slash::int64,f_array_int64,ARRAY_INT64)
  CP_ARRAY(float,f_array_float,ARRAY_FLOAT)
  CP_ARRAY(double,f_array_double,ARRAY_DOUBLE)
  CP_ARRAY(bool,f_array_bool,ARRAY_BOOL)
  CP_ARRAY(std::string,f_array_string,ARRAY_STRING)

  } else {
    u = aFrom.u;
  }

  return *this;
}

#define RESET_ARRAY(a_f_what,a_type) \
  } else if(fType==a_type) {\
    delete u.a_f_what;\
    u.a_f_what = 0;

void Lib::Value::reset() {
  //FIXME : fDimension = 0; ???
  if(fType==STRING) {
    delete u.f_string;
    u.f_string = 0;

  RESET_ARRAY(f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
  RESET_ARRAY(f_array_char,ARRAY_CHAR)
  RESET_ARRAY(f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
  RESET_ARRAY(f_array_short,ARRAY_SHORT)
  RESET_ARRAY(f_array_unsigned_int,ARRAY_UNSIGNED_INT)
  RESET_ARRAY(f_array_int,ARRAY_INT)
  RESET_ARRAY(f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
  RESET_ARRAY(f_array_int64,ARRAY_INT64)
  RESET_ARRAY(f_array_float,ARRAY_FLOAT)
  RESET_ARRAY(f_array_double,ARRAY_DOUBLE)
  RESET_ARRAY(f_array_bool,ARRAY_BOOL)
  RESET_ARRAY(f_array_string,ARRAY_STRING)

  } else {
    u.f_unsigned_int64 = 0;
  }
}
std::string Lib::Value::stype() const {
  // Used in Lib/AccessorManager, OnXLab/TupleAction, OnXLab/HistogramAction.
  return stype(fType);
}
//////////////////////////////////////////////////////////////////////////////
std::string Lib::Value::stype(
 Slash::Core::IValue::Type aType
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
#define scase(a) case a:return #a;
  switch(aType) {
  scase(NONE)
  scase(INT)
  scase(INT64)
  scase(DOUBLE)
  scase(STRING)
  scase(VOID_STAR)
  scase(DOUBLE_STAR)
  scase(FLOAT_STAR)
  scase(INT_STAR)
  scase(BOOL)
  scase(SHORT)
  scase(FLOAT)
  scase(CHAR)
  scase(UNSIGNED_CHAR)
  scase(UNSIGNED_SHORT)
  scase(UNSIGNED_INT)
  scase(UNSIGNED_INT64)
  scase(ARRAY_UNSIGNED_CHAR)
  scase(ARRAY_CHAR)
  scase(ARRAY_UNSIGNED_SHORT)
  scase(ARRAY_SHORT)
  scase(ARRAY_UNSIGNED_INT)
  scase(ARRAY_INT)
  scase(ARRAY_UNSIGNED_INT64)
  scase(ARRAY_INT64)
  scase(ARRAY_FLOAT)
  scase(ARRAY_DOUBLE)
  scase(ARRAY_BOOL)
  scase(ARRAY_STRING)
  }
#undef scase
}
//////////////////////////////////////////////////////////////////////////////
bool Lib::Value::arrayType(
 Slash::Core::IValue::Type aFrom  //A non array type.
,Slash::Core::IValue::Type& aTo
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
#define acase(a_from,a_to)\
  case a_from:\
    aTo = Slash::Core::IValue::a_to;\
    return true;

  switch(aFrom) {

  acase(UNSIGNED_CHAR,ARRAY_UNSIGNED_CHAR)
  acase(CHAR,ARRAY_CHAR)
  acase(UNSIGNED_SHORT,ARRAY_UNSIGNED_SHORT)
  acase(SHORT,ARRAY_SHORT)
  acase(UNSIGNED_INT,ARRAY_UNSIGNED_INT)
  acase(INT,ARRAY_INT)
  acase(UNSIGNED_INT64,ARRAY_UNSIGNED_INT64)
  acase(INT64,ARRAY_INT64)
  acase(BOOL,ARRAY_BOOL)
  acase(DOUBLE,ARRAY_DOUBLE)
  acase(FLOAT,ARRAY_FLOAT)
  acase(STRING,ARRAY_STRING)

  case VOID_STAR:
  case DOUBLE_STAR:
  case FLOAT_STAR:
  case INT_STAR:

  case ARRAY_UNSIGNED_CHAR:
  case ARRAY_CHAR:
  case ARRAY_UNSIGNED_SHORT:
  case ARRAY_SHORT:
  case ARRAY_UNSIGNED_INT:
  case ARRAY_INT:
  case ARRAY_UNSIGNED_INT64:
  case ARRAY_INT64:
  case ARRAY_FLOAT:
  case ARRAY_DOUBLE:
  case ARRAY_BOOL:
  case ARRAY_STRING:
  case NONE:
    aTo = NONE;
    return false;
  }
#undef acase
  return false;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::setNone(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = NONE;
  u.f_unsigned_int64 = 0;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 char aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = CHAR;
  u.f_char = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 short aValue
)
//////////////////////////////////////////////////////////////////////////////
{
  reset();
  fType = SHORT;
  u.f_short = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 int aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = INT;
  u.f_int = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 float aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = FLOAT;
  u.f_float = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 double aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = DOUBLE;
  u.f_double = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 unsigned char aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = UNSIGNED_CHAR;
  u.f_unsigned_char = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 unsigned short aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = UNSIGNED_SHORT;
  u.f_unsigned_short  = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 unsigned int aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = UNSIGNED_INT;
  u.f_unsigned_int  = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 Slash::int64 aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = INT64;
  u.f_int64 = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 Slash::uint64 aValue
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = UNSIGNED_INT64;
  u.f_unsigned_int64 = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 const std::string& aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = STRING;
  u.f_string = new std::string(aValue);
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 const char* aValue
)
/////////////////////////////////////////////////////////////////////////////
// To avoid the bool, const std::string& and passing "text" problem.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = STRING;
  u.f_string = new std::string(aValue);
}

#define SET_ARRAY(a_what,a_f_what,a_type) \
void Lib::Value::set(\
 const std::vector<unsigned int>& aOrders\
,const std::vector<a_what>& aValues\
){\
  reset();\
  fType = a_type;\
  u.a_f_what = new Array<a_what>(aOrders);\
  u.a_f_what->fill(aValues);\
}

SET_ARRAY(unsigned char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
SET_ARRAY(char,f_array_char,ARRAY_CHAR)
SET_ARRAY(unsigned short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
SET_ARRAY(short,f_array_short,ARRAY_SHORT)
SET_ARRAY(unsigned int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
SET_ARRAY(int,f_array_int,ARRAY_INT)
SET_ARRAY(Slash::uint64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
SET_ARRAY(Slash::int64,f_array_int64,ARRAY_INT64)
SET_ARRAY(float,f_array_float,ARRAY_FLOAT)
SET_ARRAY(double,f_array_double,ARRAY_DOUBLE)
SET_ARRAY(bool,f_array_bool,ARRAY_BOOL)
SET_ARRAY(std::string,f_array_string,ARRAY_STRING)

#define SET_ARRAY_1D(a_what,a_f_what,a_type) \
void Lib::Value::set(\
 const std::vector<a_what>& aValues\
){\
  reset();\
  fType = a_type;\
  std::vector<unsigned int> orders(1);\
  orders[0] = aValues.size();\
  u.a_f_what = new Array<a_what>(orders);\
  u.a_f_what->fill(aValues);\
}

SET_ARRAY_1D(unsigned char,f_array_unsigned_char,ARRAY_UNSIGNED_CHAR)
SET_ARRAY_1D(char,f_array_char,ARRAY_CHAR)
SET_ARRAY_1D(unsigned short,f_array_unsigned_short,ARRAY_UNSIGNED_SHORT)
SET_ARRAY_1D(short,f_array_short,ARRAY_SHORT)
SET_ARRAY_1D(unsigned int,f_array_unsigned_int,ARRAY_UNSIGNED_INT)
SET_ARRAY_1D(int,f_array_int,ARRAY_INT)
SET_ARRAY_1D(Slash::uint64,f_array_unsigned_int64,ARRAY_UNSIGNED_INT64)
SET_ARRAY_1D(Slash::int64,f_array_int64,ARRAY_INT64)
SET_ARRAY_1D(float,f_array_float,ARRAY_FLOAT)
SET_ARRAY_1D(double,f_array_double,ARRAY_DOUBLE)
SET_ARRAY_1D(bool,f_array_bool,ARRAY_BOOL)
SET_ARRAY_1D(std::string,f_array_string,ARRAY_STRING)

//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 void* aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = VOID_STAR;
  u.f_void_star = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 double* aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = DOUBLE_STAR;
  u.f_double_star = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 float* aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = FLOAT_STAR;
  u.f_float_star = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 int* aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = INT_STAR;
  u.f_int_star = aValue;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::set(
 bool aValue
)
/////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = BOOL;
  u.f_bool = aValue;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::setLabel(
 const std::string& aString
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  delete fLabel;
  fLabel = new std::string(aString);
}
//////////////////////////////////////////////////////////////////////////////
std::string Lib::Value::label(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fLabel?(*fLabel):"";
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::setDimension(
 unsigned int aDimension
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fDimension = aDimension;
}
//////////////////////////////////////////////////////////////////////////////
unsigned int Lib::Value::dimension(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fDimension;
}
//////////////////////////////////////////////////////////////////////////////
void Lib::Value::setType(
 Type aType
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  reset();
  fType = aType;
  switch(aType) {
  case NONE:      u.f_unsigned_int64 = 0;break;
  case UNSIGNED_CHAR:    u.f_unsigned_char = 0;break;
  case CHAR:      u.f_char = 0;break;
  case UNSIGNED_SHORT:   u.f_unsigned_short = 0;break;
  case SHORT:     u.f_short = 0;break;
  case UNSIGNED_INT:     u.f_unsigned_int = 0;break;
  case INT:       u.f_int = 0;break;
  case UNSIGNED_INT64:   u.f_unsigned_int64 =0;break;
  case INT64:     u.f_int64 = 0;break;
  case FLOAT:     u.f_float = 0;break;
  case DOUBLE:    u.f_double = 0;break;
  case BOOL:      u.f_bool = false;break;
  case VOID_STAR:        u.f_void_star = 0;break;
  case DOUBLE_STAR:      u.f_double_star = 0;break;
  case FLOAT_STAR:       u.f_float_star = 0;break;
  case INT_STAR:         u.f_int_star = 0;break;
  case STRING:       u.f_string = new std::string("");break;
  case ARRAY_UNSIGNED_CHAR:u.f_array_unsigned_char = new Array<unsigned char>();break;
  case ARRAY_CHAR:u.f_array_char = new Array<char>();break;

  case ARRAY_UNSIGNED_SHORT:u.f_array_unsigned_short = new Array<unsigned short>();break;
  case ARRAY_SHORT:u.f_array_short = new Array<short>();break;

  case ARRAY_UNSIGNED_INT:u.f_array_unsigned_int = new Array<unsigned int>();break;
  case ARRAY_INT:u.f_array_int = new Array<int>();break;
  case ARRAY_UNSIGNED_INT64:u.f_array_unsigned_int64 = new Array<Slash::uint64>();break;
  case ARRAY_INT64:u.f_array_int64 = new Array<Slash::int64>();break;

  case ARRAY_FLOAT:u.f_array_float = new Array<float>();break;
  case ARRAY_DOUBLE:u.f_array_double = new Array<double>();break;
  case ARRAY_BOOL:u.f_array_bool = new Array<bool>();break;
  case ARRAY_STRING:u.f_array_string = new Array<std::string>();break;
  }
}

#undef SET_ARRAY
