// this :
#include <Lib/mmanip.h>

int Lib::mmanip::round(double aDouble){
  if (aDouble == (double) (int(aDouble))) return int(aDouble);
  else return (aDouble>0.) ? int(aDouble+0.5) : -int(0.5-aDouble);
}

#include <math.h>
#ifndef M_PI
#define M_PI       3.1415926535897931160E0
#define M_PI_2     1.5707963267948965580E0  
#endif

double Lib::mmanip::pi(){return M_PI;}
//double Lib::mmanip::pi_2(){return M_PI_2;} //deprecated.
double Lib::mmanip::half_pi(){return M_PI_2;}
unsigned int Lib::mmanip::pow(unsigned int aA,unsigned int aB){
  // Used in Processor.y.
  unsigned int n = 1;
  for(unsigned int i=0;i<aB;i++) n *= aA; 
  return n;
}

int Lib::mmanip::solve_equation_2_degree(
 double aA
,double aB
,double aC
,double& aXM
,double& aXP
){
  // return 0 : no solution
  // return 1 : one solution
  // return 2 : two solutions

  double delta = aB * aB - 4 * aA * aC;
  if(delta<0) {
    return 0;
  } else if(delta==0) {
    aXM = -aB/(2*aA);
    aXP = aXM;
    return 1;
  } else {
    aXM = (-aB - ::sqrt(delta))/(2*aA);
    aXP = (-aB + ::sqrt(delta))/(2*aA);
    return 2;
  }
}

bool Lib::mmanip::in_domain_log(double aX){return (aX>0?true:false);}
bool Lib::mmanip::in_domain_tan(double aX){
  int n = int(aX/M_PI_2);
  if(aX!=n*M_PI_2) return true;
  return (2*int(n/2)==n?true:false);    
}
bool Lib::mmanip::in_domain_acos(double aX){
  return (fabs(aX)<=1?true:false);    
}

double Lib::mmanip::cos(double a_x){return ::cos(a_x);}
double Lib::mmanip::sin(double a_x){return ::sin(a_x);}
double Lib::mmanip::sqrt(double a_x){return ::sqrt(a_x);}
