
#include <Slash/Tools/args.h>
#include <Slash/Tools/system.h>

#include <Lib/Debug.h>

#include <Lib/InternetSocket.h>

#include <iostream>
#include <cstdlib>

int main(int argc,char** argv){
  Slash::args args(argc,argv);

  int verbose = 0;
  if(args.is_arg("-verbose")) verbose = 1;

 {std::string host;
  if(!Slash::getenv("LIB_HOST",host)) {
    std::cout << "Lib_test_client :"
              << " env variable LIB_HOST not defined."
              << std::endl;
    return EXIT_FAILURE;
  }

  int port = 50701;
  
  Lib::InternetSocket client(std::cout,host,port,verbose);

  if(!client.connect()) return EXIT_FAILURE;

  client.send_string("debug : send 0");
  client.send_string("");
  client.send_string("debug : send 1");

  client.send_string("Lib::text");
  std::vector<std::string> text;
  text.push_back("Line 1");
  text.push_back("Line 2");
  text.push_back("Line 3");
  text.push_back("Line 4");
  client.send_text(text);

  client.send_string("exit");}

  Lib::Debug::balance(std::cout);

  return EXIT_SUCCESS;
}
