
#include <Lib/FortranFormat.h>

#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/Arguments.h>
#include <Lib/Debug.h>
#include <Lib/FortranOut.h>

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);

 {Lib::Arguments args(aArgc,aArgv);

  int verbose = 0;
  std::string sverbose;
  if(args.find("-verbose",sverbose)) {
    if(sverbose.empty()) verbose = 1;
  }

  std::string sformat;
  if(!args.find("-format",sformat)) {
    sformat = "(5(1X,G13.7))";
  }

 {Lib::FortranFormat proc(sformat,printer,verbose);
  out << "Lib_fortran_format : " 
      << " parse : " << sformat
      << Lib::endl;
  if(!proc.parse()) {
    out << "Lib_fortran_format : " 
        << " parse failed."<< Lib::endl;
  } else {
    proc.result().dump(printer);
  }}

  int I = 314;
  int J = 315;
  double R = 3.14;

 {sformat = "(I10,F10)";
  out << "Lib_fortran_format : " 
      << " f77out : " << sformat
      << Lib::endl;
  Lib::FortranOut f77out(printer,sformat);
  f77out << I << R << Lib::endl;}

 {sformat = "(3(2I10,F10))";
  out << "Lib_fortran_format : " 
      << " f77out : " << sformat
      << Lib::endl;
  Lib::FortranOut f77out(printer,sformat);
  for(int index=0;index<2;index++) {
    f77out.reset();
    f77out 
      << I << J << R 
      << I << J << R 
      << I << J << R 
      << Lib::endl;
  }}

 {sformat = "(3(2(i5,2X,A),F10.2))";
  out << "Lib_fortran_format : " 
      << " f77out : " << sformat
      << Lib::endl;
  Lib::FortranOut f77out(printer,sformat);
  for(int index=0;index<2;index++) {
    f77out.reset();
    f77out 
      << I << "ab" << J << "cd" << R 
      << I << "ab" << J << "cd" << R 
      << I << "ab" << J << "cd" << R 
      << Lib::endl;
  }}

 {sformat = "(2(5X,10F5.0,/))";
  out << "Lib_fortran_format : " 
      << " f77out : " << sformat
      << Lib::endl;
  Lib::FortranOut f77out(printer,sformat,verbose);
  std::vector<double> values;
  values.push_back(1);
  values.push_back(2);
  values.push_back(3);
  values.push_back(4);
  values.push_back(5);
  values.push_back(6);
  values.push_back(7);
  values.push_back(8);
  values.push_back(9);
  values.push_back(10);

  values.push_back(9.1);
  values.push_back(8.1);
  values.push_back(7.1);
  values.push_back(6.1);
  values.push_back(5.1);
  values.push_back(4.1);
  values.push_back(3.1);
  values.push_back(2.1);
  values.push_back(1.1);
  values.push_back(0.1);

  values.push_back(6.2);
  values.push_back(4.2);
  values.push_back(3.2);
  values.push_back(2.2);
  values.push_back(1.2);
  values.push_back(1.2);
  values.push_back(2.2);
  values.push_back(3.2);
  values.push_back(4.2);
  values.push_back(5.2);
  for(int index=0;index<2;index++) {
    f77out.reset();
    f77out << values << Lib::endl;
  }}

 }

  Lib::Debug::balance(printer);
 
  return 0;
}
