#include <Lib/Printer.h>
#include <Lib/Out.h>
//#include <Lib/smanip.h>

#include <Lib/typedefs.h>

#include <vector>
#include <math.h> //log

std::vector<Lib::uint64> primes;

void decomposition(Lib::uint64,std::vector<Lib::uint64>&);
bool is_prime(Lib::uint64);
bool is_in(Lib::uint64 a_number,const std::vector<Lib::uint64>& a_vec);
void find_cycle(Lib::uint64 a_number,
                Lib::uint64 a_prime,
                std::vector<Lib::uint64>& a_cycle);
void sort(std::vector<Lib::uint64>& a_vec,bool a_inc = true);
void search();

typedef std::vector<Lib::uint64> cycle_t;
typedef unsigned int index_t;
typedef unsigned int vec_size_t;

//
#define DUMP

int main() {
  Lib::Printer printer;
  Lib::Out out(printer);
  //Lib::smanip smanip;

  //search();
  //exit(0);

  Lib::uint64 limit = 50000;

  // Start at 1 (some say that 1 is not a prime).
  {for(Lib::uint64 number=1;number<limit;number++) {
    if(is_prime(number)) {
      primes.push_back(number);
      //out << number << Lib::endl;
    }
  }}
  
/*
  // Prime decomposition :
  {for(Lib::uint64 number=2;number<limit;number++) {
    std::vector<Lib::uint64> ps;
    decomposition(number,ps);
    // Check : 
    Lib::uint64 check = 1;
    {for(index_t i=0;i<ps.size();i++) {
      check *= ps[i];
    }}
    if(check!=number) {
      out << " problem with " << number << Lib::endl;
    } else {
      //out << "Decomposition of : " << number << Lib::endl;
      {for(index_t i=0;i<ps.size();i++) {
        //out << "  " << ps[i] << Lib::endl;
      }}
    }
  }}
*/

  out << "start+ (" << limit/10 << ")..." << Lib::endl;

  //Lib::uint64 uint64_max = 0;
  //for(int i=0;i<64;i++)  uint64_max += 1<<i;

  // Work on even numbers :
 {Lib::uint64 mx = limit/10;
  //for(Lib::uint64 k=2;k<mx;k++) {
  for(Lib::uint64 k=1100;k<1101;k++) { //z=2200
  //for(Lib::uint64 k=10000;k<mx;k++) {
    if(is_prime(k)) continue; //gdb true for 2k.
    Lib::uint64 number = 2 * k;
    //Lib::uint64 number = k;
    std::vector<Lib::uint64> kps;
    decomposition(k,kps);

    if(100*(Lib::uint64)(k/100)==k) 
      out << " look " << number << Lib::endl;

#ifdef DUMP
    out << "--------------------" << Lib::endl;
#endif

    //std::vector<cycle_t> cycles;
    std::vector<Lib::uint64> nps;
    //std::vector< std::pair<Lib::uint64, std::vector<Lib::uint64> > > decs;

    Lib::uint64 Z = 1;
    size_t old_l = 0;

   {for(index_t ip=0;ip<primes.size();ip++) {
      Lib::uint64 p = primes[ip];
      if(p>number) break;

      if(is_in(p,kps)) continue; //bypass. can't lead to a sum of two prime.

      Lib::uint64 n = number-p;

      Z *= n;

     {char s[128];
      ::sprintf(s,LIB_UINT64_FORMAT,Z);
      size_t l = ::strlen(s);
      if(l<old_l) {
        //printf("debug : anomaly for %d\n",number);
        Z = 0;
      }
      old_l = l;}

      nps.push_back(p); //relevant prime for number.

#ifdef DUMP
      out << " " << number << " = 2 x "  << k << " = 2 x ( ";

     {for(index_t i=0;i<kps.size();i++) {
        out << kps[i];
        if(i!=kps.size()-1) out << " x ";
     }}

      out << " ) = " << p << " + ";
#endif

      if(n==1) {
#ifdef DUMP
        out << 1;
#endif
        //std::vector<Lib::uint64> ps;
        //ps.push_back(1);

        //decs.push_back
        //  (std::pair<Lib::uint64, std::vector<Lib::uint64> >(p,ps));

      } else {
        std::vector<Lib::uint64> ps;
        decomposition(n,ps);

        //decs.push_back
        //  (std::pair<Lib::uint64, std::vector<Lib::uint64> >(p,ps));
#ifdef DUMP
       {for(index_t i=0;i<ps.size();i++) {
          out << ps[i];
          if(i!=ps.size()-1) out << " x ";
       }}
#endif
          
/*
       //if( (p>k) && (ps.size()>1) ) {
       //  out << " anomaly aaaaaaaaaaa" << Lib::endl;
       //} 

       //check decomposition members position versus k :
      {for(index_t i=0;i<ps.size();i++) {
         // the below happens !
         //if( (p<k) && (ps[i]<k) ) {
         //  out << " anomaly llllllllllllll" << Lib::endl;
         //}

         // the below can't happen :
         //if( (ps.size()>=2)  && (ps[i]>k) ) {
         //  out << number << " anomaly mmmmmmmmmmmmmm" << Lib::endl;
         //}

         // the below can't happen :
         //if( (p>k) && (ps[i]>k) ) {
         //  out << " anomaly gggggggggggggg" << Lib::endl;
         //} 
      }}
*/

      } //end if(n==1)

#ifdef DUMP
      out << Lib::endl;
#endif

/*
     {cycle_t cycle;
      cycle.push_back(p);
      find_cycle(number,p,cycle);
      sort(cycle);
      cycles.push_back(cycle);
#ifdef DUMP
      out << " cycle (";
      for(index_t i=0;i<cycle.size();i++) {
        out << cycle[i];
        if(i!=cycle.size()-1) out << ",";
      }
      out << ")" << Lib::endl;
#endif
      }//end cycle
*/

    }} //end loop ip

    char s[128];
    ::sprintf(s,LIB_UINT64_FORMAT,Z);
    Lib::uint64 pi_z = 
      (Lib::uint64)(((double)number)/::log(double(number)));

    out << " " << number 
        << " ,half = " << k 
        << " ,nps = " << (unsigned int)nps.size()
        << " ,z/log(z) = " << pi_z
        //<< " ,2_is_in = " << (is_in(2,nps)?"true":"false")
        << " ,Z = " << Z 
        << " ,LZ = " << (unsigned int)::strlen(s)
        << Lib::endl;

/*
   // analyse cycles for number :
   {unsigned int num_2 = 0;
    bool has_1 = false;
    for(index_t i=0;i<cycles.size();i++) {
      if(cycles[i].size()==2) {
        num_2++;
        if(cycles[i][0]==1) {
          has_1 = true;
        }
      }
    }
    out << number 
        << " : num_2 = " << num_2 
        << " : has_1 = " << (has_1?"yes":"no")
        << Lib::endl;
    }

   // look if some p in nps is not in a dec :
   // (yes there are some).
   {for(index_t i=0;i<nps.size();i++) {
      Lib::uint64 p = nps[i];
      bool found = false;
      for(index_t d=0;d<decs.size();d++) {
        std::vector<Lib::uint64>& dec = decs[d].second;
        if(is_in(p,dec)) {
          found = true;
        }
      }
      //if(!found) out << " " << number << " not reach " << p << Lib::endl; 
      if(!found && (p<k) ) 
         out << " " << number << " not reach2 " << p << Lib::endl; 
    }}
*/

  }} //end k.

  return 0;
}

bool is_prime(Lib::uint64 a_number) {
  for(Lib::uint64 i=2;i<a_number;i++) {
    Lib::uint64 rest = a_number/i;
    if((i*rest)==a_number) return false;
  }
  return true;
}
void decomposition(Lib::uint64 aNumber,std::vector<Lib::uint64>& aPrimes) {
  aPrimes.clear();
  Lib::uint64 rest = aNumber;
  for(index_t i=0;i<primes.size();i++) {
    Lib::uint64 prime = primes[i];
    if(prime==1) continue;
    while(1) {
      Lib::uint64 rest2 = rest/prime;
      if(prime*rest2==rest) {
        aPrimes.push_back(prime);
        rest = rest2;
      } else {
        break;
      }
    }
  }
}
bool is_in(Lib::uint64 a_number,const std::vector<Lib::uint64>& a_vec) {
  std::vector<Lib::uint64>::const_iterator it;
  for(it=a_vec.begin();it!=a_vec.end();++it) {
    if(*it==a_number) return true;
  }
  return false;
}
void find_cycle(Lib::uint64 a_number,
                Lib::uint64 a_prime,
                cycle_t& a_cycle) {
  Lib::uint64 r = a_number - a_prime;
  if(r==1) {
    if(!is_in(r,a_cycle)) a_cycle.push_back(r);
    return;
  }
  std::vector<Lib::uint64> ps;
  decomposition(r,ps);
 {for(index_t i=0;i<ps.size();i++) {
    if(!is_in(ps[i],a_cycle)) {
      a_cycle.push_back(ps[i]);
      find_cycle(a_number,ps[i],a_cycle);
    }
  }}
}

#include <stdlib.h> //qsort

extern "C" {
typedef int (*sort_func)(const void*,const void*);
static int greater(Lib::uint64* a_1,Lib::uint64* a_2){
  if(*a_1==*a_2) return 0;
  return (*a_1>*a_2)?1:-1;
}
static int lesser(Lib::uint64* a_1,Lib::uint64* a_2){
  if(*a_1==*a_2) return 0;
  return (*a_1<*a_2)?1:-1;
}
}
void sort(std::vector<Lib::uint64>& a_vec,bool a_inc) {
  vec_size_t l = a_vec.size();
  if(l<=1) return;
  Lib::uint64* vec = new Lib::uint64[l];
 {for(index_t i=0;i<l;i++) vec[i] = a_vec[i];}

  if(a_inc) 
    ::qsort((void*)vec,(size_t)l,(size_t)sizeof(int),(sort_func)greater);
  else
    ::qsort((void*)vec,(size_t)l,(size_t)sizeof(int),(sort_func)lesser);

 {for(index_t i=0;i<l;i++) a_vec[i] = vec[i];}

  delete [] vec;
}

Lib::uint64 pw(Lib::uint64 a,unsigned int p) {
  Lib::uint64 n = 1;
  for(unsigned int i=0;i<p;i++) {
    n *= a;
  }
  return n;
}
void search() {
  // two solution found up so fare :
  //   p = 3, n = 2, q = 2, m = 3  (n1=6)
  //   p = 13, n = 3, q = 3, m = 7 (n1=2184)

  unsigned int pw_mx = 10;
  Lib::uint64 num_mx = 10000;

  for(unsigned int n=2;n<pw_mx;n++) {
  for(unsigned int m=(n+1);m<pw_mx;m++) {
  printf("debug : look : n = %d, m = %d\n",n,m);

  for(Lib::uint64 p=2;p<num_mx;p++) {
    if(!is_prime(p)) continue;

    Lib::uint64 n1 = pw(p,n) - p;
    for(Lib::uint64 q=2;q<p;q++) {
      if(!is_prime(q)) continue;

      Lib::uint64 n2 = pw(q,m) - q;
      if(n2==n1) {
        char fmt[128];
        ::sprintf(fmt,"debug : %s : p = %s, n = %%u, q = %s, m = %%u\n",
          LIB_UINT64_FORMAT,LIB_UINT64_FORMAT,LIB_UINT64_FORMAT);
        printf(fmt,n1,p,n,q,m);
        //return;
      }
    }
  }

  }}
}
