
#include <Lib/Printer.h>
#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Arguments.h>
#include <Lib/smanip.h>
#include <Lib/fmanip.h>

bool cvt_type(const std::string& aIn,std::string& aOut) {
  if(aIn=="0") {
    aOut = "Rio::StreamerInfo::BASE";
    return true;
  } else if(aIn=="20") {
    aOut = "Rio::StreamerInfo::ARRAY";
    return true;
  } else if(aIn=="40") {
    aOut = "Rio::StreamerInfo::POINTER";
    return true;
  } else if(aIn=="4") {
    aOut = "Rio::StreamerInfo::COUNTER";
    return true;
  } else if(aIn=="2") {
    aOut = "Rio::StreamerInfo::SHORT";
    return true;
  } else if(aIn=="3") {
    aOut = "Rio::StreamerInfo::INTEGER";
    return true;
  } else if(aIn=="5") {
    aOut = "Rio::StreamerInfo::FLOAT";
    return true;
  } else if(aIn=="8") {
    aOut = "Rio::StreamerInfo::DOUBLE";
    return true;
  } else if(aIn=="11") {
    aOut = "Rio::StreamerInfo::UNSIGNED_CHAR";
    return true;
  } else if(aIn=="13") {
    aOut = "Rio::StreamerInfo::UNSIGNED_INTEGER";
    return true;
  } else if(aIn=="61") {
    aOut = "Rio::StreamerInfo::OBJECT";
    return true;
  } else if(aIn=="62") {
    aOut = "Rio::StreamerInfo::OBJECT_ANY";
    return true;
  } else if(aIn=="63") {
    aOut = "Rio::StreamerInfo::OBJECT_ARROW";
    return true;
  } else if(aIn=="64") {
    aOut = "Rio::StreamerInfo::OBJECT_POINTER";
    return true;
  } else if(aIn=="65") {
    aOut = "Rio::StreamerInfo::TSTRING";
    return true;
  } else if(aIn=="66") {
    aOut = "Rio::StreamerInfo::TOBJECT";
    return true;
  } else if(aIn=="67") {
    aOut = "Rio::StreamerInfo::TNAMED";
    return true;
  } else {
    aOut = "";
    return false;
  }
}

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Printer printer;
  Lib::Out out(printer);

  Lib::Arguments args(aArgc,aArgv);

  std::string fname;
  if(!args.find("-file",fname)) {
    out << "  OS> Lib_rio_sinfo -file=<source file>" 
        << Lib::endl;
    return EXIT_FAILURE;
  }

  std::vector<std::string> lines;
  if(!Lib::fmanip::read(fname,lines)) return EXIT_FAILURE;

  for(unsigned int index=0;index<lines.size();index++) {
    std::vector<std::string> words;
    Lib::smanip::words(lines[index]," ",words);
    if(words.size()<=6) {
      out << "ERROR : not sufficient words in " 
          << Lib::sout(lines[index]) << Lib::endl; 
      return EXIT_FAILURE;
    }
    std::string cmt;
    for(unsigned int i=6;i<words.size();i++) {
      if(i!=6) cmt += " ";
      cmt += words[i];
    }
    std::string type;
    if(!cvt_type(words[5],type)) {
      out << "ERROR : unexpected type in " 
          << Lib::sout(lines[index]) << Lib::endl; 
      return EXIT_FAILURE;
    }
    out << "streamerInfo->add(new Rio::StreamerBasicType"
        << "(" << Lib::sout(words[1]) << ","
        << Lib::sout(cmt) << ","
        << words[3] << ","
        << type << ","
        << Lib::sout(words[0]) << "));" 
        << Lib::endl;
  }

  return EXIT_SUCCESS;
}
