
#include <Slash/Tools/args.h>

#include <Lib/Debug.h>
#include <Lib/InternetSocket.h>

#include <cstdlib>
#include <iostream>

int main(int argc,char** argv){
  Slash::args args(argc,argv);

  int verbose = 0;
  if(args.is_arg("-verbose")) verbose = 1;

 {int port = 50701;
  Lib::InternetSocket server(std::cout,"",port,verbose);
  if(!server.accept()) return EXIT_FAILURE;

  while(true) {
    std::string s;

   {bool have_input;
    if(!server.is_there_input(have_input)) return EXIT_FAILURE;
    if(!have_input) continue;
    std::cout << "have input..." << std::endl;}

    if(!server.wait_string(s)) break;
    if(s=="Lib::text") {
      std::vector<std::string> text;
      if(!server.wait_text(text)) break;
      unsigned int l = text.size();
      std::cout << "Lib_server : text : " << l << std::endl;
      for(unsigned int index=0;index<l;index++) {
        std::cout << text[index] << std::endl;
      }
    } else if(s=="exit") {
      std::cout << "Lib_server : string : \"" << s << "\"" << std::endl;
      break;
    } else {
      std::cout << "Lib_server : string : \"" << s << "\"" << std::endl;
    }
  }

  server.disconnect();}

  Lib::Debug::balance(std::cout);

  return EXIT_SUCCESS;
}
