
#include <Lib/Printer.h>
#include <Lib/Arguments.h>
#include <Lib/System.h>
#include <Lib/fmanip.h>
#include <Lib/smanip.h>
#include <Lib/Cloner.h>
#include <Lib/Out.h>
#include <Lib/sout.h>

// Embedded code :
#include "osc_new_app_help.h"

//////////////////////////////////////////////////////////////////////////////
int main (
 int aArgc
,char** aArgv
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aArgc<=0) return Lib::System::exitFailure();

  Lib::Printer printer;

  Lib::Arguments args(aArgc,aArgv);

  if(args.isAnArgument("-h")) {
    std::vector<std::string> text;
    text.resize(osc_new_app_help_linen);
    for(unsigned int index=0;index<osc_new_app_help_linen;index++) {
      std::string s = osc_new_app_help_lines[index];
      Lib::smanip::replace(s,"@@double_quote@@","\"");
      Lib::smanip::replace(s,"@@back_slash@@","\\");
      text[index] = s;
    }
    Lib::Out out(printer);
    for(unsigned int index=0;index<text.size();index++) {
      out << text[index] << Lib::endl;
    }
    return Lib::System::exitSuccess();
  }

  std::string name;
  args.find("-name",name);
  if(name.empty()) name="MyApp";

  std::string path;
  std::string from;
  if(args.isAnArgument("-gl")) {
    from="OnXTemplateThree";
    path="$OSC_HOME_DIR/Resources/OnX/templates/" + from;   
  } else if(args.isAnArgument("-iv")) {
    from="OnXTemplateFour";
    path="$OSC_HOME_DIR/Resources/OnX/templates/" + from;   
  } else if(args.isAnArgument("-py")) {
    from="OnXTemplateTwo";
    path="$OSC_HOME_DIR/Resources/OnX/templates/" + from;   
  } else if(args.isAnArgument("-g4")) {
    from="G4LabTemplateOne";
    path="$OSC_HOME_DIR/Resources/G4Lab/templates/" + from;   
  } else {
    std::string s;
    args.find("-template",s);
    if(s.empty()) {
      from="OnXTemplateOne";
      path="$OSC_HOME_DIR/Resources/OnX/templates/" + from;   
    } else {
      path = s;
      from = Lib::smanip::basename(s);
    }
  }

  path = Lib::fmanip::name(path);
  bool debug = args.isAnArgument("-debug");
  bool verbose = args.isAnArgument("-verbose");
  if(!Lib::Cloner::clone(path,from,name,printer,verbose,debug)) {
    return Lib::System::exitFailure();
  }

  // Some libraries (for exa Coin, gtk) may have declared 
  // C functions with ::atexit. To ease debugging we call
  // explicitly ::exit here.
  Lib::System::exit();

  return Lib::System::exitSuccess();
}
