
#include <Slash/Core/ISession.h>

#include <Slash/Tools/Managers.h>
#include <Slash/Tools/UI.h>
#include <Slash/Tools/args.h>
#include <Slash/Tools/osc_env.h>
#include <Slash/Tools/app.h>

#include "iv_viewer_onx.h"

#include <iostream>

int main(int argc,char* argv[]) {

  if(argc>0) {
    std::string arg0(argv[0]);
    //for osc-viewer.app :
    if(!Slash::if_mouse_startup(arg0,"OnX",std::cout)) {
      std::cout << "OnX_viewer :"
                << " unable to set mouse startup." << std::endl;
      return EXIT_FAILURE;
    }
  }

  Slash::args args(argc,argv);

  args.add("-onx_file","@empty@");

  if(!Slash::osc::set_env(std::cout)) {
    std::cout << "OnX_viewer :"
              << " unable to set OSC environment." << std::endl;
    return EXIT_FAILURE;
  }

  Slash::Core::ISession* session = Slash_create_session(args.tovector());
  if(!session) {
    std::cout << "OnX_viewer :"
              << " session not found."
              << std::endl;
    return 1;
  }

  Slash::UI::IUI* ui = Slash::find_UI(*session);     
  if(!ui) {
    std::cout << "OnX_viewer :"
              << "Slash::UI::IUI not found."
              << std::endl;
    return 1;
  }

  std::string s = 
    Slash::to_string(iv_viewer_onx_linen,iv_viewer_onx_lines);
  Slash::replace(s,"@@double_quote@@","\"");
  Slash::replace(s,"@@back_slash@@","\\");

  ui->load("",s,false);

  ui->steer();

  delete session;

  return 0;
}
