#ifndef OnX_Shape_h
#define OnX_Shape_h

#include <string>

#include <Lib/Debug.h>

namespace OnX {

class Shape {
public:
  Shape(const std::string& aType,
        double aSize,
        double aX,double aY,double aZ)
  :fType(aType),fSize(aSize),fX(aX),fY(aY),fZ(aZ){
    Lib::Debug::increment("OnX::Shape");
  }
  virtual ~Shape() {
    Lib::Debug::decrement("OnX::Shape");
  }
  const std::string& type() const { return fType;}
  double size() const { return fSize;}
  void setSize(double aX,double aY,double aZ) { 
    fX = aX;fY = aY;fZ = aZ;
  }
  double x() const { return fX;}
  double y() const { return fY;}
  double z() const { return fZ;}
private:
  std::string fType;
  double fSize;
  double fX;
  double fY;
  double fZ;
};

}

#endif
