#ifndef OnX_Interpreter_h
#define OnX_Interpreter_h

// Inheritance :
#include <Slash/UI/IInterpreter.h>

namespace Slash {namespace Core {class ISession;}}

namespace OnX {

class Interpreter : public virtual Slash::UI::IInterpreter {
public: //Slash::UI::IInterpreter
  virtual std::string name() const;
  virtual std::string package() const;
  virtual std::string suffix() const;
  virtual std::string execFileCommand() const;
  virtual void setFunction(Slash::UI::IInterpreter::Function,void*);
  virtual Function function(void*&) const;
  virtual bool executeScript(const std::string&,const Slash::UI::IInterpreter::Options&);
  virtual bool isOperational();
  virtual bool load(bool = false);
  virtual bool addAlias(const std::string& alias,const std::string& value);
  virtual void setCompleter(Completer,void*);
  virtual Completer completer(void*&) const;
  virtual bool complete(const std::string&,std::string&);
public:
  Interpreter(Slash::Core::ISession&,
              const std::string& name,
              const std::string& library,
              const std::string& package,
              const std::string& suffix,
              const std::string& execFileCommand,
              const std::string& mendatoryEnvironmentVariable,
              Slash::UI::IInterpreter::Function,
              void*,
              Slash::UI::IInterpreter::Completer = 0,
              void* = 0);
  virtual ~Interpreter();
private:
  std::string fName;
  std::string fLibrary;
  std::string fPackage;
  std::string fSuffix;
  std::string fExecFileCmd;
  std::string fMendatoryEnvironmentVariable;
  bool fLoaded;
  Slash::UI::IInterpreter::Function fFunction;
  void* fTag;
  Slash::UI::IInterpreter::Completer fCompleter;
  void* fCompleterTag;
  Slash::Core::ISession& fSession;
  bool fOperationalChecked;
  bool fOperationalStatus;
  std::vector< std::pair<std::string,std::string> > fAliases;
};

}

#endif




