#ifndef OnX_WidgetFactory_h
#define OnX_WidgetFactory_h 

// Inheritance :
#include <Lib/ItemML.h>

namespace Slash {namespace Core {class IWriter;}}
namespace Slash {namespace UI {class IWidgetClass;}}
namespace Slash {namespace UI {class IUI;}}

namespace OnX {

class WidgetFactory : public Lib::ItemMLFactory {
public:
  WidgetFactory(Slash::UI::IUI&, 
                Slash::Core::IWriter&,
                const std::vector<Slash::UI::IWidgetClass*>&);
  virtual ~WidgetFactory();
public:
  virtual Lib::ItemML* create(const std::string&,
                              const std::vector<Lib::ItemML::Attribute>&,
                              Lib::ItemML*);
private:
  Slash::UI::IWidgetClass* findWidgetClass(const std::string&) const;
private:
  Slash::UI::IUI& fUI;
  Slash::Core::IWriter& fPrinter;
  const std::vector<Slash::UI::IWidgetClass*>& fWidgetClasses;
};

}

#endif
