#ifndef OnX_NetManager_h
#define OnX_NetManager_h

// Inheritance :
#include <Slash/Core/IManager.h>
#include <Slash/Net/INetManager.h>

namespace Slash {namespace Core {class ISession;}}
namespace Slash {namespace Core {class IFileGetter;}}

namespace Lib {class InternetSocket;}

namespace OnX {

class NetManager
:public virtual Slash::Core::IManager 
,public virtual Slash::Net::INetManager 
{
public: //Slash::Core::IManager
  virtual std::string name() const;
  virtual void* cast(const std::string&) const;
public: //Slash::UI::INetManager
  virtual bool isClient() const;
  virtual Slash::Core::IFileGetter* fileGetter() const;
  virtual bool executeScript(const std::string&,
                             const std::string&,
                             const Slash::Net::INetManager::Options&);
  virtual bool pushEnd(const std::string&,const std::vector<std::string>&);
  virtual bool flushEnds();
  virtual unsigned int sizeEnds();
  virtual bool waitEnd(std::string&,std::vector<std::string>&);

  virtual bool sendFile(const std::string&);
  virtual bool askFile(const std::string&);
  virtual bool waitFile(const std::string&);
  virtual bool askFileExists(const std::string&,bool&);

  virtual bool sendExit(int);

  virtual bool sendString(const std::string&);
  virtual bool waitString(std::string&);
public:
  NetManager(Slash::Core::ISession&,Lib::InternetSocket&,bool = true);
  virtual ~NetManager();
  bool fetchFile(const std::string&,std::string&);
private:
  typedef std::pair<std::string, std::vector<std::string> > End;
  typedef std::vector<End> Ends;
  bool flush_one_end(const End& aEnd);
private:
  Slash::Core::ISession& fSession;
  std::string fName;
  Lib::InternetSocket& fSocket;
  bool fIsClient;
  Slash::Core::IFileGetter* fFileGetter;
  Ends fEnds; 
};

}

#endif




