@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.10.0
REM # for the package OnX with version v17r12p2.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build
REM # or :
REM #   DOS> call DOS\build.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OnX_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OnX_path=%obuild_OnX_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_do_mains=yes
SET obuild_group=main

SET obuild_args=

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   build [Options] [Target]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -g : build in debug mode.
  ECHO   -e : erase binary directory.
  ECHO   -x : execute with ECHO ON"
  ECHO   -nm : build the not-main components.
  ECHO   -group group : build the given group of components.
  ECHO Target :
  ECHO   If no option is specify and a ending
  ECHO  string is given ; this string is given
  ECHO  to a find command in order to execute 
  ECHO  selected scripts under the DOS directory.
  ECHO Examples :
  ECHO   build app
  ECHO   build -v _lib
  ECHO   build -v -g dll_
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SET obuild_args=%obuild_args% -v
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SET obuild_args=%obuild_args% -g
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-e" GOTO end_if_e

  IF "%OBUILD_DIR_BIN%" == "" (
    SET obuild_dir_bin=bin_obuild
  ) ELSE (
    SET obuild_dir_bin=%OBUILD_DIR_BIN%
  )

  IF "%obuild_dir_bin%" == "" (
    ECHO obuild_dir_bin variable not defined.
    GOTO obuild_return
  )

  IF EXIST "%obuild_OnX_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_OnX_path%\%obuild_dir_bin%"

  GOTO obuild_return

:end_if_e

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_args=%obuild_args% -x
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-nm" GOTO end_if_nm
  SET obuild_do_mains=no
  SHIFT
  GOTO next_arg
:end_if_nm

IF NOT "%1%" == "-group" GOTO end_if_group
  SHIFT
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

REM # Argument without a leading "-" is assumed to 
REM # be the last one and then to be a pattern 
REM # to find and execute command files under 
REM # the DOS directory.
SET obuild_arg=%1%
SET obuild_arg1=%1:~0,1%
IF "%obuild_arg1%" == "-" GOTO obuild_return

  FOR %%f IN (DOS\*%obuild_arg%*) DO %%f %obuild_args%

  GOTO obuild_return

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////


IF NOT %obuild_group% == main GOTO end_if_group_0
IF NOT %obuild_do_mains% == yes GOTO end_if_main_0
  IF NOT EXIST .\DOS\build_lib_OnXCore.bat  GOTO end_if_build_0
    CALL .\DOS\build_lib_OnXCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_0
:end_if_main_0
:end_if_group_0
IF NOT %obuild_group% == main GOTO end_if_group_1
IF NOT %obuild_do_mains% == yes GOTO end_if_main_1
  IF NOT EXIST .\DOS\build_lib_OnXInventor.bat  GOTO end_if_build_1
    CALL .\DOS\build_lib_OnXInventor.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_1
:end_if_main_1
:end_if_group_1
IF NOT %obuild_group% == Xt GOTO end_if_group_2
IF NOT %obuild_do_mains% == no GOTO end_if_main_2
  IF NOT EXIST .\DOS\build_lib_OnXXtCore.bat  GOTO end_if_build_2
    CALL .\DOS\build_lib_OnXXtCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_2
:end_if_main_2
:end_if_group_2
IF NOT %obuild_group% == Win GOTO end_if_group_3
IF NOT %obuild_do_mains% == yes GOTO end_if_main_3
  IF NOT EXIST .\DOS\build_lib_OnXWinCore.bat  GOTO end_if_build_3
    CALL .\DOS\build_lib_OnXWinCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_3
:end_if_main_3
:end_if_group_3
IF NOT %obuild_group% == NextStep GOTO end_if_group_4
IF NOT %obuild_do_mains% == no GOTO end_if_main_4
  IF NOT EXIST .\DOS\build_lib_OnXNextStepCore.bat  GOTO end_if_build_4
    CALL .\DOS\build_lib_OnXNextStepCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_4
:end_if_main_4
:end_if_group_4
IF NOT %obuild_group% == Qt GOTO end_if_group_5
IF NOT %obuild_do_mains% == yes GOTO end_if_main_5
  IF NOT EXIST .\DOS\build_lib_OnXQtCore.bat  GOTO end_if_build_5
    CALL .\DOS\build_lib_OnXQtCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_5
:end_if_main_5
:end_if_group_5
IF NOT %obuild_group% == gtk GOTO end_if_group_6
IF NOT %obuild_do_mains% == yes GOTO end_if_main_6
  IF NOT EXIST .\DOS\build_lib_OnXGtkCore.bat  GOTO end_if_build_6
    CALL .\DOS\build_lib_OnXGtkCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_6
:end_if_main_6
:end_if_group_6
IF NOT %obuild_group% == SDL GOTO end_if_group_7
IF NOT %obuild_do_mains% == yes GOTO end_if_main_7
  IF NOT EXIST .\DOS\build_lib_OnXSDL_Core.bat  GOTO end_if_build_7
    CALL .\DOS\build_lib_OnXSDL_Core.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_7
:end_if_main_7
:end_if_group_7
IF NOT %obuild_group% == main GOTO end_if_group_8
IF NOT %obuild_do_mains% == yes GOTO end_if_main_8
  IF NOT EXIST .\DOS\build_lib_OnXNetCore.bat  GOTO end_if_build_8
    CALL .\DOS\build_lib_OnXNetCore.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_8
:end_if_main_8
:end_if_group_8

IF NOT %obuild_group% == Xt GOTO end_if_group_9
IF NOT %obuild_do_mains% == no GOTO end_if_main_9
  IF NOT EXIST .\DOS\build_dll_OnXXt.bat  GOTO end_if_build_9
    CALL .\DOS\build_dll_OnXXt.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_9
:end_if_main_9
:end_if_group_9
IF NOT %obuild_group% == Win GOTO end_if_group_10
IF NOT %obuild_do_mains% == yes GOTO end_if_main_10
  IF NOT EXIST .\DOS\build_dll_OnXWin.bat  GOTO end_if_build_10
    CALL .\DOS\build_dll_OnXWin.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_10
:end_if_main_10
:end_if_group_10
IF NOT %obuild_group% == NextStep GOTO end_if_group_11
IF NOT %obuild_do_mains% == no GOTO end_if_main_11
  IF NOT EXIST .\DOS\build_dll_OnXNextStep.bat  GOTO end_if_build_11
    CALL .\DOS\build_dll_OnXNextStep.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_11
:end_if_main_11
:end_if_group_11
IF NOT %obuild_group% == Qt GOTO end_if_group_12
IF NOT %obuild_do_mains% == yes GOTO end_if_main_12
  IF NOT EXIST .\DOS\build_dll_OnXQt.bat  GOTO end_if_build_12
    CALL .\DOS\build_dll_OnXQt.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_12
:end_if_main_12
:end_if_group_12
IF NOT %obuild_group% == gtk GOTO end_if_group_13
IF NOT %obuild_do_mains% == yes GOTO end_if_main_13
  IF NOT EXIST .\DOS\build_dll_OnXGtk.bat  GOTO end_if_build_13
    CALL .\DOS\build_dll_OnXGtk.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_13
:end_if_main_13
:end_if_group_13
IF NOT %obuild_group% == SDL GOTO end_if_group_14
IF NOT %obuild_do_mains% == yes GOTO end_if_main_14
  IF NOT EXIST .\DOS\build_dll_OnXSDL.bat  GOTO end_if_build_14
    CALL .\DOS\build_dll_OnXSDL.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_14
:end_if_main_14
:end_if_group_14
IF NOT %obuild_group% == main GOTO end_if_group_15
IF NOT %obuild_do_mains% == yes GOTO end_if_main_15
  IF NOT EXIST .\DOS\build_dll_OnXNet.bat  GOTO end_if_build_15
    CALL .\DOS\build_dll_OnXNet.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_15
:end_if_main_15
:end_if_group_15
IF NOT %obuild_group% == main GOTO end_if_group_16
IF NOT %obuild_do_mains% == yes GOTO end_if_main_16
  IF NOT EXIST .\DOS\build_dll_OnX.bat  GOTO end_if_build_16
    CALL .\DOS\build_dll_OnX.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_16
:end_if_main_16
:end_if_group_16
IF NOT %obuild_group% == main GOTO end_if_group_17
IF NOT %obuild_do_mains% == yes GOTO end_if_main_17
  IF NOT EXIST .\DOS\build_dll_OnXExas.bat  GOTO end_if_build_17
    CALL .\DOS\build_dll_OnXExas.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_17
:end_if_main_17
:end_if_group_17
IF NOT %obuild_group% == main GOTO end_if_group_18
IF NOT %obuild_do_mains% == yes GOTO end_if_main_18
  IF NOT EXIST .\DOS\build_dll_OnXTests.bat  GOTO end_if_build_18
    CALL .\DOS\build_dll_OnXTests.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_18
:end_if_main_18
:end_if_group_18
IF NOT %obuild_group% == main GOTO end_if_group_19
IF NOT %obuild_do_mains% == yes GOTO end_if_main_19
  IF NOT EXIST .\DOS\build_dll_OnX_config_Lib.bat  GOTO end_if_build_19
    CALL .\DOS\build_dll_OnX_config_Lib.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_19
:end_if_main_19
:end_if_group_19
IF NOT %obuild_group% == main GOTO end_if_group_20
IF NOT %obuild_do_mains% == yes GOTO end_if_main_20
  IF NOT EXIST .\DOS\build_dll_OnX_config_OpenGL.bat  GOTO end_if_build_20
    CALL .\DOS\build_dll_OnX_config_OpenGL.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_20
:end_if_main_20
:end_if_group_20
IF NOT %obuild_group% == main GOTO end_if_group_21
IF NOT %obuild_do_mains% == yes GOTO end_if_main_21
  IF NOT EXIST .\DOS\build_dll_OnX_config_Inventor.bat  GOTO end_if_build_21
    CALL .\DOS\build_dll_OnX_config_Inventor.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_21
:end_if_main_21
:end_if_group_21
IF NOT %obuild_group% == main GOTO end_if_group_22
IF NOT %obuild_do_mains% == yes GOTO end_if_main_22
  IF NOT EXIST .\DOS\build_dll_OnXKUIP.bat  GOTO end_if_build_22
    CALL .\DOS\build_dll_OnXKUIP.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_22
:end_if_main_22
:end_if_group_22
IF NOT %obuild_group% == Python GOTO end_if_group_23
IF NOT %obuild_do_mains% == yes GOTO end_if_main_23
  IF NOT EXIST .\DOS\build_dll_OnXPython.bat  GOTO end_if_build_23
    CALL .\DOS\build_dll_OnXPython.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_23
:end_if_main_23
:end_if_group_23
IF NOT %obuild_group% == Python GOTO end_if_group_24
IF NOT %obuild_do_mains% == yes GOTO end_if_main_24
  IF NOT EXIST .\DOS\build_dll_OnX_SWIG_Python.bat  GOTO end_if_build_24
    CALL .\DOS\build_dll_OnX_SWIG_Python.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_24
:end_if_main_24
:end_if_group_24
IF NOT %obuild_group% == Python GOTO end_if_group_25
IF NOT %obuild_do_mains% == yes GOTO end_if_main_25
  IF NOT EXIST .\DOS\build_dll_OnX_config_Python.bat  GOTO end_if_build_25
    CALL .\DOS\build_dll_OnX_config_Python.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_25
:end_if_main_25
:end_if_group_25

IF NOT %obuild_group% == main GOTO end_if_group_26
IF NOT %obuild_do_mains% == yes GOTO end_if_main_26
  IF NOT EXIST .\DOS\build_app_OnX_new_app.bat  GOTO end_if_build_26
    CALL .\DOS\build_app_OnX_new_app.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_26
:end_if_main_26
:end_if_group_26
IF NOT %obuild_group% == main GOTO end_if_group_27
IF NOT %obuild_do_mains% == yes GOTO end_if_main_27
  IF NOT EXIST .\DOS\build_app_OnX_onx.bat  GOTO end_if_build_27
    CALL .\DOS\build_app_OnX_onx.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_27
:end_if_main_27
:end_if_group_27
IF NOT %obuild_group% == main GOTO end_if_group_28
IF NOT %obuild_do_mains% == yes GOTO end_if_main_28
  IF NOT EXIST .\DOS\build_app_OnX_viewer.bat  GOTO end_if_build_28
    CALL .\DOS\build_app_OnX_viewer.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_28
:end_if_main_28
:end_if_group_28
IF NOT %obuild_group% == main GOTO end_if_group_29
IF NOT %obuild_do_mains% == yes GOTO end_if_main_29
  IF NOT EXIST .\DOS\build_app_OnX_onx_config.bat  GOTO end_if_build_29
    CALL .\DOS\build_app_OnX_onx_config.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_29
:end_if_main_29
:end_if_group_29
IF NOT %obuild_group% == main GOTO end_if_group_30
IF NOT %obuild_do_mains% == no GOTO end_if_main_30
  IF NOT EXIST .\DOS\build_app_OnX_test_GetLine.bat  GOTO end_if_build_30
    CALL .\DOS\build_app_OnX_test_GetLine.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_30
:end_if_main_30
:end_if_group_30
IF NOT %obuild_group% == Xt GOTO end_if_group_31
IF NOT %obuild_do_mains% == no GOTO end_if_main_31
  IF NOT EXIST .\DOS\build_app_OnX_test_Xt_page.bat  GOTO end_if_build_31
    CALL .\DOS\build_app_OnX_test_Xt_page.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_31
:end_if_main_31
:end_if_group_31
IF NOT %obuild_group% == Xt GOTO end_if_group_32
IF NOT %obuild_do_mains% == no GOTO end_if_main_32
  IF NOT EXIST .\DOS\build_app_OnX_test_Xt_OpenGLArea.bat  GOTO end_if_build_32
    CALL .\DOS\build_app_OnX_test_Xt_OpenGLArea.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_32
:end_if_main_32
:end_if_group_32
IF NOT %obuild_group% == Xt GOTO end_if_group_33
IF NOT %obuild_do_mains% == no GOTO end_if_main_33
  IF NOT EXIST .\DOS\build_app_OnX_test_Xt.bat  GOTO end_if_build_33
    CALL .\DOS\build_app_OnX_test_Xt.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_33
:end_if_main_33
:end_if_group_33
IF NOT %obuild_group% == Xt GOTO end_if_group_34
IF NOT %obuild_do_mains% == no GOTO end_if_main_34
  IF NOT EXIST .\DOS\build_app_OnX_test_Xm.bat  GOTO end_if_build_34
    CALL .\DOS\build_app_OnX_test_Xm.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_34
:end_if_main_34
:end_if_group_34
IF NOT %obuild_group% == Xt GOTO end_if_group_35
IF NOT %obuild_do_mains% == no GOTO end_if_main_35
  IF NOT EXIST .\DOS\build_app_OnX_test_XmPanedW.bat  GOTO end_if_build_35
    CALL .\DOS\build_app_OnX_test_XmPanedW.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_35
:end_if_main_35
:end_if_group_35
IF NOT %obuild_group% == Xt GOTO end_if_group_36
IF NOT %obuild_do_mains% == no GOTO end_if_main_36
  IF NOT EXIST .\DOS\build_app_OnX_test_XmTabStack.bat  GOTO end_if_build_36
    CALL .\DOS\build_app_OnX_test_XmTabStack.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_36
:end_if_main_36
:end_if_group_36
IF NOT %obuild_group% == Xt GOTO end_if_group_37
IF NOT %obuild_do_mains% == no GOTO end_if_main_37
  IF NOT EXIST .\DOS\build_app_OnX_test_XmText.bat  GOTO end_if_build_37
    CALL .\DOS\build_app_OnX_test_XmText.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_37
:end_if_main_37
:end_if_group_37
IF NOT %obuild_group% == Xt GOTO end_if_group_38
IF NOT %obuild_do_mains% == no GOTO end_if_main_38
  IF NOT EXIST .\DOS\build_app_OnX_test_CommandLine.bat  GOTO end_if_build_38
    CALL .\DOS\build_app_OnX_test_CommandLine.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_38
:end_if_main_38
:end_if_group_38
IF NOT %obuild_group% == Xt GOTO end_if_group_39
IF NOT %obuild_do_mains% == no GOTO end_if_main_39
  IF NOT EXIST .\DOS\build_app_OnX_test_colorEditor.bat  GOTO end_if_build_39
    CALL .\DOS\build_app_OnX_test_colorEditor.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_39
:end_if_main_39
:end_if_group_39
IF NOT %obuild_group% == Xt GOTO end_if_group_40
IF NOT %obuild_do_mains% == no GOTO end_if_main_40
  IF NOT EXIST .\DOS\build_app_OnX_test_GL.bat  GOTO end_if_build_40
    CALL .\DOS\build_app_OnX_test_GL.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_40
:end_if_main_40
:end_if_group_40
IF NOT %obuild_group% == Qt GOTO end_if_group_41
IF NOT %obuild_do_mains% == yes GOTO end_if_main_41
  IF NOT EXIST .\DOS\build_app_OnX_test_Qt.bat  GOTO end_if_build_41
    CALL .\DOS\build_app_OnX_test_Qt.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_41
:end_if_main_41
:end_if_group_41
IF NOT %obuild_group% == gtk GOTO end_if_group_42
IF NOT %obuild_do_mains% == yes GOTO end_if_main_42
  IF NOT EXIST .\DOS\build_app_OnX_test_gtk.bat  GOTO end_if_build_42
    CALL .\DOS\build_app_OnX_test_gtk.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_42
:end_if_main_42
:end_if_group_42
IF NOT %obuild_group% == gtk GOTO end_if_group_43
IF NOT %obuild_do_mains% == yes GOTO end_if_main_43
  IF NOT EXIST .\DOS\build_app_OnX_test_gtk_menu.bat  GOTO end_if_build_43
    CALL .\DOS\build_app_OnX_test_gtk_menu.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_43
:end_if_main_43
:end_if_group_43
IF NOT %obuild_group% == gtk GOTO end_if_group_44
IF NOT %obuild_do_mains% == yes GOTO end_if_main_44
  IF NOT EXIST .\DOS\build_app_OnX_test_gtk_page.bat  GOTO end_if_build_44
    CALL .\DOS\build_app_OnX_test_gtk_page.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_44
:end_if_main_44
:end_if_group_44
IF NOT %obuild_group% == GLUT GOTO end_if_group_45
IF NOT %obuild_do_mains% == yes GOTO end_if_main_45
  IF NOT EXIST .\DOS\build_app_OnX_test_GLUT.bat  GOTO end_if_build_45
    CALL .\DOS\build_app_OnX_test_GLUT.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_45
:end_if_main_45
:end_if_group_45
IF NOT %obuild_group% == main GOTO end_if_group_46
IF NOT %obuild_do_mains% == yes GOTO end_if_main_46
  IF NOT EXIST .\DOS\build_app_OnX_server.bat  GOTO end_if_build_46
    CALL .\DOS\build_app_OnX_server.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_46
:end_if_main_46
:end_if_group_46
IF NOT %obuild_group% == main GOTO end_if_group_47
IF NOT %obuild_do_mains% == yes GOTO end_if_main_47
  IF NOT EXIST .\DOS\build_app_OnX_client.bat  GOTO end_if_build_47
    CALL .\DOS\build_app_OnX_client.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_47
:end_if_main_47
:end_if_group_47
IF NOT %obuild_group% == Python GOTO end_if_group_48
IF NOT %obuild_do_mains% == yes GOTO end_if_main_48
  IF NOT EXIST .\DOS\build_app_OnX_test_Python.bat  GOTO end_if_build_48
    CALL .\DOS\build_app_OnX_test_Python.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_48
:end_if_main_48
:end_if_group_48
IF NOT %obuild_group% == Python GOTO end_if_group_49
IF NOT %obuild_do_mains% == yes GOTO end_if_main_49
  IF NOT EXIST .\DOS\build_app_OnX_test_Python_1.bat  GOTO end_if_build_49
    CALL .\DOS\build_app_OnX_test_Python_1.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_49
:end_if_main_49
:end_if_group_49
IF NOT %obuild_group% == Python GOTO end_if_group_50
IF NOT %obuild_do_mains% == no GOTO end_if_main_50
  IF NOT EXIST .\DOS\build_app_OnX_exa_hello.bat  GOTO end_if_build_50
    CALL .\DOS\build_app_OnX_exa_hello.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_50
:end_if_main_50
:end_if_group_50
IF NOT %obuild_group% == Python GOTO end_if_group_51
IF NOT %obuild_do_mains% == no GOTO end_if_main_51
  IF NOT EXIST .\DOS\build_app_OnX_exa_OnX.bat  GOTO end_if_build_51
    CALL .\DOS\build_app_OnX_exa_OnX.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_51
:end_if_main_51
:end_if_group_51
IF NOT %obuild_group% == Python GOTO end_if_group_52
IF NOT %obuild_do_mains% == no GOTO end_if_main_52
  IF NOT EXIST .\DOS\build_app_OnX_exa_cube.bat  GOTO end_if_build_52
    CALL .\DOS\build_app_OnX_exa_cube.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_52
:end_if_main_52
:end_if_group_52
IF NOT %obuild_group% == Python GOTO end_if_group_53
IF NOT %obuild_do_mains% == no GOTO end_if_main_53
  IF NOT EXIST .\DOS\build_app_OnX_exa_detector.bat  GOTO end_if_build_53
    CALL .\DOS\build_app_OnX_exa_detector.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_53
:end_if_main_53
:end_if_group_53
IF NOT %obuild_group% == Python GOTO end_if_group_54
IF NOT %obuild_do_mains% == no GOTO end_if_main_54
  IF NOT EXIST .\DOS\build_app_OnX_exa_cylinder.bat  GOTO end_if_build_54
    CALL .\DOS\build_app_OnX_exa_cylinder.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_54
:end_if_main_54
:end_if_group_54
IF NOT %obuild_group% == Python GOTO end_if_group_55
IF NOT %obuild_do_mains% == no GOTO end_if_main_55
  IF NOT EXIST .\DOS\build_app_OnX_exa_images.bat  GOTO end_if_build_55
    CALL .\DOS\build_app_OnX_exa_images.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_55
:end_if_main_55
:end_if_group_55
IF NOT %obuild_group% == Python GOTO end_if_group_56
IF NOT %obuild_do_mains% == no GOTO end_if_main_56
  IF NOT EXIST .\DOS\build_app_OnX_exa_shapes.bat  GOTO end_if_build_56
    CALL .\DOS\build_app_OnX_exa_shapes.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_56
:end_if_main_56
:end_if_group_56
IF NOT %obuild_group% == Python GOTO end_if_group_57
IF NOT %obuild_do_mains% == no GOTO end_if_main_57
  IF NOT EXIST .\DOS\build_app_OnX_exa_menu.bat  GOTO end_if_build_57
    CALL .\DOS\build_app_OnX_exa_menu.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_57
:end_if_main_57
:end_if_group_57
IF NOT %obuild_group% == Python GOTO end_if_group_58
IF NOT %obuild_do_mains% == no GOTO end_if_main_58
  IF NOT EXIST .\DOS\build_app_OnX_exa_tree.bat  GOTO end_if_build_58
    CALL .\DOS\build_app_OnX_exa_tree.bat %obuild_args%
    @IF ERRORLEVEL 1 @GOTO obuild_return
    @ECHO OFF
:end_if_build_58
:end_if_main_58
:end_if_group_58


:obuild_return
ENDLOCAL
@ECHO ON
