@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.10.0
REM # for the package OnX with version v17r12p2.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build_OnXCore
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_OnX_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_OnX_path=%obuild_OnX_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no
SET obuild_debug=no
SET obuild_optimize=yes
SET obuild_set_x=no

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug=yes
  SHIFT
  GOTO next_arg
:end_if_g

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF %obuild_debug% == yes SET obuild_optimize=no

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%" MKDIR "%obuild_OnX_path%\%obuild_dir_bin%"

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%" MKDIR "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_OnX_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_OnX_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_1
SET Qt_home=C:\usr\local\Qt\4.4.2
:end_if_platform_1
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_3
SET Qt_moc=%Qt_home%\bin\moc
:end_if_platform_3
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_5
SET SDL_home=C:\usr\local\SDL\1.2.11
:end_if_platform_5
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_7
SET Python_home=C:\usr\local\Python\2.5
:end_if_platform_7
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_9
SET Python_version=25
:end_if_platform_9
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_11
SET obuild_cxx_command=cl.exe
:end_if_platform_11
SET obuild_platform_result=
IF "%obuild_cxx_command%" == ""  ECHO Variable obuild_cxx_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_13
SET obuild_cxx_optimize=/O2
:end_if_platform_13
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_15
SET obuild_cxx_debug=/ZI /Od
:end_if_platform_15
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_17
SET obuild_cxx_options=/nologo /DWIN32 /MD /GX /GR /W3
:end_if_platform_17
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_OnXCore_sh_18
  SET obuild_cxx_debug_local=%obuild_cxx_debug%
  GOTO end_if_db_build_lib_OnXCore_sh_18
:else_if_db_build_lib_OnXCore_sh_18
  SET obuild_cxx_debug_local=
:end_if_db_build_lib_OnXCore_sh_18

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_OnXCore_sh_19
  SET obuild_cxx_optimize_local=%obuild_cxx_optimize%
  GOTO end_if_opt_build_lib_OnXCore_sh_19
:else_if_opt_build_lib_OnXCore_sh_19
  SET obuild_cxx_optimize_local=
:end_if_opt_build_lib_OnXCore_sh_19

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_21
SET obuild_c_command=cl.exe
:end_if_platform_21
SET obuild_platform_result=
IF "%obuild_c_command%" == ""  ECHO Variable obuild_c_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_23
SET obuild_c_optimize=/O2
:end_if_platform_23
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_25
SET obuild_c_debug=/ZI /Od
:end_if_platform_25
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_27
SET obuild_c_options=/nologo /DWIN32 /MD /W3
:end_if_platform_27
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_OnXCore_sh_28
  SET obuild_c_debug_local=%obuild_c_debug%
  GOTO end_if_db_build_lib_OnXCore_sh_28
:else_if_db_build_lib_OnXCore_sh_28
  SET obuild_c_debug_local=
:end_if_db_build_lib_OnXCore_sh_28

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_OnXCore_sh_29
  SET obuild_c_optimize_local=%obuild_c_optimize%
  GOTO end_if_opt_build_lib_OnXCore_sh_29
:else_if_opt_build_lib_OnXCore_sh_29
  SET obuild_c_optimize_local=
:end_if_opt_build_lib_OnXCore_sh_29


IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%" MKDIR "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_OnX_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_OnX_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib `) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Slash `) DO SET obuild_Slash_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_Slash_path  ECHO Can't find Slash package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat `) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib `) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat `) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib `) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib `) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib `) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

SET obuild_c_includes=/I"%obuild_OnX_path%\include"

SET obuild_cxx_includes=/I"%obuild_OnX_path%\include"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_Lib_path%\include"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_Slash_path%"
SET obuild_cxx_includes=%obuild_cxx_includes% /I"%obuild_expat_path%\include"

IF EXIST "%obuild_OnX_path%\%obuild_dir_bin%\lib_OnXCore" RMDIR /S /Q "%obuild_OnX_path%\%obuild_dir_bin%\lib_OnXCore"
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\lib_OnXCore" MKDIR "%obuild_OnX_path%\%obuild_dir_bin%\lib_OnXCore"

IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%" MKDIR "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_OnX_path%\%obuild_dir_bin%\obuild_wrap.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_OnX_path%\%obuild_dir_bin%\obuild_wrap.exe" "%obuild_OnX_path%\obuild\cpp\obuild_wrap.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_wrap.obj DEL obuild_wrap.obj
)
..\bin_obuild\obuild_wrap.exe "..\scripts\OnX\Session.onx" "..\include\OnX\Core\Session_onx.h"
@IF %obuild_verbose% == yes @ECHO ON 
cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Printer.obj  /Tp"..\source\Core\Printer.cxx" 1> exe_error_0
@IF ERRORLEVEL 1 @TYPE exe_error_0 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_0
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Interpreter.obj  /Tp"..\source\Core\Interpreter.cxx" 1> exe_error_1
@IF ERRORLEVEL 1 @TYPE exe_error_1 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_1
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\ScriptManager.obj  /Tp"..\source\Core\ScriptManager.cxx" 1> exe_error_2
@IF ERRORLEVEL 1 @TYPE exe_error_2 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_2
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\StyleManager.obj  /Tp"..\source\Core\StyleManager.cxx" 1> exe_error_3
@IF ERRORLEVEL 1 @TYPE exe_error_3 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_3
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\UI_Manager.obj  /Tp"..\source\Core\UI_Manager.cxx" 1> exe_error_4
@IF ERRORLEVEL 1 @TYPE exe_error_4 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_4
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Session.obj  /Tp"..\source\Core\Session.cxx" 1> exe_error_5
@IF ERRORLEVEL 1 @TYPE exe_error_5 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_5
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\CallbackData.obj  /Tp"..\source\Core\CallbackData.cxx" 1> exe_error_6
@IF ERRORLEVEL 1 @TYPE exe_error_6 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_6
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\WidgetClass.obj  /Tp"..\source\Core\WidgetClass.cxx" 1> exe_error_7
@IF ERRORLEVEL 1 @TYPE exe_error_7 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_7
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Widget.obj  /Tp"..\source\Core\Widget.cxx" 1> exe_error_8
@IF ERRORLEVEL 1 @TYPE exe_error_8 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_8
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\WidgetFactory.obj  /Tp"..\source\Core\WidgetFactory.cxx" 1> exe_error_9
@IF ERRORLEVEL 1 @TYPE exe_error_9 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_9
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Action.obj  /Tp"..\source\Core\Action.cxx" 1> exe_error_10
@IF ERRORLEVEL 1 @TYPE exe_error_10 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_10
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\atat.obj  /Tp"..\source\Core\atat.cxx" 1> exe_error_11
@IF ERRORLEVEL 1 @TYPE exe_error_11 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_11
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\BaseUI.obj  /Tp"..\source\Core\BaseUI.cxx" 1> exe_error_12
@IF ERRORLEVEL 1 @TYPE exe_error_12 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_12
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\DummyUI.obj  /Tp"..\source\Core\DummyUI.cxx" 1> exe_error_13
@IF ERRORLEVEL 1 @TYPE exe_error_13 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_13
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\BaseCyclic.obj  /Tp"..\source\Core\BaseCyclic.cxx" 1> exe_error_14
@IF ERRORLEVEL 1 @TYPE exe_error_14 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_14
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Main.obj  /Tp"..\source\Core\Main.cxx" 1> exe_error_15
@IF ERRORLEVEL 1 @TYPE exe_error_15 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_15
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_cxx_command% /c %obuild_cxx_debug_local% %obuild_cxx_optimize_local% %obuild_cxx_options% %obuild_cxx_macros% %obuild_cxx_includes% /Fo.\lib_OnXCore\Term.obj  /Tp"..\source\Core\Term.cxx" 1> exe_error_16
@IF ERRORLEVEL 1 @TYPE exe_error_16 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_16
cd "%obuild_OnX_path%\obuild"

cd "%obuild_OnX_path%\%obuild_dir_bin%"
%obuild_c_command% /c %obuild_c_debug_local% %obuild_c_optimize_local% %obuild_c_options% %obuild_c_macros% %obuild_c_includes% /Fo.\lib_OnXCore\Getline.obj "..\source\Core\Getline.c" 1> exe_error_17
@IF ERRORLEVEL 1 @TYPE exe_error_17 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_17
cd "%obuild_OnX_path%\obuild"

@IF %obuild_verbose% == yes @ECHO OFF 

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_59
SET obuild_cxx_linker_command=link.exe
:end_if_platform_59
SET obuild_platform_result=
IF "%obuild_cxx_linker_command%" == ""  ECHO Variable obuild_cxx_linker_command not defined.  && GOTO obuild_return

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_61
SET obuild_cxx_linker_debug=/DEBUG
:end_if_platform_61
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_63
SET obuild_cxx_linker_options=/nologo
:end_if_platform_63
SET obuild_platform_result=

IF NOT %obuild_debug% == yes GOTO else_if_db_build_lib_OnXCore_sh_64
  SET obuild_cxx_linker_debug_local=%obuild_cxx_linker_debug%
  GOTO end_if_db_build_lib_OnXCore_sh_64
:else_if_db_build_lib_OnXCore_sh_64
  SET obuild_cxx_linker_debug_local=
:end_if_db_build_lib_OnXCore_sh_64

IF NOT %obuild_optimize% == yes GOTO else_if_opt_build_lib_OnXCore_sh_65
  SET obuild_cxx_linker_optimize_local=%obuild_cxx_linker_optimize%
  GOTO end_if_opt_build_lib_OnXCore_sh_65
:else_if_opt_build_lib_OnXCore_sh_65
  SET obuild_cxx_linker_optimize_local=
:end_if_opt_build_lib_OnXCore_sh_65

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_67
SET obuild_linked_paths=/LIBPATH:"%obuild_Lib_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=LibXML.lib
:end_if_platform_67
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_69
SET obuild_linked_paths=%obuild_linked_paths% /LIBPATH:"%obuild_expat_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=%obuild_linked_libraries% osc_expat.lib
:end_if_platform_69
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_71
SET obuild_linked_paths=%obuild_linked_paths% /LIBPATH:"%obuild_Lib_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=%obuild_linked_libraries% LibZip.lib
:end_if_platform_71
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_73
SET obuild_linked_paths=%obuild_linked_paths% /LIBPATH:"%obuild_zlib_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=%obuild_linked_libraries% osc_zlib.lib
:end_if_platform_73
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_75
SET obuild_linked_paths=%obuild_linked_paths% /LIBPATH:"%obuild_Lib_path%\%obuild_dir_bin%"
SET obuild_linked_libraries=%obuild_linked_libraries% LibUtils.lib
:end_if_platform_75
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_77
SET obuild_linked_libraries=%obuild_linked_libraries% user32.lib
:end_if_platform_77
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_OnX_0=%%d
cd "%obuild_OnX_path%\%obuild_dir_bin%"
IF EXIST .\lib_OnXCore\tmp_objs DEL .\lib_OnXCore\tmp_objs
FOR %%f IN (.\lib_OnXCore\*.obj) DO ECHO %%f >> .\lib_OnXCore\tmp_objs

REM # Create the archive library OnXCore :
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\lib_OnXCore\OnXCore.arc @.\lib_OnXCore\tmp_objs
@IF ERRORLEVEL 1 @GOTO obuild_return
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Build the obuild_windef.exe utility program :
cl.exe /nologo /DWIN32 /MD /O2 /W3 /Feobuild_windef.exe "%obuild_OnX_path%\obuild\cpp\obuild_windef.c" 1> exe_error_18
@IF ERRORLEVEL 1 @TYPE exe_error_18 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_18
IF EXIST obuild_windef.obj DEL obuild_windef.obj

REM # Building the .def file :
@IF %obuild_verbose% == yes @ECHO ON 
dumpbin.exe /symbols /out:.\lib_OnXCore\tmp .\lib_OnXCore\OnXCore.arc 1> exe_error_19
@IF ERRORLEVEL 1 @TYPE exe_error_19 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_19
@IF %obuild_verbose% == yes @ECHO OFF 
.\obuild_windef.exe OnXCore < .\lib_OnXCore\tmp > .\lib_OnXCore\OnXCore.def
REM # Building the linking library :
REM # It produces a .exp file.
@IF %obuild_verbose% == yes @ECHO ON 
lib.exe /nologo /machine:ix86 /out:.\OnXCore.lib /def:.\lib_OnXCore\OnXCore.def 1> exe_error_20
@IF ERRORLEVEL 1 @TYPE exe_error_20 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_20
@IF %obuild_verbose% == yes @ECHO OFF 

REM # Building the DLL :
IF EXIST .\OnXCore.dll DEL .\OnXCore.dll
@IF %obuild_verbose% == yes @ECHO ON 
link.exe /nologo /dll /out:.\OnXCore.dll .\OnXCore.exp .\lib_OnXCore\OnXCore.arc %obuild_linked_paths% %obuild_linked_libraries%
@IF %obuild_verbose% == yes @ECHO OFF 

cd "%obuild_pwd_OnX_0%"
SET obuild_pwd_OnX_0=
REM # Some cleanup :
IF EXIST "%obuild_OnX_path%\%obuild_dir_bin%\lib_OnXCore\tmp_objs" DEL "%obuild_OnX_path%\%obuild_dir_bin%\lib_OnXCore\tmp_objs"
IF EXIST "%obuild_OnX_path%\%obuild_dir_bin%\OnXCore.exp" DEL "%obuild_OnX_path%\%obuild_dir_bin%\OnXCore.exp"

:obuild_return
ENDLOCAL
@ECHO ON
