
#include <OnX/Helpers/OnX.h>

#include <Lib/Arguments.h>
#include <OnX/Interfaces/IIB.h>
static IIB& toIB(Slash::UI::IUI& aUI) {return *Lib_Cast(aUI,IIB);}

static void deprecated0(Slash::UI::IUI& aUI,const std::string& aOld) {
  Lib::Out out(aUI.session().printer());
  out << "DLD callback " << Lib::sout(aOld) << " is deprecated."
      << Lib::endl;
}

static void deprecated(Slash::UI::IUI& aUI,const std::string& aOld,const std::string& aNew) {
  Lib::Out out(aUI.session().printer());
  out << "DLD callback " << Lib::sout(aOld) << " is deprecated."
      << " Use " << Lib::sout(aNew) << " instead."
      << Lib::endl;
}

static void deprecated1(Slash::UI::IUI& aUI,const std::string& aOld,const std::string& aString) {
  Lib::Out out(aUI.session().printer());
  out << "DLD callback " << Lib::sout(aOld) << " is deprecated."
      << " " << aString
      << Lib::endl;
}

extern "C" {

/////////////////////////////////////////////////////////////////////////////
void ui_showFileChooser(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
// args[0] lib
// args[1] callback
// args[2] dirmask
// args[3] default directory
// args[...] passed to the ok callback.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"ui_showFileChooser","ui_set_fileChooser");

  if(aArgs.size()<4) return;

  std::string sargs;
  for(unsigned int index=4;index<aArgs.size();index++) {
    if(index!=4) sargs += " ";
    sargs += aArgs[index];
  }


  aUI.setCallback("fileChooser","ok","DLD",aArgs[0]+" "+aArgs[1]+" "+sargs);
  aUI.setCallback("fileChooser","cancel",
                  "DLD","OnX ui_hide fileChooser");
  aUI.setParameter("fileChooser.dirMask",aArgs[2]);
  aUI.setParameter("fileChooser.directory",aArgs[3]);
  aUI.setParameter("fileChooser.mode","open");

  Slash::UI::IWidget* w = aUI.findWidget("fileChooser");
  if(w) w->show();
}
//////////////////////////////////////////////////////////////////////////////
void ui_showFileSaver(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
// args[0] lib
// args[1] callback
// args[2] dirmask
// args[3] default directory
// args[...] passed to the ok callback.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"ui_showFileSaver","ui_set_fileChooser");

  if(aArgs.size()<4) return;

  std::string sargs;
  for(unsigned int index=4;index<aArgs.size();index++) {
    if(index!=4) sargs += " ";
    sargs += aArgs[index];
  }


  aUI.setCallback("fileChooser","ok","DLD",aArgs[0]+" "+aArgs[1]+" "+sargs);
  aUI.setCallback("fileChooser","cancel",
                  "DLD","OnX ui_hide fileChooser");
  aUI.setParameter("fileChooser.dirMask",aArgs[2]);
  aUI.setParameter("fileChooser.directory",aArgs[3]);
  aUI.setParameter("fileChooser.mode","save");

  Slash::UI::IWidget* w = aUI.findWidget("fileChooser");
  if(w) w->show();
}
//////////////////////////////////////////////////////////////////////////////
void ui_showColorChooser(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
)
//////////////////////////////////////////////////////////////////////////////
// args[0] lib
// args[1] callback
// args[..] passed to the ok callback.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated0(aUI,"ui_showColorChooser");

  if(aArgs.size()<2) return;

  std::string sargs;
  for(unsigned int index=2;index<aArgs.size();index++) {
    if(index!=2) sargs += " ";
    sargs += aArgs[index];
  }

  aUI.setCallback("colorChooser","ok","DLD",aArgs[0]+" "+aArgs[1]+" "+sargs);

  Slash::UI::IWidget* w = aUI.findWidget("colorChooser");
  if(w) w->show();
}
//////////////////////////////////////////////////////////////////////////////
void ui_executeFile(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
)
//////////////////////////////////////////////////////////////////////////////
// aArgs[0] interpreter
// aArgs[1] file
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"ui_executeFile","ui_execute_file");

  if(aArgs.size()!=2) return;
  ui_execute_file(aUI,aArgs[0],aArgs[1]);
}
//////////////////////////////////////////////////////////////////////////////
void tree_set_managers(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"tree_set_managers","tree_set");

  tree_set_with_strings(aUI,"mainTree.items",aUI.session().managerNames());
}
//////////////////////////////////////////////////////////////////////////////
void tree_set_styles(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"tree_set_styles",
                 "tree_set with @manager@StyleManager@styles@");

  Slash::UI::IStyleManager* styleManager = Slash::styleManager(aUI.session());
  if(!styleManager) return;
  tree_set_with_strings(aUI,"mainTree.items",styleManager->styles());
}
//////////////////////////////////////////////////////////////////////////////
void console_execute(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //correct Panoramix first.
  //deprecated(aUI,"console_execute","OnX ui_executeScript @consolePrompt.value@ @this.value@");

  std::string sexec;
  if(!aUI.parameterValue("consolePrompt.value",sexec)) return;
  aUI.executeScript(sexec,aUI.callbackValue());
}
//////////////////////////////////////////////////////////////////////////////
void colorChooser_ok(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated0(aUI,"colorChooser_ok");
  session_setColor(aUI.session(),aUI.callbackValue());
}
//////////////////////////////////////////////////////////////////////////////
void colorChooser_show(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated0(aUI,"colorChooser_show");
  aUI.setCallback("colorChooser","ok","DLD","OnX colorChooser_ok");
  Slash::UI::IWidget* w = aUI.findWidget("colorChooser");
  if(w) w->show();
}

/*
//////////////////////////////////////////////////////////////////////////////
void region_clear(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"region_readScene","viewer_clear @current@ all");
  aUI.executeScript("DLD","OnX viewer_clear @current@ all");
}
*/
//////////////////////////////////////////////////////////////////////////////
void page_createRegion(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"page_createRegion","page_create_region @current@...");
  if(!ui_check_args(aUI,aArgs,5)) return;
  std::string s;
  for(unsigned int index=0;index<aArgs.size();index++) s += " " + aArgs[index];
  aUI.executeScript("DLD","OnX page_create_region @current@"+s);
}
//////////////////////////////////////////////////////////////////////////////
void page_addRegions(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"page_addRegions","page_add_regions @current@...");
  if(!ui_check_args(aUI,aArgs,2)) return;
  std::string s;
  for(unsigned int index=0;index<aArgs.size();index++) s += " " + aArgs[index];
  aUI.executeScript("DLD","OnX page_add_regions @current@ SoDisplayRegion"+s);
}
//////////////////////////////////////////////////////////////////////////////
void page_createRegions(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"page_createRegions","page_create_regions @current@...");
  if(!ui_check_args(aUI,aArgs,4)) return;
  aUI.executeScript("DLD",
    "OnX page_create_regions @current@ "+aArgs[3]+" "+aArgs[0]+" "+aArgs[1]+" "+aArgs[2]);
}

//////////////////////////////////////////////////////////////////////////////
void page_deleteRegions(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"page_deleteRegions","page_delete_regions @current@");
  aUI.executeScript("DLD","OnX page_delete_regions @current@");
}
//////////////////////////////////////////////////////////////////////////////
void page_deleteRegion(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"page_deleteRegion","page_delete_region @current@");
  aUI.executeScript("DLD","OnX page_delete_region @current@");
}

//////////////////////////////////////////////////////////////////////////////
void page_destroy(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //correct Panoramix first.
  //deprecated1(aUI,"page_destroy",
  //  "See OnX/examples/OnX/page_viewer_stack.onx <destroy> callbacks.");

  std::string name = aUI.callbackData().component();
  //aUI.echo("page_destroy for : "+name);

  // Remove from Viewers pdm :
  std::string prefix = "viewers_item_";
 {std::string s = prefix + name;
  if(aUI.isComponent(s)) aUI.destroyComponent(s);}

  // Set currentViewer to another Viewer.
  // We take the last one in the OnX_viewers pdm.
 {std::vector<std::string> viewers = aUI.findChildren("OnX_viewers","name","");
  if(!viewers.empty()) {
    std::string s = *(viewers.rbegin());
    //viewers_item_Viewer_2
    //012345678901234567890
    std::string last = s.substr(prefix.size(),s.size()-prefix.size());
    set_current_widget(aUI,last);
  } else {
    aUI.setCurrentWidget(0);
  }}
}

//////////////////////////////////////////////////////////////////////////////
void OnX_removeManips(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"OnX_removeManips","viewer_remove_manips @current@");
  aUI.executeScript("DLD","OnX viewer_remove_manips @current@");
}
//////////////////////////////////////////////////////////////////////////////
void OnX_region_dumpCamera(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //check Panoramix.
  deprecated(aUI,"OnX_region_dumpCamera","OnX region_dump_camera @current@");
  aUI.executeScript("DLD","OnX region_dump_camera @current@");
}
//////////////////////////////////////////////////////////////////////////////
void OnX_region_resetCamera(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //check Panoramix.
  deprecated(aUI,"OnX_region_resetCamera","OnX region_reset_camera @current@");
  aUI.executeScript("DLD","OnX region_reset_camera @current@");
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void OnX_Tab_select(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"OnX_Tab_select","OnX ui_setCurrentWidget @this.value@");
  aUI.setCurrentWidget(aUI.findWidget(aUI.callbackValue()));
}
//////////////////////////////////////////////////////////////////////////////
void OnX_Finalize(
 Slash::Core::ISession& aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Out out(aSession.printer());
  out << "OnX_Finalize : deprecated. Use session_echo." << Lib::endl;
  out << "OnX_Finalize." << Lib::endl;
}
//////////////////////////////////////////////////////////////////////////////
void OnX_Page_Delete_Page(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"OnX_Page_Delete_Page","OnX ui_destroy_widget @current@");
  aUI.executeScript("DLD","OnX ui_destroy_widget @current@");
}

//////////////////////////////////////////////////////////////////////////////
void page_create(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"page_create","OnX viewer_add_in_viewers_pdm @this@");
  aUI.executeScript("DLD","OnX viewer_add_in_viewers_pdm @this@");
  aUI.executeScript("DLD","OnX ui_set_current_widget @this@");
}

//////////////////////////////////////////////////////////////////////////////
void viewer_popup(
 Slash::UI::IUI& aUI
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated1(aUI,"viewer_popup",
                  "See examples/OnX/page_viewer.onx <popup> callback.");

  std::string item = aUI.callbackValue();
  if(item == "No highlighted") {
    aUI.executeScript("DLD","OnX region_reset_highlight");
  } else if(item == "Dump highlighted") {
    aUI.executeScript("DLD","OnX viewer_collect");
  } else if(item == "Region to page") {
    aUI.executeScript("DLD","OnX page_currentRegionToPage");
  } else if(item == "Region on top") {
    aUI.executeScript("DLD","OnX page_currentRegionOnTop");
  } else if(item == "Decorations on") {
    aUI.executeScript("DLD","OnX ui_setParameter viewer.decoration TRUE");
  } else if(item == "Decorations off") {
    aUI.executeScript("DLD","OnX ui_setParameter viewer.decoration FALSE");
  }
}

//////////////////////////////////////////////////////////////////////////////
void ui_createComponent(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
) 
//////////////////////////////////////////////////////////////////////////////
// arguments : 
//   -class : if not, create a PageViewer.
//   -name : if not, generate one.
//   -parent : if not, take "ViewerTabStack".
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,"ui_createComponent","ui_create_component");

  Lib::Arguments args(aArgs);
  std::string sclass;
  if(!args.find("-class",sclass)) sclass = "PageViewer";
  std::string sparent;
  if(!args.find("-parent",sparent)) sparent = "ViewerTabStack";
  std::string sname;
  if(!args.find("-name",sname)) {
    if(sparent=="ViewerTabStack") {
      int n;
      if(!ui_parameterValue(aUI,"ViewerTabStack.itemCount",n)) {
        Lib::Out out(aUI.session().printer());
        out << "ui_createComponent :"
            << " can't get ViewerTabStack.itemCount value."
            << Lib::endl;
        return;
      }
      if(!Lib::smanip::printf(sname,64,"Viewer_%d",n+1)) {
        Lib::Out out(aUI.session().printer());
        out << "ui_createComponent :"
            << " problem with Lib::printf."
            << Lib::endl;
        return;
      }
    } else {
      sname = toIB(aUI).createWidgetName();
    }
  }

  if(!aUI.createComponent(sname,sclass,sparent)) {
    Lib::Out out(aUI.session().printer());
    out << "ui_createComponent :"
        << " problem when creating component."
        << Lib::endl;
    return;
  }

  Slash::UI::IWidget* widget = aUI.findWidget(sname);
  if(widget) {
    // If a PageViewer or an OpenGLArea, set it as current widget.
    Slash::UI::ISoViewer* soViewer = Lib_Cast(*widget,Slash::UI::ISoViewer);
    if(soViewer) {
      aUI.setCurrentWidget(widget);
    } else if(sclass=="OpenGLArea") {
      aUI.setCurrentWidget(widget);
    }
  }

  /*
  Slash::UI::IWidgetClass* wclass = aUI.findWidgetClass(sclass);
  if(!wclass) {
    Lib::Out out(aUI.session().printer());
    out << "ui_createComponent :"
        << " widget class " << Lib::sout(sclass) << " not found." 
        << Lib::endl;
    return;
  }

  Slash::UI::IWidget* wparent = aUI.findWidget(sparent);
  if(!wparent) {
    Lib::Out out(aUI.session().printer());
    out << "ui_createComponent :"
        << " parent widget " << Lib::sout(sparent) << " not found." 
        << Lib::endl;
    return;
  }

  Slash::UI::IWidget* widget = aUI.createWidget(*wclass,sname,*wparent);
  if(!widget) {
    Lib::Out out(aUI.session().printer());
    out << "ui_createComponent :"
        << " can't create widget " << Lib::sout(sname)
        << Lib::dot_endl;
    return;
  }

  // If a PageViewer, set it as current viewer.
  Slash::UI::ISoViewer* soViewer = Lib_Cast(*widget,Slash::UI::ISoViewer);
  if(soViewer) aUI.setCurrentWidget(soViewer);*/

}

}

#include <OnX/Helpers/Inventor.h>

#include <Inventor/nodes/SoSeparator.h>
#include <HEPVis/nodekits/SoDisplayRegion.h>

extern "C" {

//////////////////////////////////////////////////////////////////////////////
void region_erase(
 Slash::UI::IUI& aUI
,const std::vector<std::string>& aArgs
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated1(aUI,"region_erase",
    "See OnX/script/OnX/Scene.onx pull down menu.");

  if(!aArgs.size()) return;
  if( (aArgs[0]=="static") || (aArgs[0]=="staticScene") ){
    SoPage* soPage = ui_SoPage(aUI);
    if(!soPage) return;
    SoRegion* soRegion = soPage->currentRegion();
    if(!soRegion) return;
    if(!soRegion->isOfType(SoDisplayRegion::getClassTypeId())) return;
    SoDisplayRegion* displayRegion = (SoDisplayRegion*)soRegion;
    SoSeparator* sep = (SoSeparator*)displayRegion->getStaticScene();
    if(sep) sep->removeAllChildren();
  } else if( (aArgs[0]=="dynamic") || (aArgs[0]=="dynamicScene") ) {
    SoPage* soPage = ui_SoPage(aUI);
    if(!soPage) return;
    SoRegion* soRegion = soPage->currentRegion();
    if(!soRegion) return;
    if(!soRegion->isOfType(SoDisplayRegion::getClassTypeId())) return;
    SoDisplayRegion* displayRegion = (SoDisplayRegion*)soRegion;
    SoSeparator* sep = (SoSeparator*)displayRegion->getDynamicScene();
    if(sep) sep->removeAllChildren();
  } else if(aArgs[0]=="highlighted") {
    data_collect(aUI.session(),"SceneGraph","highlight==true");
    data_destroy(aUI.session());
  } else if(aArgs[0]=="not_highlighted") {
    data_collect(aUI.session(),"SceneGraph","highlight==false");
    data_destroy(aUI.session());

  } else if(aArgs[0]=="with_manip") {
    data_collect(aUI.session(),"SceneGraph","with_manip==true");
    data_destroy(aUI.session());
  } else if(aArgs[0]=="without_manip") {
    data_collect(aUI.session(),"SceneGraph","with_manip==false");
    data_destroy(aUI.session());
  }
}

void OnX_region_readScene(Slash::UI::IUI& aUI,const std::vector<std::string>& aArgs){
  deprecated(aUI,"region_readScene","region_read_scene");
  if(!ui_check_args(aUI,aArgs,1)) return;
  aUI.executeScript("DLD","OnX region_read_scene @current@ "+aArgs[0]);
}

void OnX_region_readInventorFile(Slash::UI::IUI& aUI,const std::vector<std::string>& aArgs)
{
  deprecated(aUI,"region_readInventorFile","region_read_scene");
  if(!ui_check_args(aUI,aArgs,1)) return;
  aUI.executeScript("DLD","OnX region_read_scene @current@ "+aArgs[0]);
}

}
