// this :
#include <OnX/Core/CallbackData.h>

#include <Lib/Debug.h>

//////////////////////////////////////////////////////////////////////////////
OnX::CallbackData::CallbackData(
) 
:fWidget(0)
,fX(0)
,fY(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("OnX::CallbackData");
}
//////////////////////////////////////////////////////////////////////////////
OnX::CallbackData::CallbackData(
 Slash::UI::IWidget* aWidget
,const std::string& aComponent
,const std::string& aValue
,const std::string& aEvent
,int aX
,int aY
) 
:fWidget(aWidget)
,fComponent(aComponent)
,fValue(aValue)
,fEvent(aEvent)
,fX(aX)
,fY(aY)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("OnX::CallbackData");
}
//////////////////////////////////////////////////////////////////////////////
OnX::CallbackData::CallbackData(
 const CallbackData& aData
) 
:Slash::UI::ICallbackData(aData)
,fWidget(aData.fWidget)
,fComponent(aData.fComponent)
,fValue(aData.fValue)
,fEvent(aData.fEvent)
,fX(aData.fX)
,fY(aData.fY)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::increment("OnX::CallbackData");
}
//////////////////////////////////////////////////////////////////////////////
OnX::CallbackData::~CallbackData(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  Lib::Debug::decrement("OnX::CallbackData");
}
//////////////////////////////////////////////////////////////////////////////
OnX::CallbackData& OnX::CallbackData::operator =(
 const CallbackData& aData
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fWidget = aData.fWidget;
  fComponent = aData.fComponent;
  fValue = aData.fValue;
  fEvent = aData.fEvent;
  fX = aData.fX;
  fY = aData.fY;
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
Slash::UI::IWidget* OnX::CallbackData::widget(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fWidget;
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::CallbackData::component(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fComponent;
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::CallbackData::value(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fValue;
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::CallbackData::event(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fEvent;
}
//////////////////////////////////////////////////////////////////////////////
int OnX::CallbackData::x(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fX;
}
//////////////////////////////////////////////////////////////////////////////
int OnX::CallbackData::y(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fY;
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::CallbackData::copy(
 const ICallbackData& aFrom
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fWidget = aFrom.widget();
  fComponent = aFrom.component();
  fValue = aFrom.value();
  fEvent = aFrom.event();
  fX = aFrom.x();
  fY = aFrom.y();
  return true;
}
