//////////////////////////////////////////////////////////////////////////////
void OnX::BaseUI::addFactory(
 Slash::UI::IWidgetFactory* aFactory
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fFactories.push_back(aFactory);
}
//////////////////////////////////////////////////////////////////////////////
Lib::ItemML* OnX::BaseUI::topItemML(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fTopItemML;
}
//////////////////////////////////////////////////////////////////////////////
Lib::ItemMLFactory& OnX::BaseUI::itemMLFactory(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fWidgetFactory;
}
//////////////////////////////////////////////////////////////////////////////
void OnX::BaseUI::addWidgetClass(
 Slash::UI::IWidgetClass* aClass
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fWidgetClasses.push_back(aClass);
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::BaseUI::createWidgetName(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string name;
  Lib::smanip::printf(name,256,"OnX_Component_%d",fWidgetNameCounter);
  fWidgetNameCounter++;
  return name;
}
//////////////////////////////////////////////////////////////////////////////
static bool isGeneratedName(
 const std::string& aString
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //OnX_Component_
  //012345678901234
  if(aString.size()<=14) return false;
  int i;
  return Lib::smanip::toint(aString.substr(14,aString.size()-14),i);
}
//////////////////////////////////////////////////////////////////////////////
void OnX::BaseUI::createWidgetTable(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> sChilds;
  std::vector<std::string> sAttrs;
  std::vector<std::string> sProps;
  std::vector<std::string> sCbs;

  //tooltip, pixmap : only at the creation
  std::string containers = "\
VContainer\n\
HContainer\n\
TabStack\n\
VBox\n\
HBox\n\
VPaned\n\
HPaned\n\
Reference";
  std::string leaves = "\
ScrolledText\n\
ScrolledList\n\
ScrolledTree\n\
VScrollBar\n\
HScrollBar\n\
VScale\n\
HScale\n\
ComboBox\n\
Label\n\
PushButton\n\
CommandLine\n\
OptionMenu\n\
ProgressBar\n\
OpenGLArea\n\
PageViewer\n\
PlanePageViewer\n\
Entry\n\
Password\n\
ToggleButton";

  // CallbackList "valueChanged activate create select complete collect drag increment decrement popup update" paint event"


  // Containers

  Lib::smanip::lines("Window\nDialog\nReference",sChilds);
  Lib::smanip::lines("name\nclass\nversion",sAttrs);
  Lib::smanip::lines("",sProps);
  Lib::smanip::lines("create",sCbs);
  //FIXME fWidgetClasses.push_back(new WidgetClass("OnX",sChilds,sAttrs,sProps,sCbs));

  // no more attributes except "name" and "class"
  Lib::smanip::lines("name\nclass",sAttrs);

  Lib::smanip::lines(std::string("Window\nMenuBar\nDialog\nToolBar\nWarningDialog")+"\n"+containers +"\n"+leaves,sChilds);
  Lib::smanip::lines("geometry\ndecoration\ntitle\nshow\nbackground\nforeground",sProps);
  Lib::smanip::lines("create",sCbs);
  Lib::smanip::lines("close",sCbs);
  fWidgetClasses.push_back(new WidgetClass("Window",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("CascadeButton\nReference",sChilds);
  Lib::smanip::lines("background\nforeground",sProps);
  Lib::smanip::lines("",sCbs);
  fWidgetClasses.push_back(new WidgetClass("MenuBar",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("MenuItem\nMenuSeparator\nToggleMenuItem\nCascadeButton\nReference",sChilds);
  Lib::smanip::lines("background\nforeground",sProps);
  Lib::smanip::lines("",sCbs);
  fWidgetClasses.push_back(new WidgetClass("Menu",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("Menu\nReference",sChilds);
  Lib::smanip::lines("label\npixmap\ntooltip\nbackground\nforeground",sProps);
  Lib::smanip::lines("activate",sCbs);
  Lib::smanip::lines("cascading",sCbs);
  fWidgetClasses.push_back(new WidgetClass("CascadeButton",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("ToolBarItem\nComboBox\nLabel\nPushButton\nCommandLine\nOptionMenu\nProgressBar\nPassword\nEntry",sChilds);
  Lib::smanip::lines("background\nforeground",sProps);
  Lib::smanip::lines("",sCbs);
  fWidgetClasses.push_back(new WidgetClass("ToolBar",sChilds,sAttrs,sProps,sCbs));


  // sChild = container & leaves
  Lib::smanip::lines(containers+"\n"+leaves,sChilds);
  //  Lib::smanip::lines("name",sAttrs);

  Lib::smanip::lines("expand\nbackground",sProps);
  Lib::smanip::lines("",sCbs);
  fWidgetClasses.push_back(new WidgetClass("VBox",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("HBox",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background",sProps);
  fWidgetClasses.push_back(new WidgetClass("VContainer",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("HContainer",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("splitPosition\nbackground",sProps);
  fWidgetClasses.push_back(new WidgetClass("VPaned",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("HPaned",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("tabLabel\nbackground\nforeground",sProps);
  Lib::smanip::lines("select",sCbs);

  fWidgetClasses.push_back(new WidgetClass("TabStack",sChilds,sAttrs,sProps,sCbs));
  Lib::smanip::lines("geometry\ndecoration\ntitle\nshow\nbackground\nforeground",sProps);
  Lib::smanip::lines("create",sCbs);
  fWidgetClasses.push_back(new WidgetClass("Dialog",sChilds,sAttrs,sProps,sCbs));


  // leaves : no more sChilds
  sChilds.clear();
  sChilds.resize(0);
  //  Lib::smanip::lines("name",sAttrs);

  Lib::smanip::lines("selection\nitems\nbackground\nforeground",sProps);
  Lib::smanip::lines("select",sCbs);
  fWidgetClasses.push_back(new WidgetClass("ScrolledList",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("title\ndirMask\ndirectory\nbackground\nforeground",sProps);
  Lib::smanip::lines("ok\ncancel",sCbs);
  fWidgetClasses.push_back(new WidgetClass("FileSelection",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background\nforeground",sProps);
  Lib::smanip::lines("ok",sCbs);
  fWidgetClasses.push_back(new WidgetClass("ColorSelection",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background\nforeground",sProps);
  Lib::smanip::lines("select\nselectBranch\nopen\nclose",sCbs);
  fWidgetClasses.push_back(new WidgetClass("ScrolledTree",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("value\nbackground\nforeground",sProps);
  Lib::smanip::lines("drag\nvalueChanged\nincrement\ndecrement",sCbs);
  fWidgetClasses.push_back(new WidgetClass("VScrollBar",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("HScrollBar",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("value\nbackground\nforeground\nminimum\nmaximum",sProps);
  Lib::smanip::lines("drag",sCbs);
  fWidgetClasses.push_back(new WidgetClass("VScale",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("HScale",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("value\ndefault\nitems\nbackground\nforeground",sProps);
  Lib::smanip::lines("valueChanged",sCbs);
  fWidgetClasses.push_back(new WidgetClass("ComboBox",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("value\nbackground\nforeground",sProps);
  Lib::smanip::lines("activate\ncomplete",sCbs);
  fWidgetClasses.push_back(new WidgetClass("CommandLine",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("value\nlabel\nitems\ndefault\nbackground\nforeground",sProps);
  Lib::smanip::lines("valueChanged",sCbs);
  fWidgetClasses.push_back(new WidgetClass("OptionMenu",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("popupItems\nbackground",sProps);
  Lib::smanip::lines("collect\npopup\nupdate",sCbs);
  fWidgetClasses.push_back(new WidgetClass("PageViewer",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("PlanePageViewer",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("",sProps);
  Lib::smanip::lines("",sCbs);
  fWidgetClasses.push_back(new WidgetClass("SoExaminerViewer",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("SoPlaneViewer",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("SoWalkViewer",sChilds,sAttrs,sProps,sCbs));
  fWidgetClasses.push_back(new WidgetClass("SoFlyViewer",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background",sProps);
  Lib::smanip::lines("paint\nevent",sCbs);
  fWidgetClasses.push_back(new WidgetClass("OpenGLArea",sChilds,sAttrs,sProps,sCbs));


  // activate callbacks
  Lib::smanip::lines("activate",sCbs);
  //  Lib::smanip::lines("name",sAttrs);
  //  Lib::smanip::lines("",sChilds);

  Lib::smanip::lines("background\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("Password",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("value\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("Entry",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("label\npixmap\ntooltip\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("ToolBarItem",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("label\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("PushButton",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("set\nlabel\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("ToggleButton",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background\nforeground\nlabel",sProps);
  fWidgetClasses.push_back(new WidgetClass("MenuItem",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("label\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("ToggleMenuItem",sChilds,sAttrs,sProps,sCbs));

  // no more callbacks
  Lib::smanip::lines("",sCbs);
  //  Lib::smanip::lines("name",sAttrs);
  //  Lib::smanip::lines("",sChilds);

  Lib::smanip::lines("value\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("ScrolledText",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background\nforeground\ntitle\ngeometry\ndecoration",sProps);
  fWidgetClasses.push_back(new WidgetClass("WarningDialog",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("label\nlabelString\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("Label",sChilds,sAttrs,sProps,sCbs));

  Lib::smanip::lines("background\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("MenuSeparator",sChilds,sAttrs,sProps,sCbs));
 
  Lib::smanip::lines("value\nbackground\nforeground",sProps);
  fWidgetClasses.push_back(new WidgetClass("ProgressBar",sChilds,sAttrs,sProps,sCbs));

  //no name
  //  Lib::smanip::lines("",sChilds);
  Lib::smanip::lines("class\nfile",sAttrs);
  Lib::smanip::lines("",sProps);
  //FIXME fWidgetClasses.push_back(new WidgetClass("Reference",sChilds,sAttrs,sProps,sCbs));

  return;
}

//////////////////////////////////////////////////////////////////////////////
void OnX::BaseUI::createLanguageList(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // FIXME : get this list from the System manager
 
  fCallbackLanguageList.push_back("DLD");
  fCallbackLanguageList.push_back("tcl");
  fCallbackLanguageList.push_back("cint");
  fCallbackLanguageList.push_back("kuip");
  fCallbackLanguageList.push_back("system");
  fCallbackLanguageList.push_back("sh");
  fCallbackLanguageList.push_back("DOS");
  fCallbackLanguageList.push_back("java");
}
//////////////////////////////////////////////////////////////////////////////
void OnX::BaseUI::createPropertyList(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  fPropertyList.push_back("foreground background");
  fPropertyList.push_back("color");

  fPropertyList.push_back("title label labelString tooltip dirMask tabLabel");
  fPropertyList.push_back("string");

  fPropertyList.push_back("directory pixmap file");
  fPropertyList.push_back("file");

  fPropertyList.push_back("value");
  fPropertyList.push_back("value");

  fPropertyList.push_back("set show opened");
  fPropertyList.push_back("bool");

  fPropertyList.push_back("selection default");
  fPropertyList.push_back("selection");

  fPropertyList.push_back("geometry");
  fPropertyList.push_back("geometry");

  fPropertyList.push_back("decoration");
  fPropertyList.push_back("decoration");

  fPropertyList.push_back("expand");
  fPropertyList.push_back("expand");

  fPropertyList.push_back("splitPosition sizeOfFixed value minimum maximum");
  fPropertyList.push_back("int");

  fPropertyList.push_back("items popupItems");
  fPropertyList.push_back("items");
}
//////////////////////////////////////////////////////////////////////////////
bool OnX::BaseUI::propertyType(
 const std::string& aName
,std::string& aValue
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  for (unsigned int index=0;index<fPropertyList.size();index += 2) {
    if((" "+fPropertyList[index]+" ").find(" "+aName+" ") != std::string::npos) {
      aValue = fPropertyList[index+1];
      return true;
    }
  }
  return false;
}
//////////////////////////////////////////////////////////////////////////////
const std::vector<std::string>& OnX::BaseUI::callbackLanguageList(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return fCallbackLanguageList;
}
//////////////////////////////////////////////////////////////////////////////
Slash::UI::IWidgetClass* OnX::BaseUI::findWidgetClass(
 const std::string& aName
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int number = fWidgetClasses.size();
  for (unsigned int index=0;index<number;index++) {
    if (fWidgetClasses[index]->name() == aName) {
      return fWidgetClasses[index];
    } 
  }
  return 0;
}

bool OnX::BaseUI::loadReferenceFile(Lib::ItemML& aItemML,const std::string& aFile){
  // Load a file and add its items in the aItemML tree
  // insert a <reference> tag before the insertion of item
  // this is useful for inserting file from other files.onx 
  if(!fTopItemML) return false;
  
  // build a new component
  // build a label/title propertie if necessairy
  std::vector<Lib::ItemML::Attribute> atts;
  Lib::ItemML* itemML = fWidgetFactory.create("reference",atts,&aItemML);
  if(!itemML) return false;
  
  std::string name = buildName(*itemML);
  if(!itemML->setAttributeValue("","file",aFile))  {
    delete itemML;
    return false;
  }
  Lib::ItemML* top;
  if(!load(itemML,aFile,true,true,true,top)) {
    delete itemML;
    return false;
  }

  aItemML.addChild(itemML);

  return true;
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::BaseUI::tree(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!fTopItemML) return "";
  return "<tree><treeItem>"+subTree(*fTopItemML,2)+"</treeItem></tree>";
}
//////////////////////////////////////////////////////////////////////////////
std::string OnX::BaseUI::subTree(
 Lib::ItemML& aItemML
,int depth
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string line;
  std::string value;
  std::string spaceItem = "";
  std::string spaceRoot = "";
  //spaceItem.insert(0,depth*2,' ');
  //spaceRoot.insert(0,(depth-1)*2,' ');

  aItemML.attributeValue("","class",value);
  line += spaceItem + "<label>"+value;
  aItemML.attributeValue("","name",value);
  value = Lib::smanip::toxml(value);

  line += " name=\""+value+"\"";
  
  const std::vector<Lib::ItemML::Attribute>& atbs = aItemML.attributes();
  unsigned int atbn = atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    const std::string& atb = atbs[index].first;
    if ((atb != "name") && (atb !="class")){
      line += " "+atb+"=\""+Lib::smanip::toxml(atbs[index].second)+"\"";
    }
  }
  line += "</label>\n";

  std::list<Lib::Element*>::const_iterator it;
  const std::list<Lib::Element*>& props = aItemML.properties();
  for(it=props.begin();it!=props.end();++it) {
    line += spaceRoot + "<treeItem>";
    value = Lib::smanip::toxml((*it)->value());
    
    const std::vector<Lib::ItemML::Attribute>& atbs = (*it)->attributes();
    if (atbs.size() == 0){
      line += spaceItem+"<label>"+(*it)->name()+"=\""+value+"\"</label>";      

    } else {
      line += spaceItem+"<label>"+(*it)->name()+" ";      
      for (unsigned int b=0;b<atbs.size();b++) {
        line += atbs[b].first+"=\""+atbs[b].second+"\" ";
      }
      line += "value=\""+value+"\"</label>";
    }
    line += spaceRoot + "</treeItem>";
  }

  //line += spaceItem + "<opened>false</opened>";
 {const std::list<Lib::ItemML*>& list = aItemML.children();
  std::list<Lib::ItemML*>::const_iterator it;
  for(it=list.begin();it!=list.end();++it) {
    line += spaceRoot + "<treeItem>";
    line += subTree(*(*it),depth+1);
    line += spaceRoot + "</treeItem>";
  }}
  return line;
}
