//////////////////////////////////////////////////////////////////////////////
bool OnX::BaseUI::createInputDialog(
 Lib::ItemML& aItemML                      
)
//////////////////////////////////////////////////////////////////////////////
// Assume that class of the component element is "Form".
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string inputName = buildName(aItemML);

  //Lib::Out out(printer());
  //out << "InputDialog \"" << inputName << "\"." << Lib::endl;
  
  Lib::ItemML* dialogItemML = 
    createItemML(inputName+"_dialog","Dialog",&aItemML);
  std::string value;
  aItemML.propertyValue("label",value);
  std::vector<Lib::ItemML::Attribute> atts;
  dialogItemML->addProperty("title",atts,value);

  std::string vbox = inputName + "_vbox";
  Lib::ItemML* vBoxItemML = createItemML(vbox,"VBox",dialogItemML);
  vBoxItemML->addProperty("expand",atts,"first");
  vBoxItemML->addProperty("sizeOfFixed",atts,"30");

  std::string vcontainer = inputName + "_vcontainer";
  Lib::ItemML* vContainerItemML = 
    createItemML(vcontainer,"VContainer",vBoxItemML);

  /*
  Lib::ItemML* labelItemML = 
    createItemML(inputName + "_label","Label",vContainerItemML);
  labelItemML->addProperty("label",atts,value);
  */


  // Loop on input properties :
  std::vector<std::string> inputNames;
  const std::list<Lib::Element*>& properties = aItemML.properties();
  std::list<Lib::Element*>::const_iterator it;
  for(it=properties.begin();it!=properties.end();++it) {
    if((*it)->name()=="input") {
      std::string name;
      if(!(*it)->attributeValue("name",name)) {
        Lib::Out out(printer());
        out << "OnX::BaseUI::createInputDialog :" 
            << " An input property must have a name." << Lib::endl;
        return false;
      }
      std::string type;
      (*it)->attributeValue("type",type);
      if((type.empty()) || (type=="text") ) {
        Lib::ItemML* hBoxItemML = 
          createItemML(inputName + "_hbox_" + name,"HBox",vContainerItemML);
        Lib::ItemML* labelItemML = 
          createItemML(inputName + "_label_" + name,"Label",hBoxItemML);
        std::vector<Lib::ItemML::Attribute> atts;
        int length = 0;
        if((*it)->attributeValue("label",value)) {
          labelItemML->addProperty("label",atts,value);
          length = value.size();
        } else {
          labelItemML->addProperty("label",atts,name);
          length = name.size();
        }

        Lib::smanip::printf(value,64,"%d",length * 10);
        hBoxItemML->addProperty("expand",atts,"second");
        hBoxItemML->addProperty("sizeOfFixed",atts,value);

        Lib::ItemML* entryItemML = 
          createItemML(inputName + "_input_" + name,"Entry",hBoxItemML);
        entryItemML->addProperty("background",atts,"white");
        (*it)->attributeValue("default",value);
        entryItemML->addProperty("value",atts,value);

      } else if( (type=="option")|| (type=="combo") ) {

        Lib::ItemML* hBoxItemML = 
          createItemML(inputName+"_hbox_"+name,"HBox",vContainerItemML);

        Lib::ItemML* labelItemML = 
          createItemML(inputName + "_label_" + name,"Label",hBoxItemML);
        std::vector<Lib::ItemML::Attribute> atts;
        int length = 0;
        if((*it)->attributeValue("label",value)) {
          labelItemML->addProperty("label",atts,value);
          length = value.size();
        } else {
          labelItemML->addProperty("label",atts,name);
          length = name.size();
        }

        Lib::smanip::printf(value,64,"%d",length * 10);
        hBoxItemML->addProperty("expand",atts,"second");
        hBoxItemML->addProperty("sizeOfFixed",atts,value);

        Lib::ItemML* optionItemML = createItemML
          (inputName + "_input_" + name,
           (type=="combo"?"ComboBox":"OptionMenu"),hBoxItemML);
        (*it)->attributeValue("items",value);
        optionItemML->addProperty("items",atts,value);
        (*it)->attributeValue("default",value);
        optionItemML->addProperty("default",atts,value);

      } else if( (type=="fileChooser")||(type=="fileSaver")) {
        // Variant of type "text" with the label being
        // now a button mapping a file chooser.

        Lib::ItemML* hBoxItemML = 
          createItemML(inputName + "_hbox_" + name,"HBox",vContainerItemML);

        std::string buttonName = inputName+"_pushbutton_"+name;
        Lib::ItemML* buttonItemML = 
          createItemML(buttonName,"PushButton",hBoxItemML);

        std::vector<Lib::ItemML::Attribute> atts;
        int length = 0;
        if((*it)->attributeValue("label",value)) {
          buttonItemML->addProperty("label",atts,value);
          length = value.size();
        } else {
          buttonItemML->addProperty("label",atts,name);
          length = name.size();
        }

        std::string dirMask;
        if(!(*it)->attributeValue("dirMask",dirMask)) dirMask = "*.*";

        Lib::smanip::printf(value,64,"%d",length * 10);
        hBoxItemML->addProperty("expand",atts,"second");
        hBoxItemML->addProperty("sizeOfFixed",atts,value);

        std::string entryName = inputName + "_input_" + name;
        Lib::ItemML* entryItemML = createItemML(entryName,"Entry",hBoxItemML);
        entryItemML->addProperty("background",atts,"white");
        (*it)->attributeValue("default",value);
        entryItemML->addProperty("value",atts,value);

        // Set the push button script. 
        // It maps a file chooser by passing the name of the entry.
        // The "ok" of the chooser deposits the choosed file 
        // on the entry widget.

       {std::string param = "ui."+buttonName+".script";
        std::string script = 
          "OnX ui_set_parameter "+entryName+".value @this.value@";
        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("name",param));
        buttonItemML->addProperty("session_parameter",atts,script);
        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
        std::string s = (type=="fileChooser"?"open":"save");
        buttonItemML->addProperty
          ("activate",atts,"OnX ui_set_file_chooser . "+dirMask+" "+s+" DLD @session@"+param+"@");}

        buttonItemML->addProperty
          ("activate",atts,"OnX ui_show fileChooser");
        atts.clear();

      } else if(type=="colorChooser") {
        // Variant of type "combo" with the label being
        // now a button mapping a color chooser.

        Lib::ItemML* hBoxItemML = 
          createItemML(inputName+"_hbox_"+name,"HBox",vContainerItemML);

        std::string buttonName = inputName+"_pushbutton_"+name;
        Lib::ItemML* buttonItemML = 
          createItemML(buttonName,"PushButton",hBoxItemML);

        std::vector<Lib::ItemML::Attribute> atts;
        int length = 0;
        if((*it)->attributeValue("label",value)) {
          buttonItemML->addProperty("label",atts,value);
          length = value.size();
        } else {
          buttonItemML->addProperty("label",atts,name);
          length = name.size();
        }

        Lib::smanip::printf(value,64,"%d",length * 10);
        hBoxItemML->addProperty("expand",atts,"second");
        hBoxItemML->addProperty("sizeOfFixed",atts,value);

        std::string comboName = inputName + "_input_" + name;
        Lib::ItemML* optionItemML = 
          createItemML(comboName,"ComboBox",hBoxItemML);
        (*it)->attributeValue("items",value);
        optionItemML->addProperty("items",atts,value);
        (*it)->attributeValue("default",value);
        optionItemML->addProperty("default",atts,value);

        // Set the push button script. 
        // It maps a color chooser by passing the name of the combo. 
        // The "ok" of the chooser deposits the choosed color on the 
        // combo.
        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("exec","DLD"));

       {std::string param = "ui."+buttonName+".script";
        std::string script = 
          "OnX ui_set_parameter "+comboName+".default @this.value@";
        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("name",param));
        buttonItemML->addProperty("session_parameter",atts,script);
        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
        std::string s = (type=="fileChooser"?"open":"save");
        buttonItemML->addProperty("activate",atts,
          "OnX ui_set_callback colorChooser ok DLD @session@"+param+"@");}

        buttonItemML->addProperty("activate",atts,"OnX ui_show colorChooser");
        atts.clear();

      } else if( (type=="scale")||(type=="scrollBar")) {

        // Box(Box2(Label,Entry),Scale)
        Lib::ItemML* hBoxItemML = 
          createItemML(inputName + "_hbox_" + name,"HBox",vContainerItemML);
        hBoxItemML->addProperty("expand",atts,"second");
        hBoxItemML->addProperty("sizeOfFixed",atts,"150");

        // Box2(Label,Entry)
        Lib::ItemML* hBox2ItemML = 
          createItemML(inputName + "_hbox2_" + name,"HBox",hBoxItemML);

        Lib::ItemML* labelItemML = 
          createItemML(inputName + "_label_" + name,"Label",hBox2ItemML);
        std::vector<Lib::ItemML::Attribute> atts;
        int length = 0;
        if((*it)->attributeValue("label",value)) {
          labelItemML->addProperty("label",atts,value);
          length = value.size();
        } else {
          labelItemML->addProperty("label",atts,name);
          length = name.size();
        }

        Lib::smanip::printf(value,64,"%d",length * 10);
        hBox2ItemML->addProperty("expand",atts,"second");
        hBox2ItemML->addProperty("sizeOfFixed",atts,value);

        std::string entryName = inputName + "_input_" + name;
        Lib::ItemML* entryItemML = createItemML(entryName,"Entry",hBox2ItemML);
        entryItemML->addProperty("background",atts,"white");
        (*it)->attributeValue("default",value);
        entryItemML->addProperty("value",atts,value);

        std::string sliderName = inputName + "_slider_" + name;

        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
        entryItemML->addProperty("activate",atts,
          "OnX ui_set_parameter "+sliderName+".value @this.value@");
        atts.clear();

        Lib::ItemML* sliderItemML = 
          createItemML(sliderName,
            (type=="scale"?"HScale":"HScrollBar"),hBoxItemML);
        (*it)->attributeValue("default",value);
        sliderItemML->addProperty("value",atts,value);
        (*it)->attributeValue("minimum",value);
        sliderItemML->addProperty("minimum",atts,value);
        (*it)->attributeValue("maximum",value);
        sliderItemML->addProperty("maximum",atts,value);

        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
        sliderItemML->addProperty("valueChanged",atts,
          "OnX ui_set_parameter "+entryName+".value @this.value@");
        sliderItemML->addProperty("drag",atts,
          "OnX ui_set_parameter "+entryName+".value @this.value@");
        sliderItemML->addProperty("increment",atts,
          "OnX ui_set_parameter "+entryName+".value @this.value@");
        sliderItemML->addProperty("decrement",atts,
          "OnX ui_set_parameter "+entryName+".value @this.value@");
        atts.clear();

      } else {
        Lib::Out out(printer());
        out << "OnX::BaseUI::createInputDialog :" 
            << " unknown type " << Lib::sout(type)
            << Lib::endl;
        return false;
      }

      inputNames.push_back(name);
    }
  }

  int margin = 5;
  int hchild = 35;
  if(cast("OnX::NS_UI")) { //FIXME. And remove the Slash::UI::IUI::cast ?
    margin = 0;
    hchild = 30;
  }
  
  // WIN32 : set geometry (mainly height) of the dialog :
  std::string sgeom;
  // WinTk::[V,H}Container has a margin of 5 :
  int childn = inputNames.size()+1;
  Lib::smanip::printf(sgeom,256,"%dx%d",300,margin + childn * (hchild + margin));
  dialogItemML->addProperty("geometry",atts,sgeom);

  Lib::ItemML* hContainerItemML = 
    createItemML(inputName + "_hcontainer","HContainer",vBoxItemML);

  // Ok button :
  Lib::ItemML* okItemML = 
    createItemML(inputName + "_ok","PushButton",hContainerItemML);
  okItemML->addProperty("label",atts,"Ok");
  // Apply button :
  Lib::ItemML* applyItemML = 
    createItemML(inputName + "_apply","PushButton",hContainerItemML);
  applyItemML->addProperty("label",atts,"Apply");
  atts.clear();
  atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
  okItemML->addProperty("activate",atts,"OnX ui_hide "+inputName+"_dialog");
  // Get the scripts :
 {const std::list<Lib::Element*> props = aItemML.properties();
  std::list<Lib::Element*>::const_iterator it;
  for(it=props.begin();it!=props.end();++it) {
    if((*it)->name()!="ok") continue;
    std::string sexec;
    if((*it)->attributeValue("exec",sexec)) {
      const std::string& value = (*it)->value();
      if(value.size()) {
        if(sexec=="Python") {
          std::string script;
          for(unsigned int index=0;index<inputNames.size();index++) {
            script += inputNames[index];
            script += " = OnX.ui_parameterValue(\"";
            script += inputName;
            script += "_input_";
            script += inputNames[index];
            script += ".value\")\n";
          }
          script += value;
          atts = (*it)->attributes();
          okItemML->addProperty("activate",atts,"import OnX;"+script);
          applyItemML->addProperty("activate",atts,"import OnX;"+script);
        } else {
          atts = (*it)->attributes();
          okItemML->addProperty("activate",atts,value);
          applyItemML->addProperty("activate",atts,value);
        }
      }
    }
  }}

  // Cancel button :
 {Lib::ItemML* cancelItemML = 
    createItemML(inputName + "_cancel","PushButton",hContainerItemML);
  atts.clear();
  atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
  cancelItemML->addProperty
    ("activate",atts,"OnX ui_hide "+inputName+"_dialog");
  atts.clear();
  cancelItemML->addProperty("label",atts,"Cancel");}

  // Reset button :
 {Lib::ItemML* resetItemML = 0;
  const std::list<Lib::Element*> props = aItemML.properties();
  std::list<Lib::Element*>::const_iterator it;
  for(it=props.begin();it!=props.end();++it) {
    if((*it)->name()!="reset") continue;
    std::string sexec;
    if((*it)->attributeValue("exec",sexec)) {
      const std::string& value = (*it)->value();
      if(value.size()) {
        if(!resetItemML) {
          resetItemML = 
            createItemML(inputName + "_reset","PushButton",hContainerItemML);
          atts.clear();
          resetItemML->addProperty("label",atts,"Reset");
        }
        atts = (*it)->attributes();
        resetItemML->addProperty("activate",atts,value);
      }
    }
  }}

  // Help button :
 {Lib::ItemML* helpItemML = 0;
  const std::list<Lib::Element*> props = aItemML.properties();
  std::list<Lib::Element*>::const_iterator it;
  for(it=props.begin();it!=props.end();++it) {
    if((*it)->name()!="help") continue;    
    std::string sfile;
    if((*it)->attributeValue("file",sfile)) {
      if(sfile.size()) {
        if(!helpItemML) {
          helpItemML = 
            createItemML(inputName + "_help","PushButton",hContainerItemML);
          atts.clear();
          helpItemML->addProperty("label",atts,"Help");
        }
        atts.clear();
        atts.push_back(Lib::ItemML::Attribute("exec","DLD"));
        helpItemML->addProperty("activate",atts,"OnX ui_help_file "+sfile);
      }
    }
  }}

  return true;
}
