// this :
#include <OnX/Core/Widget.h>

#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/Cast.h>
#include <Lib/smanip.h>

#include <Slash/UI/IWidgetClass.h>
#include <Slash/UI/IUI.h>

#include "../source/Core/Proxy.h"

OnX::Widget::Widget(
 Slash::UI::IUI& aUI
,Lib::ItemMLFactory& aFactory
,Lib::ItemML* aParent
,Slash::UI::IWidgetClass& aWidgetClass
)
:Lib::ItemML("widget",aFactory,aParent)
,fUI(aUI) //FIXME
,fWidgetClass(aWidgetClass)
,fWidget(0)
,fProxy(0)
{}

OnX::Widget::~Widget() {
  //if(fUI.currentWidget()==this) fUI.setCurrentWidget(0); //FIXME
}

void* OnX::Widget::cast(const std::string& aClass) const {
  if_Lib_SCast(OnX::Widget)
  else if_Lib_SCast(Slash::UI::IWidget)
  else return Lib::ItemML::cast(aClass);
}

std::string OnX::Widget::name() const { 
  std::string value;
  attributeValue("","name",value);
  return value;
}

const Slash::UI::IWidgetClass& OnX::Widget::widgetClass() const {
  return fWidgetClass;
}

void* OnX::Widget::nativeWidget() const {return getData1();}

void OnX::Widget::setProxy(void* aWidget,Proxy aProxy) { 
  fWidget = aWidget;
  fProxy = aProxy;
}

bool OnX::Widget::invalidate() {
  setData(0,0,0);
  return true;
}

bool OnX::Widget::size(unsigned int& aW,unsigned int& aH) {
  if(!fProxy) return false;
  std::vector<std::string> args;
  void* ret;
  if(!fProxy(fWidget,PX_SIZE,args,ret)) return false;
  typedef unsigned int uint_t;
  uint_t* sz = (uint_t*)ret;
  aW = sz[0];
  aH = sz[1];
  delete [] sz;        
  return true;
}

bool OnX::Widget::position(int& aX,int& aY) {
  if(!fProxy) return false;
  std::vector<std::string> args;
  void* ret;
  if(!fProxy(fWidget,PX_POSITION,args,ret)) return false;
  int* pos = (int*)ret;
  aX = pos[0];
  aY = pos[1];
  delete [] pos;        
  return true;
}

bool OnX::Widget::write(
 const std::string& aFile
,const std::string& aFormat
,const std::string& aOptions
)
{
  if(!fProxy) return false;
  std::vector<std::string> args;
  args.push_back(aFile);
  args.push_back(aFormat);
  args.push_back(aOptions);
  void* ret;
  return fProxy(fWidget,PX_WRITE,args,ret);
}

bool OnX::Widget::manage(bool a_yes_no) {
  if(!fProxy) return false;
  std::vector<std::string> args;
  args.push_back(Lib::smanip::tostring(a_yes_no));
  void* ret;
  return fProxy(fWidget,PX_MANAGE,args,ret);
}

bool OnX::Widget::show(){
  if(!fProxy) return false;
  std::vector<std::string> args;
  void* ret;
  return fProxy(fWidget,PX_SHOW,args,ret);
}

bool OnX::Widget::hide(){
  if(!fProxy) return false;
  std::vector<std::string> args;
  void* ret;
  return fProxy(fWidget,PX_HIDE,args,ret);
}

bool OnX::Widget::refresh(){
  if(!fProxy) return false;
  std::vector<std::string> args;
  void* ret;
  return fProxy(fWidget,PX_REFRESH,args,ret);
}

bool OnX::Widget::setParameter(const std::string& aName,const std::string& aValue){
  //FIXME : avoid passing by IUI.
  return fUI.setParameter(name()+"."+aName,aValue);
}

bool OnX::Widget::parameterValue(const std::string& aName,std::string& aValue){
  //FIXME : avoid passing by IUI.
  return fUI.parameterValue(name()+"."+aName,aValue);
}

#include <Lib/Element.h>
#include <OnX/Core/CallbackData.h>
bool OnX::Widget::executeCallbacks(const std::string& aCallback){
  std::string name;
  attributeValue("","name",name);
  const std::list<Lib::Element*> props = properties();
  bool found = false;
  std::list<Lib::Element*>::const_iterator it;
  for(it=props.begin();it!=props.end();++it) {
    if(aCallback==(*it)->name()) {

      std::string sexec;
      (*it)->attributeValue("exec",sexec);

      fUI.setCallbackData(CallbackData(this,name,"","",0,0));
      fUI.executeScript(sexec,(*it)->value(),(*it)->attributes()); //FIXME : ret val
      fUI.setCallbackData(CallbackData());

      found = true;
    }
  }
  return found;
}
