// this :
#include <OnX/Core/WidgetFactory.h>

// Slash :
#include <Slash/UI/IWidgetClass.h>
#include <Slash/UI/IUI.h>
#include <Slash/UI/ISoViewer.h>

#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/smanip.h>
#include <Lib/Cast.h>

#include "Widgets.cxx" //FIXME : should be Widgets.h

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
OnX::WidgetFactory::WidgetFactory(
 Slash::UI::IUI& aUI
,Slash::Core::IWriter& aPrinter
,const std::vector<Slash::UI::IWidgetClass*>& aWidgetClasses
)
:Lib::ItemMLFactory()
,fUI(aUI)
,fPrinter(aPrinter)
,fWidgetClasses(aWidgetClasses)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
OnX::WidgetFactory::~WidgetFactory(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
Slash::UI::IWidgetClass* OnX::WidgetFactory::findWidgetClass(
 const std::string& aName
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  unsigned int number = fWidgetClasses.size();
  for (unsigned int index=0;index<number;index++) {
    if (fWidgetClasses[index]->name()==aName) {
      return fWidgetClasses[index];
    } 
  }
  return 0;
}
//////////////////////////////////////////////////////////////////////////////
Lib::ItemML* OnX::WidgetFactory::create(
 const std::string& aTagName
,const std::vector<Lib::ItemML::Attribute>& aAtts
,Lib::ItemML* aParent
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  bool save = true;
 {unsigned int linen = aAtts.size();
  for(unsigned int index=0;index<linen;index++) {
    if(aAtts[index].first=="save") {
      if(!Lib::smanip::tobool(aAtts[index].second,save)) save = true;
      break;
    }
  }}

  if(aTagName=="widget") {

    std::string sclass;

   {unsigned int linen = aAtts.size();
    for(unsigned int index=0;index<linen;index++) {
      if(aAtts[index].first=="class") {
        sclass = aAtts[index].second;
        break;
      }
    }}

    if(sclass=="InputDialog") {
      Lib::ItemML* itemML = new Lib::ItemML(aTagName,*this,aParent);
      itemML->setAttributes(aAtts);
      itemML->setSaveFlag(save);
      return itemML;
    }

    if(sclass=="Copy") {
      Lib::ItemML* itemML = new Lib::ItemML(aTagName,*this,aParent);
      itemML->setAttributes(aAtts);
      itemML->setSaveFlag(save);
      return itemML;
    }

    Slash::UI::IWidgetClass* widgetClass = findWidgetClass(sclass);  
    if(widgetClass) {
      if( (widgetClass->name()=="PageViewer") ||
          (widgetClass->name()=="PlanePageViewer") ||
          (widgetClass->name()=="SoExaminerViewer") ||
          (widgetClass->name()=="SoPlaneViewer") ||
          (widgetClass->name()=="SoWalkViewer") ||
          (widgetClass->name()=="SoFlyViewer") ) {
        Lib::ItemML* itemML = new SoViewer(fUI,*this,aParent,*widgetClass);
        itemML->setAttributes(aAtts);
        itemML->setSaveFlag(save);
        return itemML;
	/*
      } else if(widgetClass->name()=="ScrolledTree") {
        Lib::ItemML* itemML = new OpenGLArea(*this,aParent,*widgetClass);
        itemML->setAttributes(aAtts);
        itemML->setSaveFlag(save);
        return itemML;
      } else if(widgetClass->name()=="OpenGLArea") {
        Lib::ItemML* itemML = new OpenGLArea(*this,aParent,*widgetClass);
        itemML->setAttributes(aAtts);
        itemML->setSaveFlag(save);
        return itemML;
        */
      } else {
        Lib::ItemML* itemML = new Widget(fUI,*this,aParent,*widgetClass);
        itemML->setAttributes(aAtts);
        itemML->setSaveFlag(save);
        return itemML;
      }
    } else {
      Lib::Out out(fPrinter);
      out << "OnX::WidgetFactory::create :"
          << " Slash::UI::IWidgetClass not found for " << Lib::sout(sclass) << "."
          << Lib::endl;
      return 0;
    }
  } else { //OnX, reference, comment are not widgets.
    //Lib::Out out(fPrinter);
    //out << "OnX::WidgetFactory::create :"
    //  << " WARNING : Slash::UI::IWidgetClass not found for " << Lib::sout(aClass) << "."
    //    << Lib::endl;
    Lib::ItemML* itemML = new Lib::ItemML(aTagName,*this,aParent);
    itemML->setAttributes(aAtts);
    itemML->setSaveFlag(save);
    return itemML;
  }
}



