// this :
#include <OnX/Inventor/Inventor.h>

// Slash :
#include <Slash/Core/ISession.h>
#include <Slash/Core/IWriter.h>

// Inventor :
#include <Inventor/errors/SoDebugError.h>

static SoErrorCB* sOld_HandlerCallback = 0;
static void* sOld_HandlerData = 0;

static void SoErrorCB_function(const SoError* aError,void* aData){
  Slash::Core::ISession* session = (Slash::Core::ISession*)aData;
  session->printer().write(aError->getDebugString().getString());  
  session->printer().write("\n");  
}

void OnX::Inventor::initialize(Slash::Core::ISession& aSession){
  sOld_HandlerCallback = SoDebugError::getHandlerCallback();
  sOld_HandlerData = SoDebugError::getHandlerData();

  SoDebugError::setHandlerCallback(SoErrorCB_function,&(aSession));
}

void OnX::Inventor::finalize(Slash::Core::ISession&){
  if(sOld_HandlerCallback) {
    SoDebugError::setHandlerCallback(sOld_HandlerCallback,sOld_HandlerData);
  }
}

