// this :
#import <OnX/SDL/NS.h>

#include <SDL/SDL.h>

// NextStep :

#import <Foundation/NSObject.h>
#import <Foundation/NSAutoReleasePool.h>
#import <Foundation/NSString.h>
#import <Foundation/NSBundle.h>
#import <AppKit/NSApplication.h>
#import <AppKit/NSMenu.h>
#import <AppKit/NSNibLoading.h>

#include <Inventor/SDL/SoSDL.h>

namespace OnX {class NS_private;}

#if MAC_OS_X_VERSION_MAX_ALLOWED <= MAC_OS_X_VERSION_10_5
@interface OnX_NSApplicationDelegate : NSObject {
#else
@interface OnX_NSApplicationDelegate : NSObject<NSApplicationDelegate> {
#endif
  OnX::NS_private* fPrivate;
}
- (id)initWithPrivate:(OnX::NS_private*)aPrivate;
- (void)dealloc;
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication*)aSender;
@end


namespace OnX {
class NS_private {
public:
  NSAutoreleasePool* fAutoreleasePool;
  NSApplication* fApplication;
  OnX_NSApplicationDelegate* fAppDelegate;
  std::string fOpenFile;
};
}

@implementation OnX_NSApplicationDelegate
- (id)initWithPrivate:(OnX::NS_private*)aPrivate {
  fPrivate = 0;
  if(self = [super init]) {
    fPrivate = aPrivate;
  }
  return self;
}
- (void)dealloc {
  [super dealloc];
}
- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication*)aSender {
  //NSLog(@"debug : delegate terminate\n");
  // Remove .log_tmp, .err, .out files :
  return NSTerminateNow;
}
- (void) applicationDidFinishLaunching: (NSNotification*) note {
  //NSLog(@"debug : applicationDidFinishLaunching\n");
}
- (BOOL)application:(NSApplication *)app openFile:(NSString*)aFile {
  //NSLog(@"debug : open : %s\n",[aFile UTF8String]);
  fPrivate->fOpenFile = std::string([aFile UTF8String]);
  return YES;
}
@end

OnX::NS::NS():fPrivate(0){
  fPrivate = new NS_private();
  fPrivate->fAutoreleasePool = 0;
  fPrivate->fApplication = 0;
  fPrivate->fAppDelegate = 0;

  //NSLog(@"debug : ================================== : 0003\n");
  // Initialize NS (NextStep) :

  fPrivate->fAutoreleasePool = [[NSAutoreleasePool alloc] init];
  fPrivate->fApplication = [NSApplication sharedApplication];  

  fPrivate->fAppDelegate = 
    [[OnX_NSApplicationDelegate alloc] initWithPrivate:fPrivate];
  [fPrivate->fApplication setDelegate:fPrivate->fAppDelegate];

  NSString* nsapp = [[NSString alloc] initWithCString:"OnX"];
  //NSImage* image = [NSImage imageNamed:nsapp];
  //[fPrivate->fApplication setApplicationIconImage:image];

  // Could have the menubar done in a .nib with InterfaceBuilder.
  BOOL status = [NSBundle loadNibNamed:nsapp owner:fPrivate->fApplication];
  if(status==NO) {
  }
  [nsapp release];

  //if(![fPrivate->fApplication mainMenu]) {
    //NOTE : no mainMenu, then the Apple application
    //       pdm is empty. Then the .onx file should
    //       have a way to exit properly.

    //NSMenu* menu = [[NSMenu allocWithZone:[NSMenu menuZone]] init];
    //[fPrivate->fApplication setMainMenu:menu];
    //[menu release];

    //FIXME : set by programm an Apple application pdm.
    // See SDLMain.m...
  //}

  [fPrivate->fApplication finishLaunching];
}

OnX::NS::~NS() { 
  //NSLog(@"debug : OnX::NS::~NS\n");
  [fPrivate->fApplication setDelegate:nil];
  [fPrivate->fAppDelegate release];
  //FIXME : the below crash if we exit the NS::steer with NS::exit.
  //FIXME [fPrivate->fAutoreleasePool release]; //delete the fApplication.
  delete fPrivate;
}

std::string OnX::NS::openFile() const {return fPrivate->fOpenFile;}
void OnX::NS::resetOpenFile() {fPrivate->fOpenFile = "";}

void OnX::NS::put(const char* aString){NSLog(@"%s",aString);}

void OnX::NS::steer(){
  //NSLog(@"debug : OnX::NS::steer\n");
  if(!fPrivate->fApplication) return;

  //[fPrivate->fApplication run];

  SoSDL::mainLoop();    
  //FIXME :
  // if clicking the opt Exit button with the gamepad,
  // we do not exit of [fPrivate->fApplication run];
  // as long as some other event is send to the desktop !
  // Do a "hard" ::exit here... 
  //SoSDL::clear();  

  //NSLog(@"debug : OnX::NS::steer : end\n");
}

void OnX::NS::exit(){
  if(!fPrivate->fApplication) return;
  //NSLog(@"debug : OnX::NS::exit\n");
  [fPrivate->fApplication stop:nil];
}
