//////////////////////////////////////////////////////////////////////////////
/// Pre SWIG /////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#ifdef SWIGJAVA
// The below induces warnings :
%ignore Lib::smanip::tostring(short);
%ignore Lib::smanip::tostring(unsigned short);
%ignore Lib::smanip::tostring(const char*);
#endif

//////////////////////////////////////////////////////////////////////////////
/// Code to wrap /////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

%include <Lib/smanip.h>
%include <Lib/fmanip.h>
%include <Lib/Randoms.h>

//////////////////////////////////////////////////////////////
/// Post SWIG ////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

// Put helpers as extensions :

%extend Lib::smanip {
  static std::vector<std::string> lines(const std::string& aString) {
    std::vector<std::string> vs;
    Lib::smanip::lines(aString,vs); //FIXME : if(!) throw ?
    return vs;
  }
  static std::string torgbs(const std::string& aString) {
    std::string s;
    Lib::smanip::torgbs(aString,s);
    return s;
  }
  static std::vector<std::string> pathNameSuffix(const std::string& aPath) {
    std::vector<std::string> vs;
    std::string p,n,s;
    Lib::smanip::pathNameSuffix(aPath,p,n,s);
    vs.push_back(p);
    vs.push_back(n);
    vs.push_back(s);
    return vs;
  }
}

%extend Lib::fmanip {
  // SWIG wraps std::string and std::string<std::string>
  // as tuple that are constant list ! Then we can't 
  // use the upper read.
  static std::vector<std::string> read(const std::string& aFile) {
    std::vector<std::string> vs;
    Lib::fmanip::read(aFile,vs);
    return vs;
  }
}
