#ifndef OnXLab_AnalysisFactory_h
#define OnXLab_AnalysisFactory_h

// Inheritance :
#include <BatchLab/Core/AnalysisFactory.h>

namespace OnXLab {

class AnalysisFactory : public BatchLab::AnalysisFactory {
public: //AIDA/IAnalysisFactory
#if (AIDA_VERSION_MAJOR<=3) && (AIDA_VERSION_MINOR<=2) 
  virtual AIDA::ITreeFactory* createTreeFactory();
  virtual AIDA::IPlotterFactory* createPlotterFactory(int = 0,char** = 0,
                                                      const std::string& = "",
                                                      const std::string& = "");
#else
  virtual AIDA::ITreeFactory* createTreeFactory(const std::string&);
  virtual AIDA::IPlotterFactory* createPlotterFactory
    (int = 0,char** = 0,const std::string& = "",const std::string& = "",const std::string& = "");
#endif
public: // Slash::Core::IManager :
  virtual void* cast(const std::string&) const;
public:
  AnalysisFactory(Slash::Core::ISession&);
  virtual ~AnalysisFactory();
};

}

#endif
