#ifndef OnXLab_env_h
#define OnXLab_env_h

#include <Slash/Tools/system.h>

namespace OnXLab {

inline bool set_env(std::ostream& a_out) {

  std::string OSC_HOME_DIR;
  if(!Slash::getenv("OSC_HOME_DIR",OSC_HOME_DIR)) {
    a_out << "OnXLab::set_env :"
          << " environment variable OSC_HOME_DIR not defined."
          << std::endl;
    return false;
  }

  std::string fs = Slash::file_separator();
  std::string ONXLABROOT = OSC_HOME_DIR + fs + "Resources" + fs + "OnXLab";
        
  //if(!Slash::putenv("ONXLABROOT",ONXLABROOT)) return false;

  if(!Slash::env_path_append("PYTHONPATH",
       ONXLABROOT+fs+"scripts"+fs+"Python")) return false;

  return true;
}

}

#endif
