
// AIDA :
#include <AIDA/IPlotter.h>

// Slash :
#include <Slash/Core/ISession.h>
#include <Slash/UI/IUI.h>
#include <Slash/UI/ISoViewer.h>
#include <Slash/Tools/AIDA.h>

// amanip :
#include <amanip/create.h>

#include <Lib/Out.h>
#include <Lib/sout.h>

#include <OnX/Helpers/Inventor.h> //ui_SoViewer

static void deprecated0(Slash::UI::IUI& aUI,const std::string& aOld) {
  Lib::Out out(aUI.session().printer());
  out << "DLD callback " << Lib::sout(aOld) << " is deprecated."
      << Lib::endl;
}

static void deprecated(Slash::UI::IUI& aUI,const std::string& aOld,const std::string& aNew) {
  Lib::Out out(aUI.session().printer());
  out << "DLD callback " << Lib::sout(aOld) << " is deprecated."
      << " Use " << Lib::sout(aNew) << " instead."
      << Lib::endl;
}

extern "C" {

void OnXLab_initialize_AIDA(Slash::UI::IUI&);
void OnXLab_declare_accessors(Slash::UI::IUI&); 
void OnXLab_command_line_args(Slash::UI::IUI&);

void OnXLab_Initialize(Slash::UI::IUI& aUI) {
  Slash::UI::ISoViewer* soViewer = ui_SoViewer(aUI);
  if(soViewer) {
    soViewer->setDecoration(false);
    soViewer->setViewing(false);
  }
  OnXLab_initialize_AIDA(aUI);
  OnXLab_declare_accessors(aUI);
  aUI.session().setParameter("OnXLab_tree.append","no");
  OnXLab_command_line_args(aUI);
}


//////////////////////////////////////////////////////////////////////////////
void OnXLab_mainTree_update(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated(aUI,
             "OnXLab_mainTree_update",
             "OnX ui_set_parameter @{OnXLab.tree}@ @cat@ .items @session@hierarchy@");
  aUI.executeScript("DLD","OnX ui_set_parameter @{OnXLab.tree}@ @cat@ .items @session@hierarchy@");
}

//////////////////////////////////////////////////////////////////////////////
void OnXLab_plotter_initialize(
 Slash::UI::IUI& aUI
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  deprecated0(aUI,"OnXLab_plotter_initialize");

  Slash::Core::ISession& session = aUI.session();

  AIDA::IAnalysisFactory* aida = Slash::find_AIDA(session);
  if(!aida) return;

  // Get current plotter :
  AIDA::IPlotter* plotter = amanip::create_plotter(*aida,"");
  if(!plotter) return;

  plotter->createRegions(1,1,0);
  plotter->setTitle("");

  delete plotter;

  Slash::UI::ISoViewer* soViewer = ui_SoViewer(aUI);
  if(soViewer) {
    soViewer->setDecoration(false);
    soViewer->setViewing(false);
  }
}

} // extern "C"
