// this :
#include <OnXLab/Core/Main.h>

#include <Lib/Debug.h>
#include <Lib/Cast.h>

#include <OnXLab/Core/AnalysisFactory.h>

OnXLab::Main::Main(const std::vector<std::string>& aArgs)
: OnX::Main(aArgs)
, OnXLab::AnalysisFactory(*((Lib::Session*)this)) //acrobatic !
{
  Lib::Debug::increment("OnXLab::Main");

  if(verboseLevel()) {    
    cout() << "OnXLab::Main::Main :"
           << " " << this << std::endl;
  }

  // declare ourself in the Session.
  // WARNING : we are a Session and a Manager !
  addManager(this);

}

OnXLab::Main::~Main() {
  if(verboseLevel()) {    
    cout() << "OnXLab::Main::~Main :"
           << " " << this << std::endl;
  }

  // take care of ourself being a manager :
  Lib::Session::removeManager(this);

  Lib::Debug::decrement("OnXLab::Main");
}

void* OnXLab::Main::cast(const std::string& aClass) const {
  // inheritance :
  if(void* p = OnX::Main::cast(aClass)) return p;
  else if(void* p = OnXLab::AnalysisFactory::cast(aClass)) return p;
  // this :
  else if_Lib_SCast(OnXLab::Main)
  else return 0;
}
