#ifndef OpenPAW_env_h
#define OpenPAW_env_h

#include <Slash/Tools/system.h>

namespace OpenPAW {

inline bool set_env(std::ostream& a_out) {

  std::string OSC_HOME_DIR;
  if(!Slash::getenv("OSC_HOME_DIR",OSC_HOME_DIR)) {
    a_out << "OpenPAW::set_env :"
          << " environment variable OSC_HOME_DIR not defined."
          << std::endl;
    return false;
  }

  std::string fs = Slash::file_separator();
  std::string OPENPAWROOT = OSC_HOME_DIR + fs + "Resources" + fs + "OpenPAW";
        
  if(!Slash::putenv("OPENPAWROOT",OPENPAWROOT)) return false;

  return true;
}

}

#endif
