#include <Lib/Parameters.h>

// This is long to compile. Isolate it in a standalone files.

void att_opt_init(
 Lib::Parameters<std::string,double>& aATT
,Lib::Parameters<std::string,std::string>& aOPT
){

  //////////////////////////////////////////////////////////////////////
  /// IGSET ////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////
  //NOTE : have the IGSET first, since PASS,CSHI,BARO,BARW
  //       exists also in cat_HPLSET.
  aATT.add(cat_IGSET,"FAIS","Fill area interior style",0,0,0);
  aATT.add(cat_IGSET,"FASI","Fill area style index",1,1,0);
  aATT.add(cat_IGSET,"LTYP","Line type",1,1,0);
  aATT.add(cat_IGSET,"BASL","Basic segment length (NDC)",0.150,0.010,0);
  aATT.add(cat_IGSET,"LWID","Line width",1.000,1.000,0);
  aATT.add(cat_IGSET,"MTYP","Marker type",1,1,0);
  aATT.add(cat_IGSET,"MSCF","Marker scale factor",1.000,1.000,0);
  aATT.add(cat_IGSET,"PLCI","Polyline color index",1,1,0);
  aATT.add(cat_IGSET,"PMCI","Polymarker color index",1,1,0);
  aATT.add(cat_IGSET,"FACI","Fill area color index",1,1,0);
  aATT.add(cat_IGSET,"TXCI","Text color index",1,1,0);
  aATT.add(cat_IGSET,"TXAL","Text alignment",0,0,0);
  aATT.add(cat_IGSET,"CHHE","Character height",0.280,0.280,0);
  aATT.add(cat_IGSET,"TANG","Text angle",0.000,0.000,0);
  aATT.add(cat_IGSET,"TXFP","Text font and precision",2,2,0);
  aATT.add(cat_IGSET,"PICT","Current automatic number",1,1,0);
  aATT.add(cat_IGSET,"BORD","Border flag",0,0,0);
  //exist in cat_HPLSET !
  aATT.add(cat_IGSET,"PASS","Number of pass in IGTEXT",1,1,0);
  aATT.add(cat_IGSET,"CSHI","IGTEXT shift",0.030,0.020,0);
  //
  aATT.add(cat_IGSET,"LASI","Label axis size",0.018,0.018,0);
  aATT.add(cat_IGSET,"LAOF","Label axis offset",0.013,0.013,0);
  aATT.add(cat_IGSET,"TMSI","Tick marks size",0.019,0.019,0);
  aATT.add(cat_IGSET,"AWLN","Axis wire lenght",0.000,0.000,0);
  //exist in cat_HPLSET !
  aATT.add(cat_IGSET,"BARO","Offset of IGHIST (IGRAPH)",0.250,0.250,0);
  aATT.add(cat_IGSET,"BARW","Width of IGHIST (IGRAPH) bars",0.500,0.500,0);
  //
  aATT.add(cat_IGSET,"NCOL","Number of COLors",8,8,0);
  aATT.add(cat_IGSET,"CLIP","Clipping mode",1,1,0);
  aATT.add(cat_IGSET,"NLIN","Number of line for 3D shapes",40,40,0);
  aATT.add(cat_IGSET,"AURZ","Automatic saving flag",0,0,0);
  aATT.add(cat_IGSET,"DIME","Dimension used (2D or 3D)",2,2,0);
  aATT.add(cat_IGSET,"ZBUF","Z-Buffer (1=on or 0=off)",0,0,0);

  //////////////////////////////////////////////////////////////////////
  /// HPLSET ///////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////
  aATT.add(cat_HPLSET,"XSIZ","Size along X",20.00,20.00,0);
  aATT.add(cat_HPLSET,"YSIZ","Size along Y",20.00,20.00,0);
  aATT.add(cat_HPLSET,"XMGL","X MarGin Left",2.00,2.00,0);
  aATT.add(cat_HPLSET,"XMGR","X MarGin Right",2.00,2.00,0);
  aATT.add(cat_HPLSET,"XLAB","distance y axis to Label",1.40,1.40,0);
  aATT.add(cat_HPLSET,"XVAL","distance y axis to axis VALues",0.40,0.40,0);
  aATT.add(cat_HPLSET,"XTIC","X axis TICk marks length",0.30,0.30,0);
  aATT.add(cat_HPLSET,"YMGL","Y MarGin Low",2.00,2.00,0);
  aATT.add(cat_HPLSET,"YMGU","Y MarGin Up",2.00,2.00,0);
  aATT.add(cat_HPLSET,"YLAB","distance x axis to Label",0.80,0.80,0);
  aATT.add(cat_HPLSET,"YVAL","distance x axis to axis VALues",0.20,0.20,0);
  aATT.add(cat_HPLSET,"YTIC","Y axis TICk marks length",0.30,0.30,0);
  aATT.add(cat_HPLSET,"YNPG","Y position for Number of PaGe",0.60,0.60,0);
  aATT.add(cat_HPLSET,"YGTI","Y position of Global TItle",1.50,1.50,0);
  aATT.add(cat_HPLSET,"YHTI","Y position of Histogram TItle",1.20,1.20,0);
  aATT.add(cat_HPLSET,"SMGR","Stat MarGin Right (%)",0.00,0.00,0);
  aATT.add(cat_HPLSET,"SMGU","Stat MarGin Up (%)",0.00,0.00,0);
  aATT.add(cat_HPLSET,"CMMG","ColorMap MarGin",0.30,0.30,0);
  aATT.add(cat_HPLSET,"CVAL","distance Color map axis VALues",0.20,0.20,0);
  aATT.add(cat_HPLSET,"KSIZ","Hershey charact. (HPLKEY)",0.28,0.28,0);
  aATT.add(cat_HPLSET,"GSIZ","Global title SIZe",0.28,0.28,0);
  aATT.add(cat_HPLSET,"TSIZ","histogram Title SIZe",0.28,0.28,0);
  aATT.add(cat_HPLSET,"ASIZ","Axis label SIZe",0.28,0.28,0);
  aATT.add(cat_HPLSET,"CSIZ","Comment and stat SIZe",0.28,0.28,0);
  aATT.add(cat_HPLSET,"PSIZ","Page number SIZe",0.28,0.28,0);
  aATT.add(cat_HPLSET,"VSIZ","axis Values SIZe",0.28,0.28,0);
  aATT.add(cat_HPLSET,"SSIZ","aSterisk SIZe (for functions)",0.28,0.28,0);
  aATT.add(cat_HPLSET,"2SIZ","scatter-plot & table-char.",0.28,0.28,0);
  aATT.add(cat_HPLSET,"XWIN","X space between WINdows",2.00,2.00,0);
  aATT.add(cat_HPLSET,"YWIN","Y space between WINdows",2.00,2.00,0);
  aATT.add(cat_HPLSET,"HMAX","Histogram MAXimum for scale",0.90,0.90,0);
  // add anyway PASS, CSHI, BARO, BARW in order that SHOW
  // gives correct output. But the four belows are in
  // principle not used.
  aATT.add(cat_HPLSET,"PASS","number of PASS for characters",1.00,1.00,0);
  aATT.add(cat_HPLSET,"CSHI","Character SHIft between 2 pass",0.03,0.03,0);
  aATT.add(cat_HPLSET,"BARO","BAR histogram Offset (%)",0.25,0.25,0);
  aATT.add(cat_HPLSET,"BARW","BAR histogram Width (%)",0.50,0.50,0);
  //
  aATT.add(cat_HPLSET,"DASH","length of basic DASHed segment",0.15,0.15,0);
  aATT.add(cat_HPLSET,"DMOD","Dash MODe (or type) for lines",1,1,0);
  aATT.add(cat_HPLSET,"GRID","GRID line type",3,3,0);
  aATT.add(cat_HPLSET,"CMAP","Color MAP position",1,1,0);
  aATT.add(cat_HPLSET,"DATE","DATE position",2,2,0);
  aATT.add(cat_HPLSET,"FILE","FILE name position",1,1,0);
  aATT.add(cat_HPLSET,"STAT","STAT values to be plotted",1111,1111,0);
  aATT.add(cat_HPLSET,"FIT","FIT values to be plotted",101,101,0);
  aATT.add(cat_HPLSET,"HTYP","Histogram fill area TYPe",0,0,0);
  aATT.add(cat_HPLSET,"BTYP","Box fill area TYPe",0,0,0);
  aATT.add(cat_HPLSET,"PTYP","Picture fill area TYPe",0,0,0);
  aATT.add(cat_HPLSET,"FTYP","Function fill area TYPe",0.00,0.00,0);
  aATT.add(cat_HPLSET,"HCOL","Histogram fill area COLor",0.00,1.00,0);
  aATT.add(cat_HPLSET,"BCOL","Box fill area and shading",1,1,0);
  aATT.add(cat_HPLSET,"PCOL","Picture fill area COLor",1,1,0);
  aATT.add(cat_HPLSET,"FCOL","Function fill area COLor",1,1,0);
  aATT.add(cat_HPLSET,"XCOL","X axis COLor",1,1,0);
  aATT.add(cat_HPLSET,"YCOL","Y axis COLor",1,1,0);
  aATT.add(cat_HPLSET,"HWID","Histogram line WIDth",1,1,0);
  aATT.add(cat_HPLSET,"BWID","Box line WIDth",1,1,0);
  aATT.add(cat_HPLSET,"PWID","Picture line WIDth",1,1,0);
  aATT.add(cat_HPLSET,"FWID","Function line WIDth",1,1,0);
  aATT.add(cat_HPLSET,"XWID","X ticks WIDth",1,1,0);
  aATT.add(cat_HPLSET,"YWID","Y ticks WIDth",1,1,0);
  aATT.add(cat_HPLSET,"CWID","Color map WIDth",0.50,0.50,0);
  aATT.add(cat_HPLSET,"TFON","Text (and Title) FONT and PREC",2,2,0);
  aATT.add(cat_HPLSET,"GFON","Global title FONT and PREC",2,2,0);
  aATT.add(cat_HPLSET,"VFON","axis Values FONT and PREC",2,2,0);
  aATT.add(cat_HPLSET,"LFON","axis Labels FONT and PREC",2,2,0);
  aATT.add(cat_HPLSET,"CFON","Comment FONT and PREC",2,2,0);
  aATT.add(cat_HPLSET,"NDVX","Number of DIVisions for X axis",10510.00,10510.00,0);
  aATT.add(cat_HPLSET,"NDVY","Number of DIVisions for Y axis",10510.00,10510.00,0);
  aATT.add(cat_HPLSET,"NDVZ","Number of DIVisions for Z axis",10510.00,10510.00,0);
  aATT.add(cat_HPLSET,"FPGN","First PaGe Number",1,1,0);
  aATT.add(cat_HPLSET,"ERRX","ERRor on X (% of bin width)",0.50,0.50,0);
  aATT.add(cat_HPLSET,"1DEF","1DPlot Option",0,0,0);
  aATT.add(cat_HPLSET,"2DEF","2D Plot Option",0,0,0);

  //////////////////////////////////////////////////////////////////////
  /// HPLOPT ///////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////////////
  aOPT.add(cat_HPLOPT,"VERT","VERTical or HORIzontal orientation of paper","VERT","VERT","HORI");
  aOPT.add(cat_HPLOPT,"NEAH","Error bars And Histogram are plotted (if both are present)","NEAH","NEAH","EAH");
  aOPT.add(cat_HPLOPT,"NCHA","scatter plots drawn with dots (NCHA) or 1 char./bin (CHA)","NCHA","NCHA","CHA");
  aOPT.add(cat_HPLOPT,"NAST","functions drawn with (AST) or without (NAST) asterisks","NAST","NAST","AST");
  aOPT.add(cat_HPLOPT,"SOFT","SOFTware or HARDware characters are used","SOFT","SOFT","HARD");
  aOPT.add(cat_HPLOPT,"NSQR","size is set to the largest square (SQR)","NSQR","NSQR","SQR");
  aOPT.add(cat_HPLOPT,"HTIT","HBOOK TITle (HTIT) or User TITle (UTIT) is printed","HTIT","HTIT","UTIT");
  aOPT.add(cat_HPLOPT,"TAB","table printed as TABles (TAB) or scatter plots (NTAB)","TAB","TAB","NTAB");
  aOPT.add(cat_HPLOPT,"BOX","a box is (BOX) or is not (NBOX) drawn around picture","BOX","BOX","NBOX");
  aOPT.add(cat_HPLOPT,"NTIC","cross-wires are drawned (TIC) or not (NTIC) on each plot","NTIC","NTIC","TIC");
  aOPT.add(cat_HPLOPT,"NSTA","STAtistics are printed (STA) or not (NSTA) on each plot","NSTA","NSTA","STA");
  aOPT.add(cat_HPLOPT,"NFIT","FIT parameters are printed or not (NFIT) on each plot","NFIT","NFIT","FIT");
  aOPT.add(cat_HPLOPT,"NZFL","picture is (ZFL) or is not (NZFL) put in Z data base","NZFL","NZFL","ZFL");
  aOPT.add(cat_HPLOPT,"NPTO","PTO (Please Turn Over) (NPTO)","NPTO","NPTO","PTO");
  aOPT.add(cat_HPLOPT,"NBAR","BAR charts for histogram (NBAR)","NBAR","NBAR","BAR");
  aOPT.add(cat_HPLOPT,"DVXR","Integer (DVXI) or Real (DVXR) divisions for X axis","DVXR","DVXR","DVXI");
  aOPT.add(cat_HPLOPT,"DVYR","Integer (DVYI) or Real (DVYR) divisions for Y axis","DVYR","DVYR","DVYI");
  aOPT.add(cat_HPLOPT,"NGRI","GRID or not grid (NGRI) on X and Y axis","NGRI","NGRI","GRID");
  aOPT.add(cat_HPLOPT,"NDAT","DATE is printed (DATE) or not (NDAT) on each plot","NDAT","NDAT","DATE");
  aOPT.add(cat_HPLOPT,"NFIL","FILE name is printed (FILE) or not (NFIL) on each plot","NFIL","NFIL","FILE");
  aOPT.add(cat_HPLOPT,"A4","page format for the plotter (A0,A1,A2,A3,A4,A5,A6)","A4","A4","A0/6");
  aOPT.add(cat_HPLOPT,"NOPG","page number is (P ) or is not (NOPG) printed","NOPG","NOPG","P");
  aOPT.add(cat_HPLOPT,"LINY","LINear or LOGarithmic scale in Y","LINY","LINY","LOGY");
  aOPT.add(cat_HPLOPT,"LINX","LINear or LOGarithmic scale in X","LINX","LINX","LOGX");
  aOPT.add(cat_HPLOPT,"LINZ","LINear or LOGarithmic scale in Z (Lego or Surface)","LINZ","LINZ","LOGZ");
  aOPT.add(cat_HPLOPT,"HNST","Filling statistics (HSTA) (HNST)","HNST","HNST","HSTA");

  //G.Barrand :
  aOPT.add(cat_OPAW_OPT,"COLL","Coloring by level (COLL) or by VALUE (COLV) (OpenPAW)","COLL","COLL","COLV");
  aOPT.add(cat_OPAW_OPT,"PTIT","If RTIT, UTIT uses a ROOT-like box for title.","PTIT","PTIT","RTIT");
  aOPT.add(cat_OPAW_OPT,"NBAC","If NBACK the infos region background is transparent.","NBAC","NBAC","BACK");

}
