extern "C" {
  void pahbok_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

#include <AIDA/IPlotter.h>

#include <Slash/Core/ISession.h>
#include <Slash/Core/IWriter.h>
#include <Slash/Tools/AIDA.h>

#include <amanip/find.h>
#include <amanip/create.h>

#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/smanip.h>

#include <OpenPAW/PAW_Manager.h>
#include "KuipHelpers.h"

//////////////////////////////////////////////////////////////////////////////
void pahbok_(
 void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);

  //std::string cmd_name = ku_name();
  std::string cmd_path = ku_path() ? ku_path() : "";
  if(session->verboseLevel()) {
    out << "pahbok :" 
        << " execute " << Lib::sout(cmd_path) 
        << Lib::endl;
  }

  OpenPAW::PAW_Manager* pawManager = find_PAW(*session);
  if(!pawManager) return;

  AIDA::IAnalysisFactory* aida = pawManager->aida();
  if(!aida) return;
  AIDA::ITree* memoryTree = pawManager->mem();
  if(!memoryTree) return;

  if(cmd_path=="/HISTOGRAM/CREATE/1DHISTO") {

    std::string NAME = ku_gets();
    std::string TITLE = ku_gets();
    int NCX = ku_geti();
    double XMIN = ku_getr();
    double XMAX = ku_getr();
    double VMAX = ku_getr();
    if((NCX<=0)||(XMAX<=XMIN)) {
      out << "pahbok :" 
          << " bad booking values."
          << Lib::endl;
      return;
    }

    if(memoryTree->find(NAME)) {
      memoryTree->rm(NAME); //ok.
      out << " *** WARNING in OpenPAW :" 
          << " Already existing histogram replaced : ID="
          << NAME 
          << Lib::endl;
    }
    AIDA::IHistogram1D* histogram = 
      amanip::create_histogram_1D
        (*aida,*memoryTree,NAME,TITLE,NCX,XMIN,XMAX);
    if(!histogram) {
      out << "pahbok :" 
            << " can't create histogram " << Lib::sout(NAME) << Lib::endl;
      return;
    }
    VMAX = 0; //FIXME

  } else if(cmd_path=="/HISTOGRAM/CREATE/2DHISTO") {

    std::string NAME = ku_gets();
    std::string TITLE = ku_gets();
    int NCX = ku_geti();
    double XMIN = ku_getr();
    double XMAX = ku_getr();
    int NCY = ku_geti();
    double YMIN = ku_getr();
    double YMAX = ku_getr();
    double VMAX = ku_getr();
    if((NCX<=0)||(XMAX<=XMIN)) {
      out << "pahbok :" 
          << " bad booking values."
          << Lib::endl;
      return;
    }
    if((NCY<=0)||(YMAX<=YMIN)) {
      out << "pahbok :" 
          << " bad booking values."
          << Lib::endl;
      return;
    }

    if(memoryTree->find(NAME)) {
      memoryTree->rm(NAME); //ok.
      out << " *** WARNING in OpenPAW :" 
          << " Already existing histogram replaced : ID="
          << NAME 
          << Lib::endl;
    }
    AIDA::IHistogram2D* histogram = 
      amanip::create_histogram_2D(*aida,*memoryTree,NAME,TITLE,
                         NCX,XMIN,XMAX,NCY,YMIN,YMAX);
    if(!histogram) {
      out << "pahbok :" 
            << " can't create histogram " << Lib::sout(NAME) << Lib::endl;
      return;
    }
    VMAX = 0; //FIXME

  } else if(cmd_path=="/HISTOGRAM/CREATE/TITLE_GLOBAL") {

    std::string CHTITLE = ku_gets();
    std::string CHOPT = ku_gets();

    Lib::smanip::touppercase(CHOPT);
    std::vector<std::string> OPTS;
    kuip_getOptions("CHOPT",OPTS);

    if(OpenPAW::PAW_Manager::isAnOption(OPTS,CHOPT,"U")) {
      // CHTITLE is used as a region title.      
      pawManager->setUTIT(CHTITLE);
    } else {
      // CHTITLE is used as a page title.
      AIDA::IPlotter* plotter = 
        amanip::create_plotter(*aida,""); //FIXME : pass where.
      if(plotter) {
        pawManager->setPlotterTitle(*plotter,CHTITLE);
        delete plotter;
      }
    }

  } else {
    out << "pahbok :" 
        << " " << cmd_path << " : dummy." << Lib::endl;

  }
}
