extern "C" {
  void pahset_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

// AIDA helpers :
#include <Slash/Tools/AIDA.h>

#include "KuipHelpers.h"
#include "FindHelpers.h"

//////////////////////////////////////////////////////////////////////////////
void pahset_(
 void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);

  //std::string cmd_name = ku_name();
  std::string cmd_path = ku_path() ? ku_path() : "";
  if(session->verboseLevel()) {
    out << "pahset :" 
        << " execute " << Lib::sout(cmd_path) 
        << Lib::endl;
  }

  OpenPAW::PAW_Manager* pawManager = find_PAW(*session);
  if(!pawManager) return;
  AIDA::IAnalysisFactory* aida = pawManager->aida();
  if(!aida) return;
  AIDA::ITree* memoryTree = pawManager->mem();
  if(!memoryTree) return;

  if(cmd_path=="/HISTOGRAM/SET/MAXIMUM") {

    std::string NAME = ku_gets();
    double VALUE = ku_getr();

    AIDA::IBaseHistogram* histogram = baseHistogram_find(*pawManager,NAME);
    if(!histogram) {
      out << "pahist :" 
          << " can't find histogram " << Lib::sout(NAME) 
          << Lib::endl;
      return;
    }

    AIDA::IAnnotation& annotation = histogram->annotation();

    std::string smn = annotation.value("opaw.value.minimum");
    if(smn=="") {
      annotation.addItem("opaw.value.automated","true");
      annotation.addItem("opaw.value.minimum","0");
      annotation.addItem("opaw.value.maximum","1");
      smn = annotation.value("opaw.value.minimum");
    }

    double mn;
    Lib::smanip::todouble(smn,mn);
    
    if(VALUE<=mn) { //PAW convention : set automatic
      annotation.setValue("opaw.value.automated","true");
    } else {
      annotation.setValue("opaw.value.automated","false");
      annotation.setValue("opaw.value.maximum",Lib::smanip::tostring(VALUE));
    }

  } else if(cmd_path=="/HISTOGRAM/SET/MINIMUM") {

    std::string NAME = ku_gets();
    double VALUE = ku_getr();

    AIDA::IBaseHistogram* histogram = baseHistogram_find(*pawManager,NAME);
    if(!histogram) {
      out << "pahist :" 
          << " can't find histogram " << Lib::sout(NAME) 
          << Lib::endl;
      return;
    }

    AIDA::IAnnotation& annotation = histogram->annotation();

    std::string smx = annotation.value("opaw.value.maximum");
    if(smx=="") {
      annotation.addItem("opaw.value.automated","true");
      annotation.addItem("opaw.value.minimum","0");
      annotation.addItem("opaw.value.maximum","1");
      smx = annotation.value("opaw.value.maximum");
    }


    double mx;
    Lib::smanip::todouble(smx,mx);
    
    if(VALUE>=mx) { //PAW convention : set automatic
      annotation.setValue("opaw.value.automated","true");
    } else {
      annotation.setValue("opaw.value.automated","false");
      annotation.setValue("opaw.value.minimum",Lib::smanip::tostring(VALUE));
    }

  } else {
    out << "pahset :" 
        << " " << cmd_path << " : dummy." << Lib::endl;

  }
}
