extern "C" {
  void panmas_(void*);
}

#include <kuip/ksys.h>
#include <kuip/kfor.h>
#include <kuip/kuser.h>
#include <kuip/klink.h>

#include <Slash/Core/ISession.h>
#include <Slash/Core/IWriter.h>
#include <Slash/Tools/AIDA.h>

#include <amanip/find.h>

#include <Lib/Out.h>
#include <Lib/sout.h>
#include <Lib/sjust.h>
#include <Lib/smanip.h>
#include <Lib/fmanip.h>

#include <OpenPAW/PAW_Manager.h>

#define MAXIMUM(a,b) ((a)>(b)?a:b)

//////////////////////////////////////////////////////////////////////////////
void panmas_(
 void* aSession
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{ 
  Slash::Core::ISession* session = (Slash::Core::ISession*)aSession;

  Slash::Core::IWriter& printer = session->printer();
  Lib::Out out(printer);

  std::string cmd_path = ku_path() ? ku_path() : "";
  //std::string cmd_name = ku_name();
  if(session->verboseLevel()) {
    out << "panmas :" 
        << " execute " << Lib::sout(cmd_path) 
        << Lib::endl;
  }

  if(cmd_path=="/NTUPLE/MASK/FILE") {

    out << "panmas :" 
        << " /NTUPLE/MASK is an obsolete feature in CERN/PAW."
        << "  Bypass the /NTUPLE/MASK/FILE command."
        << Lib::endl;
    return;

  } else if(cmd_path=="/NTUPLE/MASK/CLOSE") {

    out << "panmas :" 
        << " /NTUPLE/MASK is an obsolete feature in CERN/PAW."
        << "  Bypass the /NTUPLE/MASK/CLOSE command."
        << Lib::endl;
    return;

  } else if(cmd_path=="/NTUPLE/MASK/LIST") {

    out << "panmas :" 
        << " /NTUPLE/MASK is an obsolete feature in CERN/PAW."
        << "  Bypass the /NTUPLE/MASK/LIST command."
        << Lib::endl;
    return;

  } else {
    out << "panmas :" 
        << " " << cmd_path << " : dummy." << Lib::endl;

  }
}
