// A renamed version of HEPVis_SoFile

// this :
#include "SoCurl.h"

#include <Inventor/errors/SoDebugError.h>

//#include <HEPVis/SbFile.h>
#include <cstdio>
#include <cstdlib>
inline SbBool SbFile_exists(const SbString& aString){
  FILE* file = ::fopen(aString.getString(),"rb");
  if(!file) return FALSE;
  ::fclose(file);
  return TRUE;
}
#ifdef WIN32
#include <process.h>
#else
#include <unistd.h>
#endif
#include <sys/stat.h>
inline SbBool SbFile_tmpname(SbString& aName,const SbString& aPrefix){
  SbString head = "";
#ifdef WIN32
  SbString env = ::getenv("HOMEDRIVE");
  SbString drive = (env!="" ? env : SbString("C:"));
  head += drive;
  head += "\\";
#else
  head += "/tmp/";
#endif
  head += aPrefix;
  char spid[128];
  ::sprintf(spid,"%d",::getpid());
  head += SbString(spid);
  head += "_";

  for(int count=0;count<1000;count++) {
    char num[4];
    ::sprintf(num,"%03d",count);
    SbString tmpnm = head;
    tmpnm += SbString(num);
    struct stat finfo;
    if(::stat(tmpnm.getString(),&finfo) < 0) {
      // No directory or file found :
      aName = tmpnm; // Good file name.
      return TRUE; 
    }
  }
  // No good name found :
  aName = "";
  return FALSE;
}

SO_NODE_SOURCE(SoCurl)

void SoCurl::initClass() {
  SO_NODE_INIT_CLASS(SoCurl,SoFile,"File");
}
SoCurl::SoCurl() {
  SO_NODE_CONSTRUCTOR(SoCurl);
}
SoCurl::~SoCurl(){}

#if((COIN_MAJOR_VERSION>=2)&&(COIN_MINOR_VERSION>=5))
#else
void SoCurl::search(SoSearchAction* action) {
  SoFile::doAction((SoAction*)action);
}
#endif

//#include <cstdio> //tmpnam

SoCurl::CurlFunction SoCurl::fCurlFunction = 0;
void* SoCurl::fCurlTag = 0;
void SoCurl::setCurlFunction(CurlFunction aFunc,void* aTag) {
  fCurlFunction = aFunc;
  fCurlTag = aTag;
}

SbBool SoCurl::readNamedFile(SoInput* in) {
  SbString local = "";
  SbString s = name.getValue();
  SbString file;
  if(s.getSubString(0,4)=="http:") {
    // build a local name :
    if(!SbFile_tmpname(local,"SoCurl_")) {
      SoDebugError::postInfo("SoCurl::readNamedFile",
        "Can't build a tmpname.");
      return FALSE;
    }
    CurlFunction curl_func = fCurlFunction?fCurlFunction:curl_file;
    if(curl_func(s,local,fCurlTag)==FALSE) { 
      SoDebugError::postInfo("SoCurl::readNamedFile",
        "Can't get URL \"%s\".",s.getString());
      ::remove(local.getString());
      return FALSE;
    } else {
      file = local;
    }
  } else {
    file = s;
  } 
 {SbBool flag = name.enableNotify(FALSE);
  name.setValue(file); //do we definitly replace name ?
  name.enableNotify(flag);}
  SbBool status = SoFile::readNamedFile(in);
 {SbBool flag = name.enableNotify(FALSE);
  name.setValue(s); //restore original name (in case we SoWrite the node).
  name.enableNotify(flag);}
  if(local.getLength()>0) ::remove(local.getString());
  return status;
}

#include <cstdlib> //::system

// simply call ::system("curl") :
SbBool SoCurl::curl_file(const SbString& a_url,const SbString& a_out_file,void*) {

  //::printf("debug : SoCurl::curl_file : %d \"%s\"...\n",getpid(),a_url.getString());

  SbString cmd("curl ");
  cmd += " --silent ";
  cmd += " --compressed ";
  cmd += a_url;
  cmd += " --output ";
  cmd += a_out_file;
  if(::system(cmd.getString())==(-1)) {
    SoDebugError::postInfo("SoCurl::cur_file",
      "call to ::system(\"curl <options>\") failed.");
    ::remove(a_out_file.getString());
    return FALSE;
  }

  if(SbFile_exists(a_out_file)==FALSE) {
    SoDebugError::postInfo("SoCurl::cur_file",
			   "can't get \"%s\".",a_url.getString());
    return FALSE;
  }

  //::printf("debug : SoCurl::curl_file : %d \"%s\" end\n",getpid(),a_url.getString());

  return TRUE;
}
