/*
 * Created by G.Barrand. January 2008.
 * 
 * Node to have :
 *  - the SoSearchAction working with coin3.d
 *  - support web URL.
 * 
 */

#ifndef SoCurl_h
#define SoCurl_h

// Inheritance :
#include <Inventor/nodes/SoFile.h>

class SoCurl : public SoFile {
  SO_NODE_HEADER(SoCurl);
public:
  SoCurl();
protected:
  virtual ~SoCurl();
public:/*SoINTERNAL*/ 
  static void initClass();
public: /*SoEXTENDER*/ 
#if((COIN_MAJOR_VERSION>=2)&&(COIN_MINOR_VERSION>=5))
#else
  virtual void search(SoSearchAction* action);
#endif
  virtual SbBool readNamedFile(SoInput* in);
public:
  typedef SbBool (*CurlFunction)(const SbString&,const SbString&,void*);
  static void setCurlFunction(CurlFunction,void*);
private:
  static CurlFunction fCurlFunction;
  static void* fCurlTag;
  static SbBool curl_file(const SbString&,const SbString&,void*);
};

#endif
