#ifndef Slash_buffer_h
#define Slash_buffer_h

#include "platform.h"

#include <cstring>
#include <cstddef>

namespace Slash {

template <class T>
inline unsigned int write_buffer(T aValue,char* aBuffer) {
  size_t n = sizeof(T);
  //NOTE : aBuffer must be allocated to n.
  if(is_little_endian()) {
    ::memcpy(aBuffer,&aValue,n);
  } else {
    char* pos = (char*)&aValue;
    for(unsigned int i=0;i<n;i++,pos++) aBuffer[n-1-i] = *pos;
  }
  return n;
}

template <class T>
inline unsigned int read_buffer(const char* aBuffer,T& aValue) {
  size_t n = sizeof(T);
  //NOTE : aBuffer must be allocated to n.
  if(is_little_endian()) {
    ::memcpy(&aValue,aBuffer,n);
  } else {
    char* pos = (char*)&aValue;
    for(unsigned int i=0;i<n;i++,pos++) *pos = aBuffer[n-1-i];
  }
  return n;
}

}

#endif

