#include <Inventor/errors/SoDebugError.h>
#include <Inventor/nodekits/SoBaseKit.h>
#include <Inventor/actions/SoSearchAction.h>

inline SoNode* SoTools_searchNode(SoNode* aNode,SoType aType){
  SbBool oldsearch = SoBaseKit::isSearchingChildren();
  SoBaseKit::setSearchingChildren(TRUE);
  SoSearchAction searchAction;
  SoNode* node = 0;
  searchAction.setFind(SoSearchAction::TYPE);
  searchAction.setType(aType,TRUE);
  searchAction.apply(aNode);
  searchAction.setInterest(SoSearchAction::FIRST);
  SoBaseKit::setSearchingChildren(oldsearch);
  SoFullPath* path = (SoFullPath*)searchAction.getPath();
  if(path) node = path->getTail();
  if(node && (node->isOfType(aType)==FALSE)) { //Check
    SoDebugError::postInfo("SoTools::searchNode",
      "Get type %s whilst %s was expected !",
      node->getTypeId().getName().getString(),aType.getName().getString());
    return 0;
  }
  return node;
}
inline SoNode* SoTools_searchNode(SoNode* aNode,const SbString& aName){
  SbBool oldsearch = SoBaseKit::isSearchingChildren();
  SoBaseKit::setSearchingChildren(TRUE);
  SoSearchAction searchAction;
  SoNode* node = 0;
  searchAction.setFind(SoSearchAction::NAME);
  searchAction.setName(aName.getString());
  searchAction.apply(aNode);
  SoBaseKit::setSearchingChildren(oldsearch);
  SoFullPath* path = (SoFullPath*)searchAction.getPath();
  if(path) node = path->getTail();
  return node;
}
