#ifndef SoSDL_WILD_event_h
#define SoSDL_WILD_event_h 

#include <Slash/Tools/buffer.h>
#include <Slash/Tools/file.h>
#include <iostream> //FIXME

#include <Lib/BaseSocket.h>
#ifdef WIN32
#include <SDL.h>
#else
#include <SDL/SDL.h>
#endif

//WILD
#define WILD_USEREVENT_UPDATE_MOTION              100
#define WILD_USEREVENT_MOUSE_MOVE                 101
#define WILD_USEREVENT_MOUSE_BUTTON_DOWN          102
#define WILD_USEREVENT_MOUSE_BUTTON_UP            103
#define WILD_USEREVENT_CURL                       104
#define WILD_USEREVENT_FILE                       105

#define BEG_SEND(a_sz) \
  Slash::uint64 sz = (a_sz);			\
  char buffer[32];\
  char* pos = buffer;\
  unsigned int n;

#define END_SEND \
  if(!a_sock.send_uint64(sz)) return false;\
  if(!a_sock.send_buffer(buffer,sz)) return false;

#define BEG_SEND_NEW(a_sz) \
  Slash::uint64 sz = (a_sz);\
  char* buffer = new char[a_sz];\
  char* pos = buffer;\
  unsigned int n;

#define END_SEND_DELETE \
  if(!a_sock.send_uint64(sz)) {delete [] buffer;return false;}\
  if(!a_sock.send_buffer(buffer,sz)) {delete [] buffer;return false;}\
  delete [] buffer;

inline bool send_SDL_Event(Lib::BaseSocket& a_sock,const SDL_Event& a_event) {
  typedef unsigned char uchar;
  typedef unsigned short ushort;
  if(a_event.type==SDL_QUIT) {
    BEG_SEND(1*sizeof(uchar))

    n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;

    END_SEND

  } else if( (a_event.type==SDL_KEYDOWN) ||
             (a_event.type==SDL_KEYUP)   ){
    BEG_SEND(5*sizeof(uchar)+3*sizeof(ushort))

    n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.key.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.key.which,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.key.state,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.key.keysym.scancode,pos);pos +=n;
    n = Slash::write_buffer<ushort>(a_event.key.keysym.sym,pos);pos +=n;
    n = Slash::write_buffer<ushort>(a_event.key.keysym.mod,pos);pos +=n;
    n = Slash::write_buffer<ushort>(a_event.key.keysym.unicode,pos);pos +=n;

    END_SEND

  } else if((a_event.type==SDL_MOUSEBUTTONDOWN)  ||
            (a_event.type==SDL_MOUSEBUTTONUP)    ){
    BEG_SEND(5*sizeof(uchar)+2*sizeof(ushort))

    n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.button.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.button.which,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.button.button,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.button.state,pos);pos +=n;
    n = Slash::write_buffer<ushort>(a_event.button.x,pos);pos +=n;
    n = Slash::write_buffer<ushort>(a_event.button.y,pos);pos +=n;

    END_SEND

  } else if((a_event.type==SDL_JOYBUTTONDOWN)  ||
            (a_event.type==SDL_JOYBUTTONUP)    ){
    BEG_SEND(5*sizeof(uchar))

    n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jbutton.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jbutton.which,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jbutton.button,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jbutton.state,pos);pos +=n;

    END_SEND

  } else if(a_event.type==SDL_JOYAXISMOTION) {
    BEG_SEND(4*sizeof(uchar)+1*sizeof(ushort))

    n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jaxis.type,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jaxis.which,pos);pos +=n;
    n = Slash::write_buffer<uchar>(a_event.jaxis.axis,pos);pos +=n;
    n = Slash::write_buffer<short>(a_event.jaxis.value,pos);pos +=n;

    END_SEND

  } else if(a_event.type==SDL_USEREVENT) {
    if( (a_event.user.code==WILD_USEREVENT_CURL) ||
        (a_event.user.code==WILD_USEREVENT_FILE) ){

      unsigned int ls;
      Slash::read_buffer<unsigned int>((const char*)&(a_event.user.data1),ls);

      BEG_SEND_NEW(2*sizeof(uchar)+1*sizeof(int)+4+(ls+1))

      n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;
      n = Slash::write_buffer<uchar>(a_event.user.type,pos);pos +=n;      
      n = Slash::write_buffer<int>(a_event.user.code,pos);pos +=n;

      ::memcpy(pos,&(a_event.user.data1),4);pos += 4;
      ::memcpy(pos,a_event.user.data2,ls+1);pos += (ls+1);

      END_SEND_DELETE
     
    } else {

      BEG_SEND(2*sizeof(uchar)+1*sizeof(int)+2*4)

      n = Slash::write_buffer<uchar>(a_event.type,pos);pos +=n;
      n = Slash::write_buffer<uchar>(a_event.user.type,pos);pos +=n;
      n = Slash::write_buffer<int>(a_event.user.code,pos);pos +=n;

      //WARNING : sizeof(void*) is not portable but is at least 4 bytes.
      //          The below assumes that only 4 bytes of data
      //          had been deposited on data1,data2.
      ::memcpy(pos,&(a_event.user.data1),4);pos += 4;
      ::memcpy(pos,&(a_event.user.data2),4);pos += 4;

      END_SEND
    }
  } else {
    return false;
  }
  return true;
}

#undef BEG_SEND
#undef END_SEND
#undef BEG_SEND_NEW
#undef END_SEND_DELETE

inline bool wait_SDL_Event(Lib::BaseSocket& a_sock,SDL_Event& a_event) {
  typedef unsigned char uchar;
  typedef unsigned short ushort;
  Slash::uint64 sz;
  if(!a_sock.wait_uint64(sz)) return false;
  char* buffer = new char[sz];
  if(!a_sock.wait_buffer(buffer,sz)) {delete [] buffer;return false;}
  char* pos = buffer;
  unsigned int n;
  n = Slash::read_buffer<uchar>(pos,a_event.type);pos +=n;
  if(a_event.type==SDL_QUIT) {
  } else if( (a_event.type==SDL_KEYDOWN) ||
             (a_event.type==SDL_KEYUP)   ){
    n = Slash::read_buffer<uchar>(pos,a_event.key.type);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.key.which);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.key.state);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.key.keysym.scancode);pos += n;
    unsigned short v;
    n = Slash::read_buffer<ushort>(pos,v);pos += n;
    a_event.key.keysym.sym = (SDLKey)v;
    n = Slash::read_buffer<ushort>(pos,v);pos += n;
    a_event.key.keysym.mod = (SDLMod)v;
    n = Slash::read_buffer<ushort>(pos,a_event.key.keysym.unicode);pos += n;
  } else if((a_event.type==SDL_MOUSEBUTTONDOWN)  ||
            (a_event.type==SDL_MOUSEBUTTONUP)    ){
    n = Slash::read_buffer<uchar>(pos,a_event.button.type);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.button.which);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.button.button);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.button.state);pos += n;
    n = Slash::read_buffer<ushort>(pos,a_event.button.x);pos += n;
    n = Slash::read_buffer<ushort>(pos,a_event.button.y);pos += n;
  } else if((a_event.type==SDL_JOYBUTTONDOWN)  ||
            (a_event.type==SDL_JOYBUTTONUP)    ){
    n = Slash::read_buffer<uchar>(pos,a_event.jbutton.type);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.jbutton.which);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.jbutton.button);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.jbutton.state);pos += n;
  } else if(a_event.type==SDL_JOYAXISMOTION) {
    n = Slash::read_buffer<uchar>(pos,a_event.jaxis.type);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.jaxis.which);pos += n;
    n = Slash::read_buffer<uchar>(pos,a_event.jaxis.axis);pos += n;
    n = Slash::read_buffer<short>(pos,a_event.jaxis.value);pos += n;
  } else if(a_event.type==SDL_USEREVENT) {
    n = Slash::read_buffer<uchar>(pos,a_event.user.type);pos += n;
    n = Slash::read_buffer<int>(pos,a_event.user.code);pos += n;
    if( (a_event.user.code==WILD_USEREVENT_CURL) ||
        (a_event.user.code==WILD_USEREVENT_FILE) ){
      unsigned int ls;
      Slash::read_buffer<unsigned int>(pos,ls);pos += 4;
      Slash::write_buffer<unsigned int>(ls,(char*)&(a_event.user.data1));
      char* s = new char[ls+1];
      ::memcpy(s,pos,ls+1);pos += (ls+1);
      a_event.user.data2 = s;
    } else {
      //WARNING : sizeof(void*) is not portable but is at least 4 bytes.
      //          The below assumes that only 4 bytes of data
      //          had been deposited on data1,data2.
      ::memcpy((char*)&(a_event.user.data1),pos,4);pos += 4;
      ::memcpy((char*)&(a_event.user.data2),pos,4);pos += 4;
    }
  } else {
    delete [] buffer;
    return false;
  }
  delete [] buffer;
  return true;
}

inline void fill_SDL_Event_with_string(const std::string& a_string,SDL_Event& a_event) {
  a_event.type = SDL_USEREVENT;
  a_event.user.type = SDL_USEREVENT;
  //do not set a_event.user.code here.
  unsigned int length = a_string.size();
  Slash::write_buffer<unsigned int>(length,(char*)&(a_event.user.data1));
  char* buffer = new char[length+1];  //to be free by the user.  
  ::memcpy(buffer,a_string.c_str(),length+1);
  a_event.user.data2 = buffer;
}

inline void read_SDL_Event_string(SDL_Event& a_event,std::string& a_string) {
  unsigned int length;
  Slash::read_buffer<unsigned int>((char*)&(a_event.user.data1),length);
  a_string.resize(length);
  char* s = (char*)a_event.user.data2;
  char* pos = s;
  typedef std::string::iterator it_t;
  for(it_t it=a_string.begin();it!=a_string.end();++it) {*it = *pos;pos++;}
  delete [] s;
  a_event.user.data1 = 0;
  a_event.user.data2 = 0;
}

inline bool fill_SDL_Event_with_file(const std::string& a_file,SDL_Event& a_event) {
  a_event.type = SDL_USEREVENT;
  a_event.user.type = SDL_USEREVENT;
  //do not set a_event.user.code here.

  char* bufile;
  long length;
  if(!Slash::file::read_bytes(a_file,bufile,length)) {
    std::cout << "fill_SDL_Event_with_file : "
              << " can't read file \"" << a_file << "\"."
              << std::endl;
    //a_event.user.data1 = 0;
    //a_event.user.data2 = 0;
    //return false;
    //continue;
    length = 0;
    bufile = new char[1];    
  }
  //bufile is length+1

  //length could be 0. But bufile is not 0.

  Slash::write_buffer<unsigned int>(length,(char*)&(a_event.user.data1));
  a_event.user.data2 = bufile;

  return true;
}

inline bool read_SDL_Event_file(SDL_Event& a_event,const std::string& a_file,unsigned int& a_length) {
  unsigned int length;
  Slash::read_buffer<unsigned int>((char*)&(a_event.user.data1),length);
  char* bufile = (char*)a_event.user.data2; //not 0.

  if(!Slash::file::write_bytes(a_file,bufile,(size_t)length)) {
    std::cout << "Lib::BaseSocket::send_file : "
              << " can't write file \"" << a_file << "\"."
              << std::endl;
  }

  delete [] bufile;
  a_event.user.data1 = 0;
  a_event.user.data2 = 0;

  a_length = length;
  return true;
}

#endif

