#include <Inventor/nodes/SoSelection.h>
#include <Inventor/actions/SoHandleEventAction.h>

class MySelection : public SoSelection {
public:
  MySelection():SoSelection(),fPickRoot(0){}
public:
  virtual void handleEvent(SoHandleEventAction * action){
    //printf("debug : MySelection::handleEvent\n");
    if(fPickRoot) {
      SoNode* old = action->getPickRoot();
      action->setPickRoot(fPickRoot);
      SoSelection::handleEvent(action);
      action->setPickRoot(old);
    } else {
      SoSelection::handleEvent(action);
    }
  }
  void setPickRoot(SoNode* aNode) {fPickRoot = aNode;}  
private:
  SoNode* fPickRoot;
};

// for manip :
#include <Inventor/actions/SoSearchAction.h>
#include <Inventor/manips/SoTransformBoxManip.h>
static SbBool set_manip(SoPath& aPath) {
  if(aPath.getLength()<1) {
    ::fprintf(stdout, "set_manip : node has no parent.\n");
    return FALSE;
  }

  SoNode* parent = aPath.getNodeFromTail(1);
  if(parent->isOfType(SoGroup::getClassTypeId())==FALSE) {
    ::fprintf(stdout, "set_manip : parent is a %s\n",
              parent->getTypeId().getName().getString());
    return FALSE;
  }

  SoSearchAction action;
  action.setFind(SoSearchAction::TYPE);
  action.setType(SoTransform::getClassTypeId());
  action.apply(parent);
  SoPath* path = action.getPath();
  if(!path) {
    ::fprintf(stdout, "set_manip : no SoTransform found.\n");
    return FALSE;
  }

  // set manip :
  SoTransformBoxManip* manip = new SoTransformBoxManip;
  manip->ref();

  return manip->replaceNode(path);
}

static void selectionCB(void* aTag,SoPath* aPath)  {
 {SoNode* node = aPath->getTail(); 
  ::fprintf(stdout, "selectionCB : %s\n",
            node->getTypeId().getName().getString());}

  set_manip(*aPath);

  SoSelection* sel = (SoSelection*)aTag;
  sel->touch(); // to redraw
}

static void deselectionCB(void* aTag,SoPath* aPath)  {
  ::fprintf(stdout, "deselectionCB : %s\n",
            aPath->getTail()->getTypeId().getName().getString());
  SoSelection* sel = (SoSelection*)aTag;
  sel->touch(); // to redraw
}

#include <Inventor/actions/SoBoxHighlightRenderAction.h>
//#include <Inventor/actions/SoLineHighlightRenderAction.h>
