#ifndef amanip_app_h
#define amanip_app_h

#include "smanip.h"
#include "system.h"

namespace amanip {

inline bool if_mouse_startup(const std::string& a_arg0,std::ostream& a_out){

  //a_out << "if_mouse_startup : arg0 " << sout(a_arg0)<< std::endl;

  std::string::size_type pos = a_arg0.rfind('/');
  if(pos==std::string::npos) return false;
  //std::string app = a_arg0.substr(pos+1,a_arg0.size()-(pos+1));
  std::string path = a_arg0.substr(0,pos);
  pos = path.rfind('/');
  if(pos==std::string::npos) return false;
  std::string bname = path.substr(pos+1,a_arg0.size()-(pos+1));
  //a_out << "if_mouse_startup : bname " << sout(bname)<< std::endl;

  if(bname=="MacOS") {
    std::string OSC_HOME_DIR = path.substr(0,pos);
    //a_out << "if_mouse_startup : OSC_HOME_DIR " 
    //      << sout(OSC_HOME_DIR)<< std::endl;

    // set OSC_HOME_DIR from app_dir :
    if(!putenv("OSC_HOME_DIR",OSC_HOME_DIR)) {
      a_out << "if_mouse_startup :"
            << " can't putenv OSC_HOME_DIR to " << sout(OSC_HOME_DIR)
            << "."
            << std::endl;
      return false;
    }

    if(!env_path_append("DYLD_LIBRARY_PATH",OSC_HOME_DIR+"/bin"))
      return false;
    // for on-the-fly compilation and loading :
    if(!env_path_append("DYLD_LIBRARY_PATH",".")) return false;

    if(!isenv("DISPLAY")) {
      if(!putenv("DISPLAY",":0.0")) return false;
    }

  } else if(bname=="bin") {
    //Linux, Windows : mouse startup ?
  }

  return true;
}

}

#endif
