
//NOTE : the ifdef/else/endif HEAD are importants.
//       They are oroot keywords.

#ifdef HEAD

#include <oroot/TROOT.h>
#include <oroot/TSystem.h>
#include <oroot/TFile.h>
#include <oroot/TCanvas.h>
#include <oroot/TH1D.h>
#include <oroot/TAxis.h>

#include <iostream>

#else //HEAD

{
  gROOT->Reset();
  
  TFile f = TFile("histograms.root");  
  TCanvas* c1 = new TCanvas("c1", "  ");
  
  TH1D* hist1 = (TH1D*)f.Get("1");
  if(!hist1) {
    std::cout << "histo 1 not found." << std::endl;
  } else {
    c1->SetLogy(1);
    c1->cd();
    c1->Update(); 

    hist1->SetTitle("Total energy deposited in astronaut");
    hist1->GetXaxis()->SetTitle("edep (MeV)");
    hist1->GetYaxis()->SetTitle("nb events"); 
    hist1->Draw("HIST");
  }

  TH1D* hist2 = (TH1D*)f.Get("2");
  if(!hist2) {
    std::cout << "histo 2 not found." << std::endl;
  } else {
    c1->SetLogy(0);
    c1->cd();
    c1->Update(); 

    hist2->SetTitle("edep longitudinal profile");
    hist2->GetXaxis()->SetTitle("zlocal (mm)");
    hist2->GetYaxis()->SetTitle("Edep (MeV/mm)"); 
    hist2->Draw("HIST");  
  }
}  

#endif //HEAD

