
#include <string>
#include <vector>

// From Lib. Some code had been changed compared to the 
// Lib version ; see the FIXME.

static bool Lib_smanip_pathNameSuffix(const std::string&,std::string&,std::string&,std::string&);
static std::string Lib_smanip_basename(const std::string&);
static bool Lib_smanip_replace(std::string&,
                               const std::string&,
                               const std::string&);
static bool Lib_smanip_printf(std::string&,int,const char*,...);

static bool Lib_fmanip_read(const std::string&,std::vector<std::string>&);
static bool Lib_fmanip_write(const std::string&,const std::vector<std::string>&
);

#include <cstdlib> //EXIT_SUCCESS

//////////////////////////////////////////////////////////////////////////////
int main(
 int aArgc
,char** aArgv
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::vector<std::string> args;
 {for(int index=0;index<aArgc;index++) args.push_back(aArgv[index]);}
  
  if(args.size()!=3) return EXIT_FAILURE;

  std::string in_file = args[1];
  std::string out_file = args[2];

  if(in_file==out_file) return EXIT_FAILURE;
  
  std::vector<std::string> in_txt;
  if(!Lib_fmanip_read(in_file,in_txt)) return EXIT_FAILURE;

  std::string s_in_file = Lib_smanip_basename(in_file);

  std::vector<std::string> out_txt;
  out_txt.push_back("//");
  out_txt.push_back("//  This file had been produced automatically");
  out_txt.push_back("// by the obuild_wrap program from the file :");
  out_txt.push_back("//    "+s_in_file);
  out_txt.push_back("//");

  Lib_smanip_replace(s_in_file,".","_");

 {unsigned int number = in_txt.size();
  for(unsigned int index=0;index<number;index++) {
    std::string sindex;
    Lib_smanip_printf(sindex,32,"%d",index);
    std::string s = "  static const char ";
    s += s_in_file + "_"+sindex+"[] = \"";
    std::string ss = in_txt[index];
    Lib_smanip_replace(ss,"\"","@@double_quote@@");
    Lib_smanip_replace(ss,"\\","@@back_slash@@");
    s += ss;
    s += "\";";
    out_txt.push_back(s);
  }}

 {unsigned int number = in_txt.size();
  std::string snumber;
  Lib_smanip_printf(snumber,32,"%d",number);
  std::string s = "  static unsigned int ";
  s += s_in_file+"_linen = " + snumber +";";
  out_txt.push_back(s);}

 {out_txt.push_back
    ("  static const char* "+s_in_file+"_lines[] = {");
  unsigned int number = in_txt.size();
  for(unsigned int index=0;index<number;index++) {
    std::string sindex;
    Lib_smanip_printf(sindex,32,"%d",index);
    std::string s;
    if(index) s += ",";
    s += s_in_file+"_"+sindex;
    out_txt.push_back(s);
  }
  out_txt.push_back("};");}

  if(!Lib_fmanip_write(out_file,out_txt)) return EXIT_FAILURE;

  return EXIT_SUCCESS;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool Lib_smanip_replace(
 std::string& aString
,const std::string& aOld     
,const std::string& aNew     
)
//////////////////////////////////////////////////////////////////////////////
// return true : some replacement done.
// return false : nothing replaced.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aOld.empty()) return false;
  std::string snew;
  std::string::size_type lold = aOld.length();
  bool status = false;
  std::string stmp = aString;
  while(true) {
    std::string::size_type pos = stmp.find(aOld);
    if(pos==std::string::npos){
      snew += stmp;
      break;
    } else {
      snew += stmp.substr(0,pos);
      snew += aNew;
      stmp = stmp.substr(pos+lold,stmp.length()-(pos+lold));
      status = true;
    }
  }
  aString = snew;
  return status;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib_smanip_pathNameSuffix(
 const std::string& aString
,std::string& aPath
,std::string& aName
,std::string& aSuffix
)
//////////////////////////////////////////////////////////////////////////////
// If aString = dir0/dir1/dir2/dir3/name.xxx
//   aPath = dir0/dir1/dir2/dir3
//   aName = name.xxx
//   aSuffix = xxx
// If aString = dir0/name.xxx
//   aPath = dir0
//   aName = name.xxx
//   aSuffix = xxx
// If aString = name.xxx
//   aPath = ""
//   aName = name.xxx
//   aSuffix = xxx
// If aString = /name.xxx
//   aPath = "/"
//   aName = name.xxx
//   aSuffix = xxx
// If aString = .
//   aPath = "."
//   aName = ""
//   aSuffix = ""
// If aString = ..
//   aPath = ".."
//   aName = ""
//   aSuffix = ""
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(aString==".") {
    aPath = ".";
    aName = "";
    aSuffix = "";
    return true;
  } else if(aString=="..") {
    aPath = "..";
    aName = "";
    aSuffix = "";
    return true;
  }

  std::string::size_type pos_slash = aString.rfind('/');
  std::string::size_type pos_bslash = aString.rfind('\\');
  std::string::size_type pos = 0;
  if(pos_slash==std::string::npos) {
    if(pos_bslash==std::string::npos) {
      pos = std::string::npos;
    } else {
      pos = pos_bslash;
    }
  } else {
    if(pos_bslash==std::string::npos) {
      pos = pos_slash;
    } else {
      if(pos_slash<=pos_bslash) {
        pos = pos_bslash;
      } else {
        pos = pos_slash;
      }
    }
  }

  if(pos==std::string::npos) {
    aPath = "";
    pos = 0;
  } else if(pos==0) {
    aPath = "/";
    pos++;
  } else {
    aPath = aString.substr(0,pos);
    pos++;
  }
  std::string s = aString.substr(pos,aString.size()-pos);
  pos = s.rfind('.');
  if(pos==std::string::npos) {
    aName = s;
    aSuffix = "";
  } else {
    aName = s;
    pos++;
    aSuffix = s.substr(pos,s.size()-pos);
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
std::string Lib_smanip_basename(
 const std::string& aPath
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  std::string path,name,suffix;
  Lib_smanip_pathNameSuffix(aPath,path,name,suffix);
  return name;
}
#include <cstdarg>
#include <cstdio>
//////////////////////////////////////////////////////////////////////////////
bool Lib_smanip_printf(
 std::string& aString
,int aLength
,const char* aFormat
,...
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aString = "";
  if(aLength<0) return false;
  if(!aFormat) return false;
  char* s = new char[aLength+1];
  if(!s) return false;
  s[aLength] = '\0';
  va_list args;
  va_start (args,aFormat);
  vsprintf (s,aFormat,args);
  va_end   (args);
  if(s[aLength]!='\0') {
    delete [] s;
    return false;
  }
  aString = s;
  delete [] s;
  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include <string.h> //strlen
#define BUFSIZE 65536
//////////////////////////////////////////////////////////////////////////////
bool Lib_fmanip_read(
 const std::string& aName
,std::vector<std::string>& aText
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  aText.clear();
  //FIXME std::string name = fmanip::name(aName);
  std::string name = aName;
  FILE* file = ::fopen(name.c_str(),"rb");
  if(!file) return false;
  char buffer[BUFSIZE+1];
  while(1) {
    if(::fgets(buffer,BUFSIZE,(FILE*)file)==NULL) break; // EOF.
    int l = ::strlen(buffer);
    //  On Windows, editors when saving binary files,
    // put \r\n at place of \n ; we then look for \r\n.
    if( (l>=2) && (buffer[l-2]=='\r') && (buffer[l-1]=='\n') ) {
      buffer[l-2] = '\0';
    } else if( (l>=1) && (buffer[l-1]=='\n') ) {
      buffer[l-1] = '\0';
    }
    aText.push_back(buffer);
  }
  ::fclose(file);
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool Lib_fmanip_write(
 const std::string& aName
,const std::vector<std::string>& aText
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //std::string name = fmanip::name(aName);
  std::string name = aName;
  FILE* file = ::fopen(name.c_str(),"wb");
  if(!file) return false;
  unsigned int textn = aText.size();
  for(unsigned index=0;index<textn;index++) {
    if(::fprintf(file,"%s\n",aText[index].c_str())<0) {
      ::fclose(file);
      return false;
    }
  }
  ::fclose(file);
  return true;
}
