#ifndef oroot_TCanvas_h
#define oroot_TCanvas_h

#include <oroot/Rtypes.h>

namespace AIDA {class IPlotter;}

class TVirtualPad;

class TCanvas {
public:
  TCanvas(const char* name, const char* title = "");
  virtual ~TCanvas();
public: //TPad
  virtual void SetLogx(Int_t value = 1);
  virtual void SetLogy(Int_t value = 1);
  virtual void SetLogz(Int_t value = 1);
  Int_t GetLogx() const;
  Int_t GetLogy() const;
  Int_t GetLogz() const;
public:
  virtual void Update();  
  TVirtualPad* cd(Int_t subpadnumber = 0);
public: //INTERNAL
  AIDA::IPlotter* plotter();
private:
  AIDA::IPlotter* m_plotter;
  bool m_log_x;
  bool m_log_y;
  bool m_log_z;
};

#endif
