// this :
#include <oroot/TH1D.h>

#include <AIDA/IHistogram1D.h>

#include <oroot/internal/mem.h>

//TH1D::TH1D(const char* name,const char* title,Int_t nbinsx,Double_t xlow,Double_t xup){}

TH1D::TH1D(AIDA::IHistogram1D& a_ao):m_ao(a_ao){mem_inc("TH1D");}
TH1D::~TH1D() {mem_dec("TH1D");}

void TH1D::SetTitle(const char* title) { m_ao.setTitle(title);}
TAxis* TH1D::GetXaxis() const {
  return &(const_cast<TH1D&>(*this).m_axis_X);
}
TAxis* TH1D::GetYaxis() const {
  return &(const_cast<TH1D&>(*this).m_axis_Y);
}
TAxis* TH1D::GetZaxis() const {
  return &(const_cast<TH1D&>(*this).m_axis_Z);
}

#include <oroot/TROOT.h>
#include <oroot/TCanvas.h>

#include <Slash/Core/ISession.h>

#include <AIDA/IPlotter.h>
#include <AIDA/IPlotterRegion.h>
#include <AIDA/IPlotterStyle.h>
#include <AIDA/IAxisStyle.h>

void TH1D::Draw(Option_t* option) {
  TCanvas* canvas = gROOT->canvas();
  if(!canvas) {
    std::ostream& out = gROOT->session()->cout();
    out << "TH1D::Draw :"
        << " no TCanvas around."
        << std::endl;
    return;
  }
  AIDA::IPlotter* plotter = canvas->plotter();
  if(!plotter) {
    std::ostream& out = gROOT->session()->cout();
    out << "TH1D::Draw :"
        << " no AIDA::IPlotter on TCanvas."
        << std::endl;
    return;
  }

  AIDA::IPlotterRegion& region = plotter->currentRegion();

  region.clear();

  region.style().xAxisStyle().setLabel(m_axis_X.GetTitle());
  region.style().yAxisStyle().setLabel(m_axis_Y.GetTitle());

  region.setParameter("plotter.xAxisLogScale",
    canvas->GetLogx()==1?"TRUE":"FALSE");
  region.setParameter("plotter.yAxisLogScale",
    canvas->GetLogy()==1?"TRUE":"FALSE");
  region.setParameter("plotter.zAxisLogScale",
    canvas->GetLogz()==1?"TRUE":"FALSE");

  region.plot(m_ao,"retain=true;overall_style=ROOT_Default");

}
