// this :
#include <oroot/TROOT.h>

#include <Slash/Core/ISession.h>
#include <Slash/Tools/smanip.h>

#include <oroot/internal/mem.h>
#include <oroot/TCanvas.h>

#include <oroot/TSystem.h>

TROOT::TROOT(Slash::Core::ISession* a_session,AIDA::IAnalysisFactory* a_AIDA):m_session(a_session),m_AIDA(a_AIDA) {
  mem_inc("TROOT");
}
TROOT::~TROOT() {

 {std::vector<TCanvas*>::iterator it;
  for(it=m_canvass.begin();it!=m_canvass.end();++it) delete *it;}

  delete m_session;

  TSystem::finalize();

  mem_dec("TROOT");
}
void TROOT::Reset() {}

Slash::Core::ISession* TROOT::session() const {return m_session;}
AIDA::IAnalysisFactory* TROOT::aida() const {return m_AIDA;}
void TROOT::addCanvas(TCanvas* a_canvas){m_canvass.push_back(a_canvas);}
TCanvas* TROOT::canvas() const {
  if(m_canvass.empty()) return 0;
  return m_canvass.back();
}



//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#include <AIDA/IAnalysisFactory.h>
#include <Slash/Core/ISession.h>
#include <Slash/Tools/UI.h>
#include <Slash/Tools/osc_env.h>

#include <Slash/Tools/AIDA.h>

#include <amanip/args.h>
#include <amanip/system.h>

TROOT* gROOT = 0;

bool TROOT::initialize(int a_argc,char* a_argv[],std::ostream& a_out) {
  if(gROOT) return true; //done.


  if(!Slash::osc::set_env(a_out)) {
    a_out << "TROOT::init :"
              << " unable to set OnX environment." << std::endl;
    return false;
  }

  Slash::Core::ISession* session = 
    Slash_create_session(Slash::to(a_argc,a_argv));
  if(!session) {
    a_out << "TROOT::init :"
              << " ISession not found." << std::endl;
    return false;
  }

  std::ostream& out = session->cout();

  Slash::UI::IScriptManager* mgr = Slash::scriptManager(*session);
  if(!mgr) {
    a_out << "TROOT::init :"
              << " ScriptManager not found." << std::endl;
    delete session;
    return false;
  }

  //session->setParameter("mainTree.append","no");
  // Set OnXLab.tree to something.
  session->setParameter("OnXLab.tree","Canvas_0");
  session->redirectOutput(false);  //same as : OnX session_set_output terminal
  Slash::UI::IInterpreter::Options pms;
  //mgr->executeScript("Session","OnX OnX_declare_accessors_sess",pms);
  mgr->executeScript("Session","OnXLab OnXLab_createAIDA",pms);
  //mgr->executeScript("Session","OnXLab OnXLab_declare_accessors_sess",pms);

  Slash::UI::IUI_Manager* uim = Slash::uiManager(*session);
  if(!uim) {
    a_out << "TROOT::init :"
              << " UI_Manager not found." 
              << std::endl;
    delete session;
    return false;
  }

  amanip::args args(a_argc,a_argv);
  std::string tk = amanip::gui_toolkit(args);
  if(tk.empty()) {
    amanip::getenv("OROOT_GUI_TOOLKIT",tk);
  }

  // create an empty GUI :
  std::vector<std::string> uiargs;
  Slash::UI::IUI* ui = uim->create(tk,"@empty@",uiargs,false);
  if(!ui) {
    a_out << "TROOT::init :"
              << " UI not created." 
              << std::endl;
    delete session;
    return false;    
  }

  AIDA::IAnalysisFactory* aida = Slash::find_AIDA(*session);
  if(!aida) {
    a_out << "TROOT::init :"
              << " AIDA not found." 
              << std::endl;
    delete session;
    return false;
  }

  gROOT = new TROOT(session,aida);

  TSystem::initialize();

  return true;
}

void TROOT::finalize() {
  delete gROOT;
  gROOT = 0;
}
