// this :
#include <oroot/internal/mem.h>

#include <list>

#include <cstring> //strcmp

static bool s_check_class = false;
static int s_count = 0;
static std::list< std::pair<std::string,int> >* s_list = 0;

namespace oroot {

void mem::check_class(bool a_enable){s_check_class = a_enable;}
bool mem::check_class(){return s_check_class;}

void mem::inc(const char* aClass){
  s_count++;
  if(s_check_class) {
    if(!s_list) s_list = new std::list< std::pair<std::string,int> >;
    std::list< std::pair<std::string,int> >::iterator it;
    for(it=s_list->begin();it!=s_list->end();++it) {
      if(!::strcmp((*it).first.c_str(),aClass)) {
        (*it).second++;
        return;
      }
    }
    s_list->push_back(std::pair<std::string,int>(std::string(aClass),1));
  }
}

void mem::dec(const char* aClass){
  s_count--;
  if(s_check_class) {
    if(!s_list) s_list = new std::list< std::pair<std::string,int> >;
    std::list< std::pair<std::string,int> >::iterator it;
    for(it=s_list->begin();it!=s_list->end();++it) {
      if(!::strcmp((*it).first.c_str(),aClass)) {
        (*it).second--;
        return;
      }
    }
    s_list->push_back(std::pair<std::string,int>(std::string(aClass),-1));
  }
}

void mem::inc(const std::string& a_s){inc(a_s.c_str());}
void mem::dec(const std::string& a_s){dec(a_s.c_str());}

void mem::balance(std::ostream& a_out){
  if(s_count) {
    a_out << "osc::sim::mem::balance :"
          << " bad global object balance : " << s_count << std::endl;
    if(s_check_class) {
      a_out << "osc::sim::mem::balance :"
            << " check by class was enabled." << std::endl;
    } else {
      a_out << "osc::sim::mem::balance :"
            << " check by class was disabled." << std::endl;
    }
  }
  if(s_list) {
    std::list< std::pair<std::string,int> >::iterator it;
    for(it=s_list->begin();it!=s_list->end();++it) {
      if((*it).second) {
        a_out << "osc::sim::mem::balance :"
              << " for class \"" << (*it).first 
              << "\", bad object balance : " << (*it).second
              << std::endl;
      }
    }
    delete s_list;
    s_list = 0;
  }
}

}
