@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.10.0
REM # for the package osc_batch with version 16.11.8.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\pack\version\obuild
REM #   DOS> DOS\build
REM # or :
REM #   DOS> call DOS\build.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_osc_batch_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_osc_batch_path=%obuild_osc_batch_path:~0,-12%

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

SET obuild_verbose=no

SET obuild_group=main

SET obuild_args=

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   build [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -* : passed to packages build script.
  ECHO
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SET obuild_args=%obuild_args% -v
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  ECHO ON
  SET obuild_args=%obuild_args% -x
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-group" GOTO end_if_group
  SET obuild_args=%obuild_args% %1%
  SHIFT
  SET obuild_args=%obuild_args% %1%
  SET obuild_group=%1%
  SHIFT
  GOTO next_arg
:end_if_group

SET obuild_args=%obuild_args% %1%
SHIFT
GOTO next_arg

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////


FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_0=%%d

IF NOT EXIST "%obuild_osc_batch_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_batch_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_osc_batch_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_osc_batch_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

cd "%obuild_obuild_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build obuild/v1r10p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r10p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

cd "%obuild_foreign_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build foreign/v1r10p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

cd "%obuild_zlib_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build zlib/v1r114p11 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

cd "%obuild_zip_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build zip/v1r101p5 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  expat v1r11p13`) DO SET obuild_expat_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_expat_path  ECHO Can't find expat package.  && GOTO obuild_return

cd "%obuild_expat_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build expat/v1r11p13 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Slash v1r7p0`) DO SET obuild_Slash_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_Slash_path  ECHO Can't find Slash package.  && GOTO obuild_return

cd "%obuild_Slash_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Slash/v1r7p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Lib v8r8p1`) DO SET obuild_Lib_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_Lib_path  ECHO Can't find Lib package.  && GOTO obuild_return

cd "%obuild_Lib_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Lib/v8r8p1 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HCL v7r0p8`) DO SET obuild_HCL_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_HCL_path  ECHO Can't find HCL package.  && GOTO obuild_return

cd "%obuild_HCL_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build HCL/v7r0p8 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Midnight v4r0p8`) DO SET obuild_Midnight_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_Midnight_path  ECHO Can't find Midnight package.  && GOTO obuild_return

cd "%obuild_Midnight_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Midnight/v4r0p8 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Minuit v1r140p12`) DO SET obuild_Minuit_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_Minuit_path  ECHO Can't find Minuit package.  && GOTO obuild_return

cd "%obuild_Minuit_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Minuit/v1r140p12 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  Rio v10r0p0`) DO SET obuild_Rio_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_Rio_path  ECHO Can't find Rio package.  && GOTO obuild_return

cd "%obuild_Rio_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build Rio/v10r0p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r165p10`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

cd "%obuild_HDF5_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build HDF5/v1r165p10 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  amanip v1r0p1`) DO SET obuild_amanip_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_amanip_path  ECHO Can't find amanip package.  && GOTO obuild_return

cd "%obuild_amanip_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build amanip/v1r0p1 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  BatchLab v1r7p0`) DO SET obuild_BatchLab_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_BatchLab_path  ECHO Can't find BatchLab package.  && GOTO obuild_return

cd "%obuild_BatchLab_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build BatchLab/v1r7p0 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  UseAIDA v1r3p1`) DO SET obuild_UseAIDA_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_UseAIDA_path  ECHO Can't find UseAIDA package.  && GOTO obuild_return

cd "%obuild_UseAIDA_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build UseAIDA/v1r3p1 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_batch_1=%%d
cd "%obuild_osc_batch_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  osc_source 16.11.8`) DO SET obuild_osc_source_path=%%j
cd "%obuild_pwd_osc_batch_1%"
SET obuild_pwd_osc_batch_1=
IF NOT DEFINED obuild_osc_source_path  ECHO Can't find osc_source package.  && GOTO obuild_return

cd "%obuild_osc_source_path%\obuild"
@IF %obuild_verbose% == yes @ECHO ON 
ECHO build osc_source/16.11.8 ...
CALL DOS\build %obuild_args%
@ECHO OFF
@IF %obuild_verbose% == yes @ECHO OFF 


cd "%obuild_pwd_osc_batch_0%"
SET obuild_pwd_osc_batch_0=
:obuild_return
ENDLOCAL
@ECHO ON
