@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.10.0
REM # for the package osc_obuild with version 16.11.8.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\project\version\obuild
REM #   DOS> DOS\build_release
REM # or :
REM #   DOS> call DOS\build_release.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_osc_obuild_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_osc_obuild_path=%obuild_osc_obuild_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_erase_dir_bin=no
SET obuild_debug_signature=

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -e : erase binary directory.
  ECHO   -g : debug.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-e" GOTO end_if_e
  SET obuild_erase_dir_bin=yes
  SHIFT
  GOTO next_arg
:end_if_e

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug_signature=-debug
  SHIFT
  GOTO next_arg
:end_if_g

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF "%obuild_erase_dir_bin%" == "yes" (
  IF EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_osc_obuild_path%\%obuild_dir_bin%"
  GOTO obuild_return
)

IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_obuild_path%\%obuild_dir_bin%"

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_0=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF EXIST osc_obuild RMDIR /S /Q osc_obuild
IF NOT EXIST osc_obuild MKDIR osc_obuild
cd osc_obuild
IF NOT EXIST 16.11.8 MKDIR 16.11.8
cd 16.11.8
IF NOT EXIST lib MKDIR lib
IF NOT EXIST bin MKDIR bin
IF NOT EXIST Resources MKDIR Resources
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_dir_project=%%d

IF EXIST "%obuild_dir_project%\Versions" DEL "%obuild_dir_project%\Versions"
ECHO package foreign v1r10p0   >> "%obuild_dir_project%\Versions"
ECHO package osc_source 16.11.8   >> "%obuild_dir_project%\Versions"


IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_osc_obuild_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r10p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

IF NOT EXIST "%obuild_foreign_path%\..\foreign"  ECHO WARNING : Directory %obuild_foreign_path%\..\foreign not found.  && GOTO end_if_release_1
IF NOT EXIST "%obuild_dir_project%\Resources\.\foreign" MKDIR "%obuild_dir_project%\Resources\.\foreign"
XCOPY /E /Q "%obuild_foreign_path%\..\foreign" "%obuild_dir_project%\Resources\.\foreign" 1> exe_error_0
@IF ERRORLEVEL 1 @TYPE exe_error_0 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_0
:end_if_release_1
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  osc_source 16.11.8`) DO SET obuild_osc_source_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_osc_source_path  ECHO Can't find osc_source package.  && GOTO obuild_return

IF NOT EXIST "%obuild_osc_source_path%\release\License"  ECHO WARNING : File %obuild_osc_source_path%\release\License not found.  && GOTO end_if_release_3
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\License" "%obuild_dir_project%\." 1> exe_error_1
@IF ERRORLEVEL 1 @TYPE exe_error_1 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_1
:end_if_release_3
IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_osc_obuild_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_osc_obuild_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_4
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\setup.bat not found.  && GOTO end_if_release_5
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\setup.bat" "%obuild_dir_project%\." 1> exe_error_2
@IF ERRORLEVEL 1 @TYPE exe_error_2 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_2
:end_if_release_5
:end_if_platform_4
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_6
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\aida-setup.bat not found.  && GOTO end_if_release_7
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat" "%obuild_dir_project%\." 1> exe_error_3
@IF ERRORLEVEL 1 @TYPE exe_error_3 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_3
:end_if_release_7
:end_if_platform_6
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_8
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\README"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\README not found.  && GOTO end_if_release_9
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\README" "%obuild_dir_project%\." 1> exe_error_4
@IF ERRORLEVEL 1 @TYPE exe_error_4 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_4
:end_if_release_9
:end_if_platform_8
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_10
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\check_install.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\check_install.bat not found.  && GOTO end_if_release_11
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\check_install.bat" "%obuild_dir_project%\." 1> exe_error_5
@IF ERRORLEVEL 1 @TYPE exe_error_5 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_5
:end_if_release_11
:end_if_platform_10
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_12
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Python-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Python-setup.bat not found.  && GOTO end_if_release_13
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Python-setup.bat" "%obuild_dir_project%\." 1> exe_error_6
@IF ERRORLEVEL 1 @TYPE exe_error_6 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_6
:end_if_release_13
:end_if_platform_12
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_14
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat not found.  && GOTO end_if_release_15
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat" "%obuild_dir_project%\." 1> exe_error_7
@IF ERRORLEVEL 1 @TYPE exe_error_7 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_7
:end_if_release_15
:end_if_platform_14
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_16
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat not found.  && GOTO end_if_release_17
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat" "%obuild_dir_project%\." 1> exe_error_8
@IF ERRORLEVEL 1 @TYPE exe_error_8 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_8
:end_if_release_17
:end_if_platform_16
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_18
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\desktop"  ECHO WARNING : Directory %obuild_osc_source_path%\release\Windows_NT\desktop not found.  && GOTO end_if_release_19
IF NOT EXIST "%obuild_dir_project%\.\desktop" MKDIR "%obuild_dir_project%\.\desktop"
XCOPY /E /Q "%obuild_osc_source_path%\release\Windows_NT\desktop" "%obuild_dir_project%\.\desktop" 1> exe_error_9
@IF ERRORLEVEL 1 @TYPE exe_error_9 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_9
:end_if_release_19
:end_if_platform_18
SET obuild_platform_result=



FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_20
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" GOTO end_if_copy_10
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" "%obuild_dir_project%\bin\." 1> exe_error_10
  @IF ERRORLEVEL 1 @TYPE exe_error_10 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_10
:end_if_copy_10
:end_if_release_20
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_21
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" GOTO end_if_copy_11
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" "%obuild_dir_project%\bin\." 1> exe_error_11
  @IF ERRORLEVEL 1 @TYPE exe_error_11 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_11
:end_if_copy_11
:end_if_release_21

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_obuild_1=%%d
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe`) DO SET obuild_platform_signature=%%j
cd "%obuild_pwd_osc_obuild_1%"
SET obuild_pwd_osc_obuild_1=
IF EXIST "%obuild_dir_project%\lib" RMDIR /S /Q "%obuild_dir_project%\lib"
IF EXIST "%obuild_dir_project%\desktop" RMDIR /S /Q "%obuild_dir_project%\desktop"
FOR %%f IN ("%obuild_dir_project%"\aida-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\py-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\Python-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\Qt-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\Geant4-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\README*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\check_install*) DO DEL "%%f"
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF EXIST osc_obuild-16.11.8-%obuild_platform_signature%%obuild_debug_signature%.zip DEL osc_obuild-16.11.8-%obuild_platform_signature%%obuild_debug_signature%.zip
IF EXIST osc_obuild-darwin-app-16.11.8-%obuild_platform_signature%${obuild_debug_signature}.zip DEL osc_obuild-darwin-app-16.11.8-%obuild_platform_signature%${obuild_debug_signature}.zip
zip -q -r osc_obuild-16.11.8-%obuild_platform_signature%%obuild_debug_signature%.zip osc_obuild
cd "%obuild_osc_obuild_path%\obuild"
cd "%obuild_osc_obuild_path%\%obuild_dir_bin%"
IF EXIST obuild_platform.exe DEL obuild_platform.exe
cd "%obuild_pwd_osc_obuild_0%"
SET obuild_pwd_osc_obuild_0=
:obuild_return
ENDLOCAL
@ECHO ON
