@ECHO OFF
SETLOCAL

REM #
REM # File produced by the obuild tool version 1.10.0
REM # for the package osc_steve with version 0.1.
REM #

REM #////////////////////////////////////////////////
REM # Usage :
REM #   DOS> CD some_path\project\version\obuild
REM #   DOS> DOS\build_release
REM # or :
REM #   DOS> call DOS\build_release.bat
REM #
REM #////////////////////////////////////////////////

REM #////////////////////////////////////////////////
REM #/// Get path of this file :
REM #////////////////////////////////////////////////
SET obuild_osc_steve_path=%~dp0
REM # Remove ending \obuild\DOS\
SET obuild_osc_steve_path=%obuild_osc_steve_path:~0,-12%

SET obuild_verbose=no
SET obuild_set_x=no
SET obuild_erase_dir_bin=no
SET obuild_debug_signature=

REM #////////////////////////////////////////////////
REM #/// Treat arguments :
REM #////////////////////////////////////////////////

:next_arg
IF "%1%" == "" GOTO end_args

IF NOT "%1%" == "-h" GOTO end_if_h
  ECHO Usage :
  ECHO   DOS\run [Options]
  ECHO Options :
  ECHO   -v : verbose.
  ECHO   -x : execute with ECHO ON"
  ECHO   -e : erase binary directory.
  ECHO   -g : debug.
  GOTO obuild_return
:end_if_h

IF NOT "%1%" == "-v" GOTO end_if_v
  SET obuild_verbose=yes
  SHIFT
  GOTO next_arg
:end_if_v

IF NOT "%1%" == "-x" GOTO end_if_x
  SET obuild_set_x=yes
  SHIFT
  GOTO next_arg
:end_if_x

IF NOT "%1%" == "-e" GOTO end_if_e
  SET obuild_erase_dir_bin=yes
  SHIFT
  GOTO next_arg
:end_if_e

IF NOT "%1%" == "-g" GOTO end_if_g
  SET obuild_debug_signature=-debug
  SHIFT
  GOTO next_arg
:end_if_g

:end_args

REM #////////////////////////////////////////////////
REM #/// End arguments.
REM #////////////////////////////////////////////////

IF %obuild_set_x% == yes ECHO ON

IF "%OBUILD_DIR_BIN%" == "" (
  SET obuild_dir_bin=bin_obuild
) ELSE (
  SET obuild_dir_bin=%OBUILD_DIR_BIN%
)

IF "%obuild_dir_bin%" == "" (
  ECHO obuild_dir_bin variable not defined.
  GOTO obuild_return
)

IF "%obuild_erase_dir_bin%" == "yes" (
  IF EXIST "%obuild_osc_steve_path%\%obuild_dir_bin%" RMDIR /S /Q "%obuild_osc_steve_path%\%obuild_dir_bin%"
  GOTO obuild_return
)

IF NOT EXIST "%obuild_osc_steve_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_steve_path%\%obuild_dir_bin%"

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_0=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF EXIST osc_steve RMDIR /S /Q osc_steve
IF NOT EXIST osc_steve MKDIR osc_steve
cd osc_steve
IF NOT EXIST 0.1 MKDIR 0.1
cd 0.1
IF NOT EXIST lib MKDIR lib
IF NOT EXIST bin MKDIR bin
IF NOT EXIST Resources MKDIR Resources
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_dir_project=%%d

IF EXIST "%obuild_dir_project%\Versions" DEL "%obuild_dir_project%\Versions"
ECHO package foreign v1r10p0   >> "%obuild_dir_project%\Versions"
ECHO package steve v0r1p1   >> "%obuild_dir_project%\Versions"
ECHO package osc_source 16.11   >> "%obuild_dir_project%\Versions"


IF NOT EXIST "%obuild_osc_steve_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_steve_path%\%obuild_dir_bin%\obuild_find.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3 /GX /GR /Fe"%obuild_osc_steve_path%\%obuild_dir_bin%\obuild_find.exe" "%obuild_osc_steve_path%\obuild\cpp\obuild_find.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_find.obj DEL obuild_find.obj
)
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  foreign v1r10p0`) DO SET obuild_foreign_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_foreign_path  ECHO Can't find foreign package.  && GOTO obuild_return

IF NOT EXIST "%obuild_foreign_path%\..\foreign"  ECHO WARNING : Directory %obuild_foreign_path%\..\foreign not found.  && GOTO end_if_release_1
IF NOT EXIST "%obuild_dir_project%\Resources\.\foreign" MKDIR "%obuild_dir_project%\Resources\.\foreign"
XCOPY /E /Q "%obuild_foreign_path%\..\foreign" "%obuild_dir_project%\Resources\.\foreign" 1> exe_error_0
@IF ERRORLEVEL 1 @TYPE exe_error_0 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_0
:end_if_release_1
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\steve"  ECHO WARNING : Directory %obuild_steve_path%\steve not found.  && GOTO end_if_release_3
IF NOT EXIST "%obuild_dir_project%\Resources\steve\.\steve" MKDIR "%obuild_dir_project%\Resources\steve\.\steve"
XCOPY /E /Q "%obuild_steve_path%\steve" "%obuild_dir_project%\Resources\steve\.\steve" 1> exe_error_1
@IF ERRORLEVEL 1 @TYPE exe_error_1 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_1
:end_if_release_3
IF NOT EXIST "%obuild_steve_path%\examples"  ECHO WARNING : Directory %obuild_steve_path%\examples not found.  && GOTO end_if_release_5
IF NOT EXIST "%obuild_dir_project%\Resources\steve\.\examples" MKDIR "%obuild_dir_project%\Resources\steve\.\examples"
XCOPY /E /Q "%obuild_steve_path%\examples" "%obuild_dir_project%\Resources\steve\.\examples" 1> exe_error_2
@IF ERRORLEVEL 1 @TYPE exe_error_2 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_2
:end_if_release_5
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  osc_source 16.11`) DO SET obuild_osc_source_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_osc_source_path  ECHO Can't find osc_source package.  && GOTO obuild_return

IF NOT EXIST "%obuild_osc_source_path%\release\License"  ECHO WARNING : File %obuild_osc_source_path%\release\License not found.  && GOTO end_if_release_7
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\License" "%obuild_dir_project%\." 1> exe_error_3
@IF ERRORLEVEL 1 @TYPE exe_error_3 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_3
:end_if_release_7
IF NOT EXIST "%obuild_osc_steve_path%\%obuild_dir_bin%" MKDIR "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST "%obuild_osc_steve_path%\%obuild_dir_bin%\obuild_platform.exe" (
  cl.exe /nologo /DWIN32 /MD /O2 /W3  /GX /GR /Fe"%obuild_osc_steve_path%\%obuild_dir_bin%\obuild_platform.exe" "%obuild_osc_steve_path%\obuild\cpp\obuild_platform.cpp" 1> cl_exe_error
  IF ERRORLEVEL 1 TYPE cl_exe_error
  IF NOT ERRORLEVEL 1 DEL cl_exe_error 
  IF EXIST obuild_platform.obj DEL obuild_platform.obj
)

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_8
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\setup.bat not found.  && GOTO end_if_release_9
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\setup.bat" "%obuild_dir_project%\." 1> exe_error_4
@IF ERRORLEVEL 1 @TYPE exe_error_4 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_4
:end_if_release_9
:end_if_platform_8
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_10
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\aida-setup.bat not found.  && GOTO end_if_release_11
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\aida-setup.bat" "%obuild_dir_project%\." 1> exe_error_5
@IF ERRORLEVEL 1 @TYPE exe_error_5 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_5
:end_if_release_11
:end_if_platform_10
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_12
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\README"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\README not found.  && GOTO end_if_release_13
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\README" "%obuild_dir_project%\." 1> exe_error_6
@IF ERRORLEVEL 1 @TYPE exe_error_6 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_6
:end_if_release_13
:end_if_platform_12
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_14
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\check_install.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\check_install.bat not found.  && GOTO end_if_release_15
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\check_install.bat" "%obuild_dir_project%\." 1> exe_error_7
@IF ERRORLEVEL 1 @TYPE exe_error_7 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_7
:end_if_release_15
:end_if_platform_14
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_16
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Python-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Python-setup.bat not found.  && GOTO end_if_release_17
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Python-setup.bat" "%obuild_dir_project%\." 1> exe_error_8
@IF ERRORLEVEL 1 @TYPE exe_error_8 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_8
:end_if_release_17
:end_if_platform_16
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_18
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat not found.  && GOTO end_if_release_19
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Qt-setup.bat" "%obuild_dir_project%\." 1> exe_error_9
@IF ERRORLEVEL 1 @TYPE exe_error_9 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_9
:end_if_release_19
:end_if_platform_18
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_20
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat"  ECHO WARNING : File %obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat not found.  && GOTO end_if_release_21
IF NOT EXIST "%obuild_dir_project%" MKDIR "%obuild_dir_project%"
COPY "%obuild_osc_source_path%\release\Windows_NT\Geant4-setup.bat" "%obuild_dir_project%\." 1> exe_error_10
@IF ERRORLEVEL 1 @TYPE exe_error_10 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_10
:end_if_release_21
:end_if_platform_20
SET obuild_platform_result=
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe  "Windows_NT"`) DO SET obuild_platform_result=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT %obuild_platform_result% == yes GOTO end_if_platform_22
IF NOT EXIST "%obuild_osc_source_path%\release\Windows_NT\desktop"  ECHO WARNING : Directory %obuild_osc_source_path%\release\Windows_NT\desktop not found.  && GOTO end_if_release_23
IF NOT EXIST "%obuild_dir_project%\.\desktop" MKDIR "%obuild_dir_project%\.\desktop"
XCOPY /E /Q "%obuild_osc_source_path%\release\Windows_NT\desktop" "%obuild_dir_project%\.\desktop" 1> exe_error_11
@IF ERRORLEVEL 1 @TYPE exe_error_11 && @GOTO obuild_return
@IF NOT ERRORLEVEL 1 @DEL exe_error_11
:end_if_release_23
:end_if_platform_22
SET obuild_platform_result=

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_24
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.arc" GOTO end_if_copy_12
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.arc" "%obuild_dir_project%\lib\." 1> exe_error_12
  @IF ERRORLEVEL 1 @TYPE exe_error_12 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_12
:end_if_copy_12
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.lib" GOTO end_if_copy_13
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.lib" "%obuild_dir_project%\lib\." 1> exe_error_13
  @IF ERRORLEVEL 1 @TYPE exe_error_13 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_13
:end_if_copy_13
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.dll" GOTO end_if_copy_14
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\osc_zlib.dll" "%obuild_dir_project%\bin\." 1> exe_error_14
  @IF ERRORLEVEL 1 @TYPE exe_error_14 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_14
:end_if_copy_14
:end_if_release_24
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_25
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.arc" GOTO end_if_copy_15
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.arc" "%obuild_dir_project%\lib\." 1> exe_error_15
  @IF ERRORLEVEL 1 @TYPE exe_error_15 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_15
:end_if_copy_15
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.lib" GOTO end_if_copy_16
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.lib" "%obuild_dir_project%\lib\." 1> exe_error_16
  @IF ERRORLEVEL 1 @TYPE exe_error_16 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_16
:end_if_copy_16
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.dll" GOTO end_if_copy_17
  COPY "%obuild_zip_path%\%obuild_dir_bin%\osc_zip.dll" "%obuild_dir_project%\bin\." 1> exe_error_17
  @IF ERRORLEVEL 1 @TYPE exe_error_17 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_17
:end_if_copy_17
:end_if_release_25
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r165p10`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HDF5_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_26
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.arc" GOTO end_if_copy_18
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.arc" "%obuild_dir_project%\lib\." 1> exe_error_18
  @IF ERRORLEVEL 1 @TYPE exe_error_18 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_18
:end_if_copy_18
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.lib" GOTO end_if_copy_19
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.lib" "%obuild_dir_project%\lib\." 1> exe_error_19
  @IF ERRORLEVEL 1 @TYPE exe_error_19 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_19
:end_if_copy_19
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.dll" GOTO end_if_copy_20
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\osc_HDF5.dll" "%obuild_dir_project%\bin\." 1> exe_error_20
  @IF ERRORLEVEL 1 @TYPE exe_error_20 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_20
:end_if_copy_20
:end_if_release_26
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_27
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_core.arc" GOTO end_if_copy_21
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_core.arc" "%obuild_dir_project%\lib\." 1> exe_error_21
  @IF ERRORLEVEL 1 @TYPE exe_error_21 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_21
:end_if_copy_21
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_core.lib" GOTO end_if_copy_22
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_core.lib" "%obuild_dir_project%\lib\." 1> exe_error_22
  @IF ERRORLEVEL 1 @TYPE exe_error_22 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_22
:end_if_copy_22
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_core.dll" GOTO end_if_copy_23
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_core.dll" "%obuild_dir_project%\bin\." 1> exe_error_23
  @IF ERRORLEVEL 1 @TYPE exe_error_23 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_23
:end_if_copy_23
:end_if_release_27
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_28
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_tests_Exp.arc" GOTO end_if_copy_24
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_tests_Exp.arc" "%obuild_dir_project%\lib\." 1> exe_error_24
  @IF ERRORLEVEL 1 @TYPE exe_error_24 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_24
:end_if_copy_24
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_tests_Exp.lib" GOTO end_if_copy_25
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_tests_Exp.lib" "%obuild_dir_project%\lib\." 1> exe_error_25
  @IF ERRORLEVEL 1 @TYPE exe_error_25 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_25
:end_if_copy_25
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_tests_Exp.dll" GOTO end_if_copy_26
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_tests_Exp.dll" "%obuild_dir_project%\bin\." 1> exe_error_26
  @IF ERRORLEVEL 1 @TYPE exe_error_26 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_26
:end_if_copy_26
:end_if_release_28
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_29
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.arc" GOTO end_if_copy_27
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.arc" "%obuild_dir_project%\lib\." 1> exe_error_27
  @IF ERRORLEVEL 1 @TYPE exe_error_27 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_27
:end_if_copy_27
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.lib" GOTO end_if_copy_28
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.lib" "%obuild_dir_project%\lib\." 1> exe_error_28
  @IF ERRORLEVEL 1 @TYPE exe_error_28 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_28
:end_if_copy_28
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.dll" GOTO end_if_copy_29
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.dll" "%obuild_dir_project%\bin\." 1> exe_error_29
  @IF ERRORLEVEL 1 @TYPE exe_error_29 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_29
:end_if_copy_29
:end_if_release_29
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_30
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.arc" GOTO end_if_copy_30
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.arc" "%obuild_dir_project%\lib\." 1> exe_error_30
  @IF ERRORLEVEL 1 @TYPE exe_error_30 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_30
:end_if_copy_30
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.lib" GOTO end_if_copy_31
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.lib" "%obuild_dir_project%\lib\." 1> exe_error_31
  @IF ERRORLEVEL 1 @TYPE exe_error_31 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_31
:end_if_copy_31
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.dll" GOTO end_if_copy_32
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.dll" "%obuild_dir_project%\bin\." 1> exe_error_32
  @IF ERRORLEVEL 1 @TYPE exe_error_32 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_32
:end_if_copy_32
:end_if_release_30
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_31
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.arc" GOTO end_if_copy_33
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.arc" "%obuild_dir_project%\lib\." 1> exe_error_33
  @IF ERRORLEVEL 1 @TYPE exe_error_33 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_33
:end_if_copy_33
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.lib" GOTO end_if_copy_34
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.lib" "%obuild_dir_project%\lib\." 1> exe_error_34
  @IF ERRORLEVEL 1 @TYPE exe_error_34 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_34
:end_if_copy_34
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.dll" GOTO end_if_copy_35
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.dll" "%obuild_dir_project%\bin\." 1> exe_error_35
  @IF ERRORLEVEL 1 @TYPE exe_error_35 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_35
:end_if_copy_35
:end_if_release_31
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_32
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_ROOT.arc" GOTO end_if_copy_36
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_ROOT.arc" "%obuild_dir_project%\lib\." 1> exe_error_36
  @IF ERRORLEVEL 1 @TYPE exe_error_36 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_36
:end_if_copy_36
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_ROOT.lib" GOTO end_if_copy_37
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_ROOT.lib" "%obuild_dir_project%\lib\." 1> exe_error_37
  @IF ERRORLEVEL 1 @TYPE exe_error_37 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_37
:end_if_copy_37
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_ROOT.dll" GOTO end_if_copy_38
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_ROOT.dll" "%obuild_dir_project%\bin\." 1> exe_error_38
  @IF ERRORLEVEL 1 @TYPE exe_error_38 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_38
:end_if_copy_38
:end_if_release_32
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_33
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_mysql.arc" GOTO end_if_copy_39
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_mysql.arc" "%obuild_dir_project%\lib\." 1> exe_error_39
  @IF ERRORLEVEL 1 @TYPE exe_error_39 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_39
:end_if_copy_39
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_mysql.lib" GOTO end_if_copy_40
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_mysql.lib" "%obuild_dir_project%\lib\." 1> exe_error_40
  @IF ERRORLEVEL 1 @TYPE exe_error_40 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_40
:end_if_copy_40
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_mysql.dll" GOTO end_if_copy_41
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_mysql.dll" "%obuild_dir_project%\bin\." 1> exe_error_41
  @IF ERRORLEVEL 1 @TYPE exe_error_41 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_41
:end_if_copy_41
:end_if_release_33
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_34
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.arc" GOTO end_if_copy_42
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.arc" "%obuild_dir_project%\lib\." 1> exe_error_42
  @IF ERRORLEVEL 1 @TYPE exe_error_42 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_42
:end_if_copy_42
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.lib" GOTO end_if_copy_43
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.lib" "%obuild_dir_project%\lib\." 1> exe_error_43
  @IF ERRORLEVEL 1 @TYPE exe_error_43 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_43
:end_if_copy_43
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.dll" GOTO end_if_copy_44
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.dll" "%obuild_dir_project%\bin\." 1> exe_error_44
  @IF ERRORLEVEL 1 @TYPE exe_error_44 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_44
:end_if_copy_44
:end_if_release_34


FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_35
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" GOTO end_if_copy_45
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\owrap.exe" "%obuild_dir_project%\bin\." 1> exe_error_45
  @IF ERRORLEVEL 1 @TYPE exe_error_45 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_45
:end_if_copy_45
:end_if_release_35
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  obuild v1r10p0`) DO SET obuild_obuild_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_obuild_path  ECHO Can't find obuild package.  && GOTO obuild_return

IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_obuild_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_36
IF NOT EXIST "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" GOTO end_if_copy_46
  COPY "%obuild_obuild_path%\%obuild_dir_bin%\obuild.exe" "%obuild_dir_project%\bin\." 1> exe_error_46
  @IF ERRORLEVEL 1 @TYPE exe_error_46 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_46
:end_if_copy_46
:end_if_release_36
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_37
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\zlib_example.exe" GOTO end_if_copy_47
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\zlib_example.exe" "%obuild_dir_project%\bin\." 1> exe_error_47
  @IF ERRORLEVEL 1 @TYPE exe_error_47 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_47
:end_if_copy_47
:end_if_release_37
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zlib v1r114p11`) DO SET obuild_zlib_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_zlib_path  ECHO Can't find zlib package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zlib_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_38
IF NOT EXIST "%obuild_zlib_path%\%obuild_dir_bin%\zlib_minigzip.exe" GOTO end_if_copy_48
  COPY "%obuild_zlib_path%\%obuild_dir_bin%\zlib_minigzip.exe" "%obuild_dir_project%\bin\." 1> exe_error_48
  @IF ERRORLEVEL 1 @TYPE exe_error_48 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_48
:end_if_copy_48
:end_if_release_38
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_39
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exe" GOTO end_if_copy_49
  COPY "%obuild_zip_path%\%obuild_dir_bin%\zip_minizip.exe" "%obuild_dir_project%\bin\." 1> exe_error_49
  @IF ERRORLEVEL 1 @TYPE exe_error_49 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_49
:end_if_copy_49
:end_if_release_39
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  zip v1r101p5`) DO SET obuild_zip_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_zip_path  ECHO Can't find zip package.  && GOTO obuild_return

IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_zip_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_40
IF NOT EXIST "%obuild_zip_path%\%obuild_dir_bin%\zip_miniuzip.exe" GOTO end_if_copy_50
  COPY "%obuild_zip_path%\%obuild_dir_bin%\zip_miniuzip.exe" "%obuild_dir_project%\bin\." 1> exe_error_50
  @IF ERRORLEVEL 1 @TYPE exe_error_50 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_50
:end_if_copy_50
:end_if_release_40
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  HDF5 v1r165p10`) DO SET obuild_HDF5_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_HDF5_path  ECHO Can't find HDF5 package.  && GOTO obuild_return

IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_HDF5_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_41
IF NOT EXIST "%obuild_HDF5_path%\%obuild_dir_bin%\h5_array_compound.exe" GOTO end_if_copy_51
  COPY "%obuild_HDF5_path%\%obuild_dir_bin%\h5_array_compound.exe" "%obuild_dir_project%\bin\." 1> exe_error_51
  @IF ERRORLEVEL 1 @TYPE exe_error_51 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_51
:end_if_copy_51
:end_if_release_41
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_42
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_moc.exe" GOTO end_if_copy_52
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_moc.exe" "%obuild_dir_project%\bin\." 1> exe_error_52
  @IF ERRORLEVEL 1 @TYPE exe_error_52 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_52
:end_if_copy_52
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve-moc.exe" GOTO end_if_copy_53
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve-moc.exe" "%obuild_dir_project%\bin\." 1> exe_error_53
  @IF ERRORLEVEL 1 @TYPE exe_error_53 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_53
:end_if_copy_53
:end_if_release_42
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_43
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_config.exe" GOTO end_if_copy_54
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_config.exe" "%obuild_dir_project%\bin\." 1> exe_error_54
  @IF ERRORLEVEL 1 @TYPE exe_error_54 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_54
:end_if_copy_54
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve-config.exe" GOTO end_if_copy_55
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve-config.exe" "%obuild_dir_project%\bin\." 1> exe_error_55
  @IF ERRORLEVEL 1 @TYPE exe_error_55 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_55
:end_if_copy_55
:end_if_release_43
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_44
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_memory.exe" GOTO end_if_copy_56
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_memory.exe" "%obuild_dir_project%\bin\." 1> exe_error_56
  @IF ERRORLEVEL 1 @TYPE exe_error_56 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_56
:end_if_copy_56
:end_if_release_44
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_45
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_7.exe" GOTO end_if_copy_57
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_7.exe" "%obuild_dir_project%\bin\." 1> exe_error_57
  @IF ERRORLEVEL 1 @TYPE exe_error_57 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_57
:end_if_copy_57
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.save" GOTO end_if_copy_58
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_memory.save" "%obuild_dir_project%\bin\." 1> exe_error_58
  @IF ERRORLEVEL 1 @TYPE exe_error_58 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_58
:end_if_copy_58
:end_if_release_45
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_46
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5_debug.exe" GOTO end_if_copy_59
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5_debug.exe" "%obuild_dir_project%\bin\." 1> exe_error_59
  @IF ERRORLEVEL 1 @TYPE exe_error_59 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_59
:end_if_copy_59
:end_if_release_46
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_47
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_HDF5_store.exe" GOTO end_if_copy_60
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_HDF5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_60
  @IF ERRORLEVEL 1 @TYPE exe_error_60 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_60
:end_if_copy_60
:end_if_release_47
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_48
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_HDF5_retrieve.exe" GOTO end_if_copy_61
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_HDF5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_61
  @IF ERRORLEVEL 1 @TYPE exe_error_61 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_61
:end_if_copy_61
:end_if_release_48
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_49
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_HDF5_store.exe" GOTO end_if_copy_62
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_HDF5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_62
  @IF ERRORLEVEL 1 @TYPE exe_error_62 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_62
:end_if_copy_62
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" GOTO end_if_copy_63
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" "%obuild_dir_project%\bin\." 1> exe_error_63
  @IF ERRORLEVEL 1 @TYPE exe_error_63 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_63
:end_if_copy_63
:end_if_release_49
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_50
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_HDF5_retrieve.exe" GOTO end_if_copy_64
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_HDF5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_64
  @IF ERRORLEVEL 1 @TYPE exe_error_64 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_64
:end_if_copy_64
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" GOTO end_if_copy_65
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" "%obuild_dir_project%\bin\." 1> exe_error_65
  @IF ERRORLEVEL 1 @TYPE exe_error_65 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_65
:end_if_copy_65
:end_if_release_50
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_51
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_HDF5_store.exe" GOTO end_if_copy_66
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_HDF5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_66
  @IF ERRORLEVEL 1 @TYPE exe_error_66 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_66
:end_if_copy_66
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" GOTO end_if_copy_67
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" "%obuild_dir_project%\bin\." 1> exe_error_67
  @IF ERRORLEVEL 1 @TYPE exe_error_67 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_67
:end_if_copy_67
:end_if_release_51
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_52
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_HDF5_retrieve.exe" GOTO end_if_copy_68
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_HDF5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_68
  @IF ERRORLEVEL 1 @TYPE exe_error_68 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_68
:end_if_copy_68
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" GOTO end_if_copy_69
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" "%obuild_dir_project%\bin\." 1> exe_error_69
  @IF ERRORLEVEL 1 @TYPE exe_error_69 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_69
:end_if_copy_69
:end_if_release_52
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_53
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_HDF5_store.exe" GOTO end_if_copy_70
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_HDF5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_70
  @IF ERRORLEVEL 1 @TYPE exe_error_70 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_70
:end_if_copy_70
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" GOTO end_if_copy_71
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" "%obuild_dir_project%\bin\." 1> exe_error_71
  @IF ERRORLEVEL 1 @TYPE exe_error_71 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_71
:end_if_copy_71
:end_if_release_53
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_54
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_HDF5_retrieve.exe" GOTO end_if_copy_72
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_HDF5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_72
  @IF ERRORLEVEL 1 @TYPE exe_error_72 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_72
:end_if_copy_72
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" GOTO end_if_copy_73
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_HDF5.save" "%obuild_dir_project%\bin\." 1> exe_error_73
  @IF ERRORLEVEL 1 @TYPE exe_error_73 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_73
:end_if_copy_73
:end_if_release_54
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_55
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_HDF5_store.exe" GOTO end_if_copy_74
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_HDF5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_74
  @IF ERRORLEVEL 1 @TYPE exe_error_74 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_74
:end_if_copy_74
:end_if_release_55
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_56
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_HDF5_retrieve.exe" GOTO end_if_copy_75
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_HDF5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_75
  @IF ERRORLEVEL 1 @TYPE exe_error_75 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_75
:end_if_copy_75
:end_if_release_56
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_57
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_HDF5_store.exe" GOTO end_if_copy_76
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_HDF5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_76
  @IF ERRORLEVEL 1 @TYPE exe_error_76 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_76
:end_if_copy_76
:end_if_release_57
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_58
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_HDF5_retrieve.exe" GOTO end_if_copy_77
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_HDF5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_77
  @IF ERRORLEVEL 1 @TYPE exe_error_77 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_77
:end_if_copy_77
:end_if_release_58
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_59
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_zip_store.exe" GOTO end_if_copy_78
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_zip_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_78
  @IF ERRORLEVEL 1 @TYPE exe_error_78 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_78
:end_if_copy_78
:end_if_release_59
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_60
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_zip_retrieve.exe" GOTO end_if_copy_79
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_zip_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_79
  @IF ERRORLEVEL 1 @TYPE exe_error_79 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_79
:end_if_copy_79
:end_if_release_60
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_61
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_zip_store.exe" GOTO end_if_copy_80
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_zip_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_80
  @IF ERRORLEVEL 1 @TYPE exe_error_80 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_80
:end_if_copy_80
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" GOTO end_if_copy_81
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" "%obuild_dir_project%\bin\." 1> exe_error_81
  @IF ERRORLEVEL 1 @TYPE exe_error_81 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_81
:end_if_copy_81
:end_if_release_61
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_62
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_zip_retrieve.exe" GOTO end_if_copy_82
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_zip_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_82
  @IF ERRORLEVEL 1 @TYPE exe_error_82 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_82
:end_if_copy_82
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" GOTO end_if_copy_83
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" "%obuild_dir_project%\bin\." 1> exe_error_83
  @IF ERRORLEVEL 1 @TYPE exe_error_83 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_83
:end_if_copy_83
:end_if_release_62
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_63
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_zip_store.exe" GOTO end_if_copy_84
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_zip_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_84
  @IF ERRORLEVEL 1 @TYPE exe_error_84 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_84
:end_if_copy_84
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" GOTO end_if_copy_85
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" "%obuild_dir_project%\bin\." 1> exe_error_85
  @IF ERRORLEVEL 1 @TYPE exe_error_85 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_85
:end_if_copy_85
:end_if_release_63
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_64
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_zip_retrieve.exe" GOTO end_if_copy_86
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_zip_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_86
  @IF ERRORLEVEL 1 @TYPE exe_error_86 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_86
:end_if_copy_86
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" GOTO end_if_copy_87
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" "%obuild_dir_project%\bin\." 1> exe_error_87
  @IF ERRORLEVEL 1 @TYPE exe_error_87 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_87
:end_if_copy_87
:end_if_release_64
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_65
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_zip_store.exe" GOTO end_if_copy_88
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_zip_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_88
  @IF ERRORLEVEL 1 @TYPE exe_error_88 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_88
:end_if_copy_88
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" GOTO end_if_copy_89
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" "%obuild_dir_project%\bin\." 1> exe_error_89
  @IF ERRORLEVEL 1 @TYPE exe_error_89 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_89
:end_if_copy_89
:end_if_release_65
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_66
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_zip_retrieve.exe" GOTO end_if_copy_90
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_zip_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_90
  @IF ERRORLEVEL 1 @TYPE exe_error_90 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_90
:end_if_copy_90
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" GOTO end_if_copy_91
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_zip.save" "%obuild_dir_project%\bin\." 1> exe_error_91
  @IF ERRORLEVEL 1 @TYPE exe_error_91 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_91
:end_if_copy_91
:end_if_release_66
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_67
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_zip_store.exe" GOTO end_if_copy_92
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_zip_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_92
  @IF ERRORLEVEL 1 @TYPE exe_error_92 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_92
:end_if_copy_92
:end_if_release_67
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_68
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_zip_retrieve.exe" GOTO end_if_copy_93
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_zip_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_93
  @IF ERRORLEVEL 1 @TYPE exe_error_93 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_93
:end_if_copy_93
:end_if_release_68
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_69
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_zip_store.exe" GOTO end_if_copy_94
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_zip_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_94
  @IF ERRORLEVEL 1 @TYPE exe_error_94 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_94
:end_if_copy_94
:end_if_release_69
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_70
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_zip_retrieve.exe" GOTO end_if_copy_95
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_zip_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_95
  @IF ERRORLEVEL 1 @TYPE exe_error_95 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_95
:end_if_copy_95
:end_if_release_70
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_71
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_5_store.exe" GOTO end_if_copy_96
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_5_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_96
  @IF ERRORLEVEL 1 @TYPE exe_error_96 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_96
:end_if_copy_96
:end_if_release_71
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_72
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_5_retrieve.exe" GOTO end_if_copy_97
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_5_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_97
  @IF ERRORLEVEL 1 @TYPE exe_error_97 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_97
:end_if_copy_97
:end_if_release_72
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_73
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_6_store.exe" GOTO end_if_copy_98
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_6_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_98
  @IF ERRORLEVEL 1 @TYPE exe_error_98 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_98
:end_if_copy_98
:end_if_release_73
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_74
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_6_retrieve.exe" GOTO end_if_copy_99
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_6_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_99
  @IF ERRORLEVEL 1 @TYPE exe_error_99 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_99
:end_if_copy_99
:end_if_release_74
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_75
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_mysql_store.exe" GOTO end_if_copy_100
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_mysql_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_100
  @IF ERRORLEVEL 1 @TYPE exe_error_100 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_100
:end_if_copy_100
:end_if_release_75
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_76
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_mysql_retrieve.exe" GOTO end_if_copy_101
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_mysql_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_101
  @IF ERRORLEVEL 1 @TYPE exe_error_101 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_101
:end_if_copy_101
:end_if_release_76
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_77
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_sqlite_store.exe" GOTO end_if_copy_102
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_sqlite_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_102
  @IF ERRORLEVEL 1 @TYPE exe_error_102 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_102
:end_if_copy_102
:end_if_release_77
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_78
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_sqlite_retrieve.exe" GOTO end_if_copy_103
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_Exp_sqlite_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_103
  @IF ERRORLEVEL 1 @TYPE exe_error_103 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_103
:end_if_copy_103
:end_if_release_78
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_79
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_sqlite_store.exe" GOTO end_if_copy_104
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_sqlite_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_104
  @IF ERRORLEVEL 1 @TYPE exe_error_104 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_104
:end_if_copy_104
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" GOTO end_if_copy_105
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" "%obuild_dir_project%\bin\." 1> exe_error_105
  @IF ERRORLEVEL 1 @TYPE exe_error_105 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_105
:end_if_copy_105
:end_if_release_79
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_80
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_sqlite_retrieve.exe" GOTO end_if_copy_106
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_0_sqlite_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_106
  @IF ERRORLEVEL 1 @TYPE exe_error_106 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_106
:end_if_copy_106
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" GOTO end_if_copy_107
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" "%obuild_dir_project%\bin\." 1> exe_error_107
  @IF ERRORLEVEL 1 @TYPE exe_error_107 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_107
:end_if_copy_107
:end_if_release_80
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_81
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_sqlite_store.exe" GOTO end_if_copy_108
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_sqlite_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_108
  @IF ERRORLEVEL 1 @TYPE exe_error_108 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_108
:end_if_copy_108
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" GOTO end_if_copy_109
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" "%obuild_dir_project%\bin\." 1> exe_error_109
  @IF ERRORLEVEL 1 @TYPE exe_error_109 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_109
:end_if_copy_109
:end_if_release_81
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_82
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_sqlite_retrieve.exe" GOTO end_if_copy_110
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_1_sqlite_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_110
  @IF ERRORLEVEL 1 @TYPE exe_error_110 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_110
:end_if_copy_110
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" GOTO end_if_copy_111
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" "%obuild_dir_project%\bin\." 1> exe_error_111
  @IF ERRORLEVEL 1 @TYPE exe_error_111 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_111
:end_if_copy_111
:end_if_release_82
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_83
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_sqlite_store.exe" GOTO end_if_copy_112
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_sqlite_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_112
  @IF ERRORLEVEL 1 @TYPE exe_error_112 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_112
:end_if_copy_112
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" GOTO end_if_copy_113
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" "%obuild_dir_project%\bin\." 1> exe_error_113
  @IF ERRORLEVEL 1 @TYPE exe_error_113 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_113
:end_if_copy_113
:end_if_release_83
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_84
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_sqlite_retrieve.exe" GOTO end_if_copy_114
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_2_sqlite_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_114
  @IF ERRORLEVEL 1 @TYPE exe_error_114 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_114
:end_if_copy_114
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" GOTO end_if_copy_115
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_sqlite.save" "%obuild_dir_project%\bin\." 1> exe_error_115
  @IF ERRORLEVEL 1 @TYPE exe_error_115 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_115
:end_if_copy_115
:end_if_release_84
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_85
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_sqlite_store.exe" GOTO end_if_copy_116
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_sqlite_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_116
  @IF ERRORLEVEL 1 @TYPE exe_error_116 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_116
:end_if_copy_116
:end_if_release_85
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_86
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_sqlite_retrieve.exe" GOTO end_if_copy_117
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_3_sqlite_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_117
  @IF ERRORLEVEL 1 @TYPE exe_error_117 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_117
:end_if_copy_117
:end_if_release_86
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_87
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_sqlite_store.exe" GOTO end_if_copy_118
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_sqlite_store.exe" "%obuild_dir_project%\bin\." 1> exe_error_118
  @IF ERRORLEVEL 1 @TYPE exe_error_118 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_118
:end_if_copy_118
:end_if_release_87
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  GOTO end_if_release_88
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_sqlite_retrieve.exe" GOTO end_if_copy_119
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_exa_4_sqlite_retrieve.exe" "%obuild_dir_project%\bin\." 1> exe_error_119
  @IF ERRORLEVEL 1 @TYPE exe_error_119 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_119
:end_if_copy_119
:end_if_release_88
FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST obuild_find.exe  ECHO Program obuild_find.exe not found.  && GOTO obuild_return
FOR /F "usebackq delims=;" %%j IN (`.\obuild_find.exe  steve v0r1p1`) DO SET obuild_steve_path=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF NOT DEFINED obuild_steve_path  ECHO Can't find steve package.  && GOTO obuild_return

IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%"  ECHO WARNING : Directory %obuild_steve_path%\%obuild_dir_bin% not found.  && GOTO end_if_release_89
IF NOT EXIST "%obuild_steve_path%\%obuild_dir_bin%\steve_histogram_example.exe" GOTO end_if_copy_120
  COPY "%obuild_steve_path%\%obuild_dir_bin%\steve_histogram_example.exe" "%obuild_dir_project%\bin\." 1> exe_error_120
  @IF ERRORLEVEL 1 @TYPE exe_error_120 && @GOTO obuild_return
  @IF NOT ERRORLEVEL 1 @DEL exe_error_120
:end_if_copy_120
:end_if_release_89

FOR /F "usebackq delims=;" %%d IN (`cd`) DO SET obuild_pwd_osc_steve_1=%%d
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF NOT EXIST .\obuild_platform.exe  ECHO Program obuild_platform.exe not found.  && GOTO obuild_return
FOR /F "usebackq" %%j IN (`.\obuild_platform.exe`) DO SET obuild_platform_signature=%%j
cd "%obuild_pwd_osc_steve_1%"
SET obuild_pwd_osc_steve_1=
IF EXIST "%obuild_dir_project%\desktop" RMDIR /S /Q "%obuild_dir_project%\desktop"
IF EXIST "%obuild_dir_project%\Resources/steve/examples/old_util" RMDIR /S /Q "%obuild_dir_project%\Resources/steve/examples/old_util"
IF EXIST "%obuild_dir_project%\Resources/steve/examples/util_2" RMDIR /S /Q "%obuild_dir_project%\Resources/steve/examples/util_2"
IF EXIST "%obuild_dir_project%\Resources/steve/examples/util_3" RMDIR /S /Q "%obuild_dir_project%\Resources/steve/examples/util_3"
IF EXIST "%obuild_dir_project%\Resources/steve/examples/util_4" RMDIR /S /Q "%obuild_dir_project%\Resources/steve/examples/util_4"
IF EXIST "%obuild_dir_project%\Resources/steve/examples/util_5" RMDIR /S /Q "%obuild_dir_project%\Resources/steve/examples/util_5"
FOR %%f IN ("%obuild_dir_project%"\aida-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\py-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\Python-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\Qt-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\Geant4-setup*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\README*) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%"\check_install*) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\obuild.exe DEL "%obuild_dir_project%\bin"\obuild.exe
IF EXIST "%obuild_dir_project%\bin"\owrap.exe DEL "%obuild_dir_project%\bin"\owrap.exe
FOR %%f IN ("%obuild_dir_project%\bin"\zlib_*.exe) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\zip_*.exe) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\h5_array_compound.exe DEL "%obuild_dir_project%\bin"\h5_array_compound.exe
FOR %%f IN ("%obuild_dir_project%\bin"\steve_exa_*.exe) DO DEL "%%f"
FOR %%f IN ("%obuild_dir_project%\bin"\steve_Exp_*.exe) DO DEL "%%f"
IF EXIST "%obuild_dir_project%\bin"\steve_histogram_example.exe DEL "%obuild_dir_project%\bin"\steve_histogram_example.exe
IF EXIST "%obuild_dir_project%\bin"\steve_HDF5_debug.exe DEL "%obuild_dir_project%\bin"\steve_HDF5_debug.exe
IF EXIST "%obuild_dir_project%\bin"\steve_moc.exe DEL "%obuild_dir_project%\bin"\steve_moc.exe
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF EXIST osc_steve-0.1-%obuild_platform_signature%%obuild_debug_signature%.zip DEL osc_steve-0.1-%obuild_platform_signature%%obuild_debug_signature%.zip
IF EXIST osc_steve-darwin-app-0.1-%obuild_platform_signature%${obuild_debug_signature}.zip DEL osc_steve-darwin-app-0.1-%obuild_platform_signature%${obuild_debug_signature}.zip
zip -q -r osc_steve-0.1-%obuild_platform_signature%%obuild_debug_signature%.zip osc_steve
cd "%obuild_osc_steve_path%\obuild"
cd "%obuild_osc_steve_path%\%obuild_dir_bin%"
IF EXIST obuild_platform.exe DEL obuild_platform.exe
cd "%obuild_pwd_osc_steve_0%"
SET obuild_pwd_osc_steve_0=
:obuild_return
ENDLOCAL
@ECHO ON
