// from G4Lab_g4lab_config.cxx.

#include <steve/version.h>

#include <cstdio>   //printf
#include <cstdlib>  //EXIT_SUCCESS

#include "find_config.icxx"

int main(int aArgn,char** aArgs) {
  if(aArgn!=2) {
  
    ::printf("\
Usage: onx-config [OPTION]\n\
Options:\n\
        [--version]\n\
        [--<driver>_cppflags]\n\
        [--<driver>_libs]\n\
");
    return EXIT_SUCCESS;
  } 

  std::string arg1 = aArgs[1];

  if(arg1=="--version") {
    ::printf("%s\n",STEVE_VERSION);
    return EXIT_SUCCESS;

  } else {

   {std::string::size_type pos = arg1.find("_cppflags");
    if(pos!=std::string::npos) {
      std::string driver = arg1.substr(2,pos-2);
      if(!find_flags(aArgs[0],"steve_"+driver+".save")) return EXIT_FAILURE;
      return EXIT_SUCCESS;
    }}

   {std::string::size_type pos = arg1.find("_libs");
    if(pos!=std::string::npos) {
      std::string driver = arg1.substr(2,pos-2);
      if(!find_libs(aArgs[0],"steve_"+driver+".save")) return EXIT_FAILURE;
      return EXIT_SUCCESS;
    }}

  }

  ::fprintf(stderr,"onx-config : unknown option.\n");
  
 {::fprintf(stderr,"onx-config : passed arguments had been :\n");
  for(int index=0;index<aArgn;index++) {
    ::fprintf(stderr,"%s\n",aArgs[index]);
  }}
  
  return EXIT_FAILURE;
}

// embed Lib code :
/*
#include <smanip.cxx>
#include <cmanip.cxx>
#include <sout.cxx>
#include <Out.cxx>
#include <fmanip.cxx>
#include <dirmanip.cxx>
#include <System.cxx>
*/
