#ifndef steve_util_base_ml_h
#define steve_util_base_ml_h 

#include <vector>
#include <string>
#include <ostream>

#include <expat.h>
//#include <steve/util/item_ml.h> //For steve::util::item_ml::attribute_t typedef

namespace steve {namespace interface {class file_getter;}}

namespace steve { 
namespace util {

class item_ml_factory;
class item_ml;

class base_ml {
public:
public:
  base_ml(item_ml_factory&,unsigned int = 0);
  virtual ~base_ml();
private:
  base_ml(const base_ml&);
  base_ml& operator=(const base_ml&);
public:
  bool load_file(const std::string&,bool,std::ostream&);
  bool load_string(const std::string&,std::ostream&);
  void set_tags(const std::vector<std::string>&);
  const item_ml* top_item() const;
  item_ml* top_item();
  void empty();
  bool is_tag(const std::string&) const;
  void set_file_getter(steve::interface::file_getter*);
public:
  virtual bool visitEndelement(item_ml&,bool&);
private:
  void clear();
  bool read_file(const std::string&,
                 XML_StartElementHandler,XML_EndElementHandler,void*,
		 bool,std::ostream&);
  bool read_string(const std::string&,
                 XML_StartElementHandler,XML_EndElementHandler,void*,
		   std::ostream&);
  bool solve_references(steve::util::item_ml&,bool,std::ostream&);
  bool parse_file(const std::string&,
                   XML_StartElementHandler,XML_EndElementHandler,void*,
		  bool,std::ostream&);
  bool parse_string(const std::string&,
                    XML_StartElementHandler,XML_EndElementHandler,void*,
		    std::ostream&);
  static void character_data_handler(void*,const XML_Char*,int);
  static void startelement(void*,const XML_Char*,const XML_Char**);
  static void endelement(void*,const XML_Char*);
private:
  item_ml_factory& m_item_ml_factory;
  std::vector<std::string> m_tags;
  unsigned int m_verbosity; //FIXME : uint.
  item_ml* m_top;
  item_ml* m_current;
  //std::vector<steve::util::item_ml::attribute_t> m_atbs;
  std::vector< std::pair<std::string,std::string> > m_atbs;
  std::string m_value;
  steve::interface::file_getter* m_file_getter;
  std::ostream* m_out;
  unsigned int m_depth;
  bool m_abort;
};

}} //namespace

#endif
