// this :
#include "element.h"

#include <steve/tools/smanip.h>
#include <steve/util/mem.h>

steve::util::element::element(
 const std::string& a_name
,const std::vector<attribute_t>& a_atbs
,const std::string& a_value
){
  m_name = a_name;
  m_atbs = a_atbs; 
  m_value = a_value;
  steve::util::mem::increment("steve::util::element");
}
steve::util::element::element(const element& a_from){
  m_name = a_from.m_name;
  m_atbs = a_from.m_atbs; 
  m_value = a_from.m_value;
  steve::util::mem::increment("steve::util::element");
}
steve::util::element::~element(){
  steve::util::mem::decrement("steve::util::element");
}
steve::util::element& steve::util::element::operator=(const element& a_from){
  m_name = a_from.m_name;
  m_atbs = a_from.m_atbs; 
  m_value = a_from.m_value;
  return *this;
}
std::string steve::util::element::name() const{return m_name;}
const std::vector<steve::util::element::attribute_t>& steve::util::element::attributes() const {return m_atbs;}
std::string steve::util::element::value() const {return m_value;}
void steve::util::element::set_value(const std::string& a_value){
 m_value = a_value;
}
bool steve::util::element::is_attribute(const std::string& a_name) const {
  unsigned int number = m_atbs.size();
  for(unsigned int index=0;index<number;index++) {
    if(m_atbs[index].first==a_name) return true;
  }
  return false;
}
void steve::util::element::add_attribute(
 const std::string& a_name
,const std::string& a_value
){
  // No check is done about an existing a_name.
  m_atbs.push_back(attribute_t(a_name,a_value));
}
bool steve::util::element::attribute_value(
 const std::string& aattribute_t
,std::string& a_value
) const {
  unsigned int atbn = m_atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    if(m_atbs[index].first==aattribute_t) {
      a_value = m_atbs[index].second;
      return true;
    }
  }
  a_value = "";
  return false;
}
bool steve::util::element::set_attribute_value(
 const std::string& aattribute_t
,const std::string& a_value
){
  unsigned int atbn = m_atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    if(m_atbs[index].first==aattribute_t) {
      m_atbs[index].second = a_value;
      return true;
    }
  }
  // Not found, add one :
  m_atbs.push_back(attribute_t(aattribute_t,a_value));
  return true;
}
void steve::util::element::replace(
 const std::string& a_old
,const std::string& a_new
){
  // Used by the obuild template system.
  unsigned int atbn = m_atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    std::string& value = m_atbs[index].second;
    steve::tools::replace(value,a_old,a_new);
  }
  steve::tools::replace(m_value,a_old,a_new);
}
