#ifndef steve_util_element_h
#define steve_util_element_h 

#include <vector>
#include <string>

namespace steve {
namespace util {

class element {
public:
  typedef std::pair<std::string,std::string> attribute_t;
public:
  element(const std::string&,
           const std::vector<attribute_t>&,
           const std::string&);
  element(const element&);
  ~element();
  element& operator=(const element&);
public:
  std::string name() const;
  const std::vector<attribute_t>& attributes() const;
  std::string value() const;
  void set_value(const std::string&);
  bool is_attribute(const std::string&) const;
  bool attribute_value(const std::string&,std::string&) const;
  void add_attribute(const std::string&,const std::string&);
  bool set_attribute_value(const std::string&,const std::string&);
  void replace(const std::string&,const std::string&);
private:
  std::string m_name;
  std::vector<attribute_t> m_atbs;
  std::string m_value;
};

}}

#endif
