
// this :
#include "item_ml.h"

#include <steve/tools/smanip.h>

#include <steve/util/mem.h>
//#include <steve/util/cast.h>
#include "element.h"

//XXX
#define sout(a_string)   ("\""+a_string+"\"")

steve::util::item_ml::item_ml(
 const std::string& a_tag_name
,item_ml_factory& a_item_ml_factory
,item_ml* a_parent
)
:m_tag_name(a_tag_name)
,m_item_ml_factory(a_item_ml_factory)
,m_parent(a_parent)
,m_save_flag(true)
,m_data_1(0)
,m_data_2(0)
,m_data_int(0)
,m_depth(0)
{
  steve::util::mem::increment("steve::util::item_ml");
}
steve::util::item_ml::item_ml(
 const item_ml& a_from
)
:m_tag_name(a_from.m_tag_name)
,m_item_ml_factory(a_from.m_item_ml_factory)
,m_parent(a_from.m_parent)
,m_save_flag(true)
,m_data_1(0)
,m_data_2(0)
,m_data_int(0)
,m_depth(0)
{
  //private
  steve::util::mem::increment("steve::util::item_ml");
}

steve::util::item_ml& steve::util::item_ml::operator=(const item_ml& a_from) {
  //private
  return *this;
}
steve::util::item_ml::~item_ml(){
  clear();
  steve::util::mem::decrement("steve::util::item_ml");
}
/*
void* steve::util::item_ml::cast(const std::string& a_class) const{
  if_Lib_SCast(steve::util::item_ml)
  else return 0;
}
*/
void steve::util::item_ml::clear(){
  m_atbs.clear();

 {std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();it = m_children.erase(it)) 
    delete (*it);}

 {std::list<element*>::iterator it;
  for(it=m_properties.begin();it!=m_properties.end();it = m_properties.erase(it)) 
    delete (*it);}

}
void steve::util::item_ml::add_attribute(
 const std::string& a_name
,const std::string& a_value
){
  // No check is done about an existing a_name.
  m_atbs.push_back(attribute_t(a_name,a_value));
}
void steve::util::item_ml::add_property(
 const std::string& a_name
,const std::vector<attribute_t>& a_atbs
,const std::string& a_value
){
  m_properties.push_back(new element(a_name,a_atbs,a_value));
}
bool steve::util::item_ml::is_property(
 const std::string& a_property
) const {
  std::list<element*>::const_iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    if(a_property==(*it)->name()) return true;
  }
  return false;
}
bool steve::util::item_ml::is_attribute(
 const std::string& a_name
) const {
  unsigned int number = m_atbs.size();
  for(unsigned int index=0;index<number;index++) {
    if(m_atbs[index].first==a_name) return true;
  }
  return false;
}
bool steve::util::item_ml::property_value(
 const std::string& a_property
,std::string& a_value
) const {
  a_value = "";
  std::list<element*>::const_iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    if(a_property==(*it)->name()) {
      a_value = (*it)->value();
      return true;
    }
  }
  return false;
}
bool steve::util::item_ml::property_values(
 const std::string& a_property
,std::vector<std::string>& a_values
) const {
  a_values.clear();
  std::list<element*>::const_iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    if(a_property==(*it)->name()) {
      a_values.push_back((*it)->value());
    }
  }
  return true;
}
void steve::util::item_ml::delete_property(const std::string& a_property){
  std::list<element*>::iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    if(a_property==(*it)->name()) {
      m_properties.remove(*it);
      delete (*it);
      break;
    }
  }
}
void steve::util::item_ml::delete_property(steve::util::element* a_property){
  m_properties.remove(a_property);
  delete a_property;
}
void steve::util::item_ml::print(std::ostream& a_out){
  a_out << "steve::util::item_ml::print :" 
        << " -----> " << this << " parent : " << m_parent << std::endl;
  a_out << " data1 : " << m_data_1 
        << " data2 : " << m_data_2 
        << " dataInt : " << m_data_int
        << std::endl;

 {unsigned int atbn = m_atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    a_out << " attribute : " << sout(m_atbs[index].first) << " " 
          << sout(m_atbs[index].second) << std::endl;
  }}

 {std::list<element*>::iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    a_out << " property : \"" << (*it)->name() << "\" \"" 
          << (*it)->value() << "\"" << std::endl;
  }}

 {std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    (*it)->print(a_out);
  }}
}
void steve::util::item_ml::print_xml(
 std::ostream& a_out
,const std::string& a_spaces
){
  // begin tag :
  a_out << a_spaces << "<" << m_tag_name;
 {unsigned int atbn = m_atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    a_out << " " << m_atbs[index].first << "=" << sout(m_atbs[index].second);
  }}
  a_out << ">" << std::endl;

 {std::list<element*>::const_iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {

    const std::vector<attribute_t>& atbs = (*it)->attributes();

    bool isCallback = false;

    a_out << a_spaces << "  <" << (*it)->name();
    unsigned int atbn = atbs.size();
    for(unsigned int index=0;index<atbn;index++) {
      a_out << " " << atbs[index].first << "=" << sout(atbs[index].second);
      if(atbs[index].first=="exec") isCallback = true;
    }
    if((*it)->value().empty()) {
      a_out << "/>" << std::endl;
    } else {
      a_out << ">";
      std::string value = steve::tools::to_xml((*it)->value());
      if(isCallback) {
        if(value.find("\\n\\")==std::string::npos) {
          a_out << value;
        } else {
          a_out << std::endl;
          steve::tools::replace(value,"\\n\\","@OnX@");
          steve::tools::replace(value,"@OnX@","\\n\\\n");
          steve::tools::strip(value,steve::tools::trailing,' ');
          a_out << value;
          unsigned int l = value.size();
          if(l && value[l-1]!='\n') a_out << std::endl;
          a_out << a_spaces << "  ";
        }
      } else {
        a_out << value;
      }
      a_out << "</" << (*it)->name() << ">" << std::endl;
    }
  }}

  // End tag :
  a_out << a_spaces << "</" << m_tag_name << ">" << std::endl;
}
void steve::util::item_ml::set_attributes(
 const std::vector<attribute_t>& a_atbs
){
  m_atbs = a_atbs; 
}
const std::list<steve::util::element*>& steve::util::item_ml::properties(
) const {
  return m_properties;
}
const std::string& steve::util::item_ml::tag_name() const {return m_tag_name;}
bool steve::util::item_ml::attribute_value(
 const std::string& a_atb
,std::string& a_value
) const {
  a_value = "";
  unsigned int linen = m_atbs.size();
  for(unsigned int count=0;count<linen;count++) {
    if(m_atbs[count].first==a_atb) {
      a_value = m_atbs[count].second;
      return true;
    }
  }
  return false;
}
bool steve::util::item_ml::attribute_value(
 const std::string& a_property
,const std::string& a_atb
,std::string& a_value
) const {
  a_value = "";
  if(a_property.empty()) {
    unsigned int linen = m_atbs.size();
    for(unsigned int count=0;count<linen;count++) {
      if(m_atbs[count].first==a_atb) {
        a_value = m_atbs[count].second;
        return true;
      }
    }
    return false;
  } else {
    // Get on the first match.
    std::list<element*>::const_iterator it;
    for(it=m_properties.begin();it!=m_properties.end();++it) {
      if(a_property==(*it)->name()) {
        if((*it)->attribute_value(a_atb,a_value)) return true;
      }
    }
    return false;
  }
}
bool steve::util::item_ml::remove_attribute(const std::string& a_name){
  std::vector<attribute_t>::iterator it = m_atbs.begin();
  unsigned int linen = m_atbs.size();
  for(unsigned int count=0;count<linen;count++,it++) {
    if(m_atbs[count].first==a_name) {
      m_atbs.erase(it);
      return true; //Found and removed.
    }
  }
  return false; //Not found.
}
void steve::util::item_ml::set_data(
 void* a_data_1
,void* a_data_2
,int a_data_int
){
  m_data_1 = a_data_1;
  m_data_2 = a_data_2;
  m_data_int = a_data_int;
}
void steve::util::item_ml::get_data(
 void*& a_data_1
,void*& a_data_2
,int& a_data_int
) const {
  a_data_1 = m_data_1;
  a_data_2 = m_data_2;
  a_data_int = m_data_int;
}
void* steve::util::item_ml::get_data1() const {return m_data_1;}
void* steve::util::item_ml::get_data2() const {return m_data_2;}
int steve::util::item_ml::get_data_int() const {return m_data_int;}
void steve::util::item_ml::set_depth(unsigned int a_depth) {m_depth = a_depth;}
unsigned int steve::util::item_ml::depth() const{return m_depth;}
void steve::util::item_ml::set_save_flag(bool a_value){
  m_save_flag = a_value;
}
bool steve::util::item_ml::save_flag() const {return m_save_flag;}
void steve::util::item_ml::set_file(const std::string& a_file){
  m_file = a_file;
}
std::string steve::util::item_ml::file() const {return m_file;}
bool steve::util::item_ml::set_property_value(
 const std::string& a_property
,const std::string& a_value
,int a_index
){
  std::list<element*>::const_iterator it;
  int index = 0;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    if(a_property==(*it)->name()) {
      if(index==a_index) {
        (*it)->set_value(a_value);
        return true;
      } else {
        index ++;
      }
    }
  }
  // Not found, add one :
  std::vector<attribute_t> atts;
  add_property(a_property,atts,a_value);
  return true;
}
bool steve::util::item_ml::set_attribute_value(
 const std::string& a_property
,const std::string& a_atb
,const std::string& a_value
,int a_index
){
  if(a_property.empty()) {
    unsigned int linen = m_atbs.size();
    for(unsigned int count=0;count<linen;count++) {
      if(m_atbs[count].first==a_atb) {
        m_atbs[count].second = a_value;
        return true;
      }
    }
    // Not found, add it :
    m_atbs.push_back(attribute_t(a_atb,a_value));
    return true;
  } else {
    std::list<element*>::const_iterator it;
    int index = 0;
    for(it=m_properties.begin();it!=m_properties.end();++it) {
     if(a_property==(*it)->name()) {
        if(index==a_index) {
          (*it)->set_attribute_value(a_atb,a_value);
          return true;
        } else { 
          index ++;
        }
      }
    }
    return false;
  }
}
bool steve::util::item_ml::property_value_boolean(
 const std::string& a_property
,bool& a_value
) const {
  std::string value;
  if(!property_value(a_property,value)) return false;
  return tools::to(value,a_value);
}
const std::vector<steve::util::item_ml::attribute_t>& steve::util::item_ml::attributes() const {return m_atbs;}
void steve::util::item_ml::post_execute(
 exec_function_t a_function
,void* a_tag
){
  if(!a_function) return;
  
  if(!a_function(*this,a_tag)) return;

  std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    (*it)->post_execute(a_function,a_tag);
  }
}
void steve::util::item_ml::post_execute_backward(
 exec_function_t a_function
,void* a_tag
){
  if(!a_function) return;
  
  std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    (*it)->post_execute_backward(a_function,a_tag);
  }

  if(!a_function(*this,a_tag)) return;
}
steve::util::item_ml* steve::util::item_ml::parent() const {return m_parent;}
const std::list<steve::util::item_ml*>& steve::util::item_ml::children() const{
  return m_children;
}
steve::util::item_ml* steve::util::item_ml::find_item(
 const std::string& a_name
) const {
  std::string s;
  attribute_value("","name",s);
  if(a_name==s) return const_cast<steve::util::item_ml*>(this);
  // Look children :
  std::list<item_ml*>::const_iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    item_ml* item = (*it)->find_item(a_name);
    if(item) return item;
  }
  return 0;
}
steve::util::item_ml* steve::util::item_ml::find_item_with_tag(
 const std::string& a_tag
,const std::string& a_name
) const {
  if(a_tag==tag_name()) {
    std::string s;
    attribute_value("","name",s);
    if(a_name==s) return const_cast<steve::util::item_ml*>(this);
  }

  // Look children :
  std::list<item_ml*>::const_iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    item_ml* item = (*it)->find_item_with_tag(a_tag,a_name);
    if(item) return item;
  }
  return 0;
}
steve::util::item_ml* steve::util::item_ml::find_by_attribute(
 const std::string& a_atbribute
,const std::string& a_value
) const {
  std::string s;
  attribute_value("",a_atbribute,s);
  if(s==a_value) return const_cast<steve::util::item_ml*>(this);
  // Look children :
  std::list<item_ml*>::const_iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    item_ml* itemML = (*it)->find_by_attribute(a_atbribute,a_value);
    if(itemML) return itemML;
  }
  return 0;
}
steve::util::item_ml* steve::util::item_ml::find_by_tag(
 const std::string& a_tag
) const {
  if(tag_name()==a_tag) return const_cast<steve::util::item_ml*>(this);
  // Look children :
  std::list<item_ml*>::const_iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    item_ml* itemML = (*it)->find_by_tag(a_tag);
    if(itemML) return itemML;
  }
  return 0;
}
void steve::util::item_ml::add_child(steve::util::item_ml* a_item_ml){
  m_children.push_back(a_item_ml);
}
void steve::util::item_ml::set_parent(steve::util::item_ml* a_parent){
  // Set parent authorised only if element has no parent.
  m_parent = a_parent;
}
void steve::util::item_ml::add_after(
 steve::util::item_ml* a_item_ml
,steve::util::item_ml* a_entry
){
  std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    if((*it)==a_item_ml) {
      m_children.insert(it,a_entry);
      return;
    }
  }
}
bool steve::util::item_ml::is_first_child(
 const steve::util::item_ml& a_item_ml
){
  if(m_children.empty()) return false;
  return ( (*(m_children.begin()))==&a_item_ml) ? true : false;
}
int steve::util::item_ml::number_of_children() const{
  return m_children.size();
}
bool steve::util::item_ml::is_last_child(
 const steve::util::item_ml& a_item_ml
){
  if(m_children.empty()) return false;
  return ( m_children.back()==&a_item_ml) ? true : false;
}
steve::util::item_ml* steve::util::item_ml::previous_child(
 const steve::util::item_ml& a_item_ml
){
  std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    if((*it)==&a_item_ml) {
      if(it==m_children.begin()) return 0;
      --it;
      return *it;
    }
  }
  return 0;
}
steve::util::item_ml* steve::util::item_ml::next_child(
 const steve::util::item_ml& a_item_ml
){
  std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    if((*it)==&a_item_ml) {
      std::list<item_ml*>::iterator last = m_children.end();
      --last;
      if(it==last) return 0;
      ++it;
      return *it;
    }
  }
  return 0;
}
void steve::util::item_ml::remove_child(steve::util::item_ml*& a_item_ml,bool a_delete){
  m_children.remove(a_item_ml);
  if(a_delete) {
    delete a_item_ml;
    a_item_ml = 0;
  }
}
void steve::util::item_ml::delete_children(){
 {std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();it = m_children.erase(it)) 
    delete (*it);}
}
const steve::util::item_ml* steve::util::item_ml::find_by_property_in_same_level(
 const std::string& a_name
,const std::string& a_value
) const {
  // Look children :
  std::list<item_ml*>::const_iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    std::string s;
    if((*it)->property_value(a_name,s) && (a_value==s)) return *it;
  }
  return 0;
}
steve::util::item_ml* steve::util::item_ml::create_copy(
 steve::util::item_ml* a_parent
){
  item_ml* itemML = m_item_ml_factory.create(m_tag_name,m_atbs,a_parent);
  if(!itemML) return 0;
  itemML->m_atbs = m_atbs;
  //FIXME : m_save_flag
  
 {std::list<element*>::const_iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    itemML->m_properties.push_back(new element(*(*it)));
  }}

 {std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    //FIXME : could we have mismatch parent/child ?
    item_ml* obj = (*it)->create_copy(itemML);
    if(!obj) {
      delete itemML;
      return 0;
    }
    itemML->add_child(obj);
  }}

  return itemML;
}
bool steve::util::item_ml::copy(
 const steve::util::item_ml& a_from
,e_copy_what a_what //def = all
,bool a_clear //=true
){
  // Copy data (atbs, propertis, children) of a_from onto this.
  if((a_what==ALL)||(a_what==ATTRIBUTES)) {
    if(a_clear) m_atbs.clear();
    
   {std::vector<attribute_t>::const_iterator it;
    for(it=a_from.m_atbs.begin();it!=a_from.m_atbs.end();++it) {
      m_atbs.push_back(*it);
    }}
  }

  if((a_what==ALL)||(a_what==PROPERTIES)) {

    if(a_clear) {
      std::list<element*>::iterator it;
      for(it=m_properties.begin();
          it!=m_properties.end();
          it = m_properties.erase(it)) delete (*it);
    }

    std::list<element*>::const_iterator it;
    for(it=a_from.m_properties.begin();it!=a_from.m_properties.end();++it) {
      m_properties.push_back(new element(*(*it)));
    }
  }

  if((a_what==ALL)||(a_what==CHILDREN)) {

    if(a_clear) {
      std::list<item_ml*>::iterator it;
      for(it=m_children.begin();
          it!=m_children.end();
          it = m_children.erase(it)) delete (*it);
    }

   {std::list<item_ml*>::const_iterator it;
    for(it=a_from.m_children.begin();it!=a_from.m_children.end();++it) {
      //FIXME : could we have mismatch parent/child ?
      item_ml* obj = (*it)->create_copy(this);
      if(!obj) {
        // Something wrong, cleanup this.
        clear();
        return false;
      }
      add_child(obj);
    }}
  }

  //FIXME : m_save_flag
  
  return true;
}
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////
void steve::util::item_ml::update_tree(const steve::util::item_ml& a_old){
  // We map the opened elements in the old tree within this tree.
  // Algorithm based on the existence of a "label" property.
  const std::list<steve::util::item_ml*>& list = children();
  std::list<steve::util::item_ml*>::const_iterator it;
  for(it=list.begin();it!=list.end();++it) {
    std::string slabel;
    if((*it)->property_value("label",slabel)) {
      // Try to find a same label in the same level :
      const steve::util::item_ml* item = a_old.find_by_property_in_same_level("label",slabel);
      if(item) {
        bool sopened;
        if(item->property_value_boolean("opened",sopened) && sopened) {
          (*it)->set_property_value("opened","true");
        }
        if(a_old.number_of_children()) (*it)->update_tree(*item);
      }
    }
  }
}
void steve::util::item_ml::replace(
 const std::string& a_old
,const std::string& a_new
){
  // Used by the obuild template system.
 {unsigned int atbn = m_atbs.size();
  for(unsigned int index=0;index<atbn;index++) {
    std::string& value = m_atbs[index].second;
    steve::tools::replace(value,a_old,a_new);
  }}

 {std::list<element*>::iterator it;
  for(it=m_properties.begin();it!=m_properties.end();++it) {
    (*it)->replace(a_old,a_new);
  }}

 {std::list<item_ml*>::iterator it;
  for(it=m_children.begin();it!=m_children.end();++it) {
    (*it)->replace(a_old,a_new);
  }}
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
namespace steve{ namespace util{
class empty_attribute_visitor {
public:
  empty_attribute_visitor(std::ostream& a_out)
  :m_out(a_out),m_status(true){}
public:
  std::ostream& m_out;
  bool m_status;
};
}}
static bool checkItem(steve::util::item_ml& a_item_ml,void* a_tag){
  steve::util::empty_attribute_visitor* visitor = (steve::util::empty_attribute_visitor*)a_tag;

 {const std::vector<steve::util::item_ml::attribute_t>& atbs = a_item_ml.attributes();
  unsigned int atbn = atbs.size();       
  for(unsigned int index=0;index<atbn;index++) {
    const std::string& atb = atbs[index].first;
    const std::string& atbv = atbs[index].second;
    if(atbv.empty()) {
      std::ostream& out(visitor->m_out);
      out << "steve::util::item_ml::checkItem :"
          << " for XML item " << sout(a_item_ml.tag_name())
          << ", attribute " << sout(atb) << " has an empty value."
          << std::endl;
      visitor->m_status = false;
    }
  }}

  const std::list<steve::util::element*> props = a_item_ml.properties();
  std::list<steve::util::element*>::const_iterator it;
  for(it=props.begin();it!=props.end();++it) {
    const std::vector<steve::util::item_ml::attribute_t>& atbs = (*it)->attributes();
    unsigned int atbn = atbs.size();       
    for(unsigned int index=0;index<atbn;index++) {
      const std::string& atb = atbs[index].first;
      const std::string& atbv = atbs[index].second;
      if(atbv.empty()) {
        std::ostream& out(visitor->m_out);
        out << "steve::util::ItemM::checkItem :"
            << " for XML item " << sout(a_item_ml.tag_name())
            << ", attribute " << sout(atb) << " has an empty value."
            << std::endl;
        visitor->m_status = false;
      }
    }
  }

  return true;
}
bool steve::util::item_ml::has_empty_attribute_value(std::ostream& a_out) const{
  steve::util::empty_attribute_visitor visitor(a_out);
  visitor.m_status = true;
  const_cast<steve::util::item_ml*>(this)->post_execute(checkItem,&visitor);
  return visitor.m_status;
}
void steve::util::item_ml::collect_by_tag(
 steve::util::item_ml& a_item_ml
,const std::string& a_tag
,std::vector<steve::util::item_ml*>& a_items
) {
  if(a_item_ml.tag_name()==a_tag) a_items.push_back(&a_item_ml);

  const std::list<steve::util::item_ml*>& list = a_item_ml.children();
  std::list<steve::util::item_ml*>::const_iterator it;
  for(it=list.begin();it!=list.end();++it) collect_by_tag(*(*it),a_tag,a_items);
}
void steve::util::item_ml::unique(std::vector<steve::util::item_ml*>& a_items){
  std::vector<steve::util::item_ml*> items2;

  std::vector<steve::util::item_ml*>::const_iterator it;
  for(it=a_items.begin();it!=a_items.end();++it) {
    std::string name;
    if(!(*it)->attribute_value("","name",name)) continue;
    if(name.empty()) continue;

    bool found = false;
   {std::vector<steve::util::item_ml*>::iterator it2;
    for(it2=items2.begin();it2!=items2.end();++it2) {
      std::string name2;
      (*it2)->attribute_value("","name",name2);
      if(name2==name) {
        found = true;
        break;
      }   
    }}
    if(!found) {
      items2.push_back(*it);
    }
  }

  a_items = items2;
}
void steve::util::item_ml::remove_properties(const std::string& a_name){
  std::list<element*>::iterator it;
  for(it=m_properties.begin();it!=m_properties.end();) {
    if((*it)->name()==a_name) {
      element* element = *it;
      it = m_properties.erase(it);
      delete element;
    } else {
      ++it;
    }
  }
}

/*
// Conveniency for frequent attribute.

bool steve::util::item_ml::name_att_value(std::string& a_value) const{
  return attribute_value("","name",a_value);
}
bool steve::util::item_ml::class_att_value(std::string& a_value) const{
  return attribute_value("","class",a_value);
}
bool steve::util::item_ml::path_att_value(std::string& a_value) const{
  return attribute_value("","path",a_value);
}
*/

steve::util::item_ml_factory::item_ml_factory(){
  steve::util::mem::increment("steve::util::item_ml_factory");
}
steve::util::item_ml_factory::~item_ml_factory(){
  steve::util::mem::decrement("steve::util::item_ml_factory");
}
steve::util::item_ml* steve::util::item_ml_factory::create(
 const std::string& a_tag_name
,const std::vector<steve::util::item_ml::attribute_t>& a_atbs
,item_ml* a_parent
){
  // It does not add the new item_ml in parent.
  item_ml* itemML = new item_ml(a_tag_name,*this,a_parent);
  itemML->set_attributes(a_atbs);
  return itemML;
}
