@ECHO off
SETLOCAL

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////

SET EXA=exa_0
SET DRIVER=%1%

REM ECHO %EXA%

IF "%DRIVER%" == "" (
  ECHO Give the name of the driver to use.
  ECHO For example :
  ECHO   build exa_0 zip
  ECHO   build exa_0 HDF5
  GOTO steve_return
)

CL.exe 1> NUL 2> NUL
IF ERRORLEVEL 1 (
  ECHO CL.exe program not found. You have to setup VisualC++ environment.
  GOTO steve_return
)

FOR /F "usebackq delims=;" %%s IN (`steve-config --%DRIVER%_cppflags`) DO SET steve_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`steve-config --%DRIVER%_libs`) DO SET steve_libs=%%s

SET flags=/nologo /DWIN32 /MD /O2 /W3  /GX /GR 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
IF EXIST event.obj DEL event.obj
CL.exe %flags% /c %steve_cppflags% /Foevent.obj /Tpevent.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST schemas.obj DEL schemas.obj
CL.exe %flags% /c %steve_cppflags% /Foschemas.obj /Tpschemas.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST steve.obj DEL steve.obj
CL.exe %flags% /c %steve_cppflags% /Fosteve.obj /Tpsteve.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST main_store.obj DEL main_store.obj
CL.exe %flags% /c %steve_cppflags% /Fomain_store.obj /Tpmain_store.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

LINK.exe /nologo /OPT:NOREF /out:steve_%EXA%_%DRIVER%_store.exe main_store.obj event.obj schemas.obj steve.obj %steve_libs% 1> link_exe_error
IF ERRORLEVEL 1 TYPE link_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL link_exe_error 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////

IF EXIST main_retrieve.obj DEL main_retrieve.obj
CL.exe %flags% /c %steve_cppflags% /Fomain_retrieve.obj /Tpmain_retrieve.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

LINK.exe /nologo /OPT:NOREF /out:steve_%EXA%_%DRIVER%_retrieve.exe main_retrieve.obj event.obj schemas.obj steve.obj %steve_libs% 1> link_exe_error
IF ERRORLEVEL 1 TYPE link_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL link_exe_error 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////

IF EXIST event.obj DEL event.obj
IF EXIST schemas.obj DEL schemas.obj
IF EXIST steve.obj DEL steve.obj

IF EXIST main_store.obj DEL main_store.obj
IF EXIST main_retrieve.obj DEL main_retrieve.obj

:steve_return
ENDLOCAL
@ECHO on

