// this :
#include "event.h"

#include <steve/tools/randoms.h>

//////////////////////////////////////////////////////////////////////////////
/// hit //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::hit::hit()
:m_x(0)
,m_y(0)
,m_z(0)
{
}
exa::hit::hit(steve::tools::random::gauss& a_random,
              unsigned int a_index_in_track)
:m_x(0)
,m_y(0)
,m_z(0)
{
  m_x = a_index_in_track; //to check retrieving.
  m_y = a_random.shoot();
  m_z = a_random.shoot();
}
exa::hit::~hit(){
}

//private (dummy) :
exa::hit::hit(const hit&){}
exa::hit& exa::hit::operator=(const hit&){return *this;}

double exa::hit::x() const { return m_x;}
double exa::hit::y() const { return m_y;}
double exa::hit::z() const { return m_z;}

//////////////////////////////////////////////////////////////////////////////
/// track ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::track::track() //Used when retrieving.
:m_px(0)
,m_py(0)
,m_pz(0)
{
}
exa::track::track(steve::tools::random::gauss& a_random,
                  unsigned int a_index_in_event)
:m_px(0)
,m_py(0)
,m_pz(0)
{
  m_px = a_index_in_event; //used to check retrieving.
  m_py = a_random.shoot();
  m_pz = a_random.shoot();

 {// Create hits on track :
  unsigned int number_of_hits = a_index_in_event+1;
  for(unsigned int index=0;index<number_of_hits;index++) {
    m_hits.push_back(new exa::hit(a_random,index));
  }}
}  
exa::track::~track(){
  std::vector<hit*>::iterator it;
  for(it=m_hits.begin();it!=m_hits.end();++it) delete (*it);
  m_hits.clear();
}
exa::track::track(const track&){}
exa::track& exa::track::operator=(const track&){return *this;}
double exa::track::px() const { return m_px;}
double exa::track::py() const { return m_py;}
double exa::track::pz() const { return m_pz;}
std::vector<exa::hit*>& exa::track::hits() {return m_hits;}

//////////////////////////////////////////////////////////////////////////////
/// event ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::event::event() //Used when retrieving.
:m_id(0)
,m_energy(0)
{
}
exa::event::event(steve::tools::random::gauss& a_random,
                  unsigned int a_index_in_run)
:m_id(0)
,m_energy(0)
{
  m_id = a_index_in_run;
  m_energy = a_random.shoot();

 {// Create tracks on event :
  unsigned int number_of_tracks = a_index_in_run+1;
  for(unsigned int index=0;index<number_of_tracks;index++) {
    m_tracks.push_back(new exa::track(a_random,index));
  }}
}  
exa::event::~event(){
  std::vector<track*>::iterator it;
  for(it=m_tracks.begin();it!=m_tracks.end();++it) delete (*it);
  m_tracks.clear();
}

//private (dummy):
exa::event::event(const event& a_from){}
exa::event& exa::event::operator=(const event&){return *this;}

float exa::event::energy() const { return m_energy;}
unsigned int exa::event::id() const { return m_id;}
std::vector<exa::track*>& exa::event::tracks() {return m_tracks;}

//////////////////////////////////////////////////////////////////////////////
/// header ///////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::header::header():m_number_of_events(0){}
exa::header::~header(){}

//private (dummy) :
exa::header::header(const header& a_from):m_number_of_events(0){}
exa::header& exa::header::operator=(const header&){return *this;}

unsigned int exa::header::numberOfevents() const { return m_number_of_events;}
void exa::header::setNumberOfevents(unsigned int a_value) { 
  m_number_of_events = a_value;
}

