#ifndef exa_event_h
#define exa_event_h

namespace steve {namespace tools {namespace random {class gauss;}}}

#include <steve/instrument.h> //to help instrumenting a class.

#include <vector>

namespace exa { class track;}

namespace exa {

class hit {
public:
  hit();
  hit(steve::tools::random::gauss& a_random,
      unsigned int a_index_in_track,
      exa::track*);
  virtual ~hit();
private:
  hit(const hit&);
  hit& operator=(const hit&);
public:
  double x() const;
  double y() const;
  double z() const;
  exa::track* track() const;
private:
  double m_x;
  double m_y;
  double m_z;
  exa::track* m_track;
//steve:
  STEVE_HEADER
};

class track {
public:
  track();
  track(steve::tools::random::gauss& a_random,unsigned int a_index_in_event);
  virtual ~track();
private:
  track(const track&);
  track& operator=(const track&);
public:
  double px() const;
  double py() const;
  double pz() const;
  std::vector<hit*>& hits();
private:
  double m_px;
  double m_py;
  double m_pz;
private:
  std::vector<hit*> m_hits;
//steve:
  STEVE_HEADER
};

class event {
public:
  event();
  event(steve::tools::random::gauss& a_random,unsigned int a_index_in_run);
  virtual ~event();
  unsigned int id() const;  
  float energy() const;  
  std::vector<track*>& tracks();
private:
  event(const event&);
  event& operator=(const event&);
private:
  unsigned int m_id;
  float m_energy;
private:
  std::vector<track*> m_tracks;
//steve:
  STEVE_HEADER
};

class header {
public:
  header();
  virtual ~header();
private:
  header(const header&);
  header& operator=(const header&);
public:
  unsigned int numberOfevents() const;
  void setNumberOfevents(unsigned int);
private:
  unsigned int m_number_of_events;
//steve:
  STEVE_HEADER
};

}

#endif
