#ifndef exa_schemas_h
#define exa_schemas_h

// inheritance :
#include <steve/core/base_schema.h>

#include <steve/schema.h> //cpp macros helpers.

namespace exa {
namespace schema {

class hit : public steve::core::base_schema {
  schema_header(hit)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_x)
  schema_data_header(m_y)
  schema_data_header(m_z)
  schema_data_header(m_track)
};

class track : public steve::core::base_schema {
  schema_header(track)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_hits)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_px)
  schema_data_header(m_py)
  schema_data_header(m_pz)
public:
  hit* schema_m_hits() const;
private:
  hit* m_schema_m_hits;
};

class event : public steve::core::base_schema {
  schema_header(event)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_tracks)
  schema_nos_header(m_tracks_refs)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_id)
  schema_data_header(m_energy)
  schema_data_header(m_tracks)
  schema_data_header(m_tracks_refs)
public:
  track* schema_m_tracks() const;
private:
  track* m_schema_m_tracks;
};

class header : public steve::core::base_schema {
  schema_header(header)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(header_m_number_of_events)
};

}}

#endif
