// this :
#include "event.h"

#include <steve/interface/streamer.h>

#include <steve/tools/randoms.h>
#include <steve/tools/smanip.h>

//////////////////////////////////////////////////////////////////////////////
/// time /////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::time::time():m_time(0){}
exa::time::time(unsigned int a_index_in_hit):m_time(0){
  m_time = a_index_in_hit;
}
exa::time::~time(){}
exa::time::time(const time&){}
exa::time& exa::time::operator=(const time&){return *this;}
unsigned int exa::time::get_time() const { return m_time;}

//////////////////////////////////////////////////////////////////////////////
/// hit //////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::hit::hit()
:m_x(0)
,m_y(0)
,m_z(0)
,m_track(0)
{
}
exa::hit::hit(steve::tools::random::gauss& a_random,
              unsigned int a_index_in_track,exa::track* a_track)
:m_x(0)
,m_y(0)
,m_z(0)
,m_track(a_track)
{
  m_x = a_index_in_track; //to check retrieving.
  m_y = a_random.shoot();
  m_z = a_random.shoot();

 {// create times on hit :
  //unsigned int number_of_times = a_index_in_track+2;
  unsigned int number_of_times = 10;
  for(unsigned int index=0;index<number_of_times;index++) {
    m_times.push_back(new time(index));
    m_vec_double.push_back(index+2);
  }}
}
exa::hit::~hit(){
  std::vector<time*>::iterator it;
  for(it=m_times.begin();it!=m_times.end();++it) delete (*it);
  m_times.clear();
}

//private (dummy) :
exa::hit::hit(const hit&){}
exa::hit& exa::hit::operator=(const hit&){return *this;}

double exa::hit::x() const { return m_x;}
double exa::hit::y() const { return m_y;}
double exa::hit::z() const { return m_z;}
exa::track* exa::hit::track() const {return m_track;}
std::vector<exa::time*>& exa::hit::times() {return m_times;}
std::vector<double>& exa::hit::vec_double() {return m_vec_double;}

//////////////////////////////////////////////////////////////////////////////
/// track ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::track::track() //Used when retrieving.
:m_px(0)
,m_py(0)
,m_pz(0)
{
}
exa::track::track(steve::tools::random::gauss& a_random,
                  unsigned int a_index_in_event)
:m_px(0)
,m_py(0)
,m_pz(0)
{
  m_px = a_index_in_event; //used to check retrieving.
  m_py = a_random.shoot();
  m_pz = a_random.shoot();

 {// create hits on track :
  //unsigned int number_of_hits = a_index_in_event+1;
  unsigned int number_of_hits = 100;
  for(unsigned int index=0;index<number_of_hits;index++) {
    m_hits.push_back(new exa::hit(a_random,index,this));
  }}
}  
exa::track::~track(){
  std::vector<hit*>::iterator it;
  for(it=m_hits.begin();it!=m_hits.end();++it) delete (*it);
  m_hits.clear();
}
exa::track::track(const track&){}
exa::track& exa::track::operator=(const track&){return *this;}
double exa::track::px() const { return m_px;}
double exa::track::py() const { return m_py;}
double exa::track::pz() const { return m_pz;}
std::vector<exa::hit*>& exa::track::hits() {return m_hits;}

//////////////////////////////////////////////////////////////////////////////
/// test_stream //////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::test_stream::test_stream() //Used when retrieving.
:m_uchar(0)
,m_char(0)
,m_uint16(0)
,m_int16(0)
,m_uint32(0)
,m_int32(0)
,m_uint64(0)
,m_int64(0)
,m_float(0)
,m_double(0)
,m_string("")
{
}
void exa::test_stream::initialize() {
  m_uchar = 1;
  m_char = 2;
  m_uint16 = 3;
  m_int16 = 4;
  m_uint32 = 5;
  m_int32 = 6;
  m_uint64 = 7;
  m_int64 = 8;
  m_float = 9;
  m_double = 10;
  m_string = "11";
}
exa::test_stream::test_stream(const test_stream& a_from) //private
:m_string(a_from.m_string)
{
}
exa::test_stream& exa::test_stream::operator=(const test_stream& a_from) { return *this;}
exa::test_stream::~test_stream(){
}
steve::uchar exa::test_stream::get_uchar() const { return m_uchar;}
char exa::test_stream::get_char() const { return m_char;}
steve::uint16 exa::test_stream::get_uint16() const { return m_uint16;}
steve::int16 exa::test_stream::get_int16() const { return m_int16;}
steve::uint32 exa::test_stream::get_uint32() const { return m_uint32;}
steve::int32 exa::test_stream::get_int32() const { return m_int32;}
steve::uint64 exa::test_stream::get_uint64() const { return m_uint64;}
steve::int64 exa::test_stream::get_int64() const { return m_int64;}
float exa::test_stream::get_float() const { return m_float;}
double exa::test_stream::get_double() const { return m_double;}
std::string exa::test_stream::get_string() const { return m_string;}

bool exa::test_stream::is_equal(const test_stream& a_from) const {
  if(m_uchar!=a_from.m_uchar) return false;
  if(m_char!=a_from.m_char) return false;
  if(m_uint16!=a_from.m_uint16) return false;
  if(m_int16!=a_from.m_int16) return false;
  if(m_uint32!=a_from.m_uint32) return false;
  if(m_int32!=a_from.m_int32) return false;
  if(m_uint64!=a_from.m_uint64) return false;
  if(m_int64!=a_from.m_int64) return false;
  if(m_float!=a_from.m_float) return false;
  if(m_double!=a_from. m_double) return false;
  if(m_string!=a_from.m_string) return false;
  return true;
}
bool exa::test_stream::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_uchar)) return false;
  if(!a_streamer.write(m_char)) return false;
  if(!a_streamer.write(m_uint16)) return false;
  if(!a_streamer.write(m_int16)) return false;
  if(!a_streamer.write(m_uint32)) return false;
  if(!a_streamer.write(m_int32)) return false;
  if(!a_streamer.write(m_uint64)) return false;
  if(!a_streamer.write(m_int64)) return false;
  if(!a_streamer.write(m_float)) return false;
  if(!a_streamer.write(m_double)) return false;
  if(!a_streamer.write(m_string)) return false;
  return true;
}
bool exa::test_stream::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_uchar)) return false;
  if(!a_streamer.read(m_char)) return false;
  if(!a_streamer.read(m_uint16)) return false;
  if(!a_streamer.read(m_int16)) return false;
  if(!a_streamer.read(m_uint32)) return false;
  if(!a_streamer.read(m_int32)) return false;
  if(!a_streamer.read(m_uint64)) return false;
  if(!a_streamer.read(m_int64)) return false;
  if(!a_streamer.read(m_float)) return false;
  if(!a_streamer.read(m_double)) return false;
  if(!a_streamer.read(m_string)) return false;
  return true;
}

//////////////////////////////////////////////////////////////////////////////
/// cell /////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::cell::cell(){} //Used when retrieving.
exa::cell::cell(const cell& a_from)
:m_id(a_from.m_id)
,m_id_vec(a_from.m_id_vec)
{}
exa::cell& exa::cell::operator=(const cell& a_from) {
  m_id = a_from.m_id;
  m_id_vec = a_from.m_id_vec;
  return *this;
}
exa::cell::cell(unsigned int a_index_in_event) {
  m_id = "exa::cell:";
 {for(unsigned int index=0;index<(a_index_in_event+1);index++) {
     m_id += steve::tools::to<unsigned int>(a_index_in_event+1);
  }}
  m_id_vec = m_id;
}  
exa::cell::~cell(){
}
std::string exa::cell::id() const { return m_id;}
std::string exa::cell::id_vec() const { return m_id_vec;}

//////////////////////////////////////////////////////////////////////////////
/// event ////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::event::event() //Used when retrieving.
:m_id(0)
,m_energy(0)
,m_histo("",1,0,1)
{
}
exa::event::event(steve::tools::random::gauss& a_random,
                  unsigned int a_index_in_run,
                  analysis& a_analysis)
:m_id(0)
,m_energy(0)
,m_histo("event_m_histo",100,-10,10)
{
  m_id = a_index_in_run;
  m_energy = a_random.shoot();

  a_analysis.m_energy.fill(m_energy);

 {// Create tracks on event :
  //unsigned int number_of_tracks = a_index_in_run+1;
  unsigned int number_of_tracks = 100;
  for(unsigned int index=0;index<number_of_tracks;index++) {
    m_tracks.push_back(new exa::track(a_random,index));
  }}

 {// Fill fHisto :
  for(unsigned int index=0;index<a_index_in_run;index++) {
    m_histo.fill(a_random.shoot());
  }}

 {m_blob.resize(10);
  for(unsigned int index=0;index<10;index++) {
    m_blob[index] = (char)index;
  }}

  m_test_stream.initialize();
  
 {// create cells in event :
  unsigned int number_of_cells = 100;
  for(unsigned int index=0;index<number_of_cells;index++) {
    m_cells.push_back(exa::cell(index));
  }}

}  
exa::event::~event(){
  std::vector<track*>::iterator it;
  for(it=m_tracks.begin();it!=m_tracks.end();++it) delete (*it);
  m_tracks.clear();
  m_cells.clear();
}

//private (dummy):
exa::event::event(const event& a_from):m_histo(a_from.m_histo){}
exa::event& exa::event::operator=(const event&){return *this;}

float exa::event::energy() const { return m_energy;}
unsigned int exa::event::id() const { return m_id;}
std::vector<exa::track*>& exa::event::tracks() {return m_tracks;}
exa::util::histogram_1d& exa::event::histo() { return m_histo;}
steve::tools::blob& exa::event::blob() { return m_blob;}
exa::test_stream& exa::event::test_stream() { return m_test_stream;}
std::vector<exa::cell>& exa::event::cells() {return m_cells;}

//////////////////////////////////////////////////////////////////////////////
/// header ///////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::header::header():m_number_of_events(0){}
exa::header::~header(){}

//private (dummy) :
exa::header::header(const header& a_from):m_number_of_events(0){}
exa::header& exa::header::operator=(const header&){return *this;}

unsigned int exa::header::numberOfevents() const { return m_number_of_events;}
void exa::header::setNumberOfevents(unsigned int a_value) { 
  m_number_of_events = a_value;
}

//////////////////////////////////////////////////////////////////////////////
/// analysis /////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::analysis::analysis()
:m_energy("event_m_energy",100,-10,10)
{}
exa::analysis::~analysis(){}
exa::analysis::analysis(const analysis& a_from)
:m_energy(a_from.m_energy)
{}
exa::analysis& exa::analysis::operator=(const analysis&){return *this;}
