#ifndef exa_schemas_h
#define exa_schemas_h

// inheritance :
#include <steve/core/base_schema.h>

#include <steve/schema.h> //cpp macros helpers.

namespace exa {namespace schema { class histogram;}}

namespace exa {
namespace schema {


class time : public steve::core::base_schema {
  schema_header(time)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_time)
};

class hit : public steve::core::base_schema {
  schema_header(hit)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_times)
  schema_nos_header(m_vec_double)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_x)
  schema_data_header(m_y)
  schema_data_header(m_z)
  schema_data_header(m_track)
  schema_data_header(m_vec_double)
public:
  time* schema_m_times() const;
private:
  time* m_schema_m_times;
};

class track : public steve::core::base_schema {
  schema_header(track)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_hits)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_px)
  schema_data_header(m_py)
  schema_data_header(m_pz)
public:
  hit* schema_m_hits() const;
private:
  hit* m_schema_m_hits;
};

class test_stream : public steve::core::base_schema {
  schema_header(test_stream)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_blob)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_blob)
};

class cell : public steve::core::base_schema {
  schema_header(cell)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_id_vec)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_id)
  schema_data_header(m_id_vec)
};

class event : public steve::core::base_schema {
  schema_header(event)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_tracks)
  schema_nos_header(m_tracks_refs)
  schema_nos_header(m_blob)
  schema_nos_header(m_test_stream)
  schema_nos_header(m_cells)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(m_id)
  schema_data_header(m_energy)
  schema_data_header(m_tracks)
  schema_data_header(m_tracks_refs)
  schema_data_header(m_blob)
  schema_data_header(m_test_stream)
  schema_data_header(m_cells)
public:
  track* schema_m_tracks() const;
  histogram* schema_m_histo() const;
  test_stream* schema_m_test_stream() const;
  cell* schema_m_cells() const;
private:
  track* m_schema_m_tracks;
  histogram* m_schema_m_histo;
  test_stream* m_schema_m_test_stream;
  cell* m_schema_m_cells;
};

class header : public steve::core::base_schema {
  schema_header(header)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(header_m_number_of_events)
};

class analysis : public steve::core::base_schema {
  schema_header(analysis)
public:
  histogram* schema_m_energy() const;
private:
  histogram* m_schema_m_energy;
};

}}

#endif
