
#include "event.h"

#include <steve/interface/streamer.h>
#include <steve/core/streamer_T.h>

#include <util/stream.h>

//#define CLASS_VERSION 1

bool exa::time::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_time)) return false;
  return true;
}
bool exa::time::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_time)) return false;
  return true;
}

bool exa::hit::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_x)) return false;
  if(!a_streamer.write(m_y)) return false;
  if(!a_streamer.write(m_z)) return false;
  if(!steve::stream::out_ref<exa::track>(a_streamer,m_track)) return false;
  if(!steve::stream::out<exa::time>(a_streamer,m_times)) return false;
  if(!steve::stream::out(a_streamer,m_vec_double)) return false;
  return true;
}
bool exa::hit::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_x)) return false;
  if(!a_streamer.read(m_y)) return false;
  if(!a_streamer.read(m_z)) return false;
  if(!steve::stream::in_ref<exa::track>(a_streamer,m_track)) return false;
  if(!steve::stream::in<exa::time>(a_streamer,m_times)) return false;
  if(!steve::stream::in(a_streamer,m_vec_double)) return false;
  return true;
}

bool exa::track::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_px)) return false;
  if(!a_streamer.write(m_py)) return false;
  if(!a_streamer.write(m_pz)) return false;
  if(!steve::stream::out<hit>(a_streamer,m_hits)) return false;
  return true;
}
bool exa::track::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_px)) return false;
  if(!a_streamer.read(m_py)) return false;
  if(!a_streamer.read(m_pz)) return false;
  if(!steve::stream::in<hit>(a_streamer,m_hits)) return false;
  return true;
}

bool exa::cell::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_id)) return false;
  if(!steve::stream::out(a_streamer,m_id_vec)) return false;
  return true;
}
bool exa::cell::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_id)) return false;
  if(!steve::stream::in(a_streamer,m_id_vec)) return false;
  return true;
}

bool exa::event::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_id)) return false;
  if(!a_streamer.write(m_energy)) return false;

  if(!exa::util::out(a_streamer,m_histo.data())) return false;

  if(!a_streamer.write(m_blob.size(),m_blob.data())) return false;
  if(!m_test_stream.stream_out(a_streamer)) return false;

  if(!steve::stream::out_with_refs<track>(a_streamer,m_tracks)) return false;

  if(!steve::stream::out2<cell>(a_streamer,m_cells)) return false;

  return true;
}
bool exa::event::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_id)) return false;
  if(!a_streamer.read(m_energy)) return false;

  if(!exa::util::in(a_streamer,m_histo.data())) return false;

 {steve::uint32 sz;
  char* buffer;
  if(!a_streamer.read(sz,buffer)) return false;
  m_blob.assign(sz,buffer);}

  if(!m_test_stream.stream_in(a_streamer)) return false;

  if(!steve::stream::in_with_refs<track>(a_streamer,m_tracks)) return false;

  if(!steve::stream::in2<cell>(a_streamer,m_cells)) return false;

  return true;
}

bool exa::header::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!a_streamer.write(m_number_of_events)) return false;
  return true;
}
bool exa::header::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!a_streamer.read(m_number_of_events)) return false;
  return true;
}

bool exa::analysis::stream_out(steve::interface::streamer& a_streamer) const { 
  //steve::uint16 version = CLASS_VERSION;
  //if(!a_streamer.write(version)) return false;

  if(!exa::util::out(a_streamer,m_energy.data())) return false;
  return true;
}
bool exa::analysis::stream_in(steve::interface::streamer& a_streamer) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=CLASS_VERSION) return false;

  if(!exa::util::in(a_streamer,m_energy.data())) return false;
  return true;
}


