@ECHO off
SETLOCAL

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////

SET EXA=exa_7
SET DRIVER=memory

REM ECHO %EXA%

CL.exe 1> NUL 2> NUL
IF ERRORLEVEL 1 (
  ECHO CL.exe program not found. You have to setup VisualC++ environment.
  GOTO steve_return
)

FOR /F "usebackq delims=;" %%s IN (`steve-config --%DRIVER%_cppflags`) DO SET steve_cppflags=%%s
FOR /F "usebackq delims=;" %%s IN (`steve-config --%DRIVER%_libs`) DO SET steve_libs=%%s

SET steve_cppflags=%steve_cppflags% /I..

SET flags=/nologo /DWIN32 /MD /O2 /W3  /GX /GR 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
IF EXIST event.obj DEL event.obj
CL.exe %flags% /c %steve_cppflags% /Foevent.obj /Tpevent.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST schemas.obj DEL schemas.obj
CL.exe %flags% /c %steve_cppflags% /Foschemas.obj /Tpschemas.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST steve.obj DEL steve.obj
CL.exe %flags% /c %steve_cppflags% /Fosteve.obj /Tpsteve.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////

IF EXIST axis.obj DEL axis.obj
CL.exe %flags% /c %steve_cppflags% /Foaxis.obj /Tp..\util\axis.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST histogram.obj DEL histogram.obj
CL.exe %flags% /c %steve_cppflags% /Fohistogram.obj /Tp..\util\histogram.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

IF EXIST util_schemas.obj DEL util_schemas.obj
CL.exe %flags% /c %steve_cppflags% /Foutil_schemas.obj /Tp..\util\util_schemas.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
IF EXIST main.obj DEL main.obj
CL.exe %flags% /c %steve_cppflags% /Fomain.obj /Tpmain.cxx 1> cl_exe_error
IF ERRORLEVEL 1 TYPE cl_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL cl_exe_error 

LINK.exe /nologo /OPT:NOREF /out:steve_%EXA%_%DRIVER%.exe main.obj event.obj schemas.obj steve.obj axis.obj histogram.obj util_schemas.obj %steve_libs% 1> link_exe_error
IF ERRORLEVEL 1 TYPE link_exe_error && GOTO steve_return
IF NOT ERRORLEVEL 1 DEL link_exe_error 

REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////
REM //////////////////////////////////////////////////////////////////////////

IF EXIST event.obj DEL event.obj
IF EXIST schemas.obj DEL schemas.obj
IF EXIST steve.obj DEL steve.obj

IF EXIST axis.obj DEL axis.obj
IF EXIST histogram.obj DEL histogram.obj
IF EXIST util_schemas.obj DEL util_schemas.obj

IF EXIST main.obj DEL main.obj

:steve_return
ENDLOCAL
@ECHO on

