// this :
#include <util/histogram.h> 

#include <math.h>

#define axisX 0
#define axisY 1
#define axisZ 2

//#define CHECK_OPTIMIZE
//#define PREC 1e10-24
//#define IS_EQUAL(a,b) (fabs((a)-(b))<=PREC)

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_data::histogram_data(
)
:m_dimension(0)
,m_bin_number(0)
,m_is_profile(false)
,m_cut_v(false)
,m_min_v(0)
,m_max_v(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_data::histogram_data(
 const exa::util::histogram_data& a_from
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  copy(a_from);
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_data::~histogram_data(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram_data::copy(
 const exa::util::histogram_data& a_from
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_from.m_title;
  m_dimension = a_from.m_dimension;
  m_bin_number = a_from.m_bin_number;
  // Arrays :
  m_axes = a_from.m_axes;
  m_bin_entries = a_from.m_bin_entries;
  m_bin_Sw = a_from.m_bin_Sw;
  m_bin_Sw2 = a_from.m_bin_Sw2;
  m_bin_Sxw = a_from.m_bin_Sxw;
  m_bin_Sx2w = a_from.m_bin_Sx2w;
  // Profile :
  m_is_profile = a_from.m_is_profile;
  m_bin_Svw = a_from.m_bin_Svw;
  m_bin_Sv2w = a_from.m_bin_Sv2w;
  m_cut_v = a_from.m_cut_v;
  m_min_v = a_from.m_min_v;
  m_max_v = a_from.m_max_v;
  // Args :
  m_doubles = a_from.m_doubles;
  m_ints = a_from.m_ints;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram::histogram(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //printf("debug : histogram %lu\n",this);
}
/*
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram::histogram(
 uint32 a_dimension 
,const std::vector<uint32>& a_numbers
,const std::vector<double>& a_mins
,const std::vector<double>& a_maxs
,bool a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  configure(a_dimension,a_numbers,a_mins,a_maxs,a_profile); //FIXME : ret false
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram::histogram(
 uint32 a_dimension 
,const std::vector< std::vector<double> >& a_edges
,bool a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  configure(a_dimension,a_edges,a_profile); //FIXME : ret false.
}
*/
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram::histogram(
 const exa::util::histogram& a_histogram
)
:histogram_data(a_histogram)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram::histogram(
 const exa::util::histogram_data& a_data
)
:histogram_data(a_data)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram::~histogram(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram& exa::util::histogram::operator=(
 const histogram& a_histogram
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  copy(a_histogram);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::configure(
 uint32 a_dimension 
,const std::vector<uint32>& a_numbers
,const std::vector<double>& a_mins
,const std::vector<double>& a_maxs
,bool a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Clear :
  clear();
  // Some checks :
  if(!a_dimension) return false;
  m_axes.resize(a_dimension);
  // Setup axes :
  for(uint32 iaxis=0;iaxis<a_dimension;iaxis++) { 
    if(!m_axes[iaxis].configure
         (a_numbers[iaxis],a_mins[iaxis],a_maxs[iaxis])) {
      m_axes.clear();
      return false;
    }
  }

  m_dimension = a_dimension;
  m_is_profile = a_profile;
  allocate();
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::configure(
 uint32 a_dimension 
,const std::vector< std::vector<double> >& a_edges
,bool a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // Clear :
  clear();
  // Some checks :
  if(!a_dimension) return false;
  m_axes.resize(a_dimension);
  // Setup axes :
  for(uint32 iaxis=0;iaxis<a_dimension;iaxis++) { 
    if(!m_axes[iaxis].configure(a_edges[iaxis])) {
      m_axes.clear();
      return false;
    }
  }

  m_dimension = a_dimension;
  m_is_profile = a_profile;
  allocate();
  return true;
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram::allocate(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 iaxis;

  // Add two bins for the [under,out]flow data.
  uint32 binn = 1;
  for(iaxis=0;iaxis<m_dimension;iaxis++)
    binn *= (m_axes[iaxis].bins() + 2);

  m_bin_entries.resize(binn,0);
  m_bin_Sw.resize(binn,0);
  m_bin_Sw2.resize(binn,0);

#ifdef EXA_UTIL_VEC_VEC
  std::vector<double> empty;
  empty.resize(m_dimension,0);
  m_bin_Sxw.resize(binn,empty);
  m_bin_Sx2w.resize(binn,empty);
#else
  m_bin_Sxw.resize(binn*m_dimension,0);
  m_bin_Sx2w.resize(binn*m_dimension,0);
#endif
  
  m_bin_number = binn; // All bins : [in-range, underflow, outflow] bins.

  m_axes[0].m_offset = 1;
  for(iaxis=1;iaxis<m_dimension;iaxis++) 
    m_axes[iaxis].m_offset = 
      m_axes[iaxis-1].m_offset * (m_axes[iaxis-1].bins()+2);
  
  if(m_is_profile) {
    m_bin_Svw.resize(binn,0);
    m_bin_Sv2w.resize(binn,0);
  }

  m_doubles.resize(m_dimension,0);
  m_ints.resize(m_dimension,0);
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::is_valid(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return (m_dimension<=0?false:true);
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_data& exa::util::histogram::data(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
const exa::util::histogram_data& exa::util::histogram::data(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
const exa::util::axis& exa::util::histogram::axis(
 uint32 a_index
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return m_axes[a_index];
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::is_compatible(
 const histogram& a_histogram
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension != a_histogram.m_dimension) return false;

  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) { 
    if(!m_axes[iaxis].is_compatible(a_histogram.m_axes[iaxis])) return false;
  }

  if(m_is_profile != a_histogram.m_is_profile) return false;

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::is_profile(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return m_is_profile;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::uint32 exa::util::histogram::dimension(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return m_dimension;
}
//////////////////////////////////////////////////////////////////////////////
const std::string& exa::util::histogram::title(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return m_title;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::uint32 exa::util::histogram::number_of_bins(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return m_bin_number;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::uint32 exa::util::histogram::entries(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 number = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      number += m_bin_entries[ibin];
    }
  }
  return number;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::uint32 exa::util::histogram::all_entries(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 number = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    number += m_bin_entries[ibin];
  }
  return number;
}
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::sw(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  double sw = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sw += m_bin_Sw[ibin];
    }
  }
  return sw;
}
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::sw2(
) const 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  double sw2 = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sw2 += m_bin_Sw2[ibin];
    }
  }
  return sw2;
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram::update_fast_getters(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram::base_reset(
)
//////////////////////////////////////////////////////////////////////////////
// Reset content (different of clear that deallocate all internal things).
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_entries[ibin] = 0;
    m_bin_Sw[ibin] = 0;
    m_bin_Sw2[ibin] = 0;
    for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
      bin_Sxw(ibin,iaxis) = 0;
      bin_Sx2w(ibin,iaxis) = 0;
    }
  }
  // Profile :
  if(m_is_profile) {
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      m_bin_Svw[ibin] = 0;
      m_bin_Sv2w[ibin] = 0;
    }
  }
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram::copy(
 const exa::util::histogram& a_from
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_from.m_title;
  m_dimension = a_from.m_dimension;
  m_bin_number = a_from.m_bin_number;
  // Arrays :
  m_axes = a_from.m_axes;
  m_bin_entries = a_from.m_bin_entries;
  m_bin_Sw = a_from.m_bin_Sw;
  m_bin_Sw2 = a_from.m_bin_Sw2;
  m_bin_Sxw = a_from.m_bin_Sxw;
  m_bin_Sx2w = a_from.m_bin_Sx2w;
  // Profile :
  m_is_profile = a_from.m_is_profile;
  m_bin_Svw = a_from.m_bin_Svw;
  m_bin_Sv2w = a_from.m_bin_Sv2w;
  m_cut_v = a_from.m_cut_v;
  m_min_v = a_from.m_min_v;
  m_max_v = a_from.m_max_v;
  // Args :
  m_doubles = a_from.m_doubles;
  m_ints = a_from.m_ints;
  
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::add(
 const histogram& a_histogram
)
//////////////////////////////////////////////////////////////////////////////
// The only histogram operation that makes sense.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!is_compatible(a_histogram)) return false;
  
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_entries[ibin] += a_histogram.m_bin_entries[ibin];      
    m_bin_Sw[ibin] += a_histogram.m_bin_Sw[ibin];      
    m_bin_Sw2[ibin] += a_histogram.m_bin_Sw2[ibin];      
    for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
      bin_Sxw(ibin,iaxis) += a_histogram.bin_Sxw(ibin,iaxis);
      bin_Sx2w(ibin,iaxis) += a_histogram.bin_Sx2w(ibin,iaxis);
    }
  }

  if(m_is_profile) {
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      m_bin_Svw[ibin] += a_histogram.m_bin_Svw[ibin];      
      m_bin_Sv2w[ibin] += a_histogram.m_bin_Sv2w[ibin];      
    }
  }

  update_fast_getters();

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::subtract(
 const histogram& a_histogram
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!is_compatible(a_histogram)) return false;
  
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_entries[ibin] -= a_histogram.m_bin_entries[ibin];      
    m_bin_Sw[ibin] -= a_histogram.m_bin_Sw[ibin];      
    // Yes, it is a += in the below.
    m_bin_Sw2[ibin] += a_histogram.m_bin_Sw2[ibin];
    for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
      bin_Sxw(ibin,iaxis) -= a_histogram.bin_Sxw(ibin,iaxis);
      bin_Sx2w(ibin,iaxis) -= a_histogram.bin_Sx2w(ibin,iaxis);
    }
  }

  if(m_is_profile) {
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      m_bin_Svw[ibin] -= a_histogram.m_bin_Svw[ibin];      
      m_bin_Sv2w[ibin] -= a_histogram.m_bin_Sv2w[ibin];      
    }
  }

  update_fast_getters();

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::multiply(
 const histogram& a_histogram
)
//////////////////////////////////////////////////////////////////////////////
// We build a new histo with one entry in each bean of weight : 
//   this.w * a_histogram.w
// The current histo is overriden with this new histo.
// The m_bin_Sw2 computation is consistent with FreeHEP and ROOT.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!is_compatible(a_histogram)) return false;
  if(m_dimension<=0) return false;

  histogram h(*this);
  h.base_reset();

  std::vector<int> is(m_dimension);
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    indices(ibin,is);
    double swa = m_bin_Sw[ibin];
    double swb = a_histogram.m_bin_Sw[ibin];
    double sw2a = m_bin_Sw2[ibin];
    double sw2b = a_histogram.m_bin_Sw2[ibin];
    double sw = swa * swb;
    h.m_bin_entries[ibin] = 1;
    h.m_bin_Sw[ibin] = sw;
    h.m_bin_Sw2[ibin] = sw2a * swb * swb + sw2b * swa * swa;
    for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
      double x = m_axes[iaxis].bin_center(is[iaxis]);
      h.bin_Sxw(ibin,iaxis) = x * sw;
      h.bin_Sx2w(ibin,iaxis) = x * x * sw;
    }
  }

  copy(h);

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::divide(
 const histogram& a_histogram
)
//////////////////////////////////////////////////////////////////////////////
// We build a new histo with one entry in each bean of weight : 
//   this.w / a_histogram.w
// The current histo is overriden with this new histo.
// The m_bin_Sw2 computation is consistent with FreeHEP and ROOT.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!is_compatible(a_histogram)) return false;
  if(m_dimension<=0) return false;

  histogram h(*this);
  h.base_reset();

  std::vector<int> is(m_dimension);
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    indices(ibin,is);
    double swa = m_bin_Sw[ibin];
    double swb = a_histogram.m_bin_Sw[ibin];
    double sw2a = m_bin_Sw2[ibin];
    double sw2b = a_histogram.m_bin_Sw2[ibin];
    h.m_bin_entries[ibin] = 1;
    if(swb!=0) {
      double sw = swa / swb;
      h.m_bin_Sw[ibin] = sw;
      double swb2 = swb * swb;
      h.m_bin_Sw2[ibin] = sw2a / swb2 + sw2b * swa * swa /(swb2*swb2);
      for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
        double x = m_axes[iaxis].bin_center(is[iaxis]);
        h.bin_Sxw(ibin,iaxis) = x * sw;
        h.bin_Sx2w(ibin,iaxis) = x * x * sw;
      }
    }
  }

  copy(h);

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::multiply(
 double a_factor
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_factor<0) return false;
  double factor2 = a_factor * a_factor;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_Sw[ibin] *= a_factor;
    m_bin_Sw2[ibin] *= factor2;
    for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
      bin_Sxw(ibin,iaxis) *= a_factor;
      bin_Sx2w(ibin,iaxis) *= a_factor;
    }
  }
  if(m_is_profile) {
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      m_bin_Svw[ibin] *= a_factor;
    }
  }
  update_fast_getters();
  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////// Bins ///////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_bin(
 const std::vector<double>& a_xs
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!m_dimension) return false;
  uint32 offset;
  if(!histogram::offset(a_xs,offset)) return false;

  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw;
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
    xw = a_xs[iaxis] * a_weight;
    bin_Sxw(offset,iaxis) += xw;
    bin_Sx2w(offset,iaxis) += a_xs[iaxis] * xw;
  }

  return true;
}
/*
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_bin(
 const std::vector<double>& a_xs
,double a_value
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
// For profile.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!m_dimension) return false;
  if(m_cut_v) {
    if( (a_value<m_min_v) || (a_value>=m_max_v) ) {
      return true;
    }
  }

  uint32 offset;
  if(!histogram::offset(a_xs,offset)) return false;

  // Same as upper :
  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw;
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
    xw = a_xs[iaxis] * a_weight;
    bin_Sxw(offset,iaxis) += xw;
    bin_Sx2w(offset,iaxis) += a_xs[iaxis] * xw;
  }

  // Profile part :
  double vw = a_value * a_weight;
  m_bin_Svw[offset] += vw;
  m_bin_Sv2w[offset] += a_value * vw;

  //binSxvw(offset,iaxis) += a_xs[iaxis] * a_value * a_weight;
  //binSx2vw(offset,iaxis) += a_xs[iaxis] * a_xs[iaxis] * a_value * a_weight;

  return true;
}
*/
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::bin_entries(
 const std::vector<int>& a_is
,uint32& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  a_value = m_bin_entries[offset];
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::bin_height(
 const std::vector<int>& a_is
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  if(m_is_profile) {
    //FIXME : ret false.
    a_value = (m_bin_Sw[offset] ? (m_bin_Svw[offset]/m_bin_Sw[offset]):0);
  } else {
    a_value = m_bin_Sw[offset];
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::bin_error(
 const std::vector<int>& a_is
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  if(m_is_profile) {
    //FIXME Is it correct ?
    /* TProfile::GetBinError with kERRORMEAN mode does :
      Stat_t cont = fArray[bin];              //exa::util Svw (see TProfile::Fill)
      Stat_t sum  = m_bin_entries.fArray[bin];  //exa::util Sw
      Stat_t err2 = fSumw2.fArray[bin];       //exa::util Sv2w
      if (sum == 0) return 0;
      Stat_t eprim;
      Stat_t contsum = cont/sum;
      Stat_t eprim2  = TMath::Abs(err2/sum - contsum*contsum);
      eprim          = TMath::Sqrt(eprim2);
      ... ??? 
      if (fErrorMode == kERRORMEAN) return eprim/TMath::Sqrt(sum);
    */
    double sw = m_bin_Sw[offset];      //ROOT sum
    if(sw==0) {a_value=0;return false;} //FIXME : ok ?
    double svw = m_bin_Svw[offset];    //ROOT cont
    double sv2w = m_bin_Sv2w[offset];  //ROOT err2
    double mean = (svw / sw);        //ROOT contsum
    double rms = ::sqrt(::fabs((sv2w/sw) - mean * mean)); //ROOT eprim
    // rms = bin_rms_value.
    a_value = rms/::sqrt(sw); //ROOT kERRORMEAN mode returned value
  } else {
    a_value = ::sqrt(m_bin_Sw2[offset]);
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::bin_mean(
 const std::vector<int>& a_is
,std::vector<double>& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  a_value.resize(m_dimension,0);
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  double sw = m_bin_Sw[offset];
  if(sw==0) return false; //FIXME : ok ?
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
    a_value[iaxis] = bin_Sxw(offset,iaxis)/sw;
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::bin_rms_axes(
 const std::vector<int>& a_is
,std::vector<double>& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  a_value.resize(m_dimension,0);
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  double sw = m_bin_Sw[offset];
  if(sw==0) return false; //FIXME : ok ?
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
    double sxw = bin_Sxw(offset,iaxis);
    double sx2w = bin_Sx2w(offset,iaxis);
    double mean = sxw/sw;
    a_value[iaxis] = ::sqrt(::fabs((sx2w / sw) - mean * mean));
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::bin_rms_value( //FIXME
 const std::vector<int>& a_is
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
// For profile histograms.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!m_is_profile) return false;
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  double sw = m_bin_Sw[offset];
  if(sw==0) {a_value=0;return false;} //FIXME : ok ?
  double svw = m_bin_Svw[offset];
  double sv2w = m_bin_Sv2w[offset];
  double mean = (svw / sw);
  a_value = ::sqrt(::fabs((sv2w / sw) - mean * mean));
  return true;
}
//////////////////////////////////////////////////////////////////////////////
/////// Axes /////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::ith_axis_Sxw(
 uint32 a_axis
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_axis>=m_dimension) return 0;
  double sxw = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sxw += bin_Sxw(ibin,a_axis);
    }
  }
  return sxw;
}
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::ith_axis_Sx2w(
 uint32 a_axis
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_axis>=m_dimension) return 0;
  double sx2w = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sx2w += bin_Sx2w(ibin,a_axis);
    }
  }
  return sx2w;
}
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::ith_axis_mean(
 uint32 a_axis
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_axis>=m_dimension) return 0;
  double sw = 0;
  double sxw = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sw += m_bin_Sw[ibin];
      sxw += bin_Sxw(ibin,a_axis);
    }
  }
  if(sw==0) return 0; //FIXME : ok ?
  return sxw/sw;
}
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::ith_axis_rms(
 uint32 a_axis
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_axis>=m_dimension) return 0;
  double sw = 0;
  double sxw = 0;
  double sx2w = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sw += m_bin_Sw[ibin];
      sxw += bin_Sxw(ibin,a_axis);
      sx2w += bin_Sx2w(ibin,a_axis);
    }
  }
  if(sw==0) return 0; //FIXME : ok ?
  double mean = sxw/sw;
  return ::sqrt(::fabs((sx2w / sw) - mean * mean));
}
//////////////////////////////////////////////////////////////////////////////
exa::util::uint32 exa::util::histogram::ith_axis_bin_entries(
 uint32 a_axis
,int a_index
) const
//////////////////////////////////////////////////////////////////////////////
//WARNING : slow.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //we assume a_axis<m_dimension
  uint32 entries = 0;
  std::vector<int> is(m_dimension);
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    indices(ibin,is);
    if(is[a_axis]==a_index) {
      entries += m_bin_entries[ibin];
    }
  }
  return entries;
}
//////////////////////////////////////////////////////////////////////////////
double exa::util::histogram::ith_axis_bin_height(
 uint32 a_axis
,int a_index
) const
//////////////////////////////////////////////////////////////////////////////
//WARNING : slow.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_axis>=m_dimension) return 0;
  double sw = 0;
  std::vector<int> is(m_dimension);
  if(m_is_profile) {
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      indices(ibin,is);
      if(is[a_axis]==a_index) {
        sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
      }
    }
  } else {
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      indices(ibin,is);
      if(is[a_axis]==a_index) {
        sw += m_bin_Sw[ibin];
      }
    }
  }
  return sw;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram::clear(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  // histogram_data :
  m_axes.clear();
  m_bin_entries.clear();
  m_bin_Sw.clear();
  m_bin_Sw2.clear();
  m_bin_Sxw.clear();
  m_bin_Sx2w.clear();
  m_bin_number = 0;
  m_dimension = 0;
  // Profile :
  m_is_profile = false;
  m_bin_Svw.clear();
  m_bin_Sv2w.clear();
  m_cut_v = false;
  m_min_v = 0;
  m_max_v = 0;
  // Args :
  m_doubles.clear();
  m_ints.clear();
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::offset(
 const std::vector<double>& a_xs
,uint32& a_offset
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension<=0) return false;
  a_offset = 0;
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) { 
    uint32 ibin;
    if(!m_axes[iaxis].coord_to_absolute_index(a_xs[iaxis],ibin)) 
      return false;
    a_offset += ibin * m_axes[iaxis].m_offset;
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::histogram::indices(
 uint32 a_offset
,std::vector<int>& a_is
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset = a_offset;
 {for(int iaxis=m_dimension-1;iaxis>=0;iaxis--) { 
    a_is[iaxis] = offset/m_axes[iaxis].m_offset;
    offset -= a_is[iaxis] * m_axes[iaxis].m_offset;
  }}
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
    if(a_is[iaxis]==0) {
      a_is[iaxis] = axis::underflow_bin;
    } else if(a_is[iaxis]==m_axes[iaxis].m_number_of_bins+1) {
      a_is[iaxis] = axis::overflow_bin;
    } else {
      a_is[iaxis]--;
    }
  }
}
//HISTOGRAM_SOURCE
bool exa::util::histogram::set_title(const std::string& a_title) {
  m_title = a_title;
  return true;
}
exa::util::uint32 exa::util::histogram::extra_entries() const {
  uint32 number = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(is_out(ibin)) {
      number += m_bin_entries[ibin];
    }
  }
  return number;
}
double exa::util::histogram::equivalent_bin_entries() const {
  double sw = 0;
  double sw2 = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sw += m_bin_Sw[ibin];
      sw2 += m_bin_Sw2[ibin];
    }
  }
  if(sw2==0) return 0;//FIXME : return false
  return (sw * sw)/sw2;
}
double exa::util::histogram::sum_bin_heights() const {
  if(m_is_profile) {
    double sw = 0;
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      if(!is_out(ibin)) {
        sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
      }
    }
    return sw;
  } else {
    double sw = 0;
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      if(!is_out(ibin)) {
        sw += m_bin_Sw[ibin];
      }
    }
    return sw;
  }
}
double exa::util::histogram::sum_all_bin_heights() const {
  if(m_is_profile) {
    double sw = 0;
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
    }
    return sw;
  } else { 
    double sw = 0;
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      sw += m_bin_Sw[ibin];
    }
    return sw;
  }
}
double exa::util::histogram::sum_extra_bin_heights() const {
  if(m_is_profile) {
    double sw = 0;
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      if(is_out(ibin)) {
        sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
      }
    }
    return sw;
  } else { 
    double sw = 0;
    for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
      if(is_out(ibin)) {
        sw += m_bin_Sw[ibin];
      }
    }
    return sw;
  }
}
double exa::util::histogram::min_bin_height() const {
  double value = 0;
  bool first = true;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      double vbin;
      if(m_is_profile) {
        /*if(m_bin_Sw[ibin]==0) return false; FIXME */
        vbin = (m_bin_Sw[ibin]?m_bin_Svw[ibin]/m_bin_Sw[ibin]:0);
      } else {
        vbin = m_bin_Sw[ibin];
      }
      if(first) {
        first = false;
        value = vbin;
      } else {
        if(vbin<=value) value = vbin;
      }
    }
  }
  return value;
}
double exa::util::histogram::max_bin_height() const {
  double value = 0;
  bool first = true;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      double vbin;
      if(m_is_profile) {
        //FIXME : return false
        vbin = (m_bin_Sw[ibin]?m_bin_Svw[ibin]/m_bin_Sw[ibin]:0);
      } else {
        vbin = m_bin_Sw[ibin];
      }
      if(first) {
        first = false;
        value = vbin;
      } else {
        if(vbin>=value) value = vbin;
      }
    }
  }
  return value;
}
bool exa::util::histogram::reset() {
  base_reset();
  return true;
}
bool exa::util::histogram::scale(double a_factor) {
  return multiply(a_factor);
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_slice_x(
 histogram& a_histo
,int a_j_beg
,int a_j_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension!=2) return false;
  uint32 j_beg;
  if(!m_axes[1].in_range_to_absolute_index(a_j_beg,j_beg)) return false;
  uint32 j_end;
  if(!m_axes[1].in_range_to_absolute_index(a_j_end,j_end)) return false;
  if(j_beg>j_end) return false;

  histogram_data& hdata = a_histo.data();
  if(m_axes[0].bins()!=a_histo.m_axes[0].bins()) return false;

  uint32 aibin,aoffset,jbin,offset;     
  uint32 yoffset = m_axes[1].m_offset;

  // Fill also the outflow.
  uint32 abins = hdata.m_axes[0].bins()+2;
  for(aibin=0;aibin<abins;aibin++) {
    //offset1d = ibin
    aoffset = aibin;
    for(jbin=j_beg;jbin<=j_end;jbin++) {
      //offset2d = ibin + jbin * yoffset
      // hdata booked with x then :
      offset = aibin + jbin * yoffset;
      // Bin :
      hdata.m_bin_entries[aoffset] += m_bin_entries[offset];
      hdata.m_bin_Sw[aoffset] += m_bin_Sw[offset];
      hdata.m_bin_Sw2[aoffset] += m_bin_Sw2[offset];
      hdata.bin_Sxw(aoffset,0) += bin_Sxw(offset,0);
      hdata.bin_Sx2w(aoffset,0) += bin_Sx2w(offset,0);
      //FIXME hdata.m_bin_Svw[aoffset] += m_bin_Svw[offset];
    }
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_slice_y(
 histogram& a_histo
,int a_i_beg
,int a_i_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension!=2) return false;
  uint32 i_beg;
  if(!m_axes[0].in_range_to_absolute_index(a_i_beg,i_beg)) return false;
  uint32 i_end;
  if(!m_axes[0].in_range_to_absolute_index(a_i_end,i_end)) return false;
  if(i_beg>i_end) return false;

  histogram_data& hdata = a_histo.data();
  if(m_axes[1].bins()!=a_histo.m_axes[0].bins()) return false;

  uint32 aibin,aoffset,ibin,offset;     
  uint32 yoffset = m_axes[1].m_offset;

  // Fill also the outflow.
  uint32 abins = hdata.m_axes[0].bins()+2;
  for(aibin=0;aibin<abins;aibin++) {
    //offset1d = ibin
    aoffset = aibin;
    for(ibin=i_beg;ibin<=i_end;ibin++) {
      //offset2d = ibin + jbin * yoffset
      // hdata booked with y then :
      offset = ibin + aibin * yoffset;
      // Bin :
      hdata.m_bin_entries[aoffset] += m_bin_entries[offset];
      hdata.m_bin_Sw[aoffset] += m_bin_Sw[offset];
      hdata.m_bin_Sw2[aoffset] += m_bin_Sw2[offset];
      hdata.bin_Sxw(aoffset,0) += bin_Sxw(offset,1);
      hdata.bin_Sx2w(aoffset,0) += bin_Sx2w(offset,1);
      //FIXME hdata.m_bin_Svw[aoffset] += m_bin_Svw[offset];
    }
  }

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_slice_xy(
 histogram& a_histo
,int a_k_beg
,int a_k_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension!=3) return false;
  uint32 k_beg;
  if(!m_axes[2].in_range_to_absolute_index(a_k_beg,k_beg)) return false;
  uint32 k_end;
  if(!m_axes[2].in_range_to_absolute_index(a_k_end,k_end)) return false;
  if(k_beg>k_end) return false;

  histogram_data& hdata = a_histo.data();
  if(m_axes[0].bins()!=a_histo.m_axes[0].bins()) return false;
  if(m_axes[1].bins()!=a_histo.m_axes[1].bins()) return false;

  uint32 aibin,ajbin,kbin,aoffset,offset;     

  uint32 ayoffset = hdata.m_axes[1].m_offset;
  uint32 yoffset = m_axes[1].m_offset;
  uint32 zoffset = m_axes[2].m_offset;

  uint32 axbins = hdata.m_axes[0].bins()+2;
  uint32 aybins = hdata.m_axes[1].bins()+2;
  // Fill also the outflow.
  for(aibin=0;aibin<axbins;aibin++) {
    for(ajbin=0;ajbin<aybins;ajbin++) {
      //offset2d = ibin + jbin * m_axes[1].m_offset
      aoffset = aibin + ajbin * ayoffset;
      for(kbin=k_beg;kbin<=k_end;kbin++) {
        //offset3d = ibin + jbin * m_axes[1].m_offset + kbin * m_axes[2].m_offset;
        // hdata booked with x-y then :
        offset = aibin + ajbin * yoffset + kbin * zoffset;

        // Bin :
        hdata.m_bin_entries[aoffset] += m_bin_entries[offset];
        hdata.m_bin_Sw[aoffset] += m_bin_Sw[offset];
        hdata.m_bin_Sw2[aoffset] += m_bin_Sw2[offset];
        hdata.bin_Sxw(aoffset,0) += bin_Sxw(offset,0);
        hdata.bin_Sxw(aoffset,1) += bin_Sxw(offset,1);
        hdata.bin_Sx2w(aoffset,0) += bin_Sx2w(offset,0);
        hdata.bin_Sx2w(aoffset,1) += bin_Sx2w(offset,1);
        //FIXME hdata.m_bin_Svw[aoffset] += m_bin_Svw[offset];
      }
    }
  }
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_slice_yz(
 histogram& a_histo
,int a_i_beg
,int a_i_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension!=3) return false;
  uint32 i_beg;
  if(!m_axes[0].in_range_to_absolute_index(a_i_beg,i_beg)) return false;
  uint32 i_end;
  if(!m_axes[0].in_range_to_absolute_index(a_i_end,i_end)) return false;
  if(i_beg>i_end) return false;

  histogram_data& hdata = a_histo.data();
  if(m_axes[1].bins()!=a_histo.m_axes[0].bins()) return false;
  if(m_axes[2].bins()!=a_histo.m_axes[1].bins()) return false;

  uint32 aibin,ajbin,ibin,aoffset,offset;     

  uint32 ayoffset = hdata.m_axes[1].m_offset;
  uint32 yoffset = m_axes[1].m_offset;
  uint32 zoffset = m_axes[2].m_offset;

  uint32 axbins = hdata.m_axes[0].bins()+2;
  uint32 aybins = hdata.m_axes[1].bins()+2;
  // Fill also the outflow.
  for(aibin=0;aibin<axbins;aibin++) {
    for(ajbin=0;ajbin<aybins;ajbin++) {
      //offset2d = ibin + jbin * m_axes[1].m_offset
      aoffset = aibin + ajbin * ayoffset;
      for(ibin=i_beg;ibin<=i_end;ibin++) {
        //offset3d = ibin + jbin * m_axes[1].m_offset + kbin * m_axes[2].m_offset;
        // hdata booked with y-z then :
        offset = ibin + aibin * yoffset + ajbin * zoffset;

        // Bin :
        hdata.m_bin_entries[aoffset] += m_bin_entries[offset];
        hdata.m_bin_Sw[aoffset] += m_bin_Sw[offset];
        hdata.m_bin_Sw2[aoffset] += m_bin_Sw2[offset];
        hdata.bin_Sxw(aoffset,0) += bin_Sxw(offset,1);
        hdata.bin_Sxw(aoffset,1) += bin_Sxw(offset,2);
        hdata.bin_Sx2w(aoffset,0) += bin_Sx2w(offset,1);
        hdata.bin_Sx2w(aoffset,1) += bin_Sx2w(offset,2);
        //FIXME hdata.m_bin_Svw[aoffset] += m_bin_Svw[offset];
      }
    }
  }

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram::fill_slice_xz(
 histogram& a_histo
,int a_j_beg
,int a_j_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(m_dimension!=3) return false;
  uint32 j_beg;
  if(!m_axes[1].in_range_to_absolute_index(a_j_beg,j_beg)) return false;
  uint32 j_end;
  if(!m_axes[1].in_range_to_absolute_index(a_j_end,j_end)) return false;
  if(j_beg>j_end) return false;

  histogram_data& hdata = a_histo.data();
  if(m_axes[0].bins()!=a_histo.m_axes[0].bins()) return false;
  if(m_axes[2].bins()!=a_histo.m_axes[1].bins()) return false;

  uint32 aibin,ajbin,jbin,aoffset,offset;     

  uint32 ayoffset = hdata.m_axes[1].m_offset;
  uint32 yoffset = m_axes[1].m_offset;
  uint32 zoffset = m_axes[2].m_offset;

  uint32 axbins = hdata.m_axes[0].bins()+2;
  uint32 aybins = hdata.m_axes[1].bins()+2;
  // Fill also the outflow.
  for(aibin=0;aibin<axbins;aibin++) {
    for(ajbin=0;ajbin<aybins;ajbin++) {
      //offset2d = ibin + jbin * m_axes[1].m_offset
      aoffset = aibin + ajbin * ayoffset;
      for(jbin=j_beg;jbin<=j_end;jbin++) {
        //offset3d = ibin + jbin * m_axes[1].m_offset + kbin * m_axes[2].m_offset;
        // hdata booked with x-z then :
        offset = aibin + jbin * yoffset + ajbin * zoffset;

        // Bin :
        hdata.m_bin_entries[aoffset] += m_bin_entries[offset];
        hdata.m_bin_Sw[aoffset] += m_bin_Sw[offset];
        hdata.m_bin_Sw2[aoffset] += m_bin_Sw2[offset];
        hdata.bin_Sxw(aoffset,0) += bin_Sxw(offset,0);
        hdata.bin_Sxw(aoffset,1) += bin_Sxw(offset,2);
        hdata.bin_Sx2w(aoffset,0) += bin_Sx2w(offset,0);
        hdata.bin_Sx2w(aoffset,1) += bin_Sx2w(offset,2);
        //FIXME hdata.m_bin_Svw[aoffset] += m_bin_Svw[offset];
      }
    }
  }

  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "profile.cxx"
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "BASE_1D_SOURCE"
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d::histogram_1d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  configure(1,ns,mins,maxs,false); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d::histogram_1d(
 const std::string& a_string
,const std::vector<double>& a_edges
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(1);
  edges[0] = a_edges;
  configure(1,edges,false); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d::histogram_1d(
 const histogram_1d& a_from
)
:histogram(a_from)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d::~histogram_1d(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram_1d::fill(
 double a_x
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //m_doubles[0] = a_x;
  //return fill_bin(m_doubles,a_weight);

  if(m_dimension<=0) return false;

  uint32 ibin;
  if(!m_axes[0].coord_to_absolute_index(a_x,ibin)) return false;

  uint32 offset = ibin;

  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw = a_x * a_weight;
  double x2w = a_x * xw;
  bin_Sxw(offset,0) += xw;
  bin_Sx2w(offset,0) += x2w;

/*
  bool inRange = true;
  if(ibin==0) inRange = false;
  else if(ibin==(m_axes[0].m_number_of_bins+1)) inRange = false;

  if(inRange) {
    m_in_range_entries++;
    m_in_range_Sw += a_weight;

    m_in_range_Sxw += xw;
    m_in_range_Sx2w += x2w;
  }
*/
 
  return true;
}
BASE_1D_SOURCE(exa::util::histogram_1d)
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_1d::profile_1d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  configure(1,ns,mins,maxs,true); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_1d::profile_1d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
,double a_min_v
,double a_max_v
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  configure(1,ns,mins,maxs,true); //FIXME : ret false.

  m_cut_v = true;
  m_min_v = a_min_v;
  m_max_v = a_max_v;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_1d::profile_1d(
 const std::string& a_string
,const std::vector<double>& a_edges
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(1);
  edges[0] = a_edges;
  configure(1,edges,true); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_1d::profile_1d(
 const std::string& a_string
,const std::vector<double>& a_edges
,double a_min_v
,double a_max_v
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(1);
  edges[0] = a_edges;
  configure(1,edges,true); //FIXME : ret false.

  m_cut_v = true;
  m_min_v = a_min_v;
  m_max_v = a_max_v;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_1d::profile_1d(
 const profile_1d& a_from
)
:profile(a_from)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_1d::~profile_1d(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile_1d::fill(
 double a_x
,double a_value
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //m_doubles[0] = a_x;
  //return fill_bin(m_doubles,a_value,a_weight);

  if(!m_dimension) return false;
  if(m_cut_v) {
    if( (a_value<m_min_v) || (a_value>=m_max_v) ) {
      return true;
    }
  }

  uint32 ibin;
  if(!m_axes[0].coord_to_absolute_index(a_x,ibin)) return false;

  uint32 offset = ibin;

  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw = a_x * a_weight;
  double x2w = a_x * xw;
  bin_Sxw(offset,0) += xw;
  bin_Sx2w(offset,0) += x2w;

  // Profile part :
  double vw = a_value * a_weight;
  m_bin_Svw[offset] += vw;
  m_bin_Sv2w[offset] += a_value * vw;

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile_1d::bin_rms_value(
 int a_i
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  profile_1d& self = const_cast<profile_1d&>(*this);
  self.m_ints[0] = a_i;
  return histogram::bin_rms_value(m_ints,a_value);
}
BASE_1D_SOURCE(exa::util::profile_1d)
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "BASE_2D_SOURCE"
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d::histogram_2d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
,uint32 a_y_number
,double a_y_min
,double a_y_max
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  ns.push_back(a_y_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  mins.push_back(a_y_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  maxs.push_back(a_y_max);
  configure(2,ns,mins,maxs,false); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d::histogram_2d(
 const std::string& a_string
,const std::vector<double>& a_edges_x
,const std::vector<double>& a_edges_y
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(2);
  edges[0] = a_edges_x;
  edges[1] = a_edges_y;
  configure(2,edges,false); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d::histogram_2d(
 const histogram_2d& a_from
)
:histogram(a_from)
,m_in_range_entries(a_from.m_in_range_entries)
,m_in_range_Sw(a_from.m_in_range_Sw)
,m_in_range_Sxw(a_from.m_in_range_Sxw)
,m_in_range_Syw(a_from.m_in_range_Syw)
,m_in_range_Sx2w(a_from.m_in_range_Sx2w)
,m_in_range_Sy2w(a_from.m_in_range_Sy2w)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d::~histogram_2d(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram_2d::fill(
 double a_x
,double a_y
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //m_doubles[0] = a_x;
  //m_doubles[1] = a_y;
  //return fill_bin(m_doubles,a_weight);

  if(m_dimension<=0) return false;

  uint32 ibin;
  if(!m_axes[0].coord_to_absolute_index(a_x,ibin)) return false;
  uint32 jbin;
  if(!m_axes[1].coord_to_absolute_index(a_y,jbin)) return false;

  uint32 offset = ibin + jbin * m_axes[1].m_offset;

  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw = a_x * a_weight;
  double x2w = a_x * xw;
  bin_Sxw(offset,0) += xw;
  bin_Sx2w(offset,0) += x2w;

  double yw = a_y * a_weight;
  double y2w = a_y * yw;
  bin_Sxw(offset,1) += yw;
  bin_Sx2w(offset,1) += y2w;

  bool inRange = true;
  if(ibin==0) inRange = false;
  else if(ibin==(m_axes[0].m_number_of_bins+1)) inRange = false;

  if(jbin==0) inRange = false;
  else if(jbin==(m_axes[1].m_number_of_bins+1)) inRange = false;

  if(inRange) {
    m_in_range_entries++;
    m_in_range_Sw += a_weight;

    m_in_range_Sxw += xw;
    m_in_range_Sx2w += x2w;

    m_in_range_Syw += yw;
    m_in_range_Sy2w += y2w;
  }
 
  return true;
}
BASE_2D_SOURCE(exa::util::histogram_2d)
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d* exa::util::histogram_2d::slice_x(
 int a_j_beg
,int a_j_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  exa::util::histogram_1d* slice_x = new histogram_1d("SliceX",
                                   x_axis().bins(),
                                   x_axis().lower_edge(),
                                   x_axis().upper_edge());
  if(!fill_slice_x(*slice_x,a_j_beg,a_j_end)) {
    delete slice_x;
    return 0;
  }
  return slice_x;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d* exa::util::histogram_2d::slice_y(
 int a_i_beg
,int a_i_end
) const
//////////////////////////////////////////////////////////////////////////////
// Should be implemented by a managed histo class.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  exa::util::histogram_1d* slice_y = new histogram_1d("SliceY",
                                   y_axis().bins(),
                                   y_axis().lower_edge(),
                                   y_axis().upper_edge());
  if(!fill_slice_y(*slice_y,a_i_beg,a_i_end)) {
    delete slice_y;
    return 0;
  }
  return slice_y;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d* exa::util::histogram_2d::projection_x(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return slice_x(axis::underflow_bin,axis::overflow_bin);
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_1d* exa::util::histogram_2d::projection_y(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return slice_y(axis::underflow_bin,axis::overflow_bin);
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_2d::profile_2d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
,uint32 a_y_number
,double a_y_min
,double a_y_max
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  ns.push_back(a_y_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  mins.push_back(a_y_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  maxs.push_back(a_y_max);
  configure(2,ns,mins,maxs,true); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_2d::profile_2d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
,uint32 a_y_number
,double a_y_min
,double a_y_max
,double a_min_v
,double a_max_v
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  ns.push_back(a_y_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  mins.push_back(a_y_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  maxs.push_back(a_y_max);
  configure(2,ns,mins,maxs,true); //FIXME : ret false.

  m_cut_v = true;
  m_min_v = a_min_v;
  m_max_v = a_max_v;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_2d::profile_2d(
 const std::string& a_string
,const std::vector<double>& a_edges_x
,const std::vector<double>& a_edges_y
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(2);
  edges[0] = a_edges_x;
  edges[1] = a_edges_y;
  configure(2,edges,true); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_2d::profile_2d(
 const std::string& a_string
,const std::vector<double>& a_edges_x
,const std::vector<double>& a_edges_y
,double a_min_v
,double a_max_v
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(2);
  edges[0] = a_edges_x;
  edges[1] = a_edges_y;
  configure(2,edges,true); //FIXME : ret false.

  m_cut_v = true;
  m_min_v = a_min_v;
  m_max_v = a_max_v;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_2d::profile_2d(
 const profile_2d& a_from
)
:profile(a_from)
,m_in_range_entries(a_from.m_in_range_entries)
,m_in_range_Sw(a_from.m_in_range_Sw)
,m_in_range_Sxw(a_from.m_in_range_Sxw)
,m_in_range_Syw(a_from.m_in_range_Syw)
,m_in_range_Sx2w(a_from.m_in_range_Sx2w)
,m_in_range_Sy2w(a_from.m_in_range_Sy2w)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile_2d::~profile_2d(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile_2d::fill(
 double a_x
,double a_y
,double a_value
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //m_doubles[0] = a_x;
  //m_doubles[1] = a_y;
  //return fill_bin(m_doubles,a_value,a_weight);

  if(m_cut_v) {
    if( (a_value<m_min_v) || (a_value>=m_max_v) ) {
      return true;
    }
  }

  if(m_dimension<=0) return false;

  uint32 ibin;
  if(!m_axes[0].coord_to_absolute_index(a_x,ibin)) return false;
  uint32 jbin;
  if(!m_axes[1].coord_to_absolute_index(a_y,jbin)) return false;

  uint32 offset = ibin + jbin * m_axes[1].m_offset;

  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw = a_x * a_weight;
  double x2w = a_x * xw;
  bin_Sxw(offset,0) += xw;
  bin_Sx2w(offset,0) += x2w;

  double yw = a_y * a_weight;
  double y2w = a_y * yw;
  bin_Sxw(offset,1) += yw;
  bin_Sx2w(offset,1) += y2w;

  bool inRange = true;
  if(ibin==0) inRange = false;
  else if(ibin==(m_axes[0].m_number_of_bins+1)) inRange = false;

  if(jbin==0) inRange = false;
  else if(jbin==(m_axes[1].m_number_of_bins+1)) inRange = false;

  if(inRange) {
    m_in_range_entries++;
    m_in_range_Sw += a_weight;

    m_in_range_Sxw += xw;
    m_in_range_Sx2w += x2w;

    m_in_range_Syw += yw;
    m_in_range_Sy2w += y2w;
  }
 
  // Profile part :
  double vw = a_value * a_weight;
  m_bin_Svw[offset] += vw;
  m_bin_Sv2w[offset] += a_value * vw;

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile_2d::bin_rms_value(
 int a_i
,int a_j
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  profile_2d& self = const_cast<profile_2d&>(*this);
  self.m_ints[0] = a_i;
  self.m_ints[1] = a_j;
  return histogram::bin_rms_value(m_ints,a_value);
}
BASE_2D_SOURCE(exa::util::profile_2d)
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "BASE_3D_SOURCE"
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_3d::histogram_3d(
 const std::string& a_string
,uint32 a_x_number
,double a_x_min
,double a_x_max
,uint32 a_y_number
,double a_y_min
,double a_y_max
,uint32 a_z_number
,double a_z_min
,double a_z_max
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Szw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
,m_in_range_Sz2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector<uint32> ns;
  ns.push_back(a_x_number);
  ns.push_back(a_y_number);
  ns.push_back(a_z_number);
  std::vector<double> mins;
  mins.push_back(a_x_min);
  mins.push_back(a_y_min);
  mins.push_back(a_z_min);
  std::vector<double> maxs;
  maxs.push_back(a_x_max);
  maxs.push_back(a_y_max);
  maxs.push_back(a_z_max);
  configure(3,ns,mins,maxs); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_3d::histogram_3d(
 const std::string& a_string
,const std::vector<double>& a_edges_x
,const std::vector<double>& a_edges_y
,const std::vector<double>& a_edges_z
)
:m_in_range_entries(0)
,m_in_range_Sw(0)
,m_in_range_Sxw(0)
,m_in_range_Syw(0)
,m_in_range_Szw(0)
,m_in_range_Sx2w(0)
,m_in_range_Sy2w(0)
,m_in_range_Sz2w(0)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  m_title = a_string;
  std::vector< std::vector<double> > edges(3);
  edges[0] = a_edges_x;
  edges[1] = a_edges_y;
  edges[2] = a_edges_z;
  configure(3,edges); //FIXME : ret false.
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_3d::histogram_3d(
 const histogram_3d& a_from
)
:histogram(a_from)
,m_in_range_entries(a_from.m_in_range_entries)
,m_in_range_Sw(a_from.m_in_range_Sw)
,m_in_range_Sxw(a_from.m_in_range_Sxw)
,m_in_range_Syw(a_from.m_in_range_Syw)
,m_in_range_Szw(a_from.m_in_range_Szw)
,m_in_range_Sx2w(a_from.m_in_range_Sx2w)
,m_in_range_Sy2w(a_from.m_in_range_Sy2w)
,m_in_range_Sz2w(a_from.m_in_range_Sz2w)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_3d::~histogram_3d(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::histogram_3d::fill(
 double a_x
,double a_y
,double a_z
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //m_doubles[0] = a_x;
  //m_doubles[1] = a_y;
  //m_doubles[2] = a_z;
  //return fill_bin(m_doubles,a_weight);

  if(m_dimension<=0) return false;

  uint32 ibin;
  if(!m_axes[0].coord_to_absolute_index(a_x,ibin)) return false;
  uint32 jbin;
  if(!m_axes[1].coord_to_absolute_index(a_y,jbin)) return false;
  uint32 kbin;
  if(!m_axes[2].coord_to_absolute_index(a_z,kbin)) return false;

  uint32 offset = ibin + jbin * m_axes[1].m_offset + kbin * m_axes[2].m_offset;

  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw = a_x * a_weight;
  double x2w = a_x * xw;
  bin_Sxw(offset,0) += xw;
  bin_Sx2w(offset,0) += x2w;

  double yw = a_y * a_weight;
  double y2w = a_y * yw;
  bin_Sxw(offset,1) += yw;
  bin_Sx2w(offset,1) += y2w;

  double zw = a_z * a_weight;
  double z2w = a_z * zw;
  bin_Sxw(offset,2) += zw;
  bin_Sx2w(offset,2) += z2w;

  bool inRange = true;
  if(ibin==0) inRange = false;
  else if(ibin==(m_axes[0].m_number_of_bins+1)) inRange = false;

  if(jbin==0) inRange = false;
  else if(jbin==(m_axes[1].m_number_of_bins+1)) inRange = false;

  if(kbin==0) inRange = false;
  else if(kbin==(m_axes[2].m_number_of_bins+1)) inRange = false;

  if(inRange) {
    m_in_range_entries++;
    m_in_range_Sw += a_weight;

    m_in_range_Sxw += xw;
    m_in_range_Sx2w += x2w;

    m_in_range_Syw += yw;
    m_in_range_Sy2w += y2w;

    m_in_range_Szw += zw;
    m_in_range_Sz2w += z2w;
  }
 
  return true;
}
BASE_3D_SOURCE(exa::util::histogram_3d)
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d* exa::util::histogram_3d::slice_xy(
 int a_k_beg
,int a_k_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  exa::util::histogram_2d* slice_xy = new histogram_2d("SliceXY",
                                              x_axis().bins(),
                                              x_axis().lower_edge(),
                                              x_axis().upper_edge(),
                                              y_axis().bins(),
                                              y_axis().lower_edge(),
                                              y_axis().upper_edge());
  if(!fill_slice_xy(*slice_xy,a_k_beg,a_k_end)) {
    delete slice_xy;
    return 0;
  }
  return slice_xy;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d* exa::util::histogram_3d::slice_yz(
 int a_i_beg
,int a_i_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  exa::util::histogram_2d* slice_yz = new histogram_2d("SliceYZ",
                                              y_axis().bins(),
                                              y_axis().lower_edge(),
                                              y_axis().upper_edge(),
                                              z_axis().bins(),
                                              z_axis().lower_edge(),
                                              z_axis().upper_edge());
  if(!fill_slice_yz(*slice_yz,a_i_beg,a_i_end)) {
    delete slice_yz;
    return 0;
  }
  return slice_yz;
}
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_2d* exa::util::histogram_3d::slice_xz(
 int a_j_beg
,int a_j_end
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  exa::util::histogram_2d* slice_xz = new histogram_2d("SliceXZ",
                                              x_axis().bins(),
                                              x_axis().lower_edge(),
                                              x_axis().upper_edge(),
                                              z_axis().bins(),
                                              z_axis().lower_edge(),
                                              z_axis().upper_edge());
  if(!fill_slice_xz(*slice_xz,a_j_beg,a_j_end)) {
    delete slice_xz;
    return 0;
  }
  return slice_xz;
}
