//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
exa::util::profile::profile(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  //printf("debug : profile %lu\n",this);
}
/*
//////////////////////////////////////////////////////////////////////////////
exa::util::profile::profile(
 uint32 a_dimension 
,const std::vector<uint32>& a_numbers
,const std::vector<double>& a_mins
,const std::vector<double>& a_maxs
,bool a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  configure(a_dimension,a_numbers,a_mins,a_maxs,a_profile); //FIXME : ret false
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile::profile(
 uint32 a_dimension 
,const std::vector< std::vector<double> >& a_edges
,bool a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  configure(a_dimension,a_edges,a_profile); //FIXME : ret false.
}
*/
//////////////////////////////////////////////////////////////////////////////
exa::util::profile::profile(
 const exa::util::profile& a_profile
)
: histogram(a_profile)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile::profile(
 const exa::util::histogram_data& a_data
)
: histogram(a_data)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile::~profile(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
}
//////////////////////////////////////////////////////////////////////////////
exa::util::profile& exa::util::profile::operator=(
 const profile& a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  copy(a_profile);
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::profile::allocate(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  histogram::allocate();

  m_bin_Svw.resize(m_bin_number,0);
  m_bin_Sv2w.resize(m_bin_number,0);
}
/*
//////////////////////////////////////////////////////////////////////////////
exa::util::histogram_data& exa::util::profile::data(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return *this;
}
//////////////////////////////////////////////////////////////////////////////
const exa::util::histogram_data& exa::util::profile::data(
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  return *this;
}
*/
//////////////////////////////////////////////////////////////////////////////
void exa::util::profile::base_reset(
)
//////////////////////////////////////////////////////////////////////////////
// Reset content (different of clear that deallocate all internal things).
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  histogram::base_reset();

  // Profile :
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_Svw[ibin] = 0;
    m_bin_Sv2w[ibin] = 0;
  }

  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
void exa::util::profile::copy(
 const exa::util::profile& a_from
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  histogram::copy(a_from);

  m_is_profile = a_from.m_is_profile; //FIXME
  m_bin_Svw = a_from.m_bin_Svw;
  m_bin_Sv2w = a_from.m_bin_Sv2w;
  m_cut_v = a_from.m_cut_v;
  m_min_v = a_from.m_min_v;
  m_max_v = a_from.m_max_v;
  
  update_fast_getters();
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::add(
 const profile& a_profile
)
//////////////////////////////////////////////////////////////////////////////
// The only operation that makes sense.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!histogram::add(a_profile)) return false;
  
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_Svw[ibin] += a_profile.m_bin_Svw[ibin];      
    m_bin_Sv2w[ibin] += a_profile.m_bin_Sv2w[ibin];      
  }

  update_fast_getters();

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::subtract(
 const profile& a_profile
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!histogram::subtract(a_profile)) return false;

  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_Svw[ibin] -= a_profile.m_bin_Svw[ibin];      
    m_bin_Sv2w[ibin] -= a_profile.m_bin_Sv2w[ibin];      
  }

  update_fast_getters();

  return true;
}
/*
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::multiply(
 const profile& a_profile
)
//////////////////////////////////////////////////////////////////////////////
// We build a new histo with one entry in each bean of weight : 
//   this.w * a_profile.w
// The current histo is overriden with this new histo.
// The m_bin_Sw2 computation is consistent with FreeHEP and ROOT.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!is_compatible(a_profile)) return false;
  if(m_dimension<=0) return false;

  profile h(*this);
  h.base_reset();

  std::vector<int> is(m_dimension);
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    indices(ibin,is);
    double swa = m_bin_Sw[ibin];
    double swb = a_profile.m_bin_Sw[ibin];
    double sw2a = m_bin_Sw2[ibin];
    double sw2b = a_profile.m_bin_Sw2[ibin];
    double sw = swa * swb;
    h.m_bin_entries[ibin] = 1;
    h.m_bin_Sw[ibin] = sw;
    h.m_bin_Sw2[ibin] = sw2a * swb * swb + sw2b * swa * swa;
    for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
      double x = m_axes[iaxis].bin_center(is[iaxis]);
      h.bin_Sxw(ibin,iaxis) = x * sw;
      h.bin_Sx2w(ibin,iaxis) = x * x * sw;
    }
  }

  copy(h);

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::divide(
 const profile& a_profile
)
//////////////////////////////////////////////////////////////////////////////
// We build a new histo with one entry in each bean of weight : 
//   this.w / a_profile.w
// The current histo is overriden with this new histo.
// The m_bin_Sw2 computation is consistent with FreeHEP and ROOT.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!is_compatible(a_profile)) return false;
  if(m_dimension<=0) return false;

  profile h(*this);
  h.base_reset();

  std::vector<int> is(m_dimension);
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    indices(ibin,is);
    double swa = m_bin_Sw[ibin];
    double swb = a_profile.m_bin_Sw[ibin];
    double sw2a = m_bin_Sw2[ibin];
    double sw2b = a_profile.m_bin_Sw2[ibin];
    h.m_bin_entries[ibin] = 1;
    if(swb!=0) {
      double sw = swa / swb;
      h.m_bin_Sw[ibin] = sw;
      double swb2 = swb * swb;
      h.m_bin_Sw2[ibin] = sw2a / swb2 + sw2b * swa * swa /(swb2*swb2);
      for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
        double x = m_axes[iaxis].bin_center(is[iaxis]);
        h.bin_Sxw(ibin,iaxis) = x * sw;
        h.bin_Sx2w(ibin,iaxis) = x * x * sw;
      }
    }
  }

  copy(h);

  return true;
}
*/
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::multiply(
 double a_factor
) 
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!histogram::multiply(a_factor)) return false;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    m_bin_Svw[ibin] *= a_factor;
  }
  update_fast_getters();
  return true;
}
//////////////////////////////////////////////////////////////////////////////
//////// Bins ///////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::fill_bin(
 const std::vector<double>& a_xs
,double a_value
,double a_weight
)
//////////////////////////////////////////////////////////////////////////////
// For profile.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(!m_dimension) return false;
  if(m_cut_v) {
    if( (a_value<m_min_v) || (a_value>=m_max_v) ) {
      return true;
    }
  }

  //FIXME histogram::fill(offset,a_xs,a_weight)

  uint32 offset;
  if(!histogram::offset(a_xs,offset)) return false;

  // Same as upper :
  m_bin_entries[offset]++;
  m_bin_Sw[offset] += a_weight;
  m_bin_Sw2[offset] += a_weight * a_weight;

  double xw;
  for(uint32 iaxis=0;iaxis<m_dimension;iaxis++) {
    xw = a_xs[iaxis] * a_weight;
    bin_Sxw(offset,iaxis) += xw;
    bin_Sx2w(offset,iaxis) += a_xs[iaxis] * xw;
  }

  // Profile part :
  double vw = a_value * a_weight;
  m_bin_Svw[offset] += vw;
  m_bin_Sv2w[offset] += a_value * vw;

  //binSxvw(offset,iaxis) += a_xs[iaxis] * a_value * a_weight;
  //binSx2vw(offset,iaxis) += a_xs[iaxis] * a_xs[iaxis] * a_value * a_weight;

  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::bin_height(
 const std::vector<int>& a_is
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  //FIXME : ret false.
  a_value = (m_bin_Sw[offset] ? (m_bin_Svw[offset]/m_bin_Sw[offset]):0);
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::bin_error(
 const std::vector<int>& a_is
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  //FIXME Is it correct ?
  /* TProfile::GetBinError with kERRORMEAN mode does :
      Stat_t cont = fArray[bin];              //exa::util Svw (see TProfile::Fill)
      Stat_t sum  = m_bin_entries.fArray[bin];  //exa::util Sw
      Stat_t err2 = fSumw2.fArray[bin];       //exa::util Sv2w
      if (sum == 0) return 0;
      Stat_t eprim;
      Stat_t contsum = cont/sum;
      Stat_t eprim2  = TMath::Abs(err2/sum - contsum*contsum);
      eprim          = TMath::Sqrt(eprim2);
      ... ??? 
      if (fErrorMode == kERRORMEAN) return eprim/TMath::Sqrt(sum);
    */
  double sw = m_bin_Sw[offset];      //ROOT sum
  if(sw==0) {a_value=0;return false;} //FIXME : ok ?
  double svw = m_bin_Svw[offset];    //ROOT cont
  double sv2w = m_bin_Sv2w[offset];  //ROOT err2
  double mean = (svw / sw);        //ROOT contsum
  double rms = ::sqrt(::fabs((sv2w/sw) - mean * mean)); //ROOT eprim
  // rms = bin_rms_value.
  a_value = rms/::sqrt(sw); //ROOT kERRORMEAN mode returned value
  return true;
}
//////////////////////////////////////////////////////////////////////////////
bool exa::util::profile::bin_rms_value(
 const std::vector<int>& a_is
,double& a_value
) const
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  uint32 offset;
  if(!histogram::offset(a_is,offset)) return false;
  double sw = m_bin_Sw[offset];
  if(sw==0) {a_value=0;return false;} //FIXME : ok ?
  double svw = m_bin_Svw[offset];
  double sv2w = m_bin_Sv2w[offset];
  double mean = (svw / sw);
  a_value = ::sqrt(::fabs((sv2w / sw) - mean * mean));
  return true;
}
//////////////////////////////////////////////////////////////////////////////
/////// Axes /////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
double exa::util::profile::ith_axis_bin_height(
 uint32 a_axis
,int a_index
) const
//////////////////////////////////////////////////////////////////////////////
//WARNING : slow.
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  if(a_axis>=m_dimension) return 0;
  double sw = 0;
  std::vector<int> is(m_dimension);
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    indices(ibin,is);
    if(is[a_axis]==a_index) {
      sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
    }
  }
  return sw;
}
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void exa::util::profile::clear(
)
//////////////////////////////////////////////////////////////////////////////
//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!//
{
  histogram::clear();

  m_is_profile = false;
  m_bin_Svw.clear();
  m_bin_Sv2w.clear();
  m_cut_v = false;
  m_min_v = 0;
  m_max_v = 0;
}
//HISTOGRAM_SOURCE
double exa::util::profile::sum_bin_heights() const {
  double sw = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
    }
  }
  return sw;
}
double exa::util::profile::sum_all_bin_heights() const {
  double sw = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
  }
  return sw;
}
double exa::util::profile::sum_extra_bin_heights() const {
  double sw = 0;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(is_out(ibin)) {
      sw += (m_bin_Sw[ibin] ? (m_bin_Svw[ibin]/m_bin_Sw[ibin]):0); //FIXME
    }
  }
  return sw;
}
double exa::util::profile::min_bin_height() const {
  double value = 0;
  bool first = true;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      double vbin;
      /*if(m_bin_Sw[ibin]==0) return false; FIXME */
      vbin = (m_bin_Sw[ibin]?m_bin_Svw[ibin]/m_bin_Sw[ibin]:0);
      if(first) {
        first = false;
        value = vbin;
      } else {
        if(vbin<=value) value = vbin;
      }
    }
  }
  return value;
}
double exa::util::profile::max_bin_height() const {
  double value = 0;
  bool first = true;
  for(uint32 ibin=0;ibin<m_bin_number;ibin++) {
    if(!is_out(ibin)) {
      double vbin;
      //FIXME : return false
      vbin = (m_bin_Sw[ibin]?m_bin_Svw[ibin]/m_bin_Sw[ibin]:0);
      if(first) {
        first = false;
        value = vbin;
      } else {
        if(vbin>=value) value = vbin;
      }
    }
  }
  return value;
}
