#ifndef exa_util_Schema_h
#define exa_util_Schema_h

// inheritance :
#include <steve/core/base_schema.h>

#include <steve/schema.h>

namespace exa {
namespace schema {

class axis : public steve::core::base_schema {
  schema_header(axis)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(m_edges)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  // axis not array fields :
  schema_data_header(m_offset)
  schema_data_header(m_number_of_bins)
  schema_data_header(m_minimum_value)
  schema_data_header(m_maximum_value)
  schema_data_header(m_fixed)
  schema_data_header(m_bin_width)
  // axis std::vector fields :
  schema_data_header(m_edges)
};

class histogram : public steve::core::base_schema {
  schema_header(histogram)
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  // histogram_data std::vector fields :
  schema_nos_header(m_bin_entries)
  schema_nos_header(m_bin_Sw)
  schema_nos_header(m_bin_Sw2)
  schema_nos_header(m_bin_Sxw)
  schema_nos_header(m_bin_Sx2w)
  schema_nos_header(m_bin_Svw)
  schema_nos_header(m_bin_Sv2w)
  schema_nos_header(m_doubles)
  schema_nos_header(m_ints)
  // histogram_data array fields :
  schema_nos_header(m_axes)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  // histogram_data not array fields :
  schema_data_header(m_title)
  schema_data_header(m_dimension)
  schema_data_header(m_bin_number)
  schema_data_header(m_is_profile)
  schema_data_header(m_cut_v)
  schema_data_header(m_min_v)
  schema_data_header(m_max_v)
  // histogram_data std::vector fields :
  schema_data_header(m_bin_entries)
  schema_data_header(m_bin_Sw)
  schema_data_header(m_bin_Sw2)
  schema_data_header(m_bin_Sxw)
  schema_data_header(m_bin_Sx2w)
  schema_data_header(m_bin_Svw)
  schema_data_header(m_bin_Sv2w)
  schema_data_header(m_doubles)
  schema_data_header(m_ints)
public:
  axis* schema_m_axes() const;
private:
  axis* m_schema_m_axes;
};

}}

#endif
