#ifndef exa_util_helper_h
#define exa_util_helper_h

#include <util/schemas.h>

#include <steve/helper.h>

#include <util/histogram.h> 

#define schema_store(a_type,a_field)\
  if(!steve::store<a_type>(a_store,\
                           schema_data_get(a_field),\
                           a_data.a_field)) return false;

#define schema_store_std_vector(a_type,a_field)\
  if(!steve::store<a_type>(a_store,\
                           schema_offsets_get(a_field),\
                           schema_numbers_get(a_field),\
                           schema_data_get(a_field),\
                           a_data.a_field)) return false;

#define schema_retrieve(a_type,a_field)\
  if(!steve::retrieve<a_type>(a_store,\
                              schema_data_get(a_field),\
                              a_event,a_is,a_data.a_field)) return false;

#define schema_retrieve_std_vector(a_type,a_field)\
  if(!steve::retrieve<a_type>(a_store,\
                              schema_numbers_get(a_field),\
                              schema_data_get(a_field),\
                              a_event,a_is,a_data.a_field)) return false;

namespace exa {
namespace util {

inline bool store(steve::interface::store& a_store,
                  steve::interface::schema& a_schema,
                  const ::exa::util::axis& a_data) { 
  schema_get(::exa::schema::axis)
  //FIXME : store version.
  // axis not array fields :
  schema_store(uint32,m_offset)
  schema_store(uint32,m_number_of_bins)
  schema_store(double,m_minimum_value)
  schema_store(double,m_maximum_value)
  schema_store(bool,m_fixed)
  schema_store(double,m_bin_width)
  // axis std::vector fields :
  schema_store_std_vector(double,m_edges)
  return true;
}
inline bool retrieve(steve::interface::store& a_store,
                     steve::interface::schema& a_schema,
                     steve::uint32 a_event,
                     const steve::path_t& a_is,
                     ::exa::util::axis& a_data) { 
  schema_get(::exa::schema::axis)
  //FIXME : retrieve version.
  // axis not array fields :
  schema_retrieve(uint32,m_offset)
  schema_retrieve(uint32,m_number_of_bins)
  schema_retrieve(double,m_minimum_value)
  schema_retrieve(double,m_maximum_value)
  schema_retrieve(bool,m_fixed)
  schema_retrieve(double,m_bin_width)
  // axis std::vector fields :
  schema_retrieve_std_vector(double,m_edges)
  return true;
}

inline bool store(steve::interface::store& a_store,
                  steve::interface::schema& a_schema,
                  const ::exa::util::histogram_data& a_data) { 
  schema_get(::exa::schema::histogram)

  //FIXME : store version.

  // histogram_data not array fields :
  schema_store(std::string,m_title)
  schema_store(uint32,m_dimension)
  schema_store(uint32,m_bin_number)
  schema_store(bool,m_is_profile)
  schema_store(bool,m_cut_v)
  schema_store(double,m_min_v)
  schema_store(double,m_max_v)
  // histogram_data std::vector fields :
  schema_store_std_vector(uint32,m_bin_entries)
  schema_store_std_vector(double,m_bin_Sw)
  schema_store_std_vector(double,m_bin_Sw2)
  schema_store_std_vector(double,m_bin_Sxw)
  schema_store_std_vector(double,m_bin_Sx2w)
  schema_store_std_vector(double,m_bin_Svw)
  schema_store_std_vector(double,m_bin_Sv2w)
  schema_store_std_vector(double,m_doubles)
  schema_store_std_vector(int,m_ints)

  if(!steve::store< ::exa::util::axis >(a_store,
                                  *(schema->schema_m_axes()),
                                  schema_offsets_get(m_axes),
                                  schema_numbers_get(m_axes),
                                  store,
                                  a_data.m_axes)) return false;

  return true;
}
inline bool retrieve(steve::interface::store& a_store,
                     steve::interface::schema& a_schema,
                     steve::uint32 a_event,
                     const steve::path_t& a_is,
                     ::exa::util::histogram_data& a_data) { 
  schema_get(::exa::schema::histogram)

  //FIXME : retrieve version.

  // histogram_data not array fields :
  schema_retrieve(std::string,m_title)
  schema_retrieve(uint32,m_dimension)
  schema_retrieve(uint32,m_bin_number)
  schema_retrieve(bool,m_is_profile)
  schema_retrieve(bool,m_cut_v)
  schema_retrieve(double,m_min_v)
  schema_retrieve(double,m_max_v)
  // histogram_data std::vector fields :
  schema_retrieve_std_vector(uint32,m_bin_entries)
  schema_retrieve_std_vector(double,m_bin_Sw)
  schema_retrieve_std_vector(double,m_bin_Sw2)
  schema_retrieve_std_vector(double,m_bin_Sxw)
  schema_retrieve_std_vector(double,m_bin_Sx2w)
  schema_retrieve_std_vector(double,m_bin_Svw)
  schema_retrieve_std_vector(double,m_bin_Sv2w)
  schema_retrieve_std_vector(double,m_doubles)
  schema_retrieve_std_vector(int,m_ints)

  if(!steve::retrieve< ::exa::util::axis >(a_store,
                                     *(schema->schema_m_axes()),
                                     schema_numbers_get(m_axes),
                                     retrieve,
                                     a_event,a_is,
                                     a_data.m_axes)) return false;

  return true;
}

}}

#endif
