#ifndef exa_util_stream_h
#define exa_util_stream_h

#include <util/histogram.h> 

#include <steve/core/streamer_T.h> 

//#define AXIS_VERSION      1
//#define HISTOGRAM_VERSION 1

namespace exa {
namespace util {

inline bool axis_out(steve::interface::streamer& a_streamer,
                     const ::exa::util::axis& a_data) { 
  //steve::uint16 version = AXIS_VERSION;
  //if(!a_streamer.write(version)) return false;

  // axis not array fields :
  if(!a_streamer.write(a_data.m_offset)) return false;
  if(!a_streamer.write(a_data.m_number_of_bins)) return false;
  if(!a_streamer.write(a_data.m_minimum_value)) return false;
  if(!a_streamer.write(a_data.m_maximum_value)) return false;
  if(!a_streamer.write(a_data.m_fixed)) return false;
  if(!a_streamer.write(a_data.m_bin_width)) return false;
  // axis std::vector fields :
  if(!steve::stream::out<double>(a_streamer,a_data.m_edges)) return false;
  return true;
}
inline bool axis_in(steve::interface::streamer& a_streamer,
                        ::exa::util::axis& a_data) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=AXIS_VERSION) return false;

  // axis not array fields :
  if(!a_streamer.read(a_data.m_offset)) return false;
  if(!a_streamer.read(a_data.m_number_of_bins)) return false;
  if(!a_streamer.read(a_data.m_minimum_value)) return false;
  if(!a_streamer.read(a_data.m_maximum_value)) return false;
  if(!a_streamer.read(a_data.m_fixed)) return false;
  if(!a_streamer.read(a_data.m_bin_width)) return false;
  // axis std::vector fields :
  if(!steve::stream::in<double>(a_streamer,a_data.m_edges)) return false;
  return true;
}

inline bool out(steve::interface::streamer& a_streamer,
                const ::exa::util::histogram_data& a_data) { 
  //steve::uint16 version = HISTOGRAM_VERSION;
  //if(!a_streamer.write(version)) return false;

  // histogram_data not array fields :
  if(!a_streamer.write(a_data.m_title)) return false;
  if(!a_streamer.write(a_data.m_dimension)) return false;
  if(!a_streamer.write(a_data.m_bin_number)) return false;
  if(!a_streamer.write(a_data.m_is_profile)) return false;
  if(!a_streamer.write(a_data.m_cut_v)) return false;
  if(!a_streamer.write(a_data.m_min_v)) return false;
  if(!a_streamer.write(a_data.m_max_v)) return false;
  // histogram_data std::vector fields :
  if(!steve::stream::out<uint32>(a_streamer,a_data.m_bin_entries)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_bin_Sw)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_bin_Sw2)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_bin_Sxw)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_bin_Sx2w)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_bin_Svw)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_bin_Sv2w)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.m_doubles)) return false;
  if(!steve::stream::out<int>(a_streamer,a_data.m_ints)) return false;
  if(!steve::stream::out3< ::exa::util::axis >(a_streamer,axis_out,a_data.m_axes)) 
    return false;
  return true;
}
inline bool in(steve::interface::streamer& a_streamer,
               ::exa::util::histogram_data& a_data) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=HISTOGRAM_VERSION) return false;

  // histogram_data not array fields :
  if(!a_streamer.read(a_data.m_title)) return false;
  if(!a_streamer.read(a_data.m_dimension)) return false;
  if(!a_streamer.read(a_data.m_bin_number)) return false;
  if(!a_streamer.read(a_data.m_is_profile)) return false;
  if(!a_streamer.read(a_data.m_cut_v)) return false;
  if(!a_streamer.read(a_data.m_min_v)) return false;
  if(!a_streamer.read(a_data.m_max_v)) return false;
  // histogram_data std::vector fields :
  if(!steve::stream::in<uint32>(a_streamer,a_data.m_bin_entries)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_bin_Sw)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_bin_Sw2)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_bin_Sxw)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_bin_Sx2w)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_bin_Svw)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_bin_Sv2w)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.m_doubles)) return false;
  if(!steve::stream::in<int>(a_streamer,a_data.m_ints)) return false;

  if(!steve::stream::in3< ::exa::util::axis >(a_streamer,axis_in,a_data.m_axes)) 
    return false;
  return true;
}

}}

//#undef AXIS_VERSION
//#undef HISTOGRAM_VERSION

#endif
