// this :
#include <steve/ROOT/streamer.h>

#include <TBuffer.h>

steve::ROOT::streamer::streamer(
 TBuffer& a_buffer
)
:m_buffer(a_buffer)
,m_store(0)
{
}
steve::ROOT::streamer::~streamer()
{
}

//private:
steve::ROOT::streamer::streamer(const streamer& a_from)
:m_buffer(a_from.m_buffer){}
steve::ROOT::streamer& steve::ROOT::streamer::operator=(const streamer&){return *this;}


steve::interface::store& steve::ROOT::streamer::store() {return *m_store;}

//////////////////////////////////////////////////////////////////////////////
/// writers //////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#define WRITE(a_type,a_cast)\
bool steve::ROOT::streamer::write(a_type a_v) {\
  m_buffer << ((a_cast)a_v);\
  return true;\
}

WRITE(uchar,UChar_t)
WRITE(char,Char_t)
WRITE(uint16,UShort_t)
WRITE(int16,Short_t)
WRITE(uint32,UInt_t)
WRITE(int32,Int_t)
WRITE(uint64,ULong64_t)
WRITE(int64,Long64_t)
WRITE(float,Float_t)
WRITE(double,Double_t)
/*XXX
WRITE(int,Int_t)
WRITE(unsigned int,UInt_t)
*/

#undef WRITE

bool steve::ROOT::streamer::write(bool a_v) {
  m_buffer << ((uchar)(a_v?1:0));
  return true;
}
bool steve::ROOT::streamer::write(const std::string& a_v) {
  uint32 sz = a_v.size();
  m_buffer << ((UInt_t)sz);
  //FIXME : optimize :
  typedef std::string::const_iterator it_t;
  for(it_t it=a_v.begin();it!=a_v.end();++it) {
    m_buffer << ((Char_t)(*it));
  }
  return true;
}

bool steve::ROOT::streamer::write(uint32 a_size,char* a_buffer) { 
  m_buffer << ((UInt_t)a_size);
  //FIXME : optimize with memcpy.
 {for(uint32 index=0;index<a_size;index++) {
    m_buffer << ((Char_t)a_buffer[index]);
  }}
  return true;
}


//////////////////////////////////////////////////////////////////////////////
/// readers //////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#define READ(a_type,a_cast)\
bool steve::ROOT::streamer::read(a_type& a_v) {\
  a_cast v;\
  m_buffer >> v;\
  a_v = (a_type)v;\
  return true;\
}

READ(uchar,UChar_t)
READ(char,Char_t)
READ(uint16,UShort_t)
READ(int16,Short_t)
READ(uint32,UInt_t)
READ(int32,Int_t)
READ(uint64,ULong64_t)
READ(int64,Long64_t)
READ(float,Float_t)
READ(double,Double_t)
/*XXX
READ(int,Int_t)
READ(unsigned int,UInt_t)
*/

#undef READ

bool steve::ROOT::streamer::read(bool& a_v){
  UChar_t v;
  m_buffer >> v;
  a_v = (v==0?false:true);
  return true;
}

bool steve::ROOT::streamer::read(std::string& a_v) {
  UInt_t sz;
  m_buffer >> sz;
  a_v.resize(sz);
  //FIXME : optimize :
  typedef std::string::iterator it_t;
  for(it_t it=a_v.begin();it!=a_v.end();++it) {
    m_buffer >> (*it);
  }
  return true;
}

bool steve::ROOT::streamer::read(uint32& a_size,char*& a_buffer) { 
  // this method allocate a_buffer.
  read(a_size);
  if(!a_size) {a_buffer = 0;return true;}
  a_buffer = new char[a_size];
 {for(uint32 index = 0;index<a_size;index++) {
    m_buffer >> a_buffer[index];
  }}
  return true;
}
