// this :
#include <steve/core/numbers.h>

#include <steve/core/offset.h>

steve::core::numbers::numbers(
 std::ostream& a_out
,const path_os_t& a_path_os
,const std::string& a_name
,uint32 a_page_size
,uint32 a_compression
)
: core::store_data<uint32>(a_out,a_name,steve_id_uint32,a_page_size,a_compression)
,m_path_os(a_path_os)
,m_total(0)
{}
steve::core::numbers::~numbers(){}

//private:
steve::core::numbers::numbers(const numbers& a_from)
: core::store_data<uint32>(a_from)
,m_path_os(a_from.m_path_os)
,m_total(0)
{}
//private:
steve::core::numbers& steve::core::numbers::operator=(const numbers&) { return *this;}

bool steve::core::numbers::add(interface::store& a_store,uint32 a_value) {
  if(!core::store_data<uint32>::add(a_store,a_value)) return false;
  m_total += a_value;
  return true;
}
steve::uint32 steve::core::numbers::total() const {
  return m_total;
}
steve::uint32 steve::core::numbers::entries() const {
  return core::store_data<uint32>::entries();
}
steve::uint32 steve::core::numbers::number_of_pages() const {
  return core::store_data<uint32>::number_of_pages();
}
steve::uint32 steve::core::numbers::page_size() const {
  return core::store_data<uint32>::page_size();
}

//void steve::numbers::clear() { 
//  store_data<uint32>::clear();
//}

bool steve::core::numbers::find_value(
 interface::store& a_store
,uint32 a_event
,const path_t& a_is
,uint32& a_value) {
  if(!a_is.size()) {
    return value(a_store,a_event,a_value);
  } else {
    path_os_t path = m_path_os;
    path.resize(path.size()-1);
    core::offset of(path);
    uint32 off = 0;
    if(!of.find_offset(a_store,a_event,a_is,off)) {
      a_store.printer() << "steve::numbers::find_data :"
                        << " offset() failed."
                        << std::endl;
      return false;
    }
    return value(a_store,off,a_value);
  }
}

steve::interface::store_data& steve::core::numbers::store_data() {
  return *this;
}
