// this :
#include <steve/core/offset.h>

#include <steve/core/numbers.h>
#include <steve/core/offsets.h>

steve::core::offset::offset(
 const path_os_t& a_path_os
)
:m_path_os(a_path_os)
,m_path_size(0)
{
  m_path_size = m_path_os.size(); //optimization.
}

steve::core::offset::~offset(){}

//private:
steve::core::offset::offset(
 const offset& a_from
)
:m_path_os(a_from.m_path_os)
,m_path_size(a_from.m_path_size)
{}
//private:
steve::core::offset& steve::core::offset::operator=(const offset&) { return *this;}

bool steve::core::offset::find_offset(
 interface::store& a_store
,uint32 a_event
,const path_t& a_is
,uint32& a_off
) {
  if(!m_path_size) return false;
  if(a_is.size()!=m_path_size) {
    a_store.printer() << "offset.offset :"
        << " a_is / path size mismatch."
        << " (" << a_is.size() << "," << m_path_size <<")."
        << std::endl;
    return false;
  }
  a_off = 0;
  if(!m_path_os[0]->value(a_store,a_event,a_off)) return false;
  return offset2(a_store,0,a_is,a_off);
}
bool steve::core::offset::offset2(
 interface::store& a_store
,uint32 a_depth
,const path_t& a_is
,uint32& a_off
) const {

  if((a_depth+1)>=m_path_size) {
    a_off += a_is[a_depth];
    return true; //stop
  }

  if(!m_path_os[a_depth+1]->value(a_store,a_off+a_is[a_depth],a_off)) 
    return false;

  if(!offset2(a_store,a_depth+1,a_is,a_off)) return false;

  return true;
}

