// this :
#include <steve/core/retrieve_pages.h>

#include <steve/interface/page.h>
#include <steve/util/mem.h>

steve::core::retrieve_pages::retrieve_pages(
 uint32 a_page_size
)
: std::pair<int,interface::page*>(steve_not_found,0)
,m_page_size(a_page_size)
{
  steve::util::mem::increment("steve::core::retrieve_pages");
}

steve::core::retrieve_pages::~retrieve_pages() {
  delete second;
  steve::util::mem::decrement("steve::core::retrieve_pages");
}

//private:
steve::core::retrieve_pages::retrieve_pages(const retrieve_pages& a_from)
:m_page_size(0){}
//private:
steve::core::retrieve_pages& steve::core::retrieve_pages::operator=(const retrieve_pages&) { return *this;}

void* steve::core::retrieve_pages::cast_head() const {
  return (void*)static_cast<const steve::core::retrieve_pages*>(this);
}

steve::uint32 steve::core::retrieve_pages::page_size() const { 
  return m_page_size;
}

steve::uint32 steve::core::retrieve_pages::number_of_pages() const { 
  return 1;
}

bool steve::core::retrieve_pages::close() { return true;}

bool steve::core::retrieve_pages::commit() {
  // make no sense on a retrieve pages.
  return false;
}
