// this :
#include <steve/core/store_pages.h>

#include <steve/interface/page.h>
#include <steve/util/mem.h>

steve::core::store_pages::store_pages()
:m_count(0)
{
  steve::util::mem::increment("steve::core::store_pages");
}  
steve::core::store_pages::~store_pages(){
  std::list<interface::page*>::const_iterator it;
  for(it=begin();it!=end();++it) delete (*it);
  clear();
  steve::util::mem::decrement("steve::core::store_pages");
}  

//private:
steve::core::store_pages::store_pages(const store_pages&):m_count(0){}
//private:
steve::core::store_pages& steve::core::store_pages::operator=(const store_pages&) { return *this;}

void* steve::core::store_pages::cast_head() const {
  return (void*)static_cast<const steve::core::store_pages*>(this);
}

bool steve::core::store_pages::close() { return true;}

bool steve::core::store_pages::commit() {
  std::list<interface::page*>::const_iterator it;
  for(it=begin();it!=end();++it) {
    if(!(*it)->commit()) return false;
    delete (*it);
  }
  clear();
  return true;
}  

steve::uint32 steve::core::store_pages::count(
) const
{
  return m_count;
}
void steve::core::store_pages::increment_count() {
  m_count++;
}

steve::uint32 steve::core::store_pages::number_of_pages() const { 
  return size();
}
