// this :
#include <steve/memory/pages.h>

#include <steve/interface/page.h>
#include <steve/util/mem.h>

steve::memory::pages::pages(uint32 a_page_size)
:m_page_size(a_page_size)
{
  steve::util::mem::increment("steve::memory::pages");
}
steve::memory::pages::~pages() {
  std::vector<interface::page*>::iterator it;
  for(it=begin();it!=end();++it) {
    delete (*it);
  }
  clear();
  steve::util::mem::decrement("steve::memory::pages");
}

//private:
steve::memory::pages::pages(const pages& a_from)
:m_page_size(a_from.m_page_size){}
//private:
steve::memory::pages& steve::memory::pages::operator=(const pages&) { return *this;}

void* steve::memory::pages::cast_head() const {
  return (void*)static_cast<const steve::memory::pages*>(this);
}

steve::uint32 steve::memory::pages::page_size() const { 
  return m_page_size;
}

steve::uint32 steve::memory::pages::number_of_pages() const { 
  return size();
}
bool steve::memory::pages::close() { 
  return true;
}
bool steve::memory::pages::commit() { 
  return true;
}
