// this :
#include <steve/memory/store.h>

#include <steve/interface/store_data.h>

#include <steve/memory/page.h>
#include <steve/memory/pages.h>

//#include <stdlib.h> //div

steve::memory::store::store(std::ostream& a_writer)
:base_store(a_writer,"memory","")
{}

steve::memory::store::~store(){
  {std::map<std::string,memory::pages*>::iterator it;
   for(it=m_pages.begin();it!=m_pages.end();++it) {
     delete (*it).second;
   }
   m_pages.clear();}
}


//private:
steve::memory::store::store(const store& a_from)
:base_store(a_from){}
//private:
steve::memory::store& steve::memory::store::operator=(const store&) { return *this;}

void* steve::memory::store::cast_head() const {
  return (void*)static_cast<const steve::memory::store*>(this);
}

bool steve::memory::store::open(
 e_mode //a_mode
) {
  return true;
}
bool steve::memory::store::close() {
  return true;
}

steve::interface::page* steve::memory::store::create_page(
 interface::store_data& a_store_data
,uint32 a_page_size
,uint32 //a_compression
) {
  if(!a_store_data.store_pages()) {
    pages* pgs = new pages(a_page_size);
    a_store_data.set_store_pages(pgs,false);
    m_pages[a_store_data.name()] = pgs;
  }

  pages* pgs = (pages*)a_store_data.store_pages()->cast_head();

#define if_new_page(a_type,a_id_type) \
  if(a_store_data.type()==a_id_type) {\
    steve::interface::page* pg = new page<a_type>(a_page_size);\
    pgs->push_back(pg);\
    return pg;\
  }

  if_new_page(bool,steve_id_bool)
  else if_new_page(char,steve_id_char)
  else if_new_page(uchar,steve_id_uchar)
  else if_new_page(uint16,steve_id_uint16)
  else if_new_page(int16,steve_id_int16)
  else if_new_page(uint32,steve_id_uint32)
  else if_new_page(int32,steve_id_int32)
  else if_new_page(uint64,steve_id_uint64)
  else if_new_page(int64,steve_id_int64)
  else if_new_page(float,steve_id_float)
  else if_new_page(double,steve_id_double)
  else if_new_page(std::string,steve_id_string)

  else if_new_page(ref,steve_id_ref)

  else { return 0;}

#undef if_new_page

}

bool steve::memory::store::commit_page(
 interface::store_data& //a_store_data
,interface::page*& a_page
) {
  a_page = 0; //invalidate the pointer.
  return true;
}

steve::interface::page* steve::memory::store::find_page(
 interface::store_data& a_store_data
,uint32 a_index
,uint32& a_index_in_page
)
{ 
  if(!a_store_data.retrieve_pages()) {

    std::map<std::string,memory::pages*>::iterator  
      mit(m_pages.find(a_store_data.name()));
    if(mit==m_pages.end()) {
      m_out << "steve::memory::store::find_page :"
            << " pages not found for " << a_store_data.name()
            << std::endl;
      return 0;
    }

    a_store_data.set_retrieve_pages(mit->second,false);
  }

  pages* pgs = (pages*)a_store_data.retrieve_pages()->cast_head();

  uint32 page_size = pgs->page_size();

  uint32 page_index = a_index/page_size;
  uint32 index_in_page = a_index%page_size;

  //div_t dv = div(a_index,page_size); //optimization.
  //uint32 page_index = (uint32 )dv.quot;
  //uint32 index_in_page = (uint32 )dv.rem;

  if(page_index>=pgs->size()) {
    a_index_in_page = 0;
    return 0;
  }
  a_index_in_page = index_in_page;
  return (*pgs)[page_index];
}
