#ifndef steve_HDF5_helper_h
#define steve_HDF5_helper_h

#include <steve/typedefs.h>

#include <string>
#include <vector>
#include <hdf5.h>

namespace steve {
namespace HDF5 {

class helper {
public:
  helper(int a_level = 1);
  virtual ~helper();
private:
  helper(const helper& a_from);
  helper& operator=(const helper&);
public:
  bool write_uint32(hid_t,const std::string&,uint32);
  bool write_string_buffer(hid_t,const std::string&,
                           unsigned int a_size,const char* a_buffer);
private:
  //int m_compress;
  hid_t m_scalar;
  //hid_t m_compact;
  hid_t m_simple;
  //hid_t m_CPT;
};

hid_t string_datatype(unsigned int);

bool read_uint32(hid_t,const std::string&,uint32&);
bool read_string(hid_t,const std::string&,std::string&);
bool read_cstrings(hid_t a_location,
                   const std::string& a_name,
                   unsigned int& a_size,char*& a_buffer);

}}

#endif
