#ifndef steve_HDF5_page_h
#define steve_HDF5_page_h

// inheritance :
#include <steve/core/base_page.h>

namespace steve {
namespace HDF5 {

template <class T>
class page : public core::base_page<T> {
public: //interface::page :
  virtual void* cast_interface_page_T() const {
    return (void*)static_cast<const steve::interface::page_T<T>* >(this);
  }
public: //interface::page :
  virtual void* cast_base_page() const {
    return (void*)static_cast<const steve::interface::page*>(this);
  }
public:
  page(hid_t a_id,uint32 a_size,uint32 a_compression,const std::string& a_name)
  : core::base_page<T>(a_size)
  ,m_id(a_id)
  ,m_name(a_name)
  ,m_compression(a_compression)
  {}  
  virtual ~page(){}
protected:
  page(const page& a_from)
  : core::base_page<T>(a_from)
  ,m_id(a_from.m_id)
  ,m_name(a_from.m_name)
  ,m_compression(a_from.m_compression)
  {}
private:
  page& operator=(const page&) { return *this;}
protected:
  hid_t m_id;
  std::string m_name;
  uint32 m_compression;
};

}}

#endif
