#ifndef steve_ROOT_store_h
#define steve_ROOT_store_h

// inheritance :
#include <steve/core/base_store.h>

class TFile;
class TTree;
class TBranch;

#include <map>

namespace steve {
namespace ROOT {

class store : public core::base_store {
public: //interface::store
  virtual void* cast_head() const;
  virtual bool open(e_mode a_mode);
  virtual bool close();
  virtual interface::page* create_page(interface::store_data&,
                                            uint32 a_page_size,
                                            uint32 a_compression);
  virtual interface::page* find_page(interface::store_data&,
                                          uint32 a_index,
                                          uint32& a_index_in_page);
  virtual bool commit_page(interface::store_data&,interface::page*&);
public:
  store(std::ostream& a_out,
        const std::string& a_file_name,
        const std::string& a_options);
  virtual ~store();
public:
  bool bind_to_store(const std::string& a_branch,
                     const std::string& a_class_name,void*,bool a_fill);
  bool bind_to_retrieve(const std::string& a_branch,void*,
                        bool a_get_entry,steve::uint64 a_entry);
private:
  store(const store& a_from);
  store& operator=(const store& a_from);
//private:
  //bool dump_branches();
  //void dump_branches(TBranch&,uint32);
private:
  TFile* m_file;
  bool m_write;
  std::map<std::string,TTree*> m_schemas;
};

}}

#endif

