#ifndef steve_core_ascii_buffer_h
#define steve_core_ascii_buffer_h

// inheritance :
#include <steve/core/base_buffer.h>

#include <vector>

namespace steve {
namespace core {

class ascii_buffer : public base_buffer {
public: //interface::buffer
  virtual bool write(uchar);
  virtual bool write(char);
  virtual bool write(uint16);
  virtual bool write(int16);
  virtual bool write(uint32);
  virtual bool write(int32);
  virtual bool write(uint64);
  virtual bool write(int64);
  virtual bool write(float);
  virtual bool write(double);
  virtual bool write(bool);

  virtual bool write(const std::string&); //used by zip::page_std_string.

  virtual bool write_array(uint32,const uchar*);
  virtual bool write_array(uint32,const char*);
  virtual bool write_array(uint32,const uint16*);
  virtual bool write_array(uint32,const int16*);
  virtual bool write_array(uint32,const uint32*);
  virtual bool write_array(uint32,const int32*);
  virtual bool write_array(uint32,const uint64*);
  virtual bool write_array(uint32,const int64*);
  virtual bool write_array(uint32,const float*);
  virtual bool write_array(uint32,const double*);
  virtual bool write_array(uint32,const bool*);

  virtual bool read(uchar&);
  virtual bool read(char&);
  virtual bool read(uint16&);
  virtual bool read(int16&);
  virtual bool read(uint32&);
  virtual bool read(int32&);
  virtual bool read(uint64&);
  virtual bool read(int64&);
  virtual bool read(float&);
  virtual bool read(double&);
  virtual bool read(bool&);

  //virtual bool read(std::string&);

  virtual bool read_array(uint32&,uchar*&);
  virtual bool read_array(uint32&,char*&);
  virtual bool read_array(uint32&,uint16*&);
  virtual bool read_array(uint32&,int16*&);
  virtual bool read_array(uint32&,uint32*&);
  virtual bool read_array(uint32&,int32*&);
  virtual bool read_array(uint32&,uint64*&);
  virtual bool read_array(uint32&,int64*&);
  virtual bool read_array(uint32&,float*&);
  virtual bool read_array(uint32&,double*&);
  virtual bool read_array(uint32&,bool*&);

  virtual bool read_array(std::vector<std::string>&);
public:
  ascii_buffer(std::ostream&,uint32 = 1024,char* = 0);
  virtual ~ascii_buffer();
private:
  ascii_buffer(const ascii_buffer&);
  ascii_buffer& operator=(const ascii_buffer &);
};

}}

#endif
