#ifndef steve_core_base_buffer_h
#define steve_core_base_buffer_h

// inheritance :
#include <steve/interface/buffer.h>

#include <ostream>

namespace steve {
namespace core {

class base_buffer : public virtual interface::buffer {
public: //interface::buffer
  virtual void assign(uint32,char*);
  virtual uint32 size() const;
  virtual char* data() const;
  virtual diff_pointer_t used() const;
  virtual diff_pointer_t remaining() const;
  virtual void clear(bool a_delete = true);
public:
  base_buffer(std::ostream&,uint32 = 1024,char* = 0);
  virtual ~base_buffer();
protected:
  base_buffer(const base_buffer&);
private:
  base_buffer& operator=(const base_buffer &);
public:
  char* position() const;
  char* max_position() const;
  bool expand(uint32);
protected: //FIXME
  std::ostream& m_out;
  uint32 m_verbose;
  uint32 m_size;
  char* m_buffer;
  char* m_pos;
  char* m_max;
};

}}

#endif
