#ifndef steve_core_base_page_h
#define steve_core_base_page_h

// inheritance :
#include <steve/interface/page.h>
#include <steve/interface/page_T.h>

namespace steve {
namespace core {

template <class T>
class base_page 
:public virtual interface::page
,public virtual interface::page_T<T> 
{
public: //interface::page :
  virtual bool is_full() const {
    if(m_index>=m_size) return true;    
    return false;
  }
  virtual uint32 remain() const {
    if(m_index>=m_size) return 0;
    return m_size-m_index;
  }
  virtual uint32 page_size() const { return m_size;}
public:
  base_page(uint32 a_size)
  :m_size(a_size)
  ,m_index(0)
  {}  
  virtual ~base_page(){}
protected:
  uint32 m_size;
  uint32 m_index;
};

}}

#endif
