#ifndef steve_core_base_schema_h
#define steve_core_base_schema_h

// inheritance :
#include <steve/interface/schema.h>

#include <vector>

namespace steve {namespace interface {class store_data_visitor;}}

namespace steve {
namespace core {

class base_schema : public virtual interface::schema {
public: //interface::store
  virtual interface::offsets* create_offsets(const std::string& a_name,
                                             uint32 a_page_size,
                                             uint32 a_compression);
  virtual interface::numbers* create_numbers(const path_os_t& a_path,
                                             const std::string& a_name,
                                             uint32 a_page_size,
                                             uint32 a_compression);
  virtual steve::interface::data* create_data(const path_os_t& a_path,
                                           const std::string& a_name,
                                           const std::string& a_id_type,
                                           uint32 a_page_size,
                                           uint32 a_compression);

  virtual bool print_stats(std::ostream&) const;
  virtual bool commit();
  virtual interface::store_data* find_store_data(const std::string&) const;
  virtual bool visit_store_data(interface::store_data_visitor&,
                                bool a_visit_sub_schemas = true);
  virtual bool clear();
public:
  base_schema(std::ostream&,const std::string&);
  virtual ~base_schema();
protected:
  base_schema(const base_schema& a_from);
private:
  base_schema& operator=(const base_schema& a_from);
//public:
  //void add_data(interface::data*);
protected:
  void add_schema(steve::interface::schema*);
protected:
  std::ostream& m_out;
  std::string m_name;
private:
  std::vector<interface::offsets*> m_os;
  std::vector<interface::numbers*> m_ns;
  std::vector<interface::data*> m_datas;
  std::vector<steve::interface::schema*> m_schemas;
};

}}

#endif
