#ifndef steve_core_base_store_h
#define steve_core_base_store_h

// inheritance :
#include <steve/interface/store.h>

#include <vector>
#include <map>

namespace steve {
namespace core {

class base_store : public virtual interface::store {
public: //interface::store
  virtual void set_verbosity(uint32 a_verbosity);
  virtual steve::uint32 verbosity() const;
  virtual bool opened() const;
  virtual std::string name() const;
  virtual std::ostream& printer() const;

  virtual bool create_store_ref(void*,ref&);
  virtual bool find_store_ref(void*,ref&);
  virtual bool create_retrieve_ref(ref,void*);
  virtual bool find_retrieve_ref(ref,void*&);
  virtual bool reset_refs();
public:
  base_store(std::ostream& a_out,
             const std::string& a_store_name,
             const std::string& a_options);
  virtual ~base_store();
protected:
  base_store(const base_store& a_from);
private:
  base_store& operator=(const base_store& a_from);
//public:
  //void add_data(interface::data*);
protected:
  //bool base_close();
protected:
  std::ostream& m_out;
  std::string m_store_name;
  std::string m_options;
  bool m_opened;
  uint32 m_verbosity;
private:
  ref m_ref_counter;
  std::map<void*,ref> m_store_refs;
  std::map<ref,void*> m_retrieve_refs;
};

}}

#endif
