#ifndef steve_core_binary_no_swap_buffer_h
#define steve_core_binary_no_swap_buffer_h

// inheritance :
#include <steve/core/base_buffer.h>

namespace steve {
namespace core {

class binary_no_swap_buffer : public core::base_buffer {
public: //interface::buffer
  virtual bool write(uchar);
  virtual bool write(char);
  virtual bool write(uint16);
  virtual bool write(int16);
  virtual bool write(uint32);
  virtual bool write(int32);
  virtual bool write(uint64);
  virtual bool write(int64);
  virtual bool write(float);
  virtual bool write(double);
  virtual bool write(bool);

  //virtual bool write(const std::string&);

  virtual bool write_array(uint32,const uchar*);
  virtual bool write_array(uint32,const char*);
  virtual bool write_array(uint32,const uint16*);
  virtual bool write_array(uint32,const int16*);
  virtual bool write_array(uint32,const uint32*);
  virtual bool write_array(uint32,const int32*);
  virtual bool write_array(uint32,const uint64*);
  virtual bool write_array(uint32,const int64*);
  virtual bool write_array(uint32,const float*);
  virtual bool write_array(uint32,const double*);
  virtual bool write_array(uint32,const bool*);

  virtual bool read(uchar&);
  virtual bool read(char&);
  virtual bool read(uint16&);
  virtual bool read(int16&);
  virtual bool read(uint32&);
  virtual bool read(int32&);
  virtual bool read(uint64&);
  virtual bool read(int64&);
  virtual bool read(float&);
  virtual bool read(double&);
  virtual bool read(bool&);

  //virtual bool read(std::string&);

  virtual bool read_array(uint32&,uchar*&);
  virtual bool read_array(uint32&,char*&);
  virtual bool read_array(uint32&,uint16*&);
  virtual bool read_array(uint32&,int16*&);
  virtual bool read_array(uint32&,uint32*&);
  virtual bool read_array(uint32&,int32*&);
  virtual bool read_array(uint32&,uint64*&);
  virtual bool read_array(uint32&,int64*&);
  virtual bool read_array(uint32&,float*&);
  virtual bool read_array(uint32&,double*&);
  virtual bool read_array(uint32&,bool*&);
public:
  binary_no_swap_buffer(std::ostream&,uint32 = 1024,char* = 0);
  virtual ~binary_no_swap_buffer();
private:
  binary_no_swap_buffer(const binary_no_swap_buffer&);
  binary_no_swap_buffer& operator=(const binary_no_swap_buffer &);
};

}}

#endif
