#ifndef steve_numbers_h
#define steve_numbers_h

// Inheritance :
#include <steve/interface/numbers.h>
#include <steve/core/store_data.h>

#include <steve/path_os.h>

namespace steve {
namespace core {

class numbers 
:public virtual interface::numbers
,public core::store_data<uint32> {
public: //interface::numbers
  virtual bool add(interface::store& a_store,uint32 a_value);
  virtual bool find_value(interface::store& a_store,
                          uint32 a_event,
                          const path_t& a_is,
                          uint32& a_value);
  virtual steve::uint32 total() const;
  virtual interface::store_data& store_data();
  //FIXME : why do we have to redeclare the three below methods ?
  virtual steve::uint32 entries() const;
  virtual steve::uint32 number_of_pages() const;
  virtual steve::uint32 page_size() const;
public:
  numbers(std::ostream& a_out,
          const path_os_t& a_path,
          const std::string& a_name,
          uint32 a_page_size,
          uint32 a_compression);
  virtual ~numbers();
private:
  numbers(const numbers& a_from);
  numbers& operator=(const numbers& a_from);
private:
  path_os_t m_path_os;
  uint32 m_total;
};

}}

#endif
