#ifndef steve_core_retrieve_pages_h
#define steve_core_retrieve_pages_h

// inheritance :
#include <steve/interface/pages.h>

#include <steve/typedefs.h>

#include <algorithm>

namespace steve {namespace interface {class page;}}

namespace steve {
namespace core {

class retrieve_pages
:public virtual interface::pages
,public std::pair<int,interface::page*>
{
public:
  virtual void* cast_head() const;  
  virtual uint32 number_of_pages() const;
  virtual bool close();
  virtual bool commit();
public:
  retrieve_pages(uint32 a_page_size);
  virtual ~retrieve_pages();
protected:
  retrieve_pages(const retrieve_pages& a_from);
private:
  retrieve_pages& operator=(const retrieve_pages& a_from);
public:
  uint32 page_size() const;
private:
  uint32 m_page_size;
};

}}

#endif

