#ifndef steve_core_stat_visitor_h
#define steve_core_stat_visitor_h

// inheritance :
#include <steve/interface/store_data_visitor.h>

#include <steve/typedefs.h>

#include <ostream>

namespace steve {namespace interface {class store_data;}}

namespace steve {
namespace core {

class stat_visitor : public virtual interface::store_data_visitor {
public:
  virtual bool visit(interface::store_data& a_store_data);
public:
  stat_visitor();
  virtual ~stat_visitor();
public:
  uint32 bytes() const;
  uint32 bytes_data() const;
  uint32 bytes_numbers() const;
  uint32 bytes_offsets() const;
  uint32 bytes_refs() const;
  void reset();
  void print(std::ostream&) const;
private:
  stat_visitor(const stat_visitor& a_from);
  stat_visitor& operator=(const stat_visitor&);
private:
  uint32 m_bytes;
  uint32 m_bytes_data;
  uint32 m_bytes_offsets;
  uint32 m_bytes_numbers;
  uint32 m_bytes_refs;
};

}}


#endif
