#ifndef steve_core_store_pages_h
#define steve_core_store_pages_h

// inheritance :
#include <steve/interface/pages.h>

#include <steve/typedefs.h>
#include <list>

namespace steve {namespace interface {class page;}}

namespace steve {
namespace core {

class store_pages
:public virtual interface::pages
,public std::list<interface::page*> 
{
public:
  virtual void* cast_head() const;  
  virtual uint32 number_of_pages() const;
  virtual bool close();
  virtual bool commit();
public:
  store_pages();
  virtual ~store_pages();
private:
  store_pages(const store_pages& a_from);
  store_pages& operator=(const store_pages& a_from);
public:
  uint32 count() const;
  void increment_count();
private:
  uint32 m_count;  
};

}}

#endif

