#ifndef steve_core_streamer_h
#define steve_core_streamer_h

// inheritance :
#include <steve/interface/streamer.h>

namespace steve {namespace interface {class store;}}
namespace steve {namespace interface {class buffer;}}

namespace steve {
namespace core {

class streamer : public virtual interface::streamer {
public: //interface::buffer
  virtual bool write(uchar);
  virtual bool write(char);
  virtual bool write(uint16);
  virtual bool write(int16);
  virtual bool write(uint32);
  virtual bool write(int32);
  virtual bool write(uint64);
  virtual bool write(int64);
  virtual bool write(float);
  virtual bool write(double);

  virtual bool write(bool);
  //XXX virtual bool write(int);
  //XXX virtual bool write(unsigned int);
  virtual bool write(const std::string&);
  virtual bool write(uint32,char*);

  virtual bool read(uchar&);
  virtual bool read(char&);
  virtual bool read(uint16&);
  virtual bool read(int16&);
  virtual bool read(uint32&);
  virtual bool read(int32&);
  virtual bool read(uint64&);
  virtual bool read(int64&);
  virtual bool read(float&);
  virtual bool read(double&);

  virtual bool read(bool&);
  //XXX virtual bool read(unsigned int&);
  //XXX virtual bool read(int&);
  virtual bool read(std::string&);
  virtual bool read(uint32&,char*&);

  virtual interface::store& store();
public:
  streamer(interface::store&);
  virtual ~streamer();
public:
  void assign(uint32,char*);
  uint32 size() const;
  char* data() const;
  void clear(bool a_delete = true);
private:
  streamer(const streamer&);
  streamer& operator=(const streamer &);
private:
  interface::store& m_store;
  interface::buffer* m_buffer;
};

}}

#endif
