#ifndef steve_interface_buffer_h
#define steve_interface_buffer_h

#include <steve/typedefs.h>

#include <string>

namespace steve {
namespace interface {

class buffer {
public:
  virtual ~buffer() {}
public:
  virtual bool write(uchar) = 0;
  virtual bool write(char) = 0;
  virtual bool write(uint16) = 0;
  virtual bool write(int16) = 0;
  virtual bool write(uint32) = 0;
  virtual bool write(int32) = 0;
  virtual bool write(uint64) = 0;
  virtual bool write(int64) = 0;
  virtual bool write(float) = 0;
  virtual bool write(double) = 0;
  virtual bool write(bool) = 0;

  virtual bool write_array(uint32,const uchar*) = 0;
  virtual bool write_array(uint32,const char*) = 0;
  virtual bool write_array(uint32,const uint16*) = 0;
  virtual bool write_array(uint32,const int16*) = 0;
  virtual bool write_array(uint32,const uint32*) = 0;
  virtual bool write_array(uint32,const int32*) = 0;
  virtual bool write_array(uint32,const uint64*) = 0;
  virtual bool write_array(uint32,const int64*) = 0;
  virtual bool write_array(uint32,const float*) = 0;
  virtual bool write_array(uint32,const double*) = 0;
  virtual bool write_array(uint32,const bool*) = 0;

  virtual bool read(uchar&) = 0;
  virtual bool read(char&) = 0;
  virtual bool read(uint16&) = 0;
  virtual bool read(int16&) = 0;
  virtual bool read(uint32&) = 0;
  virtual bool read(int32&) = 0;
  virtual bool read(uint64&) = 0;
  virtual bool read(int64&) = 0;
  virtual bool read(float&) = 0;
  virtual bool read(double&) = 0;
  virtual bool read(bool&) = 0;

  virtual bool read_array(uint32&,uchar*&) = 0;
  virtual bool read_array(uint32&,char*&) = 0;
  virtual bool read_array(uint32&,uint16*&) = 0;
  virtual bool read_array(uint32&,int16*&) = 0;
  virtual bool read_array(uint32&,uint32*&) = 0;
  virtual bool read_array(uint32&,int32*&) = 0;
  virtual bool read_array(uint32&,uint64*&) = 0;
  virtual bool read_array(uint32&,int64*&) = 0;
  virtual bool read_array(uint32&,float*&) = 0;
  virtual bool read_array(uint32&,double*&) = 0;
  virtual bool read_array(uint32&,bool*&) = 0;

  virtual void assign(uint32,char*) = 0;
  virtual uint32 size() const = 0;
  virtual char* data() const = 0;
  virtual diff_pointer_t used() const = 0;
  virtual diff_pointer_t remaining() const = 0;
  virtual void clear(bool a_delete = true) = 0;
};

}}

#endif
