#ifndef steve_interface_schema_h
#define steve_interface_schema_h

#include <steve/typedefs.h>
#include <steve/path_os.h>

#include <string>
#include <ostream>

namespace steve {namespace interface {class store_data;}}
namespace steve {namespace interface {class store_data_visitor;}}

namespace steve {namespace interface {class offsets;}}
namespace steve {namespace interface {class numbers;}}
namespace steve {namespace interface {class data;}}

namespace steve {
namespace interface {

class schema {
public:
  virtual ~schema(){}
public:
  virtual void* cast_head() const = 0;
public:
  virtual interface::offsets* create_offsets(const std::string& a_name,
                                             uint32 a_page_size,
                                             uint32 a_compression) = 0;

  virtual interface::numbers* create_numbers(const path_os_t& a_path,
                                             const std::string& a_name,
                                             uint32 a_page_size,
                                             uint32 a_compression) = 0;

  virtual steve::interface::data* create_data(
                                           const path_os_t& a_path,
                                           const std::string& a_name,
                                           const std::string& a_id_type,
                                           uint32 a_page_size,
                                           uint32 a_compression) = 0;

  virtual bool print_stats(std::ostream&) const = 0;
  virtual bool commit() = 0;
  virtual interface::store_data* find_store_data(const std::string&) const = 0;
  virtual bool visit_store_data(interface::store_data_visitor&,
                                bool a_visit_sub_schemas = true) = 0;
  virtual bool clear() = 0;
};

}}

#endif

