#ifndef steve_interface_store_h
#define steve_interface_store_h

#include <steve/typedefs.h>
#include <steve/path_os.h>

#include <string>
#include <ostream>

namespace steve {namespace interface {class page;}}
namespace steve {namespace interface {class store_data;}}

namespace steve {
namespace interface {

class store {
public:
  virtual ~store(){}
public:
  virtual void* cast_head() const = 0;
public:
  enum e_mode {
    //auto     // Default case: create of store does not exist 
   create   // Create a new file (throws an exception if already exists) 
   //,recreate // Overwrite file if existing 
   ,readonly // Open in read only mode 
   //,update   // Read/write mode, overwriting modified objects. 
  };
public:
  virtual void set_verbosity(uint32 a_verbosity) = 0;
  virtual steve::uint32 verbosity() const = 0;
  virtual bool open(e_mode a_mode) = 0;
  virtual bool opened() const = 0;
  virtual std::string name() const = 0;
  virtual bool close() = 0;
  virtual interface::page* create_page(store_data&,
                                            uint32 a_page_size,
                                            uint32 a_compression) = 0;
  virtual interface::page* find_page(store_data&,
                                          uint32 a_index,
                                          uint32& a_index_in_page) = 0;
  virtual bool commit_page(store_data&,interface::page*&) = 0;
  virtual std::ostream& printer() const = 0;

  // store_refs
  virtual bool create_store_ref(void*,ref&) = 0;
  // store_ref
  virtual bool find_store_ref(void*,ref&) = 0;

  // retrieve_refs
  virtual bool create_retrieve_ref(ref,void*) = 0;
  // retrieve_ref
  virtual bool find_retrieve_ref(ref,void*&) = 0;

  virtual bool reset_refs() = 0;
};

}}

#endif

