#ifndef steve_interface_store_data_h
#define steve_interface_store_data_h

#include <string>
#include <steve/typedefs.h>

namespace steve {namespace interface {class pages;}}

namespace steve {
namespace interface {

class store_data {
public:
  virtual ~store_data(){}
public:
  virtual const std::string& name() const = 0;
  virtual std::string name() = 0;

  virtual const std::string& type() const = 0;
  virtual std::string type() = 0;

  virtual bool set_store_pages(interface::pages*,bool a_delete = true) = 0;
  virtual interface::pages* store_pages() const = 0;
  virtual bool set_retrieve_pages(interface::pages*,bool a_delete = true) = 0;
  virtual interface::pages* retrieve_pages() const = 0;

  virtual steve::uint32 entries() const = 0;
  virtual steve::uint32 store_bytes() const = 0;
  virtual steve::uint32 number_of_pages() const = 0;
  virtual steve::uint32 page_size() const = 0;
  virtual steve::uint32 compression() const = 0;
  virtual bool set_page_size(steve::uint32 a_size) = 0;
  virtual bool set_compression(steve::uint32) = 0;
};

}}

#endif
