#ifndef steve_interface_streamer_h
#define steve_interface_streamer_h

// used to stream objects to blob through
// the instrument stream_out, stream_in methods.

#include <steve/typedefs.h>

#include <string>

namespace steve {namespace interface {class store;}}

namespace steve {
namespace interface {

class streamer {
public:
  virtual ~streamer() {}
public:
  virtual bool write(uchar) = 0;
  virtual bool write(char) = 0;
  virtual bool write(uint16) = 0;
  virtual bool write(int16) = 0;
  virtual bool write(uint32) = 0;
  virtual bool write(int32) = 0;
  virtual bool write(uint64) = 0;
  virtual bool write(int64) = 0;
  virtual bool write(float) = 0;
  virtual bool write(double) = 0;

  virtual bool write(bool) = 0;
  //XXX virtual bool write(unsigned int) = 0;
  //XXX virtual bool write(int) = 0;
  virtual bool write(const std::string&) = 0;
  virtual bool write(uint32,char*) = 0;

  virtual bool read(uchar&) = 0;
  virtual bool read(char&) = 0;
  virtual bool read(uint16&) = 0;
  virtual bool read(int16&) = 0;
  virtual bool read(uint32&) = 0;
  virtual bool read(int32&) = 0;
  virtual bool read(uint64&) = 0;
  virtual bool read(int64&) = 0;
  virtual bool read(float&) = 0;
  virtual bool read(double&) = 0;

  virtual bool read(bool&) = 0;
  //XXX virtual bool read(int&) = 0;
  //XXX virtual bool read(unsigned int&) = 0;
  virtual bool read(std::string&) = 0;
  virtual bool read(uint32&,char*&) = 0;

  virtual interface::store& store() = 0; //for refs.

};

}}

#endif
