#ifndef steve_memory_page_h
#define steve_memory_page_h

// inheritance :
#include <steve/core/base_page.h>

#include <vector>

namespace steve {
namespace memory {

inline size_t size_of(bool){return sizeof(bool);}
inline size_t size_of(char){return sizeof(char);}
inline size_t size_of(uchar){return sizeof(uchar);}
inline size_t size_of(uint16){return sizeof(uint16);}
inline size_t size_of(int16){return sizeof(int16);}
inline size_t size_of(uint32){return sizeof(uint32);}
inline size_t size_of(int32){return sizeof(int32);}
inline size_t size_of(uint64){return sizeof(uint64);}
inline size_t size_of(int64){return sizeof(int64);}
inline size_t size_of(float){return sizeof(float);}
inline size_t size_of(double){return sizeof(double);}
//inline size_t size_of(ref){return sizeof(ref);}

inline size_t size_of(std::string a_v){return a_v.size();}

template <class T>
class page : public core::base_page<T> {
public: //interface::page :
  virtual void* cast_interface_page_T() const {
    return (void*)static_cast<const steve::interface::page_T<T>* >(this);
  }
public: //interface::page :
  virtual void* cast_base_page() const {
    return (void*)static_cast<const steve::interface::page*>(this);
  }
  virtual bool add(const T& a_value,uint32& a_item_size) {
    if(this->m_index>=this->m_size) return false;   
    this->m_vector[this->m_index] = a_value;
    this->m_index++;
    a_item_size = size_of(a_value);
    return true;
  }
  virtual bool add(uint32 a_size,const T* a_values,uint32& a_items_size) {
    T* pos = (T*)a_values;
    for(uint32 index=0;index<a_size;index++,pos++) {
      if(!add(*pos,a_items_size)) return false;
    }
    return true;
  }
  virtual bool value(uint32 a_index,T& a_value) const { 
    if(a_index>=this->m_size) return false;    
    a_value = this->m_vector[a_index];
    return true;
  }
  virtual bool values(uint32 a_index,uint32 a_size,T* a_values) const {
    //if((a_index+a_size)>m_size) return false;
    //T* p = (T*)&(this->m_vector[a_index]); //FIXME std::string
    //::memcpy(a_values,p,a_size*sizeof(T));
    T* pos = (T*)a_values;
    for(uint32 index=0;index<a_size;index++,pos++) {
      if(!value(a_index+index,*pos)) return false;
    }
    return true;
  }
  virtual bool commit() const {
    return true;
  }
  virtual bool retrieve() {
    return true;
  }
public:
  page(uint32 a_size)
  : core::base_page<T>(a_size)
  {
    this->m_vector.resize(this->m_size);
  }  
  virtual ~page(){
    this->m_vector.clear();
  }
private:
  page(const page& a_from): core::base_page<T>(a_from){}
  page& operator=(const page&) { return *this;}
private:
  std::vector<T> m_vector;
};

}}

#endif
