#ifndef steve_memory_store_h
#define steve_memory_store_h

// inheritance :
#include <steve/core/base_store.h>

#include <map>

namespace steve {namespace memory {class pages;}}

namespace steve {
namespace memory {

class store : public core::base_store {
public: //interface::store
  virtual void* cast_head() const;
  virtual bool open(e_mode a_mode);
  virtual bool close();
  virtual interface::page* create_page(interface::store_data&,
                                            uint32 a_page_size,
                                            uint32 a_compression);
  virtual interface::page* find_page(interface::store_data&,
                                          uint32 a_index,
                                          uint32& a_index_in_page);
  virtual bool commit_page(interface::store_data&,interface::page*&);
public:
  store(std::ostream& a_printer);
  virtual ~store();
private:
  store(const store& a_from);
  store& operator=(const store& a_from);
private:
  std::map<std::string,memory::pages*> m_pages;
};

}}

#endif

