#ifndef steve_mysql_T_h
#define steve_mysql_T_h

#include <steve/tools/smanip.h>

#include <mysql/mysql.h>

namespace steve {
namespace mysql {

template <class T>
bool read_array(
 std::ostream& a_out
,MYSQL* a_connection
,const std::string& a_name
,unsigned int& a_size
,T*& a_array
){
  // It is assumed that a_size contains in input 
  // the page size and that a_array is allocated with a_size data.
  std::string query;
  query  = "SELECT value FROM "+a_name;
  if(mysql_query(a_connection,query.c_str())) {
    a_out << "read_array<T> :"
          << " for query " << tools::sout(query)
          << " : " << std::string(mysql_error(a_connection))
          << std::endl;
    return false;
  }

  MYSQL_RES* result = mysql_store_result(a_connection);
  if(result==NULL) return false;

  unsigned int num_fields = mysql_num_fields(result);
  my_ulonglong rows = mysql_num_rows(result);
  if(num_fields!=1) {
    mysql_free_result(result);
    return false;
  }
  if(!rows) {
    a_size = 0;
    a_array = 0;
    mysql_free_result(result);
    return true; // it is ok.
  }

  if(rows>a_size) {
    mysql_free_result(result);
    return false;
  }

  a_size = rows;

  //FIXME : optimize by avoiding passing by strings.
 {MYSQL_ROW row;
  uint32 index = 0;
  while( ( row = mysql_fetch_row(result) ) != NULL ) {
    if((row[0]==NULL) || !tools::to<T>(row[0],a_array[index])) {
      mysql_free_result(result);
      return false;
    }
    index++;
  }}

  mysql_free_result(result);
  return true;
}
  
}}

#endif
