#ifndef steve_mysql_page_h
#define steve_mysql_page_h

// inheritance :
#include <steve/core/base_page.h>

#include <mysql/mysql.h>

namespace steve {
namespace mysql {

template <class T>
class page : public core::base_page<T> {
public: //interface::page :
  virtual void* cast_interface_page_T() const {
    return (void*)static_cast<const steve::interface::page_T<T>* >(this);
  }
public: //interface::page :
  virtual void* cast_base_page() const {
    return (void*)static_cast<const steve::interface::page*>(this);
  }
public:
  page(MYSQL* a_connection,
       uint32 a_size,uint32 a_index,
       const std::string& a_name)
  : core::base_page<T>(a_size)
  ,m_connection(a_connection)
  ,m_name(a_name)
  ,m_page_index(a_index)
  {}  
  virtual ~page(){}
protected:
  page(const page& a_from)
  : core::base_page<T>(a_from)
  ,m_connection(0)
  ,m_page_index(0)
  {}
private:
  page& operator=(const page&) { return *this;}
protected:
  MYSQL* m_connection;
  std::string m_name;
  uint32 m_page_index;
};

}}

#endif
