#ifndef steve_tools_blob_h
#define steve_tools_blob_h

#include <steve/typedefs.h>

#include <steve/tools/realloc.h>
//#include <steve/util/mem.h>

namespace steve {
namespace tools {

class blob {
public:
  blob():m_size(0),m_buffer(0){
    //util::mem::increment("steve::core::blob");
  }
  blob(uint32 a_size,char* a_data):m_size(a_size),m_buffer(a_data){
    //WARNING : blob takes a_data ownership.
    //util::mem::increment("steve::core::blob");
  }
  virtual ~blob(){
    delete [] m_buffer;
    //util::mem::decrement("steve::core::blob");
  }
private:
  blob(const blob&){}
  blob& operator=(const blob&) { return *this;}
public:
  inline void assign(uint32 a_size,char* a_buffer) {
    //WARNING : it takes a_buffer ownership.
    delete [] m_buffer;
    m_size = a_size;
    m_buffer = a_buffer;
  }
  inline uint32 size() const { return m_size;}
  inline char* data() const { return m_buffer;}
  inline bool resize(uint32 a_size){
    if(!tools::realloc<char>(m_buffer,a_size,m_size)) {
      m_size = 0;
      return false;
    }
    m_size = a_size;
    return true;
  }
  inline const char& operator[](unsigned int a_index) const {
    return m_buffer[a_index];
  }
  inline char& operator[](unsigned int a_index) {return m_buffer[a_index];}
  inline void clear(bool a_delete = true) {
    if(a_delete) delete [] m_buffer;
    m_size = 0;
    m_buffer = 0;
  }
protected:
  uint32 m_size;
  char* m_buffer;
};

}}

#endif
