#ifndef steve_tools_sql_h
#define steve_tools_sql_h

namespace steve {
namespace tools {

inline bool to_sql(const std::string& a_type,std::string& a_sql) {
  if(a_type==steve_id_uchar) {
    a_sql = "TINYINT UNSIGNED";
  } else if(a_type==steve_id_char) {
    a_sql = "TINYINT";
  } else if(a_type==steve_id_uint16) {
    a_sql = "SMALLINT UNSIGNED";
  } else if(a_type==steve_id_int16) {
    a_sql = "SMALLINT";
  } else if(a_type==steve_id_uint32) {
    a_sql = "INT UNSIGNED";
  } else if(a_type==steve_id_int32) {
    a_sql = "INT";
  } else if(a_type==steve_id_uint64) {
    a_sql = "BIGINT UNSIGNED";
  } else if(a_type==steve_id_int64) {
    a_sql = "BIGINT";
  } else if(a_type==steve_id_float) {
    a_sql = "FLOAT";
  } else if(a_type==steve_id_double) {
    a_sql = "DOUBLE";
  } else if(a_type==steve_id_ref) {
    a_sql = "INT UNSIGNED";
  } else if(a_type==steve_id_bool) {
    a_sql = "TINYINT UNSIGNED";
  } else if(a_type==steve_id_string) {
    a_sql = "BLOB"; //65535 case sensitive
    //a_sql = "TEXT"; //65535 not case sensitive
  } else {
    return false;
  }
  return true;
}

}}

#endif
