#ifndef steve_typedefs_h
#define steve_typedefs_h

// Similar to AIDA/v3r3p0/Types.h
// Similar to Lib/v8r1p0/typedefs.h

namespace steve {

#if defined(WIN32) && !defined(GNU_GCC)

// 32 bit platform.

// WIN32 and NOT GNU_GCC
typedef int int32;
typedef __int64 int64;
#define STEVE_INT32_FORMAT "%d"
#define STEVE_INT64_FORMAT "%ld"

typedef unsigned int uint32;
typedef unsigned __int64 uint64;
#define STEVE_UINT32_FORMAT "%u"
#define STEVE_UINT64_FORMAT "%lu"

typedef unsigned int diff_pointer_t;

#elif defined(_LP64) 

// 64 bit platform.

typedef int int32;
typedef long int64;
#define STEVE_INT32_FORMAT "%d"
#define STEVE_INT64_FORMAT "%ld"

typedef unsigned int uint32;
typedef unsigned long uint64;
#define STEVE_UINT32_FORMAT "%u"
#define STEVE_UINT64_FORMAT "%lu"

#define STEVE_INT64_AS_LONG

typedef unsigned long diff_pointer_t;

#elif defined(__alpha) 

// 64 bit platform.

typedef int int32;
typedef long int64;
#define STEVE_INT32_FORMAT "%d"
#define STEVE_INT64_FORMAT "%ld"

typedef unsigned int uint32;
typedef unsigned long uint64;
#define STEVE_UINT32_FORMAT "%u"
#define STEVE_UINT64_FORMAT "%lu"

typedef unsigned long diff_pointer_t;

#define STEVE_INT64_AS_LONG

#else 

// 32 bit platform.

typedef int int32;
typedef long long int64;
#define STEVE_INT32_FORMAT "%ld"
#define STEVE_INT64_FORMAT "%lld"

typedef unsigned int uint32;
typedef unsigned long long uint64;
#define STEVE_UINT32_FORMAT "%lu"
#define STEVE_UINT64_FORMAT "%llu"

typedef unsigned int diff_pointer_t;

#endif

typedef unsigned char uchar;
typedef short int16;
typedef unsigned short uint16;
typedef uint32 ref;

#define steve_not_found (-1)

//WARNING : the below strings may go in files.
#define steve_id_bool       "bool"
#define steve_id_char       "char"
#define steve_id_uchar      "uchar"
#define steve_id_int16      "int16"
#define steve_id_uint16     "uint16"
#define steve_id_int32      "int32"
#define steve_id_uint32     "uint32"
#define steve_id_int64      "int64"
#define steve_id_uint64     "uint64"
#define steve_id_float      "float"
#define steve_id_double     "double"
#define steve_id_string     "string"
#define steve_id_ref        "ref"

}

#endif
