#ifndef steve_util_mem_h
#define steve_util_mem_h

#include <string>
#include <ostream>

namespace steve {
namespace util {

class mem {
public:
  mem();
  virtual ~mem();
private:
  mem(const mem& a_from);
  mem& operator=(const mem&);
public:
  static void increment();
  static void decrement();
  static void increment(const char*);
  static void increment(const std::string&);
  static void decrement(const char*);
  static void decrement(const std::string&);
  static void reset();
  static void balance(std::ostream&);
  static void set_check_by_class(bool);
  static bool check_by_class();
};

}}

#endif




