#ifndef steve_zip_page_h
#define steve_zip_page_h

// inheritance :
#include <steve/core/base_page.h>

namespace steve {namespace zip {class writer;}}
namespace steve {namespace zip {class reader;}}

namespace steve {
namespace zip {

template <class T>
class page : public core::base_page<T> {
public: //interface::page :
  virtual void* cast_interface_page_T() const {
    return (void*)static_cast<const steve::interface::page_T<T>* >(this);
  }
public: //interface::page :
  virtual void* cast_base_page() const {
    return (void*)static_cast<const steve::interface::page*>(this);
  }
public:
  page(writer& a_writer,
       reader& a_reader,
       uint32 a_size,
       uint32 a_compression,
       const std::string& a_name)
  : core::base_page<T>(a_size)
  ,m_writer(a_writer)
  ,m_reader(a_reader)
  ,m_name(a_name)
  ,m_compression(a_compression)
  {}  
  virtual ~page(){}
protected:
  page(const page& a_from)
  : core::base_page<T>(a_from)
  ,m_writer(a_from.m_writer)
  ,m_reader(a_from.m_reader)
  ,m_name(a_from.m_name)
  ,m_compression(a_from.m_compression)
  {}
private:
  page& operator=(const page&) { return *this;}
protected:
  writer& m_writer;
  reader& m_reader;
  std::string m_name;
  uint32 m_compression;
};

}}

#endif
