#ifndef steve_reader_h
#define steve_reader_h

#include <steve/typedefs.h>
#include <map>

#include <string>
#include <ostream>

#include <unzip.h>

namespace steve {
namespace zip {

class reader {
public:
  reader(std::ostream&);
  virtual ~reader();
private:
  reader(const reader& a_from);
  reader& operator=(const reader& a_from);
public:
  bool open(const std::string&);
  bool close();
  bool read_entry(const std::string& a_name,
                  unsigned int& a_size,
                  char*& a_buffer);
  bool read_entry(const std::string& a_name,std::string& a_value);
  bool enabled() const;
private:
  bool start(uint32&); 
  bool next(bool&); 
  bool current_name(std::string&); 
  bool current_read(unsigned int& a_size,char*& a_buffer);
  bool build_map(); 
private:
  std::ostream& m_out;
  std::string m_file_name;
  unzFile m_file;
  typedef std::pair<uLong,uLong> file_pos_t;
  std::map<std::string,file_pos_t> m_map;
};

}}

#endif
