#ifndef steve_zip_store_h
#define steve_zip_store_h

// inheritance :
#include <steve/core/base_store.h>

#include <steve/zip/writer.h>
#include <steve/zip/reader.h>

namespace steve {
namespace zip {

class store : public core::base_store {
public: //interface::store
  virtual void* cast_head() const;
  virtual bool open(e_mode a_mode);
  virtual bool close();
  virtual interface::page* create_page(interface::store_data&,
                                            uint32 a_page_size,
                                            uint32 a_compression);
  virtual interface::page* find_page(interface::store_data&,
                                          uint32 a_index,
                                          uint32& a_index_in_page);
  virtual bool commit_page(interface::store_data&,interface::page*&);
public:
  store(std::ostream& a_out,
        const std::string& a_file_name,
        const std::string& a_options);
  virtual ~store();
private:
  store(const store& a_from);
  store& operator=(const store& a_from);
private:
  zip::writer m_writer;
  zip::reader m_reader;
};

}}

#endif

