#ifndef steve_zip_writer_h
#define steve_zip_writer_h

#include <string>
#include <ostream>

namespace steve {
namespace zip {

class writer {
public:
  writer(std::ostream& a_error_out);
  virtual ~writer();
private:
  writer(const writer& a_from);
  writer& operator=(const writer& a_from);
public:
  void disable();
  void enable();
  bool enabled() const;

  bool open(const std::string&);
  bool open_entry(const std::string& a_name,unsigned int a_compression);
  bool close_entry();
  bool write(unsigned int,const char*) const;
private:
  std::ostream& m_err;
  std::string m_fileName;
  void* m_file;
  bool m_entry_opened;
};

}}

#endif
