// this :
#include <Exp/Event_Schema.h>

Exp::Event_Schema::~Event_Schema(){}
//private:
Exp::Event_Schema::Event_Schema(const Event_Schema& a_from)
:base_schema(a_from){}
Exp::Event_Schema& Exp::Event_Schema::operator=(const Event_Schema&){ return *this;}

void* Exp::Event_Schema::cast_head() const {
  return (void*)static_cast<const ::Exp::Event_Schema*>(this);
}

/////////////////////////////////////
/// offsets and numbers /////////////
/////////////////////////////////////
schema_nos_method(Exp::Event_Schema,Event_fTracks)
schema_nos_method(Exp::Event_Schema,Event_fCells)
#ifdef EXP_REF
schema_nos_method(Exp::Event_Schema,Event_fTracks_ref)
#endif
schema_nos_method(Exp::Event_Schema,Track_fHits)
schema_nos_method(Exp::Event_Schema,Hit_fTimes)
schema_nos_method(Exp::Event_Schema,Hit_fVec)
#ifdef EXP_STRING
schema_nos_method(Exp::Event_Schema,Cell_fID_Vec);
#endif
schema_nos_method(Exp::Event_Schema,Event_fBlob);
schema_nos_method(Exp::Event_Schema,Event_fObject);
schema_nos_method(Exp::Event_Schema,Event_this_blob);
/////////////////////////////////////
/// data ////////////////////////////
/////////////////////////////////////
schema_data_method(Exp::Event_Schema,Time_fTime)
schema_data_method(Exp::Event_Schema,Time_fRandom)
schema_data_method(Exp::Event_Schema,Hit_fX)
schema_data_method(Exp::Event_Schema,Hit_fY)
schema_data_method(Exp::Event_Schema,Hit_fZ)
schema_data_method(Exp::Event_Schema,Hit_fVec)
schema_data_method(Exp::Event_Schema,Hit_fRandom)
#ifdef EXP_REF
schema_data_method(Exp::Event_Schema,Hit_fTrack)
#endif
schema_data_method(Exp::Event_Schema,Track_fPx)
schema_data_method(Exp::Event_Schema,Track_fPy)
schema_data_method(Exp::Event_Schema,Track_fPz)
schema_data_method(Exp::Event_Schema,Track_fRandom)
#ifdef EXP_STRING
schema_data_method(Exp::Event_Schema,Cell_fID);
schema_data_method(Exp::Event_Schema,Cell_fID_Vec);
#endif
schema_data_method(Exp::Event_Schema,Event_fID);
schema_data_method(Exp::Event_Schema,Event_fEnergy);
#ifdef EXP_REF
schema_data_method(Exp::Event_Schema,Event_fTracks_ref)
#endif
schema_data_method(Exp::Event_Schema,Event_fBlob);
schema_data_method(Exp::Event_Schema,Event_fObject);
schema_data_method(Exp::Event_Schema,Event_this_blob);

Exp::Event_Schema::Event_Schema(
 std::ostream& a_printer
,const std::string& a_namespace
,steve::path_os_t a_head
)
:base_schema(a_printer,a_namespace)
{
  /////////////////////////////////////
  /// offsets /////////////////////////
  /////////////////////////////////////
  schema_offsets_new(Event_fTracks)
  schema_offsets_new(Event_fCells)
#ifdef EXP_REF
  schema_offsets_new(Event_fTracks_ref)
#endif
  schema_offsets_new(Track_fHits)
  schema_offsets_new(Hit_fTimes)
  schema_offsets_new(Hit_fVec)
#ifdef EXP_STRING
  schema_offsets_new(Cell_fID_Vec)
#endif
  schema_offsets_new(Event_fBlob)
  schema_offsets_new(Event_fObject)
  schema_offsets_new(Event_this_blob)
  /////////////////////////////////////
  /// path_os /////////////////////////
  /////////////////////////////////////
  steve::path_os_t path_fTracks = a_head;
  path_fTracks.push_back(m_steve_offsets_Event_fTracks);

  steve::path_os_t path_fCells = a_head;
  path_fCells.push_back(m_steve_offsets_Event_fCells);

#ifdef EXP_REF
  steve::path_os_t path_fTracks_ref = a_head;
  path_fTracks_ref.push_back(m_steve_offsets_Event_fTracks_ref);
#endif

  steve::path_os_t path_fTracks_fHits = a_head;
  path_fTracks_fHits.push_back(m_steve_offsets_Event_fTracks);
  path_fTracks_fHits.push_back(m_steve_offsets_Track_fHits);

  steve::path_os_t path_fTracks_fHits_fTimes = a_head;
  path_fTracks_fHits_fTimes.push_back(m_steve_offsets_Event_fTracks);
  path_fTracks_fHits_fTimes.push_back(m_steve_offsets_Track_fHits);
  path_fTracks_fHits_fTimes.push_back(m_steve_offsets_Hit_fTimes);

  steve::path_os_t path_fTracks_fHits_fVec = a_head;
  path_fTracks_fHits_fVec.push_back(m_steve_offsets_Event_fTracks);
  path_fTracks_fHits_fVec.push_back(m_steve_offsets_Track_fHits);
  path_fTracks_fHits_fVec.push_back(m_steve_offsets_Hit_fVec);

#ifdef EXP_STRING
  steve::path_os_t path_fCells_fID_Vec = a_head;
  path_fCells_fID_Vec.push_back(m_steve_offsets_Event_fTracks);
  path_fCells_fID_Vec.push_back(m_steve_offsets_Cell_fID_Vec);
#endif

  steve::path_os_t path_fBlob = a_head;
  path_fBlob.push_back(m_steve_offsets_Event_fBlob);

  steve::path_os_t path_fObject = a_head;
  path_fObject.push_back(m_steve_offsets_Event_fObject);

  steve::path_os_t path_Event_this_blob = a_head;
  path_Event_this_blob.push_back(m_steve_offsets_Event_this_blob);

  steve::path_os_t path_this = a_head;

  /////////////////////////////////////
  /// numbers /////////////////////////
  /////////////////////////////////////
  schema_numbers_new(path_fTracks,Event_fTracks)
  schema_numbers_new(path_fCells,Event_fCells)
#ifdef EXP_REF
  schema_numbers_new(path_fTracks_ref,Event_fTracks_ref)
#endif
  schema_numbers_new(path_fTracks_fHits,Track_fHits)
  schema_numbers_new(path_fTracks_fHits_fTimes,Hit_fTimes)
  schema_numbers_new(path_fTracks_fHits_fVec,Hit_fVec)
#ifdef EXP_STRING
  schema_numbers_new(path_fCells_fID_Vec,Cell_fID_Vec)
#endif
  schema_numbers_new(path_fBlob,Event_fBlob)
  schema_numbers_new(path_fObject,Event_fObject)
  schema_numbers_new(path_Event_this_blob,Event_this_blob)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_new(path_fTracks_fHits_fTimes,Time_fTime,steve_id_int32)
  schema_data_new(path_fTracks_fHits_fTimes,Time_fRandom,steve_id_bool)
  schema_data_new(path_fTracks_fHits,Hit_fX,steve_id_double)
  schema_data_new(path_fTracks_fHits,Hit_fY,steve_id_double)
  schema_data_new(path_fTracks_fHits,Hit_fZ,steve_id_double)
  schema_data_new(path_fTracks_fHits_fVec,Hit_fVec,steve_id_double)
  schema_data_new(path_fTracks_fHits,Hit_fRandom,steve_id_bool)
#ifdef EXP_REF
  schema_data_new(path_fTracks_fHits,Hit_fTrack,steve_id_ref)
#endif
  schema_data_new(path_fTracks,Track_fPx,steve_id_double)
  schema_data_new(path_fTracks,Track_fPy,steve_id_double)
  schema_data_new(path_fTracks,Track_fPz,steve_id_double)
  schema_data_new(path_fTracks,Track_fRandom,steve_id_bool)
#ifdef EXP_STRING
  schema_data_new(path_fCells,Cell_fID,steve_id_string);
  schema_data_new(path_fCells_fID_Vec,Cell_fID_Vec,steve_id_char);
#endif
  schema_data_new(path_this,Event_fID,steve_id_uint32);
  schema_data_new(path_this,Event_fEnergy,steve_id_float);
#ifdef EXP_REF
  schema_data_new(path_fTracks_ref,Event_fTracks_ref,steve_id_ref)
#endif
  schema_data_new(path_fBlob,Event_fBlob,steve_id_char);
  schema_data_new(path_fObject,Event_fObject,steve_id_char);
  schema_data_new(path_Event_this_blob,Event_this_blob,steve_id_char);
}
