#ifndef Exp_Event_Schema_h
#define Exp_Event_Schema_h

// inheritance :
#include <steve/core/base_schema.h>

#include <steve/schema.h>

#include <Exp/Exp.h>

namespace Exp {

class Event_Schema : public steve::core::base_schema {
  virtual void* cast_head() const;
public:
  Event_Schema(std::ostream& a_printer,
             const std::string& a_namespace,
             steve::path_os_t a_head = steve::path_os_t());
  virtual ~Event_Schema();
private:
  Event_Schema(const Event_Schema&);
  Event_Schema& operator=(const Event_Schema&);
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  schema_nos_header(Event_fTracks)
  schema_nos_header(Event_fCells)
#ifdef EXP_REF
  schema_nos_header(Event_fTracks_ref)
#endif
  schema_nos_header(Track_fHits)
  schema_nos_header(Hit_fTimes)
  schema_nos_header(Hit_fVec)
#ifdef EXP_STRING
  schema_nos_header(Cell_fID_Vec)
#endif
  schema_nos_header(Event_fBlob)
  schema_nos_header(Event_fObject)
  schema_nos_header(Event_this_blob)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(Time_fTime)
  schema_data_header(Time_fRandom)
  schema_data_header(Hit_fX)
  schema_data_header(Hit_fY)
  schema_data_header(Hit_fZ)
  schema_data_header(Hit_fVec)
  schema_data_header(Hit_fRandom)
#ifdef EXP_REF
  schema_data_header(Hit_fTrack)
#endif
  schema_data_header(Track_fPx)
  schema_data_header(Track_fPy)
  schema_data_header(Track_fPz)
  schema_data_header(Track_fRandom)
#ifdef EXP_STRING
  schema_data_header(Cell_fID)
  schema_data_header(Cell_fID_Vec)
#endif
  schema_data_header(Event_fID)
  schema_data_header(Event_fEnergy)
#ifdef EXP_REF
  schema_data_header(Event_fTracks_ref)
#endif
  schema_data_header(Event_fBlob)
  schema_data_header(Event_fObject)
  schema_data_header(Event_this_blob)
};

}

#endif
