// this :
#include <Exp/Schema.h>

#include <steve/core/stat_visitor.h>

Exp::Schema::Schema(std::ostream& a_printer)
:f_Event(a_printer,"Event",steve::path_os_t())
,f_Event_fHisto(a_printer,"Event_fHisto",steve::path_os_t())
{
}

Exp::Schema::~Schema(){}
//private:
/*
Schema::Schema(const Schema& a_from)
:Event_Schema(a_from.m_store)
{}
*/
Exp::Schema& Exp::Schema::operator=(const Schema&){return *this;}

void* Exp::Schema::cast_head() const {
  return (void*)static_cast<const Exp::Schema*>(this);
}

steve::interface::offsets* Exp::Schema::create_offsets(const std::string&,steve::uint32,steve::uint32){
  return false;
}
steve::interface::numbers* Exp::Schema::create_numbers(
 const steve::path_os_t& a_path_os
,const std::string& a_name
,steve::uint32 a_page_size
,steve::uint32 a_compression
){
  return false;
}

steve::interface::data* Exp::Schema::create_data(
 const steve::path_os_t& a_path_os
,const std::string& a_name
,const std::string& a_id_type
,steve::uint32 a_page_size
,steve::uint32 a_compression
){
  return false;
}

bool Exp::Schema::visit_store_data(steve::interface::store_data_visitor& a_visitor,bool a_visit_sub_schema)
{
  if(!f_Event.visit_store_data(a_visitor,a_visit_sub_schema)) return false;
  return f_Event_fHisto.visit_store_data(a_visitor,a_visit_sub_schema);
}
bool Exp::Schema::commit(){
  if(!f_Event.commit()) return false;
  return f_Event_fHisto.commit();
}

bool Exp::Schema::clear(){
  if(!f_Event.clear()) return false;
  return f_Event_fHisto.clear();
}

steve::interface::store_data* Exp::Schema::find_store_data(
 const std::string& a_name) const{
  steve::interface::store_data* sd = f_Event.find_store_data(a_name);
  if(sd) return sd;
  return f_Event_fHisto.find_store_data(a_name);
}

bool Exp::Schema::print_stats(std::ostream& a_printer) const{
  Exp::Schema& self = const_cast<Exp::Schema&>(*this);

  steve::core::stat_visitor v;
  if(!self.f_Event.visit_store_data(v)) return false;
  if(!self.f_Event_fHisto.visit_store_data(v)) return false;

  v.print(a_printer);

  return true;
}
