#ifndef Exp_Header_Schema_h
#define Exp_Header_Schema_h

// inheritance :
#include <steve/core/base_schema.h>

#include <steve/schema.h>

namespace Exp {

class Header_Schema : public steve::core::base_schema {
  virtual void* cast_head() const;
public:
  Header_Schema(std::ostream& a_printer,
              const std::string& a_namespace,
              steve::path_os_t a_head = steve::path_os_t());
  virtual ~Header_Schema();
private:
  Header_Schema(const Header_Schema&);
  Header_Schema& operator=(const Header_Schema&);
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  schema_data_header(Header_fNumberOfEvents)
};

}

#define HEADER_SCHEMA\
 ::Exp::Header_Schema* schema = (::Exp::Header_Schema*)a_schema.cast_head();

#define HEADER_DATA(a_name) *(schema->steve_data_##a_name())
#define HEADER_OFFSETS(a_name) *(schema->steve_offsets_##a_name())
#define HEADER_NUMBERS(a_name) *(schema->steve_numbers_##a_name())

#endif
