#include <Exp/Event.h>

#ifdef STEVE_USE_STEVE
#include <Exp/Schema.h>
#include <HCL/Schema.h>
#include <Exp/Analysis.h>
#include <Exp/Header_Schema.h>
#endif

#ifdef STEVE_USE_ROOT
#include <Exp/Schema.h> //FIXME
#include <Exp/Header_Schema.h>
#endif

#include <steve/interface/store.h>
#include <steve/tools/args.h>
#include <steve/tools/atime.h>
#include <steve/util/mem.h>

#include <iostream>

int main(int a_argc,char* a_argv[]) {
  //steve::util::mem::set_check_by_class(true);

  std::ostream& printer = std::cout;
  std::ostream& out = std::cout;

 {
#include "args.icxx"

  steve::interface::store* steve_store = 
    steve::DRIVER::create_store(printer,store_name);
  if(!steve_store) {
    out << "Can't create store." << std::endl;
    return 1;
  }
  steve_store->set_verbosity(verbosity);

  if(!steve_store->open(steve::interface::store::readonly)) {
    return 1;
  }

#include "retrieve.icxx"

  steve_store->close();

  delete steve_store;

  }
  steve::util::mem::balance(printer);
  return 0;
}
