#include <Exp/Event.h>

#ifdef STEVE_USE_STEVE
#include <Exp/Schema.h>
#include <HCL/Schema.h>
#include <Exp/Header_Schema.h>
#endif

#ifdef STEVE_USE_ROOT
#include <Exp/Schema.h> //FIXME
#include <Exp/Header_Schema.h>
#endif

#include <Exp/Analysis.h>

#include <steve/interface/store.h>
#include <steve/interface/store_data_visitor.h>
#include <steve/interface/store_data.h>

#include <steve/tools/args.h>
#include <steve/tools/atime.h>
#include <steve/tools/sprintf.h>
#include <steve/util/mem.h>

#include <iostream>

int main(int a_argc,char* a_argv[]) {
  //steve::util::mem::set_check_by_class(true);

  std::ostream& printer = std::cout;
  std::ostream& out = std::cout;

 {
#include "args.icxx"

  std::string options; //for root.
  steve::tools::sprintf(options,64,"compression=%d",compression);
  
  steve::interface::store* steve_store = 
    steve::DRIVER::create_store(std::cout,store_name,options);
  if(!steve_store) {
    std::cout << "Can't create store." << std::endl;
    return 1;
  }
  steve_store->set_verbosity(verbosity);

  if(!steve_store->open(steve::interface::store::create)) {
    return 1;
  }

#include "store.icxx"

  steve_store->close();

  delete steve_store;

  }
  steve::util::mem::balance(std::cout);
  return 0;
}
