#ifndef Exp_Schema_h
#define Exp_Schema_h

// inheritance :
#include <steve/interface/schema.h>

#include <Exp/Event_Schema.h>
#include <HCL/Schema.h>

namespace Exp {

class Schema : public virtual steve::interface::schema {
public: //steve::interface::schema
  virtual void* cast_head() const;

  virtual steve::interface::offsets* create_offsets(const std::string& a_name,
                                             steve::uint32 a_page_size,
                                             steve::uint32 a_compression);
  virtual steve::interface::numbers* create_numbers(const steve::path_os_t& a_path,
                                             const std::string& a_name,
                                             steve::uint32 a_page_size,
                                             steve::uint32 a_compression);
  virtual steve::interface::data* create_data(const steve::path_os_t& a_path,
                                           const std::string& a_name,
                                           const std::string& a_id_type,
                                           steve::uint32 a_page_size,
                                           steve::uint32 a_compression);
  virtual bool print_stats(std::ostream&) const;
  virtual bool commit();
  virtual bool clear();
  virtual steve::interface::store_data* find_store_data(const std::string&) const;
  virtual bool visit_store_data(steve::interface::store_data_visitor&,bool = true);
public:
  Schema(std::ostream&);
  virtual ~Schema();
private:
  //FIXME Schema(const Schema&);
  Schema& operator=(const Schema&);
public:
  Event_Schema f_Event;
  HCL::Schema f_Event_fHisto;
};

}

#define EXP_SCHEMA\
 ::Exp::Schema* exp_schema = (::Exp::Schema*)a_schema.cast_head();\
 if(!exp_schema) return false;\
 Event_Schema& schema = exp_schema->f_Event;

#define EXP_DATA(a_name) *(schema.steve_data_##a_name())
#define EXP_OFFSETS(a_name) *(schema.steve_offsets_##a_name())
#define EXP_NUMBERS(a_name) *(schema.steve_numbers_##a_name())

#endif
