#define STORE_NAME "memory"

#include <Exp/Event.h>
#include <Exp/Schema.h>
#include <Exp/Header_Schema.h>
#include <HCL/Schema.h>
#include <Exp/Analysis.h>

#include <steve/interface/store.h>
#include <steve/interface/store_data_visitor.h>
#include <steve/interface/store_data.h>

#include <steve/tools/args.h>
#include <steve/tools/atime.h>
#include <steve/util/mem.h>

#include <steve/memory/factory.h>

#include <iostream>

int main(int a_argc,char* a_argv[]) {
  steve::util::mem::set_check_by_class(true);

  std::ostream& printer = std::cout;
  std::ostream& out = std::cout;

 {
#include "args.icxx"

  steve::interface::store* steve_store = steve::memory::create_store(printer);
  if(!steve_store) {
    out << "Can't create store." << std::endl;
    return 1;
  }
  steve_store->set_verbosity(verbosity);

#include "store.icxx"

  if(steve_store->verbosity()) 
    out << "Retrieve and check events..." << std::endl;

#include "retrieve.icxx"

  delete steve_store;

  }
  steve::util::mem::balance(printer);
  return 0;
}
