// this :
#include <HCL/Schema.h>

HCL::Schema::~Schema(){}
//private:
HCL::Schema::Schema(const Schema& a_from)
:base_schema(a_from){}
HCL::Schema& HCL::Schema::operator=(const Schema&){ return *this;}

void* HCL::Schema::cast_head() const {
  return (void*)static_cast<const ::HCL::Schema*>(this);
}

/////////////////////////////////////
/// offsets and numbers /////////////
/////////////////////////////////////
// HistogramData std::vector fields :
schema_nos_method(HCL::Schema,fBinEntries)
schema_nos_method(HCL::Schema,fBinSw)
schema_nos_method(HCL::Schema,fBinSw2)
schema_nos_method(HCL::Schema,fBinSxw)
schema_nos_method(HCL::Schema,fBinSx2w)
schema_nos_method(HCL::Schema,fBinSvw)
schema_nos_method(HCL::Schema,fBinSv2w)
schema_nos_method(HCL::Schema,fDoubles)
schema_nos_method(HCL::Schema,fInts)
// HistogramData array fields :
schema_nos_method(HCL::Schema,fAxes)
// Axis std::vector fields :
schema_nos_method(HCL::Schema,Axis_fEdges)
/////////////////////////////////////
/// data ////////////////////////////
/////////////////////////////////////
// HistogramData not array fields :
schema_data_method(HCL::Schema,fTitle)
schema_data_method(HCL::Schema,fDimension)
schema_data_method(HCL::Schema,fBinNumber)
schema_data_method(HCL::Schema,fMode)
schema_data_method(HCL::Schema,fProfile)
schema_data_method(HCL::Schema,fCutV)
schema_data_method(HCL::Schema,fMinV)
schema_data_method(HCL::Schema,fMaxV)
// HistogramData std::vector fields :
schema_data_method(HCL::Schema,fBinEntries)
schema_data_method(HCL::Schema,fBinSw)
schema_data_method(HCL::Schema,fBinSw2)
schema_data_method(HCL::Schema,fBinSxw)
schema_data_method(HCL::Schema,fBinSx2w)
schema_data_method(HCL::Schema,fBinSvw)
schema_data_method(HCL::Schema,fBinSv2w)
schema_data_method(HCL::Schema,fDoubles)
schema_data_method(HCL::Schema,fInts)
// Axis not array fields :
schema_data_method(HCL::Schema,Axis_fOffset)
schema_data_method(HCL::Schema,Axis_fNumberOfBins)
schema_data_method(HCL::Schema,Axis_fMinimumValue)
schema_data_method(HCL::Schema,Axis_fMaximumValue)
schema_data_method(HCL::Schema,Axis_fFixed)
schema_data_method(HCL::Schema,Axis_fBinWidth)
// Axis std::vector fields :
schema_data_method(HCL::Schema,Axis_fEdges)

HCL::Schema::Schema(
 std::ostream& a_printer
,const std::string& a_namespace
,steve::path_os_t a_head
)
:base_schema(a_printer,a_namespace)
{
  /////////////////////////////////////
  /// offsets /////////////////////////
  /////////////////////////////////////
  // HistogramData std::vector fields :
  schema_offsets_new(fBinEntries)
  schema_offsets_new(fBinSw)
  schema_offsets_new(fBinSw2)
  schema_offsets_new(fBinSxw)
  schema_offsets_new(fBinSx2w)
  schema_offsets_new(fBinSvw)
  schema_offsets_new(fBinSv2w)
  schema_offsets_new(fDoubles)
  schema_offsets_new(fInts)
  // HistogramData array fields :
  schema_offsets_new(fAxes)
  // Axis std::vector fields :
  schema_offsets_new(Axis_fEdges)

  /////////////////////////////////////
  /// path_os /////////////////////////
  /////////////////////////////////////
  // Histogram std::vector fields :
  steve::path_os_t path_fBinEntries = a_head;
  path_fBinEntries.push_back(m_steve_offsets_fBinEntries);
  steve::path_os_t path_fBinSw = a_head;
  path_fBinSw.push_back(m_steve_offsets_fBinSw);
  steve::path_os_t path_fBinSw2 = a_head;
  path_fBinSw2.push_back(m_steve_offsets_fBinSw2);
  steve::path_os_t path_fBinSxw = a_head;
  path_fBinSxw.push_back(m_steve_offsets_fBinSxw);
  steve::path_os_t path_fBinSx2w = a_head;
  path_fBinSx2w.push_back(m_steve_offsets_fBinSx2w);
  steve::path_os_t path_fBinSvw = a_head;
  path_fBinSvw.push_back(m_steve_offsets_fBinSvw);
  steve::path_os_t path_fBinSv2w = a_head;
  path_fBinSv2w.push_back(m_steve_offsets_fBinSv2w);
  steve::path_os_t path_fDoubles = a_head;
  path_fDoubles.push_back(m_steve_offsets_fDoubles);
  steve::path_os_t path_fInts = a_head;
  path_fInts.push_back(m_steve_offsets_fInts);

  // HistogramData array fields :
  steve::path_os_t path_fAxes = a_head;
  path_fAxes.push_back(m_steve_offsets_fAxes);

  // Axis std::vector fields :
  steve::path_os_t path_fAxes_fEdges = a_head;
  path_fAxes_fEdges.push_back(m_steve_offsets_fAxes);
  path_fAxes_fEdges.push_back(m_steve_offsets_Axis_fEdges);

  steve::path_os_t path_this = a_head;

  /////////////////////////////////////
  /// numbers /////////////////////////
  /////////////////////////////////////
  // HistogramData std::vector fields :
  schema_numbers_new(path_fBinEntries,fBinEntries)
  schema_numbers_new(path_fBinSw,fBinSw)
  schema_numbers_new(path_fBinSw2,fBinSw2)
  schema_numbers_new(path_fBinSxw,fBinSxw)
  schema_numbers_new(path_fBinSx2w,fBinSx2w)
  schema_numbers_new(path_fBinSvw,fBinSvw)
  schema_numbers_new(path_fBinSv2w,fBinSv2w)
  schema_numbers_new(path_fDoubles,fDoubles)
  schema_numbers_new(path_fInts,fInts)
  // HistogramData array fields :
  schema_numbers_new(path_fAxes,fAxes)

  // Axis std::vector fields :
  schema_numbers_new(path_fAxes_fEdges,Axis_fEdges)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  // HistogramData not array fields :
  schema_data_new(path_this,fTitle,steve_id_string)
  schema_data_new(path_this,fDimension,steve_id_int32)
  schema_data_new(path_this,fBinNumber,steve_id_int32)
  schema_data_new(path_this,fMode,steve_id_int32)
  schema_data_new(path_this,fProfile,steve_id_bool)
  schema_data_new(path_this,fCutV,steve_id_bool)
  schema_data_new(path_this,fMinV,steve_id_double)
  schema_data_new(path_this,fMaxV,steve_id_double)
  // HistogramData std::vector fields :
  schema_data_new(path_fBinEntries,fBinEntries,steve_id_int32)
  schema_data_new(path_fBinSw,fBinSw,steve_id_double)
  schema_data_new(path_fBinSw2,fBinSw2,steve_id_double)
  schema_data_new(path_fBinSxw,fBinSxw,steve_id_double)
  schema_data_new(path_fBinSx2w,fBinSx2w,steve_id_double)
  schema_data_new(path_fBinSvw,fBinSvw,steve_id_double)
  schema_data_new(path_fBinSv2w,fBinSv2w,steve_id_double)
  schema_data_new(path_fDoubles,fDoubles,steve_id_double)
  schema_data_new(path_fInts,fInts,steve_id_int32)

  // Axis not array fields :
  schema_data_new(path_fAxes,Axis_fOffset,steve_id_int32)
  schema_data_new(path_fAxes,Axis_fNumberOfBins,steve_id_int32)
  schema_data_new(path_fAxes,Axis_fMinimumValue,steve_id_double)
  schema_data_new(path_fAxes,Axis_fMaximumValue,steve_id_double)
  schema_data_new(path_fAxes,Axis_fFixed,steve_id_bool)
  schema_data_new(path_fAxes,Axis_fBinWidth,steve_id_double)
  // Axis std::vector fields :
  schema_data_new(path_fAxes_fEdges,Axis_fEdges,steve_id_double)
}
