#ifndef HCL_Schema_h
#define HCL_Schema_h

// inheritance :
#include <steve/core/base_schema.h>

#include <steve/schema.h>

namespace HCL {

class Schema : public steve::core::base_schema {
public: //steve::interface::schema
  virtual void* cast_head() const;
public:
  Schema(std::ostream&,
       const std::string& a_namespace,
       steve::path_os_t a_head);
  virtual ~Schema();
private:
  Schema(const Schema&);
  Schema& operator=(const Schema&);
public:
  /////////////////////////////////////
  /// offsets and numbers /////////////
  /////////////////////////////////////
  // HistogramData std::vector fields :
  schema_nos_header(fBinEntries)
  schema_nos_header(fBinSw)
  schema_nos_header(fBinSw2)
  schema_nos_header(fBinSxw)
  schema_nos_header(fBinSx2w)
  schema_nos_header(fBinSvw)
  schema_nos_header(fBinSv2w)
  schema_nos_header(fDoubles)
  schema_nos_header(fInts)
  // HistogramData array fields :
  schema_nos_header(fAxes)

  // Axis std::vector fields :
  schema_nos_header(Axis_fEdges)
  /////////////////////////////////////
  /// data ////////////////////////////
  /////////////////////////////////////
  // HistogramData not array fields :
  schema_data_header(fTitle)
  schema_data_header(fDimension)
  schema_data_header(fBinNumber)
  schema_data_header(fMode)
  schema_data_header(fProfile)
  schema_data_header(fCutV)
  schema_data_header(fMinV)
  schema_data_header(fMaxV)
  // HistogramData std::vector fields :
  schema_data_header(fBinEntries)
  schema_data_header(fBinSw)
  schema_data_header(fBinSw2)
  schema_data_header(fBinSxw)
  schema_data_header(fBinSx2w)
  schema_data_header(fBinSvw)
  schema_data_header(fBinSv2w)
  schema_data_header(fDoubles)
  schema_data_header(fInts)

  // Axis not array fields :
  schema_data_header(Axis_fOffset)
  schema_data_header(Axis_fNumberOfBins)
  schema_data_header(Axis_fMinimumValue)
  schema_data_header(Axis_fMaximumValue)
  schema_data_header(Axis_fFixed)
  schema_data_header(Axis_fBinWidth)
  // Axis std::vector fields :
  schema_data_header(Axis_fEdges)
};

}

#define HCL_SCHEMA ::HCL::Schema* schema = (::HCL::Schema*)a_schema.cast_head();

#define HCL_DATA(a_name) *(schema->steve_data_##a_name())
#define HCL_OFFSETS(a_name) *(schema->steve_offsets_##a_name())
#define HCL_NUMBERS(a_name) *(schema->steve_numbers_##a_name())

#endif
