#ifndef steve_HCL_helper_h
#define steve_HCL_helper_h

#include <HCL/Schema.h>

#include <steve/helper.h>

#include <HCL/Histogram.h>


#define HCL_STORE(a_type,a_member,a_field)\
  if(!steve::store<a_type>(a_store,\
                           HCL_DATA(a_member),\
                           a_data.a_field)) return false;

#define HCL_STORE_STD_VECTOR(a_type,a_member,a_field)\
  if(!steve::store<a_type>(a_store,\
                           HCL_OFFSETS(a_member),\
                           HCL_NUMBERS(a_member),\
                           HCL_DATA(a_member),\
                           a_data.a_field)) return false;

#define HCL_RETRIEVE(a_type,a_member,a_field)\
  if(!steve::retrieve<a_type>(a_store,\
                              HCL_DATA(a_member),\
                              a_event,a_is,a_data.a_field)) return false;

#define HCL_RETRIEVE_STD_VECTOR(a_type,a_member,a_field)\
  if(!steve::retrieve<a_type>(a_store,\
                              HCL_NUMBERS(a_member),\
                              HCL_DATA(a_member),\
                              a_event,a_is,a_data.a_field)) return false;


namespace steve {
namespace HCL {

inline bool store(steve::interface::store& a_store,
                  steve::interface::schema& a_schema,
                  const ::HCL::Axis& a_data) { 
  HCL_SCHEMA
  //FIXME : store version.
  // Axis not array fields :
  HCL_STORE(int,Axis_fOffset,fOffset)
  HCL_STORE(int,Axis_fNumberOfBins,fNumberOfBins)
  HCL_STORE(double,Axis_fMinimumValue,fMinimumValue)
  HCL_STORE(double,Axis_fMaximumValue,fMaximumValue)
  HCL_STORE(bool,Axis_fFixed,fFixed)
  HCL_STORE(double,Axis_fBinWidth,fBinWidth)
  // Axis std::vector fields :
  HCL_STORE_STD_VECTOR(double,Axis_fEdges,fEdges)
  return true;
}
inline bool retrieve(steve::interface::store& a_store,
                     steve::interface::schema& a_schema,
                     steve::uint32 a_event,
                     const steve::path_t& a_is,
                     ::HCL::Axis& a_data) { 
  HCL_SCHEMA
  //FIXME : retrieve version.
  // Axis not array fields :
  HCL_RETRIEVE(int,Axis_fOffset,fOffset)
  HCL_RETRIEVE(int,Axis_fNumberOfBins,fNumberOfBins)
  HCL_RETRIEVE(double,Axis_fMinimumValue,fMinimumValue)
  HCL_RETRIEVE(double,Axis_fMaximumValue,fMaximumValue)
  HCL_RETRIEVE(bool,Axis_fFixed,fFixed)
  HCL_RETRIEVE(double,Axis_fBinWidth,fBinWidth)
  // Axis std::vector fields :
  HCL_RETRIEVE_STD_VECTOR(double,Axis_fEdges,fEdges)
  return true;
}

inline bool store(steve::interface::store& a_store,
                  steve::interface::schema& a_schema,
                  const ::HCL::HistogramData& a_data) { 
  HCL_SCHEMA

  //FIXME : store version.

  // HistogramData not array fields :
  HCL_STORE(std::string,fTitle,fTitle)
  HCL_STORE(int,fDimension,fDimension)
  HCL_STORE(int,fBinNumber,fBinNumber)
  HCL_STORE(int,fMode,fMode)
  HCL_STORE(bool,fProfile,fProfile)
  HCL_STORE(bool,fCutV,fCutV)
  HCL_STORE(double,fMinV,fMinV)
  HCL_STORE(double,fMaxV,fMaxV)
  // HistogramData std::vector fields :
  HCL_STORE_STD_VECTOR(int,fBinEntries,fBinEntries)
  HCL_STORE_STD_VECTOR(double,fBinSw,fBinSw)
  HCL_STORE_STD_VECTOR(double,fBinSw2,fBinSw2)
  HCL_STORE_STD_VECTOR(double,fBinSxw,fBinSxw)
  HCL_STORE_STD_VECTOR(double,fBinSx2w,fBinSx2w)
  HCL_STORE_STD_VECTOR(double,fBinSvw,fBinSvw)
  HCL_STORE_STD_VECTOR(double,fBinSv2w,fBinSv2w)
  HCL_STORE_STD_VECTOR(double,fDoubles,fDoubles)
  HCL_STORE_STD_VECTOR(int,fInts,fInts)

  if(!steve::store< ::HCL::Axis >(a_store,a_schema,
                                  HCL_OFFSETS(fAxes),
                                  HCL_NUMBERS(fAxes),
                                  store,
                                  a_data.fAxes)) return false;

  return true;
}
inline bool retrieve(steve::interface::store& a_store,
                     steve::interface::schema& a_schema,
                     steve::uint32 a_event,
                     const steve::path_t& a_is,
                     ::HCL::HistogramData& a_data) { 
  HCL_SCHEMA

  //FIXME : retrieve version.

  // HistogramData not array fields :
  HCL_RETRIEVE(std::string,fTitle,fTitle)
  HCL_RETRIEVE(int,fDimension,fDimension)
  HCL_RETRIEVE(int,fBinNumber,fBinNumber)
  HCL_RETRIEVE(int,fMode,fMode)
  HCL_RETRIEVE(bool,fProfile,fProfile)
  HCL_RETRIEVE(bool,fCutV,fCutV)
  HCL_RETRIEVE(double,fMinV,fMinV)
  HCL_RETRIEVE(double,fMaxV,fMaxV)
  // HistogramData std::vector fields :
  HCL_RETRIEVE_STD_VECTOR(int,fBinEntries,fBinEntries)
  HCL_RETRIEVE_STD_VECTOR(double,fBinSw,fBinSw)
  HCL_RETRIEVE_STD_VECTOR(double,fBinSw2,fBinSw2)
  HCL_RETRIEVE_STD_VECTOR(double,fBinSxw,fBinSxw)
  HCL_RETRIEVE_STD_VECTOR(double,fBinSx2w,fBinSx2w)
  HCL_RETRIEVE_STD_VECTOR(double,fBinSvw,fBinSvw)
  HCL_RETRIEVE_STD_VECTOR(double,fBinSv2w,fBinSv2w)
  HCL_RETRIEVE_STD_VECTOR(double,fDoubles,fDoubles)
  HCL_RETRIEVE_STD_VECTOR(int,fInts,fInts)

  if(!steve::retrieve< ::HCL::Axis >(a_store,a_schema,
                                     HCL_NUMBERS(fAxes),
                                     retrieve,
                                     a_event,a_is,
                                     a_data.fAxes)) return false;

  return true;
}

}}

#undef HCL_STORE
#undef HCL_STORE_STD_VECTOR
#undef HCL_RETRIEVE
#undef HCL_RETRIEVE_STD_VECTOR

#endif
