#ifndef steve_HCL_streamer_h
#define steve_HCL_streamer_h

#include <HCL/Histogram.h>

//#define HCL_AXIS_VERSION      1
//#define HCL_HISTOGRAM_VERSION 1

namespace steve {
namespace HCL {

inline bool Axis_out(steve::interface::streamer& a_streamer,
                     const ::HCL::Axis& a_data) { 
  //steve::uint16 version = HCL_AXIS_VERSION;
  //if(!a_streamer.write(version)) return false;

  // Axis not array fields :
  if(!a_streamer.write(a_data.fOffset)) return false;
  if(!a_streamer.write(a_data.fNumberOfBins)) return false;
  if(!a_streamer.write(a_data.fMinimumValue)) return false;
  if(!a_streamer.write(a_data.fMaximumValue)) return false;
  if(!a_streamer.write(a_data.fFixed)) return false;
  if(!a_streamer.write(a_data.fBinWidth)) return false;
  // Axis std::vector fields :
  if(!steve::stream::out<double>(a_streamer,a_data.fEdges)) return false;
  return true;
}
inline bool Axis_in(steve::interface::streamer& a_streamer,
                        ::HCL::Axis& a_data) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=HCL_AXIS_VERSION) return false;

  // Axis not array fields :
  if(!a_streamer.read(a_data.fOffset)) return false;
  if(!a_streamer.read(a_data.fNumberOfBins)) return false;
  if(!a_streamer.read(a_data.fMinimumValue)) return false;
  if(!a_streamer.read(a_data.fMaximumValue)) return false;
  if(!a_streamer.read(a_data.fFixed)) return false;
  if(!a_streamer.read(a_data.fBinWidth)) return false;
  // Axis std::vector fields :
  if(!steve::stream::in<double>(a_streamer,a_data.fEdges)) return false;
  return true;
}

inline bool out(steve::interface::streamer& a_streamer,
                const ::HCL::HistogramData& a_data) { 
  //steve::uint16 version = HCL_HISTOGRAM_VERSION;
  //if(!a_streamer.write(version)) return false;

  // HistogramData not array fields :
  if(!a_streamer.write(a_data.fTitle)) return false;
  if(!a_streamer.write(a_data.fDimension)) return false;
  if(!a_streamer.write(a_data.fBinNumber)) return false;
  if(!a_streamer.write(a_data.fMode)) return false;
  if(!a_streamer.write(a_data.fProfile)) return false;
  if(!a_streamer.write(a_data.fCutV)) return false;
  if(!a_streamer.write(a_data.fMinV)) return false;
  if(!a_streamer.write(a_data.fMaxV)) return false;
  // HistogramData std::vector fields :
  if(!steve::stream::out<int>(a_streamer,a_data.fBinEntries)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fBinSw)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fBinSw2)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fBinSxw)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fBinSx2w)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fBinSvw)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fBinSv2w)) return false;
  if(!steve::stream::out<double>(a_streamer,a_data.fDoubles)) return false;
  if(!steve::stream::out<int>(a_streamer,a_data.fInts)) return false;
  if(!steve::stream::out3< ::HCL::Axis >(a_streamer,Axis_out,a_data.fAxes)) 
    return false;
  return true;
}
inline bool in(steve::interface::streamer& a_streamer,
               ::HCL::HistogramData& a_data) { 
  //steve::uint16 version;
  //if(!a_streamer.read(version)) return false;
  //if(version!=HCL_HISTOGRAM_VERSION) return false;

  // HistogramData not array fields :
  if(!a_streamer.read(a_data.fTitle)) return false;
  if(!a_streamer.read(a_data.fDimension)) return false;
  if(!a_streamer.read(a_data.fBinNumber)) return false;
  if(!a_streamer.read(a_data.fMode)) return false;
  if(!a_streamer.read(a_data.fProfile)) return false;
  if(!a_streamer.read(a_data.fCutV)) return false;
  if(!a_streamer.read(a_data.fMinV)) return false;
  if(!a_streamer.read(a_data.fMaxV)) return false;
  // HistogramData std::vector fields :
  if(!steve::stream::in<int>(a_streamer,a_data.fBinEntries)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fBinSw)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fBinSw2)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fBinSxw)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fBinSx2w)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fBinSvw)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fBinSv2w)) return false;
  if(!steve::stream::in<double>(a_streamer,a_data.fDoubles)) return false;
  if(!steve::stream::in<int>(a_streamer,a_data.fInts)) return false;

  if(!steve::stream::in3< ::HCL::Axis >(a_streamer,Axis_in,a_data.fAxes)) 
    return false;
  return true;
}

}}

//#undef HCL_AXIS_VERSION
//#undef HCL_HISTOGRAM_VERSION

#endif
