 
#include <hdf5.h>

#include <stdio.h>

#define FILE   "steve_debug.hdf5"
#define NX     10000
#define RANK   1

int
main (void)
{
    hid_t       file, dataset;
    hid_t       mem_datatype;
    hid_t       file_datatype;
    hid_t       dataspace;
    hsize_t     dims[1];
    double      data[NX];
    int         i, j, k;
    hid_t       file_props;
    hid_t       props;
    int         compression;
    char DATASETNAME[64];

    printf("main : debug : 4\n");
    /* 
     * Data  and output buffer initialization. 
     */
    for (j = 0; j < NX; j++) {
	    data[j] = j;
    }     

    file_props = H5Pcreate(H5P_FILE_ACCESS);
   {int mdc_nelmts;
    size_t rdcc_nelmts;
    size_t rdcc_nbytes;
    double rdcc_w0;
    H5Pget_cache(file_props,&mdc_nelmts,&rdcc_nelmts,&rdcc_nbytes,&rdcc_w0);
    H5Pset_cache(file_props,mdc_nelmts,0,0,rdcc_w0);}
    file = H5Fcreate(FILE, H5F_ACC_TRUNC, H5P_DEFAULT, file_props);

    dims[0] = NX;

    compression = 6;

    for( k=0;k<50000;k++) {
      /*printf("debug : %d\n",k);*/

      dataspace = H5Screate_simple(RANK, dims, NULL); 

      props = H5Pcreate(H5P_DATASET_CREATE);
      H5Pset_layout(props,H5D_CHUNKED);
      H5Pset_shuffle(props);
      H5Pset_chunk(props,1,dims);
      H5Pset_deflate(props,compression);

      file_datatype = H5Tcopy(H5T_IEEE_F64LE);
      mem_datatype = H5Tcopy(H5T_NATIVE_DOUBLE);

      sprintf(DATASETNAME,"IntArray_%d",k);

      dataset = H5Dcreate(file,DATASETNAME,file_datatype,dataspace,props);

      /*H5Dwrite(dataset,H5T_NATIVE_INT,H5S_ALL,H5S_ALL,H5P_DEFAULT,data);*/
      H5Dwrite(dataset,mem_datatype,H5S_ALL,H5S_ALL,H5P_DEFAULT,data);

      H5Pclose(props);
      H5Dclose(dataset);

      H5Sclose(dataspace);
      H5Tclose(file_datatype);
      H5Tclose(mem_datatype);
    }


    H5Fclose(file);
    H5Pclose(file_props);
 
    return 0;
}     
